// Compiled by ClojureScript 1.10.891 {:static-fns true, :optimize-constants false, :target :nodejs, :nodejs-rt false, :optimizations :advanced}
goog.provide('fluree.crypto.pkcs7');
goog.require('cljs.core');
goog.require('goog.array');
goog.scope(function(){
fluree.crypto.pkcs7.goog$module$goog$array = goog.module.get('goog.array');
});
fluree.crypto.pkcs7.byte_QMARK_ = (function fluree$crypto$pkcs7$byte_QMARK_(b){
return ((typeof b === 'number') && ((((b >= (0))) && ((((b <= (255))) && (((b - Math.floor(b)) === (0))))))));
});
fluree.crypto.pkcs7.bytes_QMARK_ = (function fluree$crypto$pkcs7$bytes_QMARK_(bytes){
return cljs.core.every_QMARK_(fluree.crypto.pkcs7.byte_QMARK_,bytes);
});
fluree.crypto.pkcs7.compare_bytes = (function fluree$crypto$pkcs7$compare_bytes(ba1,ba2){
if(cljs.core.not_EQ_.cljs$core$IFn$_invoke$arity$2(ba1.length,ba2.length)){
return false;
} else {
if((((!(fluree.crypto.pkcs7.bytes_QMARK_(ba1)))) || ((!(fluree.crypto.pkcs7.bytes_QMARK_(ba2)))))){
return false;
} else {
return cljs.core.every_QMARK_(cljs.core.true_QMARK_,cljs.core.map.cljs$core$IFn$_invoke$arity$3(cljs.core._EQ_,ba1,ba2));
}
}
});
fluree.crypto.pkcs7.encode = (function fluree$crypto$pkcs7$encode(k,m){
var n = (k - cljs.core.mod(m.length,k));
return m.concat(fluree.crypto.pkcs7.goog$module$goog$array.repeat.call(null,n,n));
});
fluree.crypto.pkcs7.decode = (function fluree$crypto$pkcs7$decode(k,m){
var len = m.length;
var last_byte = (m[(len - (1))]);
var error = (((last_byte > len)) || ((((last_byte > k)) || ((((last_byte === (0))) || ((!((cljs.core.mod(len,k) === (0))))))))));
if(error){
throw (new Error(["invalid pkcs7 encoding: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(m)].join('')));
} else {
}

var computed = fluree.crypto.pkcs7.goog$module$goog$array.repeat.call(null,last_byte,last_byte);
var provided = (function (){var G__72324 = m;
var G__72325 = (len - last_byte);
return fluree.crypto.pkcs7.goog$module$goog$array.slice.call(null,G__72324,G__72325);
})();
if(fluree.crypto.pkcs7.compare_bytes(computed,provided)){
} else {
throw (new Error("paddings don't match"));
}

var G__72326 = m;
var G__72327 = (0);
var G__72328 = (len - last_byte);
return fluree.crypto.pkcs7.goog$module$goog$array.slice.call(null,G__72326,G__72327,G__72328);
});
