// Compiled by ClojureScript 1.10.891 {:static-fns true, :optimize-constants false, :target :nodejs, :nodejs-rt false, :optimizations :advanced}
goog.provide('fluree.db.auth');
goog.require('cljs.core');
goog.require('fluree.db.dbproto');
goog.require('fluree.db.util.async');
/**
 * Given an _auth identity, returns associated roles.
 *   First returns roles directly associated with auth ident.
 *   If none exist, attempts to retrieve default roles for associated
 *   user, if they exist.
 */
fluree.db.auth.roles = (function fluree$db$auth$roles(db,auth_id){
var c__11484__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__11485__auto__ = (function (){var switch__11409__auto__ = (function (state_69839){
var state_val_69840 = (state_69839[(1)]);
if((state_val_69840 === (7))){
var inst_69791 = typeof auth_id === 'string';
var state_69839__$1 = state_69839;
if(cljs.core.truth_(inst_69791)){
var statearr_69841_69869 = state_69839__$1;
(statearr_69841_69869[(1)] = (9));

} else {
var statearr_69842_69870 = state_69839__$1;
(statearr_69842_69870[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69840 === (1))){
var state_69839__$1 = state_69839;
var statearr_69843_69871 = state_69839__$1;
(statearr_69843_69871[(2)] = null);

(statearr_69843_69871[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69840 === (4))){
var inst_69781 = (state_69839[(2)]);
var state_69839__$1 = state_69839;
var statearr_69844_69872 = state_69839__$1;
(statearr_69844_69872[(2)] = inst_69781);

(statearr_69844_69872[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69840 === (15))){
var inst_69832 = (state_69839[(2)]);
var state_69839__$1 = state_69839;
var statearr_69845_69873 = state_69839__$1;
(statearr_69845_69873[(2)] = inst_69832);

(statearr_69845_69873[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69840 === (13))){
var inst_69812 = (state_69839[(7)]);
var state_69839__$1 = state_69839;
var statearr_69846_69874 = state_69839__$1;
(statearr_69846_69874[(2)] = inst_69812);

(statearr_69846_69874[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69840 === (6))){
var inst_69789 = cljs.core.PersistentVector.EMPTY;
var state_69839__$1 = state_69839;
var statearr_69847_69875 = state_69839__$1;
(statearr_69847_69875[(2)] = inst_69789);

(statearr_69847_69875[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69840 === (3))){
var inst_69837 = (state_69839[(2)]);
var state_69839__$1 = state_69839;
return cljs.core.async.impl.ioc_helpers.return_chan(state_69839__$1,inst_69837);
} else {
if((state_val_69840 === (12))){
var inst_69812 = (state_69839[(7)]);
var inst_69810 = (state_69839[(2)]);
var inst_69811 = fluree.db.util.async.throw_err(inst_69810);
var inst_69812__$1 = cljs.core.not_empty(inst_69811);
var state_69839__$1 = (function (){var statearr_69848 = state_69839;
(statearr_69848[(7)] = inst_69812__$1);

return statearr_69848;
})();
if(cljs.core.truth_(inst_69812__$1)){
var statearr_69849_69876 = state_69839__$1;
(statearr_69849_69876[(1)] = (13));

} else {
var statearr_69850_69877 = state_69839__$1;
(statearr_69850_69877[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69840 === (2))){
var _ = (function (){var statearr_69851 = state_69839;
(statearr_69851[(4)] = cljs.core.cons((5),(state_69839[(4)])));

return statearr_69851;
})();
var inst_69787 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((0),auth_id);
var state_69839__$1 = state_69839;
if(inst_69787){
var statearr_69852_69878 = state_69839__$1;
(statearr_69852_69878[(1)] = (6));

} else {
var statearr_69853_69879 = state_69839__$1;
(statearr_69853_69879[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69840 === (11))){
var inst_69798 = (state_69839[(8)]);
var inst_69798__$1 = (state_69839[(2)]);
var inst_69799 = [new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.Keyword(null,"where","where",-2044795965)];
var inst_69800 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_69801 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_69802 = [inst_69798__$1,"_auth/roles","?roles"];
var inst_69803 = (new cljs.core.PersistentVector(null,3,(5),inst_69801,inst_69802,null));
var inst_69804 = [inst_69803];
var inst_69805 = (new cljs.core.PersistentVector(null,1,(5),inst_69800,inst_69804,null));
var inst_69806 = ["?roles",inst_69805];
var inst_69807 = cljs.core.PersistentHashMap.fromArrays(inst_69799,inst_69806);
var inst_69808 = fluree.db.dbproto._query.cljs$core$IFn$_invoke$arity$2(db,inst_69807);
var state_69839__$1 = (function (){var statearr_69855 = state_69839;
(statearr_69855[(8)] = inst_69798__$1);

return statearr_69855;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_69839__$1,(12),inst_69808);
} else {
if((state_val_69840 === (9))){
var inst_69793 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_69794 = ["_auth/id",auth_id];
var inst_69795 = (new cljs.core.PersistentVector(null,2,(5),inst_69793,inst_69794,null));
var state_69839__$1 = state_69839;
var statearr_69856_69880 = state_69839__$1;
(statearr_69856_69880[(2)] = inst_69795);

(statearr_69856_69880[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69840 === (5))){
var _ = (function (){var statearr_69857 = state_69839;
(statearr_69857[(4)] = cljs.core.rest((state_69839[(4)])));

return statearr_69857;
})();
var state_69839__$1 = state_69839;
var ex69854 = (state_69839__$1[(2)]);
var statearr_69858_69881 = state_69839__$1;
(statearr_69858_69881[(5)] = ex69854);


if((ex69854 instanceof Error)){
var statearr_69859_69882 = state_69839__$1;
(statearr_69859_69882[(1)] = (4));

(statearr_69859_69882[(5)] = null);

} else {
throw ex69854;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69840 === (14))){
var inst_69798 = (state_69839[(8)]);
var inst_69815 = [new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.Keyword(null,"where","where",-2044795965)];
var inst_69816 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_69817 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_69818 = ["?user","_user/auth",inst_69798];
var inst_69819 = (new cljs.core.PersistentVector(null,3,(5),inst_69817,inst_69818,null));
var inst_69820 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_69821 = ["?user","_user/roles","?roles"];
var inst_69822 = (new cljs.core.PersistentVector(null,3,(5),inst_69820,inst_69821,null));
var inst_69823 = [inst_69819,inst_69822];
var inst_69824 = (new cljs.core.PersistentVector(null,2,(5),inst_69816,inst_69823,null));
var inst_69825 = ["?roles",inst_69824];
var inst_69826 = cljs.core.PersistentHashMap.fromArrays(inst_69815,inst_69825);
var inst_69827 = fluree.db.dbproto._query.cljs$core$IFn$_invoke$arity$2(db,inst_69826);
var state_69839__$1 = state_69839;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_69839__$1,(16),inst_69827);
} else {
if((state_val_69840 === (16))){
var inst_69829 = (state_69839[(2)]);
var inst_69830 = fluree.db.util.async.throw_err(inst_69829);
var state_69839__$1 = state_69839;
var statearr_69860_69883 = state_69839__$1;
(statearr_69860_69883[(2)] = inst_69830);

(statearr_69860_69883[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69840 === (10))){
var state_69839__$1 = state_69839;
var statearr_69861_69884 = state_69839__$1;
(statearr_69861_69884[(2)] = auth_id);

(statearr_69861_69884[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69840 === (8))){
var inst_69834 = (state_69839[(2)]);
var _ = (function (){var statearr_69862 = state_69839;
(statearr_69862[(4)] = cljs.core.rest((state_69839[(4)])));

return statearr_69862;
})();
var state_69839__$1 = state_69839;
var statearr_69863_69885 = state_69839__$1;
(statearr_69863_69885[(2)] = inst_69834);

(statearr_69863_69885[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$auth$roles_$_state_machine__11410__auto__ = null;
var fluree$db$auth$roles_$_state_machine__11410__auto____0 = (function (){
var statearr_69864 = [null,null,null,null,null,null,null,null,null];
(statearr_69864[(0)] = fluree$db$auth$roles_$_state_machine__11410__auto__);

(statearr_69864[(1)] = (1));

return statearr_69864;
});
var fluree$db$auth$roles_$_state_machine__11410__auto____1 = (function (state_69839){
while(true){
var ret_value__11411__auto__ = (function (){try{while(true){
var result__11412__auto__ = switch__11409__auto__(state_69839);
if(cljs.core.keyword_identical_QMARK_(result__11412__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11412__auto__;
}
break;
}
}catch (e69865){var ex__11413__auto__ = e69865;
var statearr_69866_69886 = state_69839;
(statearr_69866_69886[(2)] = ex__11413__auto__);


if(cljs.core.seq((state_69839[(4)]))){
var statearr_69867_69887 = state_69839;
(statearr_69867_69887[(1)] = cljs.core.first((state_69839[(4)])));

} else {
throw ex__11413__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11411__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__69888 = state_69839;
state_69839 = G__69888;
continue;
} else {
return ret_value__11411__auto__;
}
break;
}
});
fluree$db$auth$roles_$_state_machine__11410__auto__ = function(state_69839){
switch(arguments.length){
case 0:
return fluree$db$auth$roles_$_state_machine__11410__auto____0.call(this);
case 1:
return fluree$db$auth$roles_$_state_machine__11410__auto____1.call(this,state_69839);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$auth$roles_$_state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$auth$roles_$_state_machine__11410__auto____0;
fluree$db$auth$roles_$_state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$auth$roles_$_state_machine__11410__auto____1;
return fluree$db$auth$roles_$_state_machine__11410__auto__;
})()
})();
var state__11486__auto__ = (function (){var statearr_69868 = (f__11485__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11485__auto__.cljs$core$IFn$_invoke$arity$0() : f__11485__auto__.call(null));
(statearr_69868[(6)] = c__11484__auto__);

return statearr_69868;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11486__auto__);
}));

return c__11484__auto__;
});
/**
 * Given an _auth identity, returns roles directly associated
 *   with the auth ident.  If none found, attempts to retrieve
 *   default roles for an associated user.
 */
fluree.db.auth.root_role_QMARK_ = (function fluree$db$auth$root_role_QMARK_(db,auth_id){
var c__11484__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__11485__auto__ = (function (){var switch__11409__auto__ = (function (state_69959){
var state_val_69960 = (state_69959[(1)]);
if((state_val_69960 === (7))){
var inst_69898 = typeof auth_id === 'string';
var state_69959__$1 = state_69959;
if(cljs.core.truth_(inst_69898)){
var statearr_69961_69989 = state_69959__$1;
(statearr_69961_69989[(1)] = (9));

} else {
var statearr_69962_69990 = state_69959__$1;
(statearr_69962_69990[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69960 === (1))){
var state_69959__$1 = state_69959;
var statearr_69963_69991 = state_69959__$1;
(statearr_69963_69991[(2)] = null);

(statearr_69963_69991[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69960 === (4))){
var inst_69889 = (state_69959[(2)]);
var state_69959__$1 = state_69959;
var statearr_69964_69992 = state_69959__$1;
(statearr_69964_69992[(2)] = inst_69889);

(statearr_69964_69992[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69960 === (15))){
var inst_69952 = (state_69959[(2)]);
var state_69959__$1 = state_69959;
var statearr_69965_69993 = state_69959__$1;
(statearr_69965_69993[(2)] = inst_69952);

(statearr_69965_69993[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69960 === (13))){
var inst_69925 = (state_69959[(7)]);
var state_69959__$1 = state_69959;
var statearr_69966_69994 = state_69959__$1;
(statearr_69966_69994[(2)] = inst_69925);

(statearr_69966_69994[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69960 === (6))){
var state_69959__$1 = state_69959;
var statearr_69967_69995 = state_69959__$1;
(statearr_69967_69995[(2)] = false);

(statearr_69967_69995[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69960 === (3))){
var inst_69957 = (state_69959[(2)]);
var state_69959__$1 = state_69959;
return cljs.core.async.impl.ioc_helpers.return_chan(state_69959__$1,inst_69957);
} else {
if((state_val_69960 === (12))){
var inst_69925 = (state_69959[(7)]);
var inst_69923 = (state_69959[(2)]);
var inst_69924 = fluree.db.util.async.throw_err(inst_69923);
var inst_69925__$1 = cljs.core.not_empty(inst_69924);
var state_69959__$1 = (function (){var statearr_69968 = state_69959;
(statearr_69968[(7)] = inst_69925__$1);

return statearr_69968;
})();
if(cljs.core.truth_(inst_69925__$1)){
var statearr_69969_69996 = state_69959__$1;
(statearr_69969_69996[(1)] = (13));

} else {
var statearr_69970_69997 = state_69959__$1;
(statearr_69970_69997[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69960 === (2))){
var _ = (function (){var statearr_69971 = state_69959;
(statearr_69971[(4)] = cljs.core.cons((5),(state_69959[(4)])));

return statearr_69971;
})();
var inst_69895 = (auth_id == null);
var state_69959__$1 = state_69959;
if(cljs.core.truth_(inst_69895)){
var statearr_69972_69998 = state_69959__$1;
(statearr_69972_69998[(1)] = (6));

} else {
var statearr_69973_69999 = state_69959__$1;
(statearr_69973_69999[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69960 === (11))){
var inst_69905 = (state_69959[(8)]);
var inst_69905__$1 = (state_69959[(2)]);
var inst_69906 = [new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.Keyword(null,"where","where",-2044795965),new cljs.core.Keyword(null,"opts","opts",155075701)];
var inst_69907 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_69908 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_69909 = ["?role","_role/id","root"];
var inst_69910 = (new cljs.core.PersistentVector(null,3,(5),inst_69908,inst_69909,null));
var inst_69911 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_69912 = [inst_69905__$1,"_auth/roles","?role"];
var inst_69913 = (new cljs.core.PersistentVector(null,3,(5),inst_69911,inst_69912,null));
var inst_69914 = [inst_69910,inst_69913];
var inst_69915 = (new cljs.core.PersistentVector(null,2,(5),inst_69907,inst_69914,null));
var inst_69916 = [new cljs.core.Keyword(null,"cache","cache",-1237023054)];
var inst_69917 = [true];
var inst_69918 = cljs.core.PersistentHashMap.fromArrays(inst_69916,inst_69917);
var inst_69919 = ["?role",inst_69915,inst_69918];
var inst_69920 = cljs.core.PersistentHashMap.fromArrays(inst_69906,inst_69919);
var inst_69921 = fluree.db.dbproto._query.cljs$core$IFn$_invoke$arity$2(db,inst_69920);
var state_69959__$1 = (function (){var statearr_69975 = state_69959;
(statearr_69975[(8)] = inst_69905__$1);

return statearr_69975;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_69959__$1,(12),inst_69921);
} else {
if((state_val_69960 === (9))){
var inst_69900 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_69901 = ["_auth/id",auth_id];
var inst_69902 = (new cljs.core.PersistentVector(null,2,(5),inst_69900,inst_69901,null));
var state_69959__$1 = state_69959;
var statearr_69976_70000 = state_69959__$1;
(statearr_69976_70000[(2)] = inst_69902);

(statearr_69976_70000[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69960 === (5))){
var _ = (function (){var statearr_69977 = state_69959;
(statearr_69977[(4)] = cljs.core.rest((state_69959[(4)])));

return statearr_69977;
})();
var state_69959__$1 = state_69959;
var ex69974 = (state_69959__$1[(2)]);
var statearr_69978_70001 = state_69959__$1;
(statearr_69978_70001[(5)] = ex69974);


if((ex69974 instanceof Error)){
var statearr_69979_70002 = state_69959__$1;
(statearr_69979_70002[(1)] = (4));

(statearr_69979_70002[(5)] = null);

} else {
throw ex69974;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69960 === (14))){
var inst_69905 = (state_69959[(8)]);
var inst_69928 = [new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.Keyword(null,"where","where",-2044795965),new cljs.core.Keyword(null,"opts","opts",155075701)];
var inst_69929 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_69930 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_69931 = ["?role","_role/id","root"];
var inst_69932 = (new cljs.core.PersistentVector(null,3,(5),inst_69930,inst_69931,null));
var inst_69933 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_69934 = ["?user","_user/auth",inst_69905];
var inst_69935 = (new cljs.core.PersistentVector(null,3,(5),inst_69933,inst_69934,null));
var inst_69936 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_69937 = ["?user","_user/roles","?roles"];
var inst_69938 = (new cljs.core.PersistentVector(null,3,(5),inst_69936,inst_69937,null));
var inst_69939 = [inst_69932,inst_69935,inst_69938];
var inst_69940 = (new cljs.core.PersistentVector(null,3,(5),inst_69929,inst_69939,null));
var inst_69941 = [new cljs.core.Keyword(null,"cache","cache",-1237023054)];
var inst_69942 = [true];
var inst_69943 = cljs.core.PersistentHashMap.fromArrays(inst_69941,inst_69942);
var inst_69944 = ["?role",inst_69940,inst_69943];
var inst_69945 = cljs.core.PersistentHashMap.fromArrays(inst_69928,inst_69944);
var inst_69946 = fluree.db.dbproto._query.cljs$core$IFn$_invoke$arity$2(db,inst_69945);
var state_69959__$1 = state_69959;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_69959__$1,(16),inst_69946);
} else {
if((state_val_69960 === (16))){
var inst_69948 = (state_69959[(2)]);
var inst_69949 = fluree.db.util.async.throw_err(inst_69948);
var inst_69950 = cljs.core.not_empty(inst_69949);
var state_69959__$1 = state_69959;
var statearr_69980_70003 = state_69959__$1;
(statearr_69980_70003[(2)] = inst_69950);

(statearr_69980_70003[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69960 === (10))){
var state_69959__$1 = state_69959;
var statearr_69981_70004 = state_69959__$1;
(statearr_69981_70004[(2)] = auth_id);

(statearr_69981_70004[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_69960 === (8))){
var inst_69954 = (state_69959[(2)]);
var _ = (function (){var statearr_69982 = state_69959;
(statearr_69982[(4)] = cljs.core.rest((state_69959[(4)])));

return statearr_69982;
})();
var state_69959__$1 = state_69959;
var statearr_69983_70005 = state_69959__$1;
(statearr_69983_70005[(2)] = inst_69954);

(statearr_69983_70005[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$auth$root_role_QMARK__$_state_machine__11410__auto__ = null;
var fluree$db$auth$root_role_QMARK__$_state_machine__11410__auto____0 = (function (){
var statearr_69984 = [null,null,null,null,null,null,null,null,null];
(statearr_69984[(0)] = fluree$db$auth$root_role_QMARK__$_state_machine__11410__auto__);

(statearr_69984[(1)] = (1));

return statearr_69984;
});
var fluree$db$auth$root_role_QMARK__$_state_machine__11410__auto____1 = (function (state_69959){
while(true){
var ret_value__11411__auto__ = (function (){try{while(true){
var result__11412__auto__ = switch__11409__auto__(state_69959);
if(cljs.core.keyword_identical_QMARK_(result__11412__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11412__auto__;
}
break;
}
}catch (e69985){var ex__11413__auto__ = e69985;
var statearr_69986_70006 = state_69959;
(statearr_69986_70006[(2)] = ex__11413__auto__);


if(cljs.core.seq((state_69959[(4)]))){
var statearr_69987_70007 = state_69959;
(statearr_69987_70007[(1)] = cljs.core.first((state_69959[(4)])));

} else {
throw ex__11413__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11411__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__70008 = state_69959;
state_69959 = G__70008;
continue;
} else {
return ret_value__11411__auto__;
}
break;
}
});
fluree$db$auth$root_role_QMARK__$_state_machine__11410__auto__ = function(state_69959){
switch(arguments.length){
case 0:
return fluree$db$auth$root_role_QMARK__$_state_machine__11410__auto____0.call(this);
case 1:
return fluree$db$auth$root_role_QMARK__$_state_machine__11410__auto____1.call(this,state_69959);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$auth$root_role_QMARK__$_state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$auth$root_role_QMARK__$_state_machine__11410__auto____0;
fluree$db$auth$root_role_QMARK__$_state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$auth$root_role_QMARK__$_state_machine__11410__auto____1;
return fluree$db$auth$root_role_QMARK__$_state_machine__11410__auto__;
})()
})();
var state__11486__auto__ = (function (){var statearr_69988 = (f__11485__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11485__auto__.cljs$core$IFn$_invoke$arity$0() : f__11485__auto__.call(null));
(statearr_69988[(6)] = c__11484__auto__);

return statearr_69988;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11486__auto__);
}));

return c__11484__auto__;
});
