// Compiled by ClojureScript 1.10.891 {:static-fns true, :optimize-constants false, :target :nodejs, :nodejs-rt false, :optimizations :advanced}
goog.provide('fluree.db.index');
goog.require('cljs.core');
goog.require('clojure.data.avl');
goog.require('fluree.db.dbproto');
goog.require('cljs.core.async');
goog.require('fluree.db.util.async');
goog.require('fluree.db.util.log');

/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.index.IndexConfig = (function (index_type,comparator,historyComparator,__meta,__extmap,__hash){
this.index_type = index_type;
this.comparator = comparator;
this.historyComparator = historyComparator;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
(fluree.db.index.IndexConfig.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4502__auto__,k__4503__auto__){
var self__ = this;
var this__4502__auto____$1 = this;
return this__4502__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4503__auto__,null);
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4504__auto__,k27674,else__4505__auto__){
var self__ = this;
var this__4504__auto____$1 = this;
var G__27678 = k27674;
var G__27678__$1 = (((G__27678 instanceof cljs.core.Keyword))?G__27678.fqn:null);
switch (G__27678__$1) {
case "index-type":
return self__.index_type;

break;
case "comparator":
return self__.comparator;

break;
case "historyComparator":
return self__.historyComparator;

break;
default:
return cljs.core.get.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k27674,else__4505__auto__);

}
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4522__auto__,f__4523__auto__,init__4524__auto__){
var self__ = this;
var this__4522__auto____$1 = this;
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (ret__4525__auto__,p__27679){
var vec__27680 = p__27679;
var k__4526__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__27680,(0),null);
var v__4527__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__27680,(1),null);
return (f__4523__auto__.cljs$core$IFn$_invoke$arity$3 ? f__4523__auto__.cljs$core$IFn$_invoke$arity$3(ret__4525__auto__,k__4526__auto__,v__4527__auto__) : f__4523__auto__.call(null,ret__4525__auto__,k__4526__auto__,v__4527__auto__));
}),init__4524__auto__,this__4522__auto____$1);
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4517__auto__,writer__4518__auto__,opts__4519__auto__){
var self__ = this;
var this__4517__auto____$1 = this;
var pr_pair__4520__auto__ = (function (keyval__4521__auto__){
return cljs.core.pr_sequential_writer(writer__4518__auto__,cljs.core.pr_writer,""," ","",opts__4519__auto__,keyval__4521__auto__);
});
return cljs.core.pr_sequential_writer(writer__4518__auto__,pr_pair__4520__auto__,"#fluree.db.index.IndexConfig{",", ","}",opts__4519__auto__,cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"index-type","index-type",500383962),self__.index_type],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"comparator","comparator",2144896662),self__.comparator],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658),self__.historyComparator],null))], null),self__.__extmap));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__27673){
var self__ = this;
var G__27673__$1 = this;
return (new cljs.core.RecordIter((0),G__27673__$1,3,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"index-type","index-type",500383962),new cljs.core.Keyword(null,"comparator","comparator",2144896662),new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658)], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator(self__.__extmap):cljs.core.nil_iter())));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4500__auto__){
var self__ = this;
var this__4500__auto____$1 = this;
return self__.__meta;
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4497__auto__){
var self__ = this;
var this__4497__auto____$1 = this;
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,self__.historyComparator,self__.__meta,self__.__extmap,self__.__hash));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4506__auto__){
var self__ = this;
var this__4506__auto____$1 = this;
return (3 + cljs.core.count(self__.__extmap));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4498__auto__){
var self__ = this;
var this__4498__auto____$1 = this;
var h__4360__auto__ = self__.__hash;
if((!((h__4360__auto__ == null)))){
return h__4360__auto__;
} else {
var h__4360__auto____$1 = (function (){var fexpr__27683 = (function (coll__4499__auto__){
return (1512230614 ^ cljs.core.hash_unordered_coll(coll__4499__auto__));
});
return fexpr__27683(this__4498__auto____$1);
})();
(self__.__hash = h__4360__auto____$1);

return h__4360__auto____$1;
}
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this27675,other27676){
var self__ = this;
var this27675__$1 = this;
return (((!((other27676 == null)))) && ((((this27675__$1.constructor === other27676.constructor)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this27675__$1.index_type,other27676.index_type)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this27675__$1.comparator,other27676.comparator)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this27675__$1.historyComparator,other27676.historyComparator)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this27675__$1.__extmap,other27676.__extmap)))))))))));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4512__auto__,k__4513__auto__){
var self__ = this;
var this__4512__auto____$1 = this;
if(cljs.core.contains_QMARK_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658),null,new cljs.core.Keyword(null,"comparator","comparator",2144896662),null,new cljs.core.Keyword(null,"index-type","index-type",500383962),null], null), null),k__4513__auto__)){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(cljs.core._with_meta(cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,this__4512__auto____$1),self__.__meta),k__4513__auto__);
} else {
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,self__.historyComparator,self__.__meta,cljs.core.not_empty(cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(self__.__extmap,k__4513__auto__)),null));
}
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IAssociative$_contains_key_QMARK_$arity$2 = (function (this__4509__auto__,k27674){
var self__ = this;
var this__4509__auto____$1 = this;
var G__27684 = k27674;
var G__27684__$1 = (((G__27684 instanceof cljs.core.Keyword))?G__27684.fqn:null);
switch (G__27684__$1) {
case "index-type":
case "comparator":
case "historyComparator":
return true;

break;
default:
return cljs.core.contains_QMARK_(self__.__extmap,k27674);

}
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4510__auto__,k__4511__auto__,G__27673){
var self__ = this;
var this__4510__auto____$1 = this;
var pred__27685 = cljs.core.keyword_identical_QMARK_;
var expr__27686 = k__4511__auto__;
if(cljs.core.truth_((function (){var G__27688 = new cljs.core.Keyword(null,"index-type","index-type",500383962);
var G__27689 = expr__27686;
return (pred__27685.cljs$core$IFn$_invoke$arity$2 ? pred__27685.cljs$core$IFn$_invoke$arity$2(G__27688,G__27689) : pred__27685.call(null,G__27688,G__27689));
})())){
return (new fluree.db.index.IndexConfig(G__27673,self__.comparator,self__.historyComparator,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__27690 = new cljs.core.Keyword(null,"comparator","comparator",2144896662);
var G__27691 = expr__27686;
return (pred__27685.cljs$core$IFn$_invoke$arity$2 ? pred__27685.cljs$core$IFn$_invoke$arity$2(G__27690,G__27691) : pred__27685.call(null,G__27690,G__27691));
})())){
return (new fluree.db.index.IndexConfig(self__.index_type,G__27673,self__.historyComparator,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__27692 = new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658);
var G__27693 = expr__27686;
return (pred__27685.cljs$core$IFn$_invoke$arity$2 ? pred__27685.cljs$core$IFn$_invoke$arity$2(G__27692,G__27693) : pred__27685.call(null,G__27692,G__27693));
})())){
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,G__27673,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,self__.historyComparator,self__.__meta,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k__4511__auto__,G__27673),null));
}
}
}
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4515__auto__){
var self__ = this;
var this__4515__auto____$1 = this;
return cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(new cljs.core.Keyword(null,"index-type","index-type",500383962),self__.index_type,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"comparator","comparator",2144896662),self__.comparator,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658),self__.historyComparator,null))], null),self__.__extmap));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4501__auto__,G__27673){
var self__ = this;
var this__4501__auto____$1 = this;
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,self__.historyComparator,G__27673,self__.__extmap,self__.__hash));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4507__auto__,entry__4508__auto__){
var self__ = this;
var this__4507__auto____$1 = this;
if(cljs.core.vector_QMARK_(entry__4508__auto__)){
return this__4507__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4508__auto__,(0)),cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4508__auto__,(1)));
} else {
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(cljs.core._conj,this__4507__auto____$1,entry__4508__auto__);
}
}));

(fluree.db.index.IndexConfig.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"index-type","index-type",2140915489,null),new cljs.core.Symbol(null,"comparator","comparator",-509539107,null),new cljs.core.Symbol(null,"historyComparator","historyComparator",236913869,null)], null);
}));

(fluree.db.index.IndexConfig.cljs$lang$type = true);

(fluree.db.index.IndexConfig.cljs$lang$ctorPrSeq = (function (this__4546__auto__){
return (new cljs.core.List(null,"fluree.db.index/IndexConfig",null,(1),null));
}));

(fluree.db.index.IndexConfig.cljs$lang$ctorPrWriter = (function (this__4546__auto__,writer__4547__auto__){
return cljs.core._write(writer__4547__auto__,"fluree.db.index/IndexConfig");
}));

/**
 * Positional factory function for fluree.db.index/IndexConfig.
 */
fluree.db.index.__GT_IndexConfig = (function fluree$db$index$__GT_IndexConfig(index_type,comparator,historyComparator){
return (new fluree.db.index.IndexConfig(index_type,comparator,historyComparator,null,null,null));
});

/**
 * Factory function for fluree.db.index/IndexConfig, taking a map of keywords to field values.
 */
fluree.db.index.map__GT_IndexConfig = (function fluree$db$index$map__GT_IndexConfig(G__27677){
var extmap__4542__auto__ = (function (){var G__27694 = cljs.core.dissoc.cljs$core$IFn$_invoke$arity$variadic(G__27677,new cljs.core.Keyword(null,"index-type","index-type",500383962),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.Keyword(null,"comparator","comparator",2144896662),new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658)], 0));
if(cljs.core.record_QMARK_(G__27677)){
return cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,G__27694);
} else {
return G__27694;
}
})();
return (new fluree.db.index.IndexConfig(new cljs.core.Keyword(null,"index-type","index-type",500383962).cljs$core$IFn$_invoke$arity$1(G__27677),new cljs.core.Keyword(null,"comparator","comparator",2144896662).cljs$core$IFn$_invoke$arity$1(G__27677),new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658).cljs$core$IFn$_invoke$arity$1(G__27677),null,cljs.core.not_empty(extmap__4542__auto__),null));
});


/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {fluree.db.dbproto.INode}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {fluree.db.dbproto.IResolve}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.index.IndexNode = (function (block,t,rhs,children,config,leftmost_QMARK_,__meta,__extmap,__hash){
this.block = block;
this.t = t;
this.rhs = rhs;
this.children = children;
this.config = config;
this.leftmost_QMARK_ = leftmost_QMARK_;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
(fluree.db.index.IndexNode.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4502__auto__,k__4503__auto__){
var self__ = this;
var this__4502__auto____$1 = this;
return this__4502__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4503__auto__,null);
}));

(fluree.db.index.IndexNode.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4504__auto__,k27698,else__4505__auto__){
var self__ = this;
var this__4504__auto____$1 = this;
var G__27702 = k27698;
var G__27702__$1 = (((G__27702 instanceof cljs.core.Keyword))?G__27702.fqn:null);
switch (G__27702__$1) {
case "block":
return self__.block;

break;
case "t":
return self__.t;

break;
case "rhs":
return self__.rhs;

break;
case "children":
return self__.children;

break;
case "config":
return self__.config;

break;
case "leftmost?":
return self__.leftmost_QMARK_;

break;
default:
return cljs.core.get.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k27698,else__4505__auto__);

}
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4522__auto__,f__4523__auto__,init__4524__auto__){
var self__ = this;
var this__4522__auto____$1 = this;
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (ret__4525__auto__,p__27703){
var vec__27704 = p__27703;
var k__4526__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__27704,(0),null);
var v__4527__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__27704,(1),null);
return (f__4523__auto__.cljs$core$IFn$_invoke$arity$3 ? f__4523__auto__.cljs$core$IFn$_invoke$arity$3(ret__4525__auto__,k__4526__auto__,v__4527__auto__) : f__4523__auto__.call(null,ret__4525__auto__,k__4526__auto__,v__4527__auto__));
}),init__4524__auto__,this__4522__auto____$1);
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4517__auto__,writer__4518__auto__,opts__4519__auto__){
var self__ = this;
var this__4517__auto____$1 = this;
var pr_pair__4520__auto__ = (function (keyval__4521__auto__){
return cljs.core.pr_sequential_writer(writer__4518__auto__,cljs.core.pr_writer,""," ","",opts__4519__auto__,keyval__4521__auto__);
});
return cljs.core.pr_sequential_writer(writer__4518__auto__,pr_pair__4520__auto__,"#fluree.db.index.IndexNode{",", ","}",opts__4519__auto__,cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"block","block",664686210),self__.block],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"t","t",-1397832519),self__.t],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"rhs","rhs",-229356739),self__.rhs],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"children","children",-940561982),self__.children],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"config","config",994861415),self__.config],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),self__.leftmost_QMARK_],null))], null),self__.__extmap));
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__27697){
var self__ = this;
var G__27697__$1 = this;
return (new cljs.core.RecordIter((0),G__27697__$1,6,new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"rhs","rhs",-229356739),new cljs.core.Keyword(null,"children","children",-940561982),new cljs.core.Keyword(null,"config","config",994861415),new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559)], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator(self__.__extmap):cljs.core.nil_iter())));
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$IResolve$ = cljs.core.PROTOCOL_SENTINEL);

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$IResolve$_resolve$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
var c__11484__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__11485__auto__ = (function (){var switch__11409__auto__ = (function (state_27708){
var state_val_27709 = (state_27708[(1)]);
if((state_val_27709 === (1))){
var state_27708__$1 = state_27708;
return cljs.core.async.impl.ioc_helpers.return_chan(state_27708__$1,this$__$1);
} else {
return null;
}
});
return (function() {
var fluree$db$index$state_machine__11410__auto__ = null;
var fluree$db$index$state_machine__11410__auto____0 = (function (){
var statearr_27710 = [null,null,null,null,null,null,null];
(statearr_27710[(0)] = fluree$db$index$state_machine__11410__auto__);

(statearr_27710[(1)] = (1));

return statearr_27710;
});
var fluree$db$index$state_machine__11410__auto____1 = (function (state_27708){
while(true){
var ret_value__11411__auto__ = (function (){try{while(true){
var result__11412__auto__ = switch__11409__auto__(state_27708);
if(cljs.core.keyword_identical_QMARK_(result__11412__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11412__auto__;
}
break;
}
}catch (e27711){var ex__11413__auto__ = e27711;
var statearr_27712_27824 = state_27708;
(statearr_27712_27824[(2)] = ex__11413__auto__);


if(cljs.core.seq((state_27708[(4)]))){
var statearr_27713_27825 = state_27708;
(statearr_27713_27825[(1)] = cljs.core.first((state_27708[(4)])));

} else {
throw ex__11413__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11411__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__27826 = state_27708;
state_27708 = G__27826;
continue;
} else {
return ret_value__11411__auto__;
}
break;
}
});
fluree$db$index$state_machine__11410__auto__ = function(state_27708){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__11410__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__11410__auto____1.call(this,state_27708);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__11410__auto____0;
fluree$db$index$state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__11410__auto____1;
return fluree$db$index$state_machine__11410__auto__;
})()
})();
var state__11486__auto__ = (function (){var statearr_27714 = (f__11485__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11485__auto__.cljs$core$IFn$_invoke$arity$0() : f__11485__auto__.call(null));
(statearr_27714[(6)] = c__11484__auto__);

return statearr_27714;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11486__auto__);
}));

return c__11484__auto__;
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$IResolve$_first_flake$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.key(cljs.core.first(self__.children));
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$IResolve$_rhs$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.rhs;
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4500__auto__){
var self__ = this;
var this__4500__auto____$1 = this;
return self__.__meta;
}));

(fluree.db.index.IndexNode.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4497__auto__){
var self__ = this;
var this__4497__auto____$1 = this;
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,self__.__hash));
}));

(fluree.db.index.IndexNode.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4506__auto__){
var self__ = this;
var this__4506__auto____$1 = this;
return (6 + cljs.core.count(self__.__extmap));
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$ = cljs.core.PROTOCOL_SENTINEL);

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$_lookup$arity$2 = (function (this$,flake){
var self__ = this;
var this$__$1 = this;
return cljs.core.val((function (){var or__4253__auto__ = clojure.data.avl.nearest(self__.children,cljs.core._LT__EQ_,flake);
if(cljs.core.truth_(or__4253__auto__)){
return or__4253__auto__;
} else {
return cljs.core.first(self__.children);
}
})());
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$_lookup_after$arity$2 = (function (_,flake){
var self__ = this;
var ___$1 = this;
return cljs.core.val((function (){var or__4253__auto__ = clojure.data.avl.nearest(self__.children,cljs.core._GT_,flake);
if(cljs.core.truth_(or__4253__auto__)){
return or__4253__auto__;
} else {
return cljs.core.last(self__.children);
}
})());
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$_lookup_leaf$arity$2 = (function (this$,flake){
var self__ = this;
var this$__$1 = this;
var c__11484__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__11485__auto__ = (function (){var switch__11409__auto__ = (function (state_27739){
var state_val_27740 = (state_27739[(1)]);
if((state_val_27740 === (7))){
var inst_27721 = (state_27739[(7)]);
var inst_27725 = fluree.db.dbproto._resolve(inst_27721);
var state_27739__$1 = state_27739;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_27739__$1,(10),inst_27725);
} else {
if((state_val_27740 === (1))){
var state_27739__$1 = state_27739;
var statearr_27741_27827 = state_27739__$1;
(statearr_27741_27827[(2)] = null);

(statearr_27741_27827[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27740 === (4))){
var inst_27715 = (state_27739[(2)]);
var state_27739__$1 = state_27739;
var statearr_27742_27828 = state_27739__$1;
(statearr_27742_27828[(2)] = inst_27715);

(statearr_27742_27828[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27740 === (6))){
var inst_27721 = (state_27739[(7)]);
var state_27739__$1 = state_27739;
var statearr_27743_27829 = state_27739__$1;
(statearr_27743_27829[(2)] = inst_27721);

(statearr_27743_27829[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27740 === (3))){
var inst_27737 = (state_27739[(2)]);
var state_27739__$1 = state_27739;
return cljs.core.async.impl.ioc_helpers.return_chan(state_27739__$1,inst_27737);
} else {
if((state_val_27740 === (2))){
var inst_27721 = (state_27739[(7)]);
var _ = (function (){var statearr_27745 = state_27739;
(statearr_27745[(4)] = cljs.core.cons((5),(state_27739[(4)])));

return statearr_27745;
})();
var inst_27721__$1 = this$__$1.fluree$db$dbproto$INode$_lookup$arity$2(null,flake);
var inst_27722 = new cljs.core.Keyword(null,"leaf","leaf",1306118732).cljs$core$IFn$_invoke$arity$1(inst_27721__$1);
var state_27739__$1 = (function (){var statearr_27746 = state_27739;
(statearr_27746[(7)] = inst_27721__$1);

return statearr_27746;
})();
if(cljs.core.truth_(inst_27722)){
var statearr_27747_27830 = state_27739__$1;
(statearr_27747_27830[(1)] = (6));

} else {
var statearr_27748_27831 = state_27739__$1;
(statearr_27748_27831[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27740 === (9))){
var inst_27731 = (state_27739[(2)]);
var inst_27732 = fluree.db.util.async.throw_err(inst_27731);
var state_27739__$1 = state_27739;
var statearr_27749_27832 = state_27739__$1;
(statearr_27749_27832[(2)] = inst_27732);

(statearr_27749_27832[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27740 === (5))){
var _ = (function (){var statearr_27750 = state_27739;
(statearr_27750[(4)] = cljs.core.rest((state_27739[(4)])));

return statearr_27750;
})();
var state_27739__$1 = state_27739;
var ex27744 = (state_27739__$1[(2)]);
var statearr_27751_27833 = state_27739__$1;
(statearr_27751_27833[(5)] = ex27744);


if((ex27744 instanceof Error)){
var statearr_27752_27834 = state_27739__$1;
(statearr_27752_27834[(1)] = (4));

(statearr_27752_27834[(5)] = null);

} else {
throw ex27744;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27740 === (10))){
var inst_27727 = (state_27739[(2)]);
var inst_27728 = fluree.db.util.async.throw_err(inst_27727);
var inst_27729 = fluree.db.dbproto._lookup_leaf(inst_27728,flake);
var state_27739__$1 = state_27739;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_27739__$1,(9),inst_27729);
} else {
if((state_val_27740 === (8))){
var inst_27734 = (state_27739[(2)]);
var _ = (function (){var statearr_27753 = state_27739;
(statearr_27753[(4)] = cljs.core.rest((state_27739[(4)])));

return statearr_27753;
})();
var state_27739__$1 = state_27739;
var statearr_27754_27835 = state_27739__$1;
(statearr_27754_27835[(2)] = inst_27734);

(statearr_27754_27835[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$index$state_machine__11410__auto__ = null;
var fluree$db$index$state_machine__11410__auto____0 = (function (){
var statearr_27755 = [null,null,null,null,null,null,null,null];
(statearr_27755[(0)] = fluree$db$index$state_machine__11410__auto__);

(statearr_27755[(1)] = (1));

return statearr_27755;
});
var fluree$db$index$state_machine__11410__auto____1 = (function (state_27739){
while(true){
var ret_value__11411__auto__ = (function (){try{while(true){
var result__11412__auto__ = switch__11409__auto__(state_27739);
if(cljs.core.keyword_identical_QMARK_(result__11412__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11412__auto__;
}
break;
}
}catch (e27756){var ex__11413__auto__ = e27756;
var statearr_27757_27836 = state_27739;
(statearr_27757_27836[(2)] = ex__11413__auto__);


if(cljs.core.seq((state_27739[(4)]))){
var statearr_27758_27837 = state_27739;
(statearr_27758_27837[(1)] = cljs.core.first((state_27739[(4)])));

} else {
throw ex__11413__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11411__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__27838 = state_27739;
state_27739 = G__27838;
continue;
} else {
return ret_value__11411__auto__;
}
break;
}
});
fluree$db$index$state_machine__11410__auto__ = function(state_27739){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__11410__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__11410__auto____1.call(this,state_27739);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__11410__auto____0;
fluree$db$index$state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__11410__auto____1;
return fluree$db$index$state_machine__11410__auto__;
})()
})();
var state__11486__auto__ = (function (){var statearr_27759 = (f__11485__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11485__auto__.cljs$core$IFn$_invoke$arity$0() : f__11485__auto__.call(null));
(statearr_27759[(6)] = c__11484__auto__);

return statearr_27759;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11486__auto__);
}));

return c__11484__auto__;
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$_lookup_leaf_after$arity$2 = (function (this$,flake){
var self__ = this;
var this$__$1 = this;
var c__11484__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__11485__auto__ = (function (){var switch__11409__auto__ = (function (state_27784){
var state_val_27785 = (state_27784[(1)]);
if((state_val_27785 === (7))){
var inst_27766 = (state_27784[(7)]);
var inst_27770 = fluree.db.dbproto._resolve(inst_27766);
var state_27784__$1 = state_27784;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_27784__$1,(10),inst_27770);
} else {
if((state_val_27785 === (1))){
var state_27784__$1 = state_27784;
var statearr_27786_27839 = state_27784__$1;
(statearr_27786_27839[(2)] = null);

(statearr_27786_27839[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27785 === (4))){
var inst_27760 = (state_27784[(2)]);
var state_27784__$1 = state_27784;
var statearr_27787_27840 = state_27784__$1;
(statearr_27787_27840[(2)] = inst_27760);

(statearr_27787_27840[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27785 === (6))){
var inst_27766 = (state_27784[(7)]);
var state_27784__$1 = state_27784;
var statearr_27788_27841 = state_27784__$1;
(statearr_27788_27841[(2)] = inst_27766);

(statearr_27788_27841[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27785 === (3))){
var inst_27782 = (state_27784[(2)]);
var state_27784__$1 = state_27784;
return cljs.core.async.impl.ioc_helpers.return_chan(state_27784__$1,inst_27782);
} else {
if((state_val_27785 === (2))){
var inst_27766 = (state_27784[(7)]);
var _ = (function (){var statearr_27790 = state_27784;
(statearr_27790[(4)] = cljs.core.cons((5),(state_27784[(4)])));

return statearr_27790;
})();
var inst_27766__$1 = this$__$1.fluree$db$dbproto$INode$_lookup_after$arity$2(null,flake);
var inst_27767 = new cljs.core.Keyword(null,"leaf","leaf",1306118732).cljs$core$IFn$_invoke$arity$1(inst_27766__$1);
var state_27784__$1 = (function (){var statearr_27791 = state_27784;
(statearr_27791[(7)] = inst_27766__$1);

return statearr_27791;
})();
if(cljs.core.truth_(inst_27767)){
var statearr_27792_27842 = state_27784__$1;
(statearr_27792_27842[(1)] = (6));

} else {
var statearr_27793_27843 = state_27784__$1;
(statearr_27793_27843[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27785 === (9))){
var inst_27776 = (state_27784[(2)]);
var inst_27777 = fluree.db.util.async.throw_err(inst_27776);
var state_27784__$1 = state_27784;
var statearr_27794_27844 = state_27784__$1;
(statearr_27794_27844[(2)] = inst_27777);

(statearr_27794_27844[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27785 === (5))){
var _ = (function (){var statearr_27795 = state_27784;
(statearr_27795[(4)] = cljs.core.rest((state_27784[(4)])));

return statearr_27795;
})();
var state_27784__$1 = state_27784;
var ex27789 = (state_27784__$1[(2)]);
var statearr_27796_27845 = state_27784__$1;
(statearr_27796_27845[(5)] = ex27789);


if((ex27789 instanceof Error)){
var statearr_27797_27846 = state_27784__$1;
(statearr_27797_27846[(1)] = (4));

(statearr_27797_27846[(5)] = null);

} else {
throw ex27789;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27785 === (10))){
var inst_27772 = (state_27784[(2)]);
var inst_27773 = fluree.db.util.async.throw_err(inst_27772);
var inst_27774 = fluree.db.dbproto._lookup_leaf_after(inst_27773,flake);
var state_27784__$1 = state_27784;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_27784__$1,(9),inst_27774);
} else {
if((state_val_27785 === (8))){
var inst_27779 = (state_27784[(2)]);
var _ = (function (){var statearr_27798 = state_27784;
(statearr_27798[(4)] = cljs.core.rest((state_27784[(4)])));

return statearr_27798;
})();
var state_27784__$1 = state_27784;
var statearr_27799_27847 = state_27784__$1;
(statearr_27799_27847[(2)] = inst_27779);

(statearr_27799_27847[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$index$state_machine__11410__auto__ = null;
var fluree$db$index$state_machine__11410__auto____0 = (function (){
var statearr_27800 = [null,null,null,null,null,null,null,null];
(statearr_27800[(0)] = fluree$db$index$state_machine__11410__auto__);

(statearr_27800[(1)] = (1));

return statearr_27800;
});
var fluree$db$index$state_machine__11410__auto____1 = (function (state_27784){
while(true){
var ret_value__11411__auto__ = (function (){try{while(true){
var result__11412__auto__ = switch__11409__auto__(state_27784);
if(cljs.core.keyword_identical_QMARK_(result__11412__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11412__auto__;
}
break;
}
}catch (e27801){var ex__11413__auto__ = e27801;
var statearr_27802_27848 = state_27784;
(statearr_27802_27848[(2)] = ex__11413__auto__);


if(cljs.core.seq((state_27784[(4)]))){
var statearr_27803_27849 = state_27784;
(statearr_27803_27849[(1)] = cljs.core.first((state_27784[(4)])));

} else {
throw ex__11413__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11411__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__27850 = state_27784;
state_27784 = G__27850;
continue;
} else {
return ret_value__11411__auto__;
}
break;
}
});
fluree$db$index$state_machine__11410__auto__ = function(state_27784){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__11410__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__11410__auto____1.call(this,state_27784);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__11410__auto____0;
fluree$db$index$state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__11410__auto____1;
return fluree$db$index$state_machine__11410__auto__;
})()
})();
var state__11486__auto__ = (function (){var statearr_27804 = (f__11485__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11485__auto__.cljs$core$IFn$_invoke$arity$0() : f__11485__auto__.call(null));
(statearr_27804[(6)] = c__11484__auto__);

return statearr_27804;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11486__auto__);
}));

return c__11484__auto__;
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4498__auto__){
var self__ = this;
var this__4498__auto____$1 = this;
var h__4360__auto__ = self__.__hash;
if((!((h__4360__auto__ == null)))){
return h__4360__auto__;
} else {
var h__4360__auto____$1 = (function (){var fexpr__27805 = (function (coll__4499__auto__){
return (659789215 ^ cljs.core.hash_unordered_coll(coll__4499__auto__));
});
return fexpr__27805(this__4498__auto____$1);
})();
(self__.__hash = h__4360__auto____$1);

return h__4360__auto____$1;
}
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this27699,other27700){
var self__ = this;
var this27699__$1 = this;
return (((!((other27700 == null)))) && ((((this27699__$1.constructor === other27700.constructor)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this27699__$1.block,other27700.block)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this27699__$1.t,other27700.t)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this27699__$1.rhs,other27700.rhs)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this27699__$1.children,other27700.children)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this27699__$1.config,other27700.config)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this27699__$1.leftmost_QMARK_,other27700.leftmost_QMARK_)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this27699__$1.__extmap,other27700.__extmap)))))))))))))))));
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4512__auto__,k__4513__auto__){
var self__ = this;
var this__4512__auto____$1 = this;
if(cljs.core.contains_QMARK_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"children","children",-940561982),null,new cljs.core.Keyword(null,"block","block",664686210),null,new cljs.core.Keyword(null,"config","config",994861415),null,new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),null,new cljs.core.Keyword(null,"t","t",-1397832519),null,new cljs.core.Keyword(null,"rhs","rhs",-229356739),null], null), null),k__4513__auto__)){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(cljs.core._with_meta(cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,this__4512__auto____$1),self__.__meta),k__4513__auto__);
} else {
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,cljs.core.not_empty(cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(self__.__extmap,k__4513__auto__)),null));
}
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IAssociative$_contains_key_QMARK_$arity$2 = (function (this__4509__auto__,k27698){
var self__ = this;
var this__4509__auto____$1 = this;
var G__27806 = k27698;
var G__27806__$1 = (((G__27806 instanceof cljs.core.Keyword))?G__27806.fqn:null);
switch (G__27806__$1) {
case "block":
case "t":
case "rhs":
case "children":
case "config":
case "leftmost?":
return true;

break;
default:
return cljs.core.contains_QMARK_(self__.__extmap,k27698);

}
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4510__auto__,k__4511__auto__,G__27697){
var self__ = this;
var this__4510__auto____$1 = this;
var pred__27807 = cljs.core.keyword_identical_QMARK_;
var expr__27808 = k__4511__auto__;
if(cljs.core.truth_((function (){var G__27810 = new cljs.core.Keyword(null,"block","block",664686210);
var G__27811 = expr__27808;
return (pred__27807.cljs$core$IFn$_invoke$arity$2 ? pred__27807.cljs$core$IFn$_invoke$arity$2(G__27810,G__27811) : pred__27807.call(null,G__27810,G__27811));
})())){
return (new fluree.db.index.IndexNode(G__27697,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__27812 = new cljs.core.Keyword(null,"t","t",-1397832519);
var G__27813 = expr__27808;
return (pred__27807.cljs$core$IFn$_invoke$arity$2 ? pred__27807.cljs$core$IFn$_invoke$arity$2(G__27812,G__27813) : pred__27807.call(null,G__27812,G__27813));
})())){
return (new fluree.db.index.IndexNode(self__.block,G__27697,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__27814 = new cljs.core.Keyword(null,"rhs","rhs",-229356739);
var G__27815 = expr__27808;
return (pred__27807.cljs$core$IFn$_invoke$arity$2 ? pred__27807.cljs$core$IFn$_invoke$arity$2(G__27814,G__27815) : pred__27807.call(null,G__27814,G__27815));
})())){
return (new fluree.db.index.IndexNode(self__.block,self__.t,G__27697,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__27816 = new cljs.core.Keyword(null,"children","children",-940561982);
var G__27817 = expr__27808;
return (pred__27807.cljs$core$IFn$_invoke$arity$2 ? pred__27807.cljs$core$IFn$_invoke$arity$2(G__27816,G__27817) : pred__27807.call(null,G__27816,G__27817));
})())){
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,G__27697,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__27818 = new cljs.core.Keyword(null,"config","config",994861415);
var G__27819 = expr__27808;
return (pred__27807.cljs$core$IFn$_invoke$arity$2 ? pred__27807.cljs$core$IFn$_invoke$arity$2(G__27818,G__27819) : pred__27807.call(null,G__27818,G__27819));
})())){
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,G__27697,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__27820 = new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559);
var G__27821 = expr__27808;
return (pred__27807.cljs$core$IFn$_invoke$arity$2 ? pred__27807.cljs$core$IFn$_invoke$arity$2(G__27820,G__27821) : pred__27807.call(null,G__27820,G__27821));
})())){
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,G__27697,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k__4511__auto__,G__27697),null));
}
}
}
}
}
}
}));

(fluree.db.index.IndexNode.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4515__auto__){
var self__ = this;
var this__4515__auto____$1 = this;
return cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(new cljs.core.Keyword(null,"block","block",664686210),self__.block,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"t","t",-1397832519),self__.t,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"rhs","rhs",-229356739),self__.rhs,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"children","children",-940561982),self__.children,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"config","config",994861415),self__.config,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),self__.leftmost_QMARK_,null))], null),self__.__extmap));
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4501__auto__,G__27697){
var self__ = this;
var this__4501__auto____$1 = this;
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,G__27697,self__.__extmap,self__.__hash));
}));

(fluree.db.index.IndexNode.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4507__auto__,entry__4508__auto__){
var self__ = this;
var this__4507__auto____$1 = this;
if(cljs.core.vector_QMARK_(entry__4508__auto__)){
return this__4507__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4508__auto__,(0)),cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4508__auto__,(1)));
} else {
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(cljs.core._conj,this__4507__auto____$1,entry__4508__auto__);
}
}));

(fluree.db.index.IndexNode.getBasis = (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"block","block",-1989749559,null),new cljs.core.Symbol(null,"t","t",242699008,null),new cljs.core.Symbol(null,"rhs","rhs",1411174788,null),new cljs.core.Symbol(null,"children","children",699969545,null),new cljs.core.Symbol(null,"config","config",-1659574354,null),new cljs.core.Symbol(null,"leftmost?","leftmost?",-31657032,null)], null);
}));

(fluree.db.index.IndexNode.cljs$lang$type = true);

(fluree.db.index.IndexNode.cljs$lang$ctorPrSeq = (function (this__4546__auto__){
return (new cljs.core.List(null,"fluree.db.index/IndexNode",null,(1),null));
}));

(fluree.db.index.IndexNode.cljs$lang$ctorPrWriter = (function (this__4546__auto__,writer__4547__auto__){
return cljs.core._write(writer__4547__auto__,"fluree.db.index/IndexNode");
}));

/**
 * Positional factory function for fluree.db.index/IndexNode.
 */
fluree.db.index.__GT_IndexNode = (function fluree$db$index$__GT_IndexNode(block,t,rhs,children,config,leftmost_QMARK_){
return (new fluree.db.index.IndexNode(block,t,rhs,children,config,leftmost_QMARK_,null,null,null));
});

/**
 * Factory function for fluree.db.index/IndexNode, taking a map of keywords to field values.
 */
fluree.db.index.map__GT_IndexNode = (function fluree$db$index$map__GT_IndexNode(G__27701){
var extmap__4542__auto__ = (function (){var G__27822 = cljs.core.dissoc.cljs$core$IFn$_invoke$arity$variadic(G__27701,new cljs.core.Keyword(null,"block","block",664686210),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"rhs","rhs",-229356739),new cljs.core.Keyword(null,"children","children",-940561982),new cljs.core.Keyword(null,"config","config",994861415),new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559)], 0));
if(cljs.core.record_QMARK_(G__27701)){
return cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,G__27822);
} else {
return G__27822;
}
})();
return (new fluree.db.index.IndexNode(new cljs.core.Keyword(null,"block","block",664686210).cljs$core$IFn$_invoke$arity$1(G__27701),new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(G__27701),new cljs.core.Keyword(null,"rhs","rhs",-229356739).cljs$core$IFn$_invoke$arity$1(G__27701),new cljs.core.Keyword(null,"children","children",-940561982).cljs$core$IFn$_invoke$arity$1(G__27701),new cljs.core.Keyword(null,"config","config",994861415).cljs$core$IFn$_invoke$arity$1(G__27701),new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559).cljs$core$IFn$_invoke$arity$1(G__27701),null,cljs.core.not_empty(extmap__4542__auto__),null));
});

fluree.db.index.index_node_QMARK_ = (function fluree$db$index$index_node_QMARK_(node){
return (node instanceof fluree.db.index.IndexNode);
});

/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {fluree.db.dbproto.INode}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {fluree.db.dbproto.IResolve}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.index.DataNode = (function (block,t,flakes,rhs,config,__meta,__extmap,__hash){
this.block = block;
this.t = t;
this.flakes = flakes;
this.rhs = rhs;
this.config = config;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
(fluree.db.index.DataNode.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4502__auto__,k__4503__auto__){
var self__ = this;
var this__4502__auto____$1 = this;
return this__4502__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4503__auto__,null);
}));

(fluree.db.index.DataNode.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4504__auto__,k27853,else__4505__auto__){
var self__ = this;
var this__4504__auto____$1 = this;
var G__27857 = k27853;
var G__27857__$1 = (((G__27857 instanceof cljs.core.Keyword))?G__27857.fqn:null);
switch (G__27857__$1) {
case "block":
return self__.block;

break;
case "t":
return self__.t;

break;
case "flakes":
return self__.flakes;

break;
case "rhs":
return self__.rhs;

break;
case "config":
return self__.config;

break;
default:
return cljs.core.get.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k27853,else__4505__auto__);

}
}));

(fluree.db.index.DataNode.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4522__auto__,f__4523__auto__,init__4524__auto__){
var self__ = this;
var this__4522__auto____$1 = this;
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (ret__4525__auto__,p__27858){
var vec__27859 = p__27858;
var k__4526__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__27859,(0),null);
var v__4527__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__27859,(1),null);
return (f__4523__auto__.cljs$core$IFn$_invoke$arity$3 ? f__4523__auto__.cljs$core$IFn$_invoke$arity$3(ret__4525__auto__,k__4526__auto__,v__4527__auto__) : f__4523__auto__.call(null,ret__4525__auto__,k__4526__auto__,v__4527__auto__));
}),init__4524__auto__,this__4522__auto____$1);
}));

(fluree.db.index.DataNode.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4517__auto__,writer__4518__auto__,opts__4519__auto__){
var self__ = this;
var this__4517__auto____$1 = this;
var pr_pair__4520__auto__ = (function (keyval__4521__auto__){
return cljs.core.pr_sequential_writer(writer__4518__auto__,cljs.core.pr_writer,""," ","",opts__4519__auto__,keyval__4521__auto__);
});
return cljs.core.pr_sequential_writer(writer__4518__auto__,pr_pair__4520__auto__,"#fluree.db.index.DataNode{",", ","}",opts__4519__auto__,cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"block","block",664686210),self__.block],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"t","t",-1397832519),self__.t],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"flakes","flakes",1977895739),self__.flakes],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"rhs","rhs",-229356739),self__.rhs],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"config","config",994861415),self__.config],null))], null),self__.__extmap));
}));

(fluree.db.index.DataNode.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__27852){
var self__ = this;
var G__27852__$1 = this;
return (new cljs.core.RecordIter((0),G__27852__$1,5,new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"flakes","flakes",1977895739),new cljs.core.Keyword(null,"rhs","rhs",-229356739),new cljs.core.Keyword(null,"config","config",994861415)], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator(self__.__extmap):cljs.core.nil_iter())));
}));

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$ = cljs.core.PROTOCOL_SENTINEL);

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$_resolve$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
var c__11484__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__11485__auto__ = (function (){var switch__11409__auto__ = (function (state_27863){
var state_val_27864 = (state_27863[(1)]);
if((state_val_27864 === (1))){
var state_27863__$1 = state_27863;
return cljs.core.async.impl.ioc_helpers.return_chan(state_27863__$1,this$__$1);
} else {
return null;
}
});
return (function() {
var fluree$db$index$state_machine__11410__auto__ = null;
var fluree$db$index$state_machine__11410__auto____0 = (function (){
var statearr_27865 = [null,null,null,null,null,null,null];
(statearr_27865[(0)] = fluree$db$index$state_machine__11410__auto__);

(statearr_27865[(1)] = (1));

return statearr_27865;
});
var fluree$db$index$state_machine__11410__auto____1 = (function (state_27863){
while(true){
var ret_value__11411__auto__ = (function (){try{while(true){
var result__11412__auto__ = switch__11409__auto__(state_27863);
if(cljs.core.keyword_identical_QMARK_(result__11412__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11412__auto__;
}
break;
}
}catch (e27866){var ex__11413__auto__ = e27866;
var statearr_27867_27899 = state_27863;
(statearr_27867_27899[(2)] = ex__11413__auto__);


if(cljs.core.seq((state_27863[(4)]))){
var statearr_27868_27900 = state_27863;
(statearr_27868_27900[(1)] = cljs.core.first((state_27863[(4)])));

} else {
throw ex__11413__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11411__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__27901 = state_27863;
state_27863 = G__27901;
continue;
} else {
return ret_value__11411__auto__;
}
break;
}
});
fluree$db$index$state_machine__11410__auto__ = function(state_27863){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__11410__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__11410__auto____1.call(this,state_27863);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__11410__auto____0;
fluree$db$index$state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__11410__auto____1;
return fluree$db$index$state_machine__11410__auto__;
})()
})();
var state__11486__auto__ = (function (){var statearr_27869 = (f__11485__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11485__auto__.cljs$core$IFn$_invoke$arity$0() : f__11485__auto__.call(null));
(statearr_27869[(6)] = c__11484__auto__);

return statearr_27869;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11486__auto__);
}));

return c__11484__auto__;
}));

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$_resolve_history$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("-resolve-history called on DATA NODE!!!",cljs.core.PersistentArrayMap.EMPTY);
}));

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$_first_flake$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.first(self__.flakes);
}));

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$_rhs$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.rhs;
}));

(fluree.db.index.DataNode.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4500__auto__){
var self__ = this;
var this__4500__auto____$1 = this;
return self__.__meta;
}));

(fluree.db.index.DataNode.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4497__auto__){
var self__ = this;
var this__4497__auto____$1 = this;
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,self__.config,self__.__meta,self__.__extmap,self__.__hash));
}));

(fluree.db.index.DataNode.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4506__auto__){
var self__ = this;
var this__4506__auto____$1 = this;
return (5 + cljs.core.count(self__.__extmap));
}));

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$INode$ = cljs.core.PROTOCOL_SENTINEL);

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$INode$_lookup$arity$2 = (function (root,flake){
var self__ = this;
var root__$1 = this;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("-lookup was called on a data node, which shouldn't happen!",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(500),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","unexpected-error","db/unexpected-error",1973857597)], null));
}));

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$INode$_lookup_leaf$arity$2 = (function (root,flake){
var self__ = this;
var root__$1 = this;
fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["-lookup-leaf was called on a data node, which shouldn't happen!"], 0));

var c__11484__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__11485__auto__ = (function (){var switch__11409__auto__ = (function (state_27875){
var state_val_27876 = (state_27875[(1)]);
if((state_val_27876 === (1))){
var inst_27870 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_27871 = [(500),new cljs.core.Keyword("db","unexpected-error","db/unexpected-error",1973857597)];
var inst_27872 = cljs.core.PersistentHashMap.fromArrays(inst_27870,inst_27871);
var inst_27873 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("-lookup-leaf was called on a data node, which shouldn't happen!",inst_27872);
var state_27875__$1 = state_27875;
return cljs.core.async.impl.ioc_helpers.return_chan(state_27875__$1,inst_27873);
} else {
return null;
}
});
return (function() {
var fluree$db$index$state_machine__11410__auto__ = null;
var fluree$db$index$state_machine__11410__auto____0 = (function (){
var statearr_27877 = [null,null,null,null,null,null,null];
(statearr_27877[(0)] = fluree$db$index$state_machine__11410__auto__);

(statearr_27877[(1)] = (1));

return statearr_27877;
});
var fluree$db$index$state_machine__11410__auto____1 = (function (state_27875){
while(true){
var ret_value__11411__auto__ = (function (){try{while(true){
var result__11412__auto__ = switch__11409__auto__(state_27875);
if(cljs.core.keyword_identical_QMARK_(result__11412__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11412__auto__;
}
break;
}
}catch (e27878){var ex__11413__auto__ = e27878;
var statearr_27879_27902 = state_27875;
(statearr_27879_27902[(2)] = ex__11413__auto__);


if(cljs.core.seq((state_27875[(4)]))){
var statearr_27880_27903 = state_27875;
(statearr_27880_27903[(1)] = cljs.core.first((state_27875[(4)])));

} else {
throw ex__11413__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11411__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__27904 = state_27875;
state_27875 = G__27904;
continue;
} else {
return ret_value__11411__auto__;
}
break;
}
});
fluree$db$index$state_machine__11410__auto__ = function(state_27875){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__11410__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__11410__auto____1.call(this,state_27875);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__11410__auto____0;
fluree$db$index$state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__11410__auto____1;
return fluree$db$index$state_machine__11410__auto__;
})()
})();
var state__11486__auto__ = (function (){var statearr_27881 = (f__11485__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11485__auto__.cljs$core$IFn$_invoke$arity$0() : f__11485__auto__.call(null));
(statearr_27881[(6)] = c__11484__auto__);

return statearr_27881;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11486__auto__);
}));

return c__11484__auto__;
}));

(fluree.db.index.DataNode.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4498__auto__){
var self__ = this;
var this__4498__auto____$1 = this;
var h__4360__auto__ = self__.__hash;
if((!((h__4360__auto__ == null)))){
return h__4360__auto__;
} else {
var h__4360__auto____$1 = (function (){var fexpr__27882 = (function (coll__4499__auto__){
return (1312629141 ^ cljs.core.hash_unordered_coll(coll__4499__auto__));
});
return fexpr__27882(this__4498__auto____$1);
})();
(self__.__hash = h__4360__auto____$1);

return h__4360__auto____$1;
}
}));

(fluree.db.index.DataNode.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this27854,other27855){
var self__ = this;
var this27854__$1 = this;
return (((!((other27855 == null)))) && ((((this27854__$1.constructor === other27855.constructor)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this27854__$1.block,other27855.block)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this27854__$1.t,other27855.t)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this27854__$1.flakes,other27855.flakes)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this27854__$1.rhs,other27855.rhs)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this27854__$1.config,other27855.config)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this27854__$1.__extmap,other27855.__extmap)))))))))))))));
}));

(fluree.db.index.DataNode.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4512__auto__,k__4513__auto__){
var self__ = this;
var this__4512__auto____$1 = this;
if(cljs.core.contains_QMARK_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"block","block",664686210),null,new cljs.core.Keyword(null,"config","config",994861415),null,new cljs.core.Keyword(null,"t","t",-1397832519),null,new cljs.core.Keyword(null,"flakes","flakes",1977895739),null,new cljs.core.Keyword(null,"rhs","rhs",-229356739),null], null), null),k__4513__auto__)){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(cljs.core._with_meta(cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,this__4512__auto____$1),self__.__meta),k__4513__auto__);
} else {
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,self__.config,self__.__meta,cljs.core.not_empty(cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(self__.__extmap,k__4513__auto__)),null));
}
}));

(fluree.db.index.DataNode.prototype.cljs$core$IAssociative$_contains_key_QMARK_$arity$2 = (function (this__4509__auto__,k27853){
var self__ = this;
var this__4509__auto____$1 = this;
var G__27883 = k27853;
var G__27883__$1 = (((G__27883 instanceof cljs.core.Keyword))?G__27883.fqn:null);
switch (G__27883__$1) {
case "block":
case "t":
case "flakes":
case "rhs":
case "config":
return true;

break;
default:
return cljs.core.contains_QMARK_(self__.__extmap,k27853);

}
}));

(fluree.db.index.DataNode.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4510__auto__,k__4511__auto__,G__27852){
var self__ = this;
var this__4510__auto____$1 = this;
var pred__27884 = cljs.core.keyword_identical_QMARK_;
var expr__27885 = k__4511__auto__;
if(cljs.core.truth_((function (){var G__27887 = new cljs.core.Keyword(null,"block","block",664686210);
var G__27888 = expr__27885;
return (pred__27884.cljs$core$IFn$_invoke$arity$2 ? pred__27884.cljs$core$IFn$_invoke$arity$2(G__27887,G__27888) : pred__27884.call(null,G__27887,G__27888));
})())){
return (new fluree.db.index.DataNode(G__27852,self__.t,self__.flakes,self__.rhs,self__.config,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__27889 = new cljs.core.Keyword(null,"t","t",-1397832519);
var G__27890 = expr__27885;
return (pred__27884.cljs$core$IFn$_invoke$arity$2 ? pred__27884.cljs$core$IFn$_invoke$arity$2(G__27889,G__27890) : pred__27884.call(null,G__27889,G__27890));
})())){
return (new fluree.db.index.DataNode(self__.block,G__27852,self__.flakes,self__.rhs,self__.config,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__27891 = new cljs.core.Keyword(null,"flakes","flakes",1977895739);
var G__27892 = expr__27885;
return (pred__27884.cljs$core$IFn$_invoke$arity$2 ? pred__27884.cljs$core$IFn$_invoke$arity$2(G__27891,G__27892) : pred__27884.call(null,G__27891,G__27892));
})())){
return (new fluree.db.index.DataNode(self__.block,self__.t,G__27852,self__.rhs,self__.config,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__27893 = new cljs.core.Keyword(null,"rhs","rhs",-229356739);
var G__27894 = expr__27885;
return (pred__27884.cljs$core$IFn$_invoke$arity$2 ? pred__27884.cljs$core$IFn$_invoke$arity$2(G__27893,G__27894) : pred__27884.call(null,G__27893,G__27894));
})())){
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,G__27852,self__.config,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__27895 = new cljs.core.Keyword(null,"config","config",994861415);
var G__27896 = expr__27885;
return (pred__27884.cljs$core$IFn$_invoke$arity$2 ? pred__27884.cljs$core$IFn$_invoke$arity$2(G__27895,G__27896) : pred__27884.call(null,G__27895,G__27896));
})())){
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,G__27852,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,self__.config,self__.__meta,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k__4511__auto__,G__27852),null));
}
}
}
}
}
}));

(fluree.db.index.DataNode.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4515__auto__){
var self__ = this;
var this__4515__auto____$1 = this;
return cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(new cljs.core.Keyword(null,"block","block",664686210),self__.block,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"t","t",-1397832519),self__.t,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"flakes","flakes",1977895739),self__.flakes,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"rhs","rhs",-229356739),self__.rhs,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"config","config",994861415),self__.config,null))], null),self__.__extmap));
}));

(fluree.db.index.DataNode.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4501__auto__,G__27852){
var self__ = this;
var this__4501__auto____$1 = this;
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,self__.config,G__27852,self__.__extmap,self__.__hash));
}));

(fluree.db.index.DataNode.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4507__auto__,entry__4508__auto__){
var self__ = this;
var this__4507__auto____$1 = this;
if(cljs.core.vector_QMARK_(entry__4508__auto__)){
return this__4507__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4508__auto__,(0)),cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4508__auto__,(1)));
} else {
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(cljs.core._conj,this__4507__auto____$1,entry__4508__auto__);
}
}));

(fluree.db.index.DataNode.getBasis = (function (){
return new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"block","block",-1989749559,null),new cljs.core.Symbol(null,"t","t",242699008,null),new cljs.core.Symbol(null,"flakes","flakes",-676540030,null),new cljs.core.Symbol(null,"rhs","rhs",1411174788,null),new cljs.core.Symbol(null,"config","config",-1659574354,null)], null);
}));

(fluree.db.index.DataNode.cljs$lang$type = true);

(fluree.db.index.DataNode.cljs$lang$ctorPrSeq = (function (this__4546__auto__){
return (new cljs.core.List(null,"fluree.db.index/DataNode",null,(1),null));
}));

(fluree.db.index.DataNode.cljs$lang$ctorPrWriter = (function (this__4546__auto__,writer__4547__auto__){
return cljs.core._write(writer__4547__auto__,"fluree.db.index/DataNode");
}));

/**
 * Positional factory function for fluree.db.index/DataNode.
 */
fluree.db.index.__GT_DataNode = (function fluree$db$index$__GT_DataNode(block,t,flakes,rhs,config){
return (new fluree.db.index.DataNode(block,t,flakes,rhs,config,null,null,null));
});

/**
 * Factory function for fluree.db.index/DataNode, taking a map of keywords to field values.
 */
fluree.db.index.map__GT_DataNode = (function fluree$db$index$map__GT_DataNode(G__27856){
var extmap__4542__auto__ = (function (){var G__27897 = cljs.core.dissoc.cljs$core$IFn$_invoke$arity$variadic(G__27856,new cljs.core.Keyword(null,"block","block",664686210),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"flakes","flakes",1977895739),new cljs.core.Keyword(null,"rhs","rhs",-229356739),new cljs.core.Keyword(null,"config","config",994861415)], 0));
if(cljs.core.record_QMARK_(G__27856)){
return cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,G__27897);
} else {
return G__27897;
}
})();
return (new fluree.db.index.DataNode(new cljs.core.Keyword(null,"block","block",664686210).cljs$core$IFn$_invoke$arity$1(G__27856),new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(G__27856),new cljs.core.Keyword(null,"flakes","flakes",1977895739).cljs$core$IFn$_invoke$arity$1(G__27856),new cljs.core.Keyword(null,"rhs","rhs",-229356739).cljs$core$IFn$_invoke$arity$1(G__27856),new cljs.core.Keyword(null,"config","config",994861415).cljs$core$IFn$_invoke$arity$1(G__27856),null,cljs.core.not_empty(extmap__4542__auto__),null));
});

/**
 * Creates a new data node
 */
fluree.db.index.data_node = (function fluree$db$index$data_node(block_id,t,flakes,rhs,config){
return fluree.db.index.__GT_DataNode(block_id,t,flakes,rhs,config);
});
fluree.db.index.data_node_QMARK_ = (function fluree$db$index$data_node_QMARK_(node){
return (node instanceof fluree.db.index.DataNode);
});
