// Compiled by ClojureScript 1.10.891 {:static-fns true, :optimize-constants false, :target :nodejs, :nodejs-rt false, :optimizations :advanced}
goog.provide('fluree.db.time_travel');
goog.require('cljs.core');
goog.require('fluree.db.dbproto');
goog.require('fluree.db.util.core');
goog.require('fluree.db.query.range');
goog.require('clojure.string');
goog.require('fluree.db.flake');
goog.require('fluree.db.util.async');
goog.require('cljs.core.async');
/**
 * Given a duration, returns a ISO-8601 formatted time string of now minus duration
 */
fluree.db.time_travel.duration_parse = (function fluree$db$time_travel$duration_parse(time_str){
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("Duration timeframes not yet supported in javascript.",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","platform-support","db/platform-support",72429710)], null));
});
fluree.db.time_travel.time_to_t = (function fluree$db$time_travel$time_to_t(db,time_str){
var c__11484__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__11485__auto__ = (function (){var switch__11409__auto__ = (function (state_29773){
var state_val_29774 = (state_29773[(1)]);
if((state_val_29774 === (7))){
var state_29773__$1 = state_29773;
var statearr_29775_29817 = state_29773__$1;
(statearr_29775_29817[(2)] = time_str);

(statearr_29775_29817[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (20))){
var inst_29758 = (state_29773[(7)]);
var state_29773__$1 = state_29773;
if(cljs.core.truth_(inst_29758)){
var statearr_29776_29818 = state_29773__$1;
(statearr_29776_29818[(1)] = (22));

} else {
var statearr_29777_29819 = state_29773__$1;
(statearr_29777_29819[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (1))){
var state_29773__$1 = state_29773;
var statearr_29778_29820 = state_29773__$1;
(statearr_29778_29820[(2)] = null);

(statearr_29778_29820[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (24))){
var inst_29766 = (state_29773[(2)]);
var state_29773__$1 = state_29773;
var statearr_29779_29821 = state_29773__$1;
(statearr_29779_29821[(2)] = inst_29766);

(statearr_29779_29821[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (4))){
var inst_29712 = (state_29773[(2)]);
var state_29773__$1 = state_29773;
var statearr_29780_29822 = state_29773__$1;
(statearr_29780_29822[(2)] = inst_29712);

(statearr_29780_29822[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (15))){
var inst_29742 = (state_29773[(2)]);
var inst_29743 = fluree.db.util.async.throw_err(inst_29742);
var state_29773__$1 = state_29773;
var statearr_29781_29823 = state_29773__$1;
(statearr_29781_29823[(2)] = inst_29743);

(statearr_29781_29823[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (21))){
var inst_29768 = (state_29773[(2)]);
var _ = (function (){var statearr_29782 = state_29773;
(statearr_29782[(4)] = cljs.core.rest((state_29773[(4)])));

return statearr_29782;
})();
var state_29773__$1 = state_29773;
var statearr_29783_29824 = state_29773__$1;
(statearr_29783_29824[(2)] = inst_29768);

(statearr_29783_29824[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (13))){
var inst_29737 = (state_29773[(8)]);
var state_29773__$1 = state_29773;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_29773__$1,(15),inst_29737);
} else {
if((state_val_29774 === (22))){
var inst_29758 = (state_29773[(7)]);
var state_29773__$1 = state_29773;
var statearr_29784_29825 = state_29773__$1;
(statearr_29784_29825[(2)] = inst_29758);

(statearr_29784_29825[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (6))){
var inst_29720 = fluree.db.util.core.str__GT_epoch_ms(time_str);
var state_29773__$1 = state_29773;
var statearr_29785_29826 = state_29773__$1;
(statearr_29785_29826[(2)] = inst_29720);

(statearr_29785_29826[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (17))){
var state_29773__$1 = state_29773;
var statearr_29786_29827 = state_29773__$1;
(statearr_29786_29827[(2)] = null);

(statearr_29786_29827[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (3))){
var inst_29771 = (state_29773[(2)]);
var state_29773__$1 = state_29773;
return cljs.core.async.impl.ioc_helpers.return_chan(state_29773__$1,inst_29771);
} else {
if((state_val_29774 === (12))){
var state_29773__$1 = state_29773;
var statearr_29787_29828 = state_29773__$1;
(statearr_29787_29828[(2)] = null);

(statearr_29787_29828[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (2))){
var _ = (function (){var statearr_29788 = state_29773;
(statearr_29788[(4)] = cljs.core.cons((5),(state_29773[(4)])));

return statearr_29788;
})();
var inst_29718 = typeof time_str === 'string';
var state_29773__$1 = state_29773;
if(cljs.core.truth_(inst_29718)){
var statearr_29789_29829 = state_29773__$1;
(statearr_29789_29829[(1)] = (6));

} else {
var statearr_29790_29830 = state_29773__$1;
(statearr_29790_29830[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (23))){
var inst_29764 = new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(db);
var state_29773__$1 = state_29773;
var statearr_29791_29831 = state_29773__$1;
(statearr_29791_29831[(2)] = inst_29764);

(statearr_29791_29831[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (19))){
var inst_29759 = (state_29773[(9)]);
var state_29773__$1 = state_29773;
var statearr_29792_29832 = state_29773__$1;
(statearr_29792_29832[(2)] = inst_29759);

(statearr_29792_29832[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (11))){
var inst_29737 = (state_29773[(8)]);
var inst_29737__$1 = (state_29773[(2)]);
var inst_29738 = (inst_29737__$1 == null);
var state_29773__$1 = (function (){var statearr_29794 = state_29773;
(statearr_29794[(8)] = inst_29737__$1);

return statearr_29794;
})();
if(cljs.core.truth_(inst_29738)){
var statearr_29795_29833 = state_29773__$1;
(statearr_29795_29833[(1)] = (12));

} else {
var statearr_29796_29834 = state_29773__$1;
(statearr_29796_29834[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (9))){
var state_29773__$1 = state_29773;
var statearr_29797_29835 = state_29773__$1;
(statearr_29797_29835[(2)] = null);

(statearr_29797_29835[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (5))){
var _ = (function (){var statearr_29798 = state_29773;
(statearr_29798[(4)] = cljs.core.rest((state_29773[(4)])));

return statearr_29798;
})();
var state_29773__$1 = state_29773;
var ex29793 = (state_29773__$1[(2)]);
var statearr_29799_29836 = state_29773__$1;
(statearr_29799_29836[(5)] = ex29793);


if((ex29793 instanceof Error)){
var statearr_29800_29837 = state_29773__$1;
(statearr_29800_29837[(1)] = (4));

(statearr_29800_29837[(5)] = null);

} else {
throw ex29793;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (14))){
var inst_29745 = (state_29773[(10)]);
var inst_29745__$1 = (state_29773[(2)]);
var inst_29746 = cljs.core.empty_QMARK_(inst_29745__$1);
var state_29773__$1 = (function (){var statearr_29801 = state_29773;
(statearr_29801[(10)] = inst_29745__$1);

return statearr_29801;
})();
if(inst_29746){
var statearr_29802_29838 = state_29773__$1;
(statearr_29802_29838[(1)] = (16));

} else {
var statearr_29803_29839 = state_29773__$1;
(statearr_29803_29839[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (16))){
var inst_29723 = (state_29773[(11)]);
var inst_29748 = ["There is no data as of ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_29723)].join('');
var inst_29749 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_29750 = [(400),new cljs.core.Keyword("db","invalid-block","db/invalid-block",1677435518)];
var inst_29751 = cljs.core.PersistentHashMap.fromArrays(inst_29749,inst_29750);
var inst_29752 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_29748,inst_29751);
var inst_29753 = (function(){throw inst_29752})();
var state_29773__$1 = state_29773;
var statearr_29804_29840 = state_29773__$1;
(statearr_29804_29840[(2)] = inst_29753);

(statearr_29804_29840[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (10))){
var inst_29725 = (state_29773[(12)]);
var inst_29723 = (state_29773[(11)]);
var inst_29729 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_29730 = ["_block/instant",(0)];
var inst_29731 = (new cljs.core.PersistentVector(null,2,(5),inst_29729,inst_29730,null));
var inst_29732 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_29733 = ["_block/instant",inst_29723];
var inst_29734 = (new cljs.core.PersistentVector(null,2,(5),inst_29732,inst_29733,null));
var inst_29735 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$6(inst_29725,new cljs.core.Keyword(null,"post","post",269697687),cljs.core._GT_,inst_29731,cljs.core._LT_,inst_29734);
var state_29773__$1 = state_29773;
var statearr_29805_29841 = state_29773__$1;
(statearr_29805_29841[(2)] = inst_29735);

(statearr_29805_29841[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (18))){
var inst_29723 = (state_29773[(11)]);
var inst_29759 = (state_29773[(9)]);
var inst_29758 = (state_29773[(7)]);
var inst_29745 = (state_29773[(10)]);
var inst_29756 = (state_29773[(2)]);
var inst_29757 = (function (){var epoch_as_of = inst_29723;
var ts = inst_29745;
var _ = inst_29756;
return (function (p1__29711_SHARP_){
return p1__29711_SHARP_.s;
});
})();
var inst_29758__$1 = cljs.core.apply.cljs$core$IFn$_invoke$arity$3(cljs.core.min_key,inst_29757,inst_29745);
var inst_29759__$1 = inst_29758__$1.s;
var state_29773__$1 = (function (){var statearr_29806 = state_29773;
(statearr_29806[(9)] = inst_29759__$1);

(statearr_29806[(7)] = inst_29758__$1);

return statearr_29806;
})();
if(cljs.core.truth_(inst_29759__$1)){
var statearr_29807_29842 = state_29773__$1;
(statearr_29807_29842[(1)] = (19));

} else {
var statearr_29808_29843 = state_29773__$1;
(statearr_29808_29843[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29774 === (8))){
var inst_29725 = (state_29773[(12)]);
var inst_29723 = (state_29773[(2)]);
var inst_29725__$1 = fluree.db.dbproto._rootdb(db);
var inst_29726 = (inst_29725__$1 == null);
var state_29773__$1 = (function (){var statearr_29809 = state_29773;
(statearr_29809[(12)] = inst_29725__$1);

(statearr_29809[(11)] = inst_29723);

return statearr_29809;
})();
if(cljs.core.truth_(inst_29726)){
var statearr_29810_29844 = state_29773__$1;
(statearr_29810_29844[(1)] = (9));

} else {
var statearr_29811_29845 = state_29773__$1;
(statearr_29811_29845[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$time_travel$time_to_t_$_state_machine__11410__auto__ = null;
var fluree$db$time_travel$time_to_t_$_state_machine__11410__auto____0 = (function (){
var statearr_29812 = [null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_29812[(0)] = fluree$db$time_travel$time_to_t_$_state_machine__11410__auto__);

(statearr_29812[(1)] = (1));

return statearr_29812;
});
var fluree$db$time_travel$time_to_t_$_state_machine__11410__auto____1 = (function (state_29773){
while(true){
var ret_value__11411__auto__ = (function (){try{while(true){
var result__11412__auto__ = switch__11409__auto__(state_29773);
if(cljs.core.keyword_identical_QMARK_(result__11412__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11412__auto__;
}
break;
}
}catch (e29813){var ex__11413__auto__ = e29813;
var statearr_29814_29846 = state_29773;
(statearr_29814_29846[(2)] = ex__11413__auto__);


if(cljs.core.seq((state_29773[(4)]))){
var statearr_29815_29847 = state_29773;
(statearr_29815_29847[(1)] = cljs.core.first((state_29773[(4)])));

} else {
throw ex__11413__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11411__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__29848 = state_29773;
state_29773 = G__29848;
continue;
} else {
return ret_value__11411__auto__;
}
break;
}
});
fluree$db$time_travel$time_to_t_$_state_machine__11410__auto__ = function(state_29773){
switch(arguments.length){
case 0:
return fluree$db$time_travel$time_to_t_$_state_machine__11410__auto____0.call(this);
case 1:
return fluree$db$time_travel$time_to_t_$_state_machine__11410__auto____1.call(this,state_29773);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$time_travel$time_to_t_$_state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$time_travel$time_to_t_$_state_machine__11410__auto____0;
fluree$db$time_travel$time_to_t_$_state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$time_travel$time_to_t_$_state_machine__11410__auto____1;
return fluree$db$time_travel$time_to_t_$_state_machine__11410__auto__;
})()
})();
var state__11486__auto__ = (function (){var statearr_29816 = (f__11485__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11485__auto__.cljs$core$IFn$_invoke$arity$0() : f__11485__auto__.call(null));
(statearr_29816[(6)] = c__11484__auto__);

return statearr_29816;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11486__auto__);
}));

return c__11484__auto__;
});
fluree.db.time_travel.t_to_block = (function fluree$db$time_travel$t_to_block(db,t){
var c__11484__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__11485__auto__ = (function (){var switch__11409__auto__ = (function (state_29903){
var state_val_29904 = (state_29903[(1)]);
if((state_val_29904 === (7))){
var inst_29857 = (state_29903[(7)]);
var inst_29861 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_29862 = ["_block/number",t];
var inst_29863 = (new cljs.core.PersistentVector(null,2,(5),inst_29861,inst_29862,null));
var inst_29864 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_29865 = ["_block/number"];
var inst_29866 = (new cljs.core.PersistentVector(null,1,(5),inst_29864,inst_29865,null));
var inst_29867 = [new cljs.core.Keyword(null,"limit","limit",-1355822363)];
var inst_29868 = [(1)];
var inst_29869 = cljs.core.PersistentHashMap.fromArrays(inst_29867,inst_29868);
var inst_29870 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$7(inst_29857,new cljs.core.Keyword(null,"psot","psot",2111653059),cljs.core._GT__EQ_,inst_29863,cljs.core._LT__EQ_,inst_29866,inst_29869);
var state_29903__$1 = state_29903;
var statearr_29905_29944 = state_29903__$1;
(statearr_29905_29944[(2)] = inst_29870);

(statearr_29905_29944[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29904 === (20))){
var state_29903__$1 = state_29903;
var statearr_29906_29945 = state_29903__$1;
(statearr_29906_29945[(2)] = (1));

(statearr_29906_29945[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29904 === (1))){
var state_29903__$1 = state_29903;
var statearr_29907_29946 = state_29903__$1;
(statearr_29907_29946[(2)] = null);

(statearr_29907_29946[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29904 === (4))){
var inst_29850 = (state_29903[(2)]);
var state_29903__$1 = state_29903;
var statearr_29908_29947 = state_29903__$1;
(statearr_29908_29947[(2)] = inst_29850);

(statearr_29908_29947[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29904 === (15))){
var inst_29886 = (state_29903[(8)]);
var inst_29886__$1 = (state_29903[(2)]);
var inst_29887 = (inst_29886__$1 == null);
var state_29903__$1 = (function (){var statearr_29909 = state_29903;
(statearr_29909[(8)] = inst_29886__$1);

return statearr_29909;
})();
if(cljs.core.truth_(inst_29887)){
var statearr_29910_29948 = state_29903__$1;
(statearr_29910_29948[(1)] = (16));

} else {
var statearr_29911_29949 = state_29903__$1;
(statearr_29911_29949[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29904 === (21))){
var inst_29898 = (state_29903[(2)]);
var _ = (function (){var statearr_29912 = state_29903;
(statearr_29912[(4)] = cljs.core.rest((state_29903[(4)])));

return statearr_29912;
})();
var state_29903__$1 = state_29903;
var statearr_29913_29950 = state_29903__$1;
(statearr_29913_29950[(2)] = inst_29898);

(statearr_29913_29950[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29904 === (13))){
var state_29903__$1 = state_29903;
var statearr_29914_29951 = state_29903__$1;
(statearr_29914_29951[(2)] = null);

(statearr_29914_29951[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29904 === (6))){
var state_29903__$1 = state_29903;
var statearr_29915_29952 = state_29903__$1;
(statearr_29915_29952[(2)] = null);

(statearr_29915_29952[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29904 === (17))){
var inst_29886 = (state_29903[(8)]);
var inst_29890 = (function (){var G__29856 = inst_29886;
return (function (p1__29849_SHARP_){
var f = p1__29849_SHARP_;
return f.o;
});
})();
var inst_29891 = (inst_29890.cljs$core$IFn$_invoke$arity$1 ? inst_29890.cljs$core$IFn$_invoke$arity$1(inst_29886) : inst_29890.call(null,inst_29886));
var state_29903__$1 = state_29903;
var statearr_29916_29953 = state_29903__$1;
(statearr_29916_29953[(2)] = inst_29891);

(statearr_29916_29953[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29904 === (3))){
var inst_29901 = (state_29903[(2)]);
var state_29903__$1 = state_29903;
return cljs.core.async.impl.ioc_helpers.return_chan(state_29903__$1,inst_29901);
} else {
if((state_val_29904 === (12))){
var inst_29877 = (state_29903[(2)]);
var inst_29878 = fluree.db.util.async.throw_err(inst_29877);
var state_29903__$1 = state_29903;
var statearr_29917_29954 = state_29903__$1;
(statearr_29917_29954[(2)] = inst_29878);

(statearr_29917_29954[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29904 === (2))){
var inst_29857 = (state_29903[(7)]);
var _ = (function (){var statearr_29918 = state_29903;
(statearr_29918[(4)] = cljs.core.cons((5),(state_29903[(4)])));

return statearr_29918;
})();
var inst_29857__$1 = fluree.db.dbproto._rootdb(db);
var inst_29858 = (inst_29857__$1 == null);
var state_29903__$1 = (function (){var statearr_29919 = state_29903;
(statearr_29919[(7)] = inst_29857__$1);

return statearr_29919;
})();
if(cljs.core.truth_(inst_29858)){
var statearr_29920_29955 = state_29903__$1;
(statearr_29920_29955[(1)] = (6));

} else {
var statearr_29921_29956 = state_29903__$1;
(statearr_29921_29956[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29904 === (19))){
var inst_29893 = (state_29903[(9)]);
var state_29903__$1 = state_29903;
var statearr_29922_29957 = state_29903__$1;
(statearr_29922_29957[(2)] = inst_29893);

(statearr_29922_29957[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29904 === (11))){
var inst_29880 = (state_29903[(10)]);
var inst_29880__$1 = (state_29903[(2)]);
var inst_29881 = (inst_29880__$1 == null);
var state_29903__$1 = (function (){var statearr_29924 = state_29903;
(statearr_29924[(10)] = inst_29880__$1);

return statearr_29924;
})();
if(cljs.core.truth_(inst_29881)){
var statearr_29925_29958 = state_29903__$1;
(statearr_29925_29958[(1)] = (13));

} else {
var statearr_29926_29959 = state_29903__$1;
(statearr_29926_29959[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29904 === (9))){
var state_29903__$1 = state_29903;
var statearr_29927_29960 = state_29903__$1;
(statearr_29927_29960[(2)] = null);

(statearr_29927_29960[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29904 === (5))){
var _ = (function (){var statearr_29928 = state_29903;
(statearr_29928[(4)] = cljs.core.rest((state_29903[(4)])));

return statearr_29928;
})();
var state_29903__$1 = state_29903;
var ex29923 = (state_29903__$1[(2)]);
var statearr_29929_29961 = state_29903__$1;
(statearr_29929_29961[(5)] = ex29923);


if((ex29923 instanceof Error)){
var statearr_29930_29962 = state_29903__$1;
(statearr_29930_29962[(1)] = (4));

(statearr_29930_29962[(5)] = null);

} else {
throw ex29923;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29904 === (14))){
var inst_29880 = (state_29903[(10)]);
var inst_29884 = cljs.core.first(inst_29880);
var state_29903__$1 = state_29903;
var statearr_29931_29963 = state_29903__$1;
(statearr_29931_29963[(2)] = inst_29884);

(statearr_29931_29963[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29904 === (16))){
var state_29903__$1 = state_29903;
var statearr_29932_29964 = state_29903__$1;
(statearr_29932_29964[(2)] = null);

(statearr_29932_29964[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29904 === (10))){
var inst_29872 = (state_29903[(11)]);
var state_29903__$1 = state_29903;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_29903__$1,(12),inst_29872);
} else {
if((state_val_29904 === (18))){
var inst_29893 = (state_29903[(9)]);
var inst_29893__$1 = (state_29903[(2)]);
var inst_29894 = (inst_29893__$1 > (1));
var state_29903__$1 = (function (){var statearr_29933 = state_29903;
(statearr_29933[(9)] = inst_29893__$1);

return statearr_29933;
})();
if(cljs.core.truth_(inst_29894)){
var statearr_29934_29965 = state_29903__$1;
(statearr_29934_29965[(1)] = (19));

} else {
var statearr_29935_29966 = state_29903__$1;
(statearr_29935_29966[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_29904 === (8))){
var inst_29872 = (state_29903[(11)]);
var inst_29872__$1 = (state_29903[(2)]);
var inst_29873 = (inst_29872__$1 == null);
var state_29903__$1 = (function (){var statearr_29936 = state_29903;
(statearr_29936[(11)] = inst_29872__$1);

return statearr_29936;
})();
if(cljs.core.truth_(inst_29873)){
var statearr_29937_29967 = state_29903__$1;
(statearr_29937_29967[(1)] = (9));

} else {
var statearr_29938_29968 = state_29903__$1;
(statearr_29938_29968[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$time_travel$t_to_block_$_state_machine__11410__auto__ = null;
var fluree$db$time_travel$t_to_block_$_state_machine__11410__auto____0 = (function (){
var statearr_29939 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_29939[(0)] = fluree$db$time_travel$t_to_block_$_state_machine__11410__auto__);

(statearr_29939[(1)] = (1));

return statearr_29939;
});
var fluree$db$time_travel$t_to_block_$_state_machine__11410__auto____1 = (function (state_29903){
while(true){
var ret_value__11411__auto__ = (function (){try{while(true){
var result__11412__auto__ = switch__11409__auto__(state_29903);
if(cljs.core.keyword_identical_QMARK_(result__11412__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11412__auto__;
}
break;
}
}catch (e29940){var ex__11413__auto__ = e29940;
var statearr_29941_29969 = state_29903;
(statearr_29941_29969[(2)] = ex__11413__auto__);


if(cljs.core.seq((state_29903[(4)]))){
var statearr_29942_29970 = state_29903;
(statearr_29942_29970[(1)] = cljs.core.first((state_29903[(4)])));

} else {
throw ex__11413__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11411__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__29971 = state_29903;
state_29903 = G__29971;
continue;
} else {
return ret_value__11411__auto__;
}
break;
}
});
fluree$db$time_travel$t_to_block_$_state_machine__11410__auto__ = function(state_29903){
switch(arguments.length){
case 0:
return fluree$db$time_travel$t_to_block_$_state_machine__11410__auto____0.call(this);
case 1:
return fluree$db$time_travel$t_to_block_$_state_machine__11410__auto____1.call(this,state_29903);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$time_travel$t_to_block_$_state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$time_travel$t_to_block_$_state_machine__11410__auto____0;
fluree$db$time_travel$t_to_block_$_state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$time_travel$t_to_block_$_state_machine__11410__auto____1;
return fluree$db$time_travel$t_to_block_$_state_machine__11410__auto__;
})()
})();
var state__11486__auto__ = (function (){var statearr_29943 = (f__11485__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11485__auto__.cljs$core$IFn$_invoke$arity$0() : f__11485__auto__.call(null));
(statearr_29943[(6)] = c__11484__auto__);

return statearr_29943;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11486__auto__);
}));

return c__11484__auto__;
});
/**
 * Returns the block that any given 't' is contained within.
 */
fluree.db.time_travel.non_border_t_to_block = (function fluree$db$time_travel$non_border_t_to_block(db,t){
var c__11484__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__11485__auto__ = (function (){var switch__11409__auto__ = (function (state_30024){
var state_val_30025 = (state_30024[(1)]);
if((state_val_30025 === (7))){
var inst_29980 = (state_30024[(7)]);
var inst_29984 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_29985 = [t,"_block/transactions"];
var inst_29986 = (new cljs.core.PersistentVector(null,2,(5),inst_29984,inst_29985,null));
var inst_29987 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$4(inst_29980,new cljs.core.Keyword(null,"opst","opst",1213963058),cljs.core._EQ_,inst_29986);
var state_30024__$1 = state_30024;
var statearr_30026_30065 = state_30024__$1;
(statearr_30026_30065[(2)] = inst_29987);

(statearr_30026_30065[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30025 === (20))){
var inst_30014 = (state_30024[(8)]);
var state_30024__$1 = state_30024;
var statearr_30027_30066 = state_30024__$1;
(statearr_30027_30066[(2)] = inst_30014);

(statearr_30027_30066[(1)] = (22));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30025 === (1))){
var state_30024__$1 = state_30024;
var statearr_30028_30067 = state_30024__$1;
(statearr_30028_30067[(2)] = null);

(statearr_30028_30067[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30025 === (4))){
var inst_29973 = (state_30024[(2)]);
var state_30024__$1 = state_30024;
var statearr_30029_30068 = state_30024__$1;
(statearr_30029_30068[(2)] = inst_29973);

(statearr_30029_30068[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30025 === (15))){
var inst_30003 = (state_30024[(9)]);
var inst_30003__$1 = (state_30024[(2)]);
var inst_30004 = (inst_30003__$1 == null);
var state_30024__$1 = (function (){var statearr_30030 = state_30024;
(statearr_30030[(9)] = inst_30003__$1);

return statearr_30030;
})();
if(cljs.core.truth_(inst_30004)){
var statearr_30031_30069 = state_30024__$1;
(statearr_30031_30069[(1)] = (16));

} else {
var statearr_30032_30070 = state_30024__$1;
(statearr_30032_30070[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30025 === (21))){
var state_30024__$1 = state_30024;
var statearr_30033_30071 = state_30024__$1;
(statearr_30033_30071[(2)] = (1));

(statearr_30033_30071[(1)] = (22));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30025 === (13))){
var state_30024__$1 = state_30024;
var statearr_30034_30072 = state_30024__$1;
(statearr_30034_30072[(2)] = null);

(statearr_30034_30072[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30025 === (22))){
var inst_30019 = (state_30024[(2)]);
var _ = (function (){var statearr_30035 = state_30024;
(statearr_30035[(4)] = cljs.core.rest((state_30024[(4)])));

return statearr_30035;
})();
var state_30024__$1 = state_30024;
var statearr_30036_30073 = state_30024__$1;
(statearr_30036_30073[(2)] = inst_30019);

(statearr_30036_30073[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30025 === (6))){
var state_30024__$1 = state_30024;
var statearr_30037_30074 = state_30024__$1;
(statearr_30037_30074[(2)] = null);

(statearr_30037_30074[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30025 === (17))){
var inst_30003 = (state_30024[(9)]);
var inst_30007 = (function (){var G__29979 = inst_30003;
return (function (p1__29972_SHARP_){
var f = p1__29972_SHARP_;
return f.s;
});
})();
var inst_30008 = (inst_30007.cljs$core$IFn$_invoke$arity$1 ? inst_30007.cljs$core$IFn$_invoke$arity$1(inst_30003) : inst_30007.call(null,inst_30003));
var state_30024__$1 = state_30024;
var statearr_30038_30075 = state_30024__$1;
(statearr_30038_30075[(2)] = inst_30008);

(statearr_30038_30075[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30025 === (3))){
var inst_30022 = (state_30024[(2)]);
var state_30024__$1 = state_30024;
return cljs.core.async.impl.ioc_helpers.return_chan(state_30024__$1,inst_30022);
} else {
if((state_val_30025 === (12))){
var inst_29994 = (state_30024[(2)]);
var inst_29995 = fluree.db.util.async.throw_err(inst_29994);
var state_30024__$1 = state_30024;
var statearr_30039_30076 = state_30024__$1;
(statearr_30039_30076[(2)] = inst_29995);

(statearr_30039_30076[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30025 === (2))){
var inst_29980 = (state_30024[(7)]);
var _ = (function (){var statearr_30040 = state_30024;
(statearr_30040[(4)] = cljs.core.cons((5),(state_30024[(4)])));

return statearr_30040;
})();
var inst_29980__$1 = fluree.db.dbproto._rootdb(db);
var inst_29981 = (inst_29980__$1 == null);
var state_30024__$1 = (function (){var statearr_30041 = state_30024;
(statearr_30041[(7)] = inst_29980__$1);

return statearr_30041;
})();
if(cljs.core.truth_(inst_29981)){
var statearr_30042_30077 = state_30024__$1;
(statearr_30042_30077[(1)] = (6));

} else {
var statearr_30043_30078 = state_30024__$1;
(statearr_30043_30078[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30025 === (19))){
var inst_30014 = (state_30024[(8)]);
var inst_30013 = (state_30024[(2)]);
var inst_30014__$1 = fluree.db.util.async.throw_err(inst_30013);
var inst_30015 = (inst_30014__$1 > (1));
var state_30024__$1 = (function (){var statearr_30044 = state_30024;
(statearr_30044[(8)] = inst_30014__$1);

return statearr_30044;
})();
if(cljs.core.truth_(inst_30015)){
var statearr_30045_30079 = state_30024__$1;
(statearr_30045_30079[(1)] = (20));

} else {
var statearr_30046_30080 = state_30024__$1;
(statearr_30046_30080[(1)] = (21));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30025 === (11))){
var inst_29997 = (state_30024[(10)]);
var inst_29997__$1 = (state_30024[(2)]);
var inst_29998 = (inst_29997__$1 == null);
var state_30024__$1 = (function (){var statearr_30048 = state_30024;
(statearr_30048[(10)] = inst_29997__$1);

return statearr_30048;
})();
if(cljs.core.truth_(inst_29998)){
var statearr_30049_30081 = state_30024__$1;
(statearr_30049_30081[(1)] = (13));

} else {
var statearr_30050_30082 = state_30024__$1;
(statearr_30050_30082[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30025 === (9))){
var state_30024__$1 = state_30024;
var statearr_30051_30083 = state_30024__$1;
(statearr_30051_30083[(2)] = null);

(statearr_30051_30083[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30025 === (5))){
var _ = (function (){var statearr_30052 = state_30024;
(statearr_30052[(4)] = cljs.core.rest((state_30024[(4)])));

return statearr_30052;
})();
var state_30024__$1 = state_30024;
var ex30047 = (state_30024__$1[(2)]);
var statearr_30053_30084 = state_30024__$1;
(statearr_30053_30084[(5)] = ex30047);


if((ex30047 instanceof Error)){
var statearr_30054_30085 = state_30024__$1;
(statearr_30054_30085[(1)] = (4));

(statearr_30054_30085[(5)] = null);

} else {
throw ex30047;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30025 === (14))){
var inst_29997 = (state_30024[(10)]);
var inst_30001 = cljs.core.first(inst_29997);
var state_30024__$1 = state_30024;
var statearr_30055_30086 = state_30024__$1;
(statearr_30055_30086[(2)] = inst_30001);

(statearr_30055_30086[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30025 === (16))){
var state_30024__$1 = state_30024;
var statearr_30056_30087 = state_30024__$1;
(statearr_30056_30087[(2)] = null);

(statearr_30056_30087[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30025 === (10))){
var inst_29989 = (state_30024[(11)]);
var state_30024__$1 = state_30024;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_30024__$1,(12),inst_29989);
} else {
if((state_val_30025 === (18))){
var inst_30010 = (state_30024[(2)]);
var inst_30011 = fluree.db.time_travel.t_to_block(db,inst_30010);
var state_30024__$1 = state_30024;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_30024__$1,(19),inst_30011);
} else {
if((state_val_30025 === (8))){
var inst_29989 = (state_30024[(11)]);
var inst_29989__$1 = (state_30024[(2)]);
var inst_29990 = (inst_29989__$1 == null);
var state_30024__$1 = (function (){var statearr_30057 = state_30024;
(statearr_30057[(11)] = inst_29989__$1);

return statearr_30057;
})();
if(cljs.core.truth_(inst_29990)){
var statearr_30058_30088 = state_30024__$1;
(statearr_30058_30088[(1)] = (9));

} else {
var statearr_30059_30089 = state_30024__$1;
(statearr_30059_30089[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$time_travel$non_border_t_to_block_$_state_machine__11410__auto__ = null;
var fluree$db$time_travel$non_border_t_to_block_$_state_machine__11410__auto____0 = (function (){
var statearr_30060 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_30060[(0)] = fluree$db$time_travel$non_border_t_to_block_$_state_machine__11410__auto__);

(statearr_30060[(1)] = (1));

return statearr_30060;
});
var fluree$db$time_travel$non_border_t_to_block_$_state_machine__11410__auto____1 = (function (state_30024){
while(true){
var ret_value__11411__auto__ = (function (){try{while(true){
var result__11412__auto__ = switch__11409__auto__(state_30024);
if(cljs.core.keyword_identical_QMARK_(result__11412__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11412__auto__;
}
break;
}
}catch (e30061){var ex__11413__auto__ = e30061;
var statearr_30062_30090 = state_30024;
(statearr_30062_30090[(2)] = ex__11413__auto__);


if(cljs.core.seq((state_30024[(4)]))){
var statearr_30063_30091 = state_30024;
(statearr_30063_30091[(1)] = cljs.core.first((state_30024[(4)])));

} else {
throw ex__11413__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11411__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__30092 = state_30024;
state_30024 = G__30092;
continue;
} else {
return ret_value__11411__auto__;
}
break;
}
});
fluree$db$time_travel$non_border_t_to_block_$_state_machine__11410__auto__ = function(state_30024){
switch(arguments.length){
case 0:
return fluree$db$time_travel$non_border_t_to_block_$_state_machine__11410__auto____0.call(this);
case 1:
return fluree$db$time_travel$non_border_t_to_block_$_state_machine__11410__auto____1.call(this,state_30024);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$time_travel$non_border_t_to_block_$_state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$time_travel$non_border_t_to_block_$_state_machine__11410__auto____0;
fluree$db$time_travel$non_border_t_to_block_$_state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$time_travel$non_border_t_to_block_$_state_machine__11410__auto____1;
return fluree$db$time_travel$non_border_t_to_block_$_state_machine__11410__auto__;
})()
})();
var state__11486__auto__ = (function (){var statearr_30064 = (f__11485__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11485__auto__.cljs$core$IFn$_invoke$arity$0() : f__11485__auto__.call(null));
(statearr_30064[(6)] = c__11484__auto__);

return statearr_30064;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11486__auto__);
}));

return c__11484__auto__;
});
/**
 * Returns the block for a given time as a string (ISO-8601 formatted time or a duration).
 *   If a block (positive integer) is provided, returns it unmodified.
 */
fluree.db.time_travel.block_to_int_format = (function fluree$db$time_travel$block_to_int_format(db,time_str){
var c__11484__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__11485__auto__ = (function (){var switch__11409__auto__ = (function (state_30153){
var state_val_30154 = (state_30153[(1)]);
if((state_val_30154 === (7))){
var inst_30102 = (state_30153[(7)]);
var inst_30102__$1 = typeof time_str === 'string';
var state_30153__$1 = (function (){var statearr_30155 = state_30153;
(statearr_30155[(7)] = inst_30102__$1);

return statearr_30155;
})();
if(cljs.core.truth_(inst_30102__$1)){
var statearr_30156_30190 = state_30153__$1;
(statearr_30156_30190[(1)] = (9));

} else {
var statearr_30157_30191 = state_30153__$1;
(statearr_30157_30191[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30154 === (20))){
var inst_30125 = (state_30153[(2)]);
var inst_30126 = fluree.db.util.async.throw_err(inst_30125);
var inst_30127 = fluree.db.time_travel.t_to_block(db,inst_30126);
var state_30153__$1 = state_30153;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_30153__$1,(21),inst_30127);
} else {
if((state_val_30154 === (1))){
var state_30153__$1 = state_30153;
var statearr_30158_30192 = state_30153__$1;
(statearr_30158_30192[(2)] = null);

(statearr_30158_30192[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30154 === (24))){
var inst_30142 = (state_30153[(2)]);
var state_30153__$1 = state_30153;
var statearr_30159_30193 = state_30153__$1;
(statearr_30159_30193[(2)] = inst_30142);

(statearr_30159_30193[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30154 === (4))){
var inst_30093 = (state_30153[(2)]);
var state_30153__$1 = state_30153;
var statearr_30160_30194 = state_30153__$1;
(statearr_30160_30194[(2)] = inst_30093);

(statearr_30160_30194[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30154 === (15))){
var inst_30114 = (state_30153[(2)]);
var inst_30115 = fluree.db.util.async.throw_err(inst_30114);
var inst_30116 = fluree.db.time_travel.t_to_block(db,inst_30115);
var state_30153__$1 = state_30153;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_30153__$1,(16),inst_30116);
} else {
if((state_val_30154 === (21))){
var inst_30129 = (state_30153[(2)]);
var inst_30130 = fluree.db.util.async.throw_err(inst_30129);
var state_30153__$1 = state_30153;
var statearr_30161_30195 = state_30153__$1;
(statearr_30161_30195[(2)] = inst_30130);

(statearr_30161_30195[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30154 === (13))){
var inst_30121 = typeof time_str === 'string';
var state_30153__$1 = state_30153;
if(cljs.core.truth_(inst_30121)){
var statearr_30162_30196 = state_30153__$1;
(statearr_30162_30196[(1)] = (17));

} else {
var statearr_30163_30197 = state_30153__$1;
(statearr_30163_30197[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30154 === (22))){
var inst_30133 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([time_str], 0));
var inst_30134 = ["Invalid block key provided: ",inst_30133].join('');
var inst_30135 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_30136 = [(400),new cljs.core.Keyword("db","invalid-time","db/invalid-time",-1496866235)];
var inst_30137 = cljs.core.PersistentHashMap.fromArrays(inst_30135,inst_30136);
var inst_30138 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_30134,inst_30137);
var inst_30139 = (function(){throw inst_30138})();
var state_30153__$1 = state_30153;
var statearr_30164_30198 = state_30153__$1;
(statearr_30164_30198[(2)] = inst_30139);

(statearr_30164_30198[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30154 === (6))){
var state_30153__$1 = state_30153;
var statearr_30165_30199 = state_30153__$1;
(statearr_30165_30199[(2)] = time_str);

(statearr_30165_30199[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30154 === (17))){
var inst_30123 = fluree.db.time_travel.time_to_t(db,time_str);
var state_30153__$1 = state_30153;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_30153__$1,(20),inst_30123);
} else {
if((state_val_30154 === (3))){
var inst_30151 = (state_30153[(2)]);
var state_30153__$1 = state_30153;
return cljs.core.async.impl.ioc_helpers.return_chan(state_30153__$1,inst_30151);
} else {
if((state_val_30154 === (12))){
var inst_30111 = fluree.db.time_travel.duration_parse(time_str);
var inst_30112 = fluree.db.time_travel.time_to_t(db,inst_30111);
var state_30153__$1 = state_30153;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_30153__$1,(15),inst_30112);
} else {
if((state_val_30154 === (2))){
var _ = (function (){var statearr_30166 = state_30153;
(statearr_30166[(4)] = cljs.core.cons((5),(state_30153[(4)])));

return statearr_30166;
})();
var inst_30099 = cljs.core.pos_int_QMARK_(time_str);
var state_30153__$1 = state_30153;
if(inst_30099){
var statearr_30167_30200 = state_30153__$1;
(statearr_30167_30200[(1)] = (6));

} else {
var statearr_30168_30201 = state_30153__$1;
(statearr_30168_30201[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30154 === (23))){
var state_30153__$1 = state_30153;
var statearr_30169_30202 = state_30153__$1;
(statearr_30169_30202[(2)] = null);

(statearr_30169_30202[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30154 === (19))){
var inst_30144 = (state_30153[(2)]);
var state_30153__$1 = state_30153;
var statearr_30170_30203 = state_30153__$1;
(statearr_30170_30203[(2)] = inst_30144);

(statearr_30170_30203[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30154 === (11))){
var inst_30109 = (state_30153[(2)]);
var state_30153__$1 = state_30153;
if(cljs.core.truth_(inst_30109)){
var statearr_30172_30204 = state_30153__$1;
(statearr_30172_30204[(1)] = (12));

} else {
var statearr_30173_30205 = state_30153__$1;
(statearr_30173_30205[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30154 === (9))){
var inst_30104 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(time_str,(0));
var inst_30105 = cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_30104);
var inst_30106 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("P",inst_30105);
var state_30153__$1 = state_30153;
var statearr_30174_30206 = state_30153__$1;
(statearr_30174_30206[(2)] = inst_30106);

(statearr_30174_30206[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30154 === (5))){
var _ = (function (){var statearr_30175 = state_30153;
(statearr_30175[(4)] = cljs.core.rest((state_30153[(4)])));

return statearr_30175;
})();
var state_30153__$1 = state_30153;
var ex30171 = (state_30153__$1[(2)]);
var statearr_30176_30207 = state_30153__$1;
(statearr_30176_30207[(5)] = ex30171);


if((ex30171 instanceof Error)){
var statearr_30177_30208 = state_30153__$1;
(statearr_30177_30208[(1)] = (4));

(statearr_30177_30208[(5)] = null);

} else {
throw ex30171;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30154 === (14))){
var inst_30146 = (state_30153[(2)]);
var state_30153__$1 = state_30153;
var statearr_30178_30209 = state_30153__$1;
(statearr_30178_30209[(2)] = inst_30146);

(statearr_30178_30209[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30154 === (16))){
var inst_30118 = (state_30153[(2)]);
var inst_30119 = fluree.db.util.async.throw_err(inst_30118);
var state_30153__$1 = state_30153;
var statearr_30179_30210 = state_30153__$1;
(statearr_30179_30210[(2)] = inst_30119);

(statearr_30179_30210[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30154 === (10))){
var inst_30102 = (state_30153[(7)]);
var state_30153__$1 = state_30153;
var statearr_30180_30211 = state_30153__$1;
(statearr_30180_30211[(2)] = inst_30102);

(statearr_30180_30211[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30154 === (18))){
var state_30153__$1 = state_30153;
var statearr_30181_30212 = state_30153__$1;
(statearr_30181_30212[(1)] = (22));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30154 === (8))){
var inst_30148 = (state_30153[(2)]);
var _ = (function (){var statearr_30183 = state_30153;
(statearr_30183[(4)] = cljs.core.rest((state_30153[(4)])));

return statearr_30183;
})();
var state_30153__$1 = state_30153;
var statearr_30184_30213 = state_30153__$1;
(statearr_30184_30213[(2)] = inst_30148);

(statearr_30184_30213[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$time_travel$block_to_int_format_$_state_machine__11410__auto__ = null;
var fluree$db$time_travel$block_to_int_format_$_state_machine__11410__auto____0 = (function (){
var statearr_30185 = [null,null,null,null,null,null,null,null];
(statearr_30185[(0)] = fluree$db$time_travel$block_to_int_format_$_state_machine__11410__auto__);

(statearr_30185[(1)] = (1));

return statearr_30185;
});
var fluree$db$time_travel$block_to_int_format_$_state_machine__11410__auto____1 = (function (state_30153){
while(true){
var ret_value__11411__auto__ = (function (){try{while(true){
var result__11412__auto__ = switch__11409__auto__(state_30153);
if(cljs.core.keyword_identical_QMARK_(result__11412__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11412__auto__;
}
break;
}
}catch (e30186){var ex__11413__auto__ = e30186;
var statearr_30187_30214 = state_30153;
(statearr_30187_30214[(2)] = ex__11413__auto__);


if(cljs.core.seq((state_30153[(4)]))){
var statearr_30188_30215 = state_30153;
(statearr_30188_30215[(1)] = cljs.core.first((state_30153[(4)])));

} else {
throw ex__11413__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11411__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__30216 = state_30153;
state_30153 = G__30216;
continue;
} else {
return ret_value__11411__auto__;
}
break;
}
});
fluree$db$time_travel$block_to_int_format_$_state_machine__11410__auto__ = function(state_30153){
switch(arguments.length){
case 0:
return fluree$db$time_travel$block_to_int_format_$_state_machine__11410__auto____0.call(this);
case 1:
return fluree$db$time_travel$block_to_int_format_$_state_machine__11410__auto____1.call(this,state_30153);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$time_travel$block_to_int_format_$_state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$time_travel$block_to_int_format_$_state_machine__11410__auto____0;
fluree$db$time_travel$block_to_int_format_$_state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$time_travel$block_to_int_format_$_state_machine__11410__auto____1;
return fluree$db$time_travel$block_to_int_format_$_state_machine__11410__auto__;
})()
})();
var state__11486__auto__ = (function (){var statearr_30189 = (f__11485__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11485__auto__.cljs$core$IFn$_invoke$arity$0() : f__11485__auto__.call(null));
(statearr_30189[(6)] = c__11484__auto__);

return statearr_30189;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11486__auto__);
}));

return c__11484__auto__;
});
/**
 * Given a positive integer block, returns the t (negative integer) associated.
 *   If block does not exist, throws.
 */
fluree.db.time_travel.block_to_t = (function fluree$db$time_travel$block_to_t(db,block){
var c__11484__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__11485__auto__ = (function (){var switch__11409__auto__ = (function (state_30271){
var state_val_30272 = (state_30271[(1)]);
if((state_val_30272 === (7))){
var inst_30225 = (state_30271[(7)]);
var inst_30229 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_30230 = ["_block/number",block];
var inst_30231 = (new cljs.core.PersistentVector(null,2,(5),inst_30229,inst_30230,null));
var inst_30232 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$4(inst_30225,new cljs.core.Keyword(null,"post","post",269697687),cljs.core._EQ_,inst_30231);
var state_30271__$1 = state_30271;
var statearr_30273_30313 = state_30271__$1;
(statearr_30273_30313[(2)] = inst_30232);

(statearr_30273_30313[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30272 === (20))){
var inst_30258 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([block], 0));
var inst_30259 = ["Invalid block key provided: ",inst_30258].join('');
var inst_30260 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_30261 = [(400),new cljs.core.Keyword("db","invalid-time","db/invalid-time",-1496866235)];
var inst_30262 = cljs.core.PersistentHashMap.fromArrays(inst_30260,inst_30261);
var inst_30263 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_30259,inst_30262);
var inst_30264 = (function(){throw inst_30263})();
var state_30271__$1 = state_30271;
var statearr_30274_30314 = state_30271__$1;
(statearr_30274_30314[(2)] = inst_30264);

(statearr_30274_30314[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30272 === (1))){
var state_30271__$1 = state_30271;
var statearr_30275_30315 = state_30271__$1;
(statearr_30275_30315[(2)] = null);

(statearr_30275_30315[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30272 === (4))){
var inst_30218 = (state_30271[(2)]);
var state_30271__$1 = state_30271;
var statearr_30276_30316 = state_30271__$1;
(statearr_30276_30316[(2)] = inst_30218);

(statearr_30276_30316[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30272 === (15))){
var inst_30248 = (state_30271[(8)]);
var inst_30248__$1 = (state_30271[(2)]);
var inst_30249 = (inst_30248__$1 == null);
var state_30271__$1 = (function (){var statearr_30277 = state_30271;
(statearr_30277[(8)] = inst_30248__$1);

return statearr_30277;
})();
if(cljs.core.truth_(inst_30249)){
var statearr_30278_30317 = state_30271__$1;
(statearr_30278_30317[(1)] = (16));

} else {
var statearr_30279_30318 = state_30271__$1;
(statearr_30279_30318[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30272 === (21))){
var inst_30255 = (state_30271[(9)]);
var inst_30266 = (state_30271[(2)]);
var _ = (function (){var statearr_30280 = state_30271;
(statearr_30280[(4)] = cljs.core.rest((state_30271[(4)])));

return statearr_30280;
})();
var state_30271__$1 = (function (){var statearr_30281 = state_30271;
(statearr_30281[(10)] = inst_30266);

return statearr_30281;
})();
var statearr_30282_30319 = state_30271__$1;
(statearr_30282_30319[(2)] = inst_30255);

(statearr_30282_30319[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30272 === (13))){
var state_30271__$1 = state_30271;
var statearr_30283_30320 = state_30271__$1;
(statearr_30283_30320[(2)] = null);

(statearr_30283_30320[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30272 === (6))){
var state_30271__$1 = state_30271;
var statearr_30284_30321 = state_30271__$1;
(statearr_30284_30321[(2)] = null);

(statearr_30284_30321[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30272 === (17))){
var inst_30248 = (state_30271[(8)]);
var inst_30252 = (function (){var G__30224 = inst_30248;
return (function (p1__30217_SHARP_){
var f = p1__30217_SHARP_;
return f.t;
});
})();
var inst_30253 = (inst_30252.cljs$core$IFn$_invoke$arity$1 ? inst_30252.cljs$core$IFn$_invoke$arity$1(inst_30248) : inst_30252.call(null,inst_30248));
var state_30271__$1 = state_30271;
var statearr_30285_30322 = state_30271__$1;
(statearr_30285_30322[(2)] = inst_30253);

(statearr_30285_30322[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30272 === (3))){
var inst_30269 = (state_30271[(2)]);
var state_30271__$1 = state_30271;
return cljs.core.async.impl.ioc_helpers.return_chan(state_30271__$1,inst_30269);
} else {
if((state_val_30272 === (12))){
var inst_30239 = (state_30271[(2)]);
var inst_30240 = fluree.db.util.async.throw_err(inst_30239);
var state_30271__$1 = state_30271;
var statearr_30286_30323 = state_30271__$1;
(statearr_30286_30323[(2)] = inst_30240);

(statearr_30286_30323[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30272 === (2))){
var inst_30225 = (state_30271[(7)]);
var _ = (function (){var statearr_30287 = state_30271;
(statearr_30287[(4)] = cljs.core.cons((5),(state_30271[(4)])));

return statearr_30287;
})();
var inst_30225__$1 = fluree.db.dbproto._rootdb(db);
var inst_30226 = (inst_30225__$1 == null);
var state_30271__$1 = (function (){var statearr_30288 = state_30271;
(statearr_30288[(7)] = inst_30225__$1);

return statearr_30288;
})();
if(cljs.core.truth_(inst_30226)){
var statearr_30289_30324 = state_30271__$1;
(statearr_30289_30324[(1)] = (6));

} else {
var statearr_30290_30325 = state_30271__$1;
(statearr_30290_30325[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30272 === (19))){
var state_30271__$1 = state_30271;
var statearr_30291_30326 = state_30271__$1;
(statearr_30291_30326[(2)] = null);

(statearr_30291_30326[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30272 === (11))){
var inst_30242 = (state_30271[(11)]);
var inst_30242__$1 = (state_30271[(2)]);
var inst_30243 = (inst_30242__$1 == null);
var state_30271__$1 = (function (){var statearr_30293 = state_30271;
(statearr_30293[(11)] = inst_30242__$1);

return statearr_30293;
})();
if(cljs.core.truth_(inst_30243)){
var statearr_30294_30327 = state_30271__$1;
(statearr_30294_30327[(1)] = (13));

} else {
var statearr_30295_30328 = state_30271__$1;
(statearr_30295_30328[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30272 === (9))){
var state_30271__$1 = state_30271;
var statearr_30296_30329 = state_30271__$1;
(statearr_30296_30329[(2)] = null);

(statearr_30296_30329[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30272 === (5))){
var _ = (function (){var statearr_30297 = state_30271;
(statearr_30297[(4)] = cljs.core.rest((state_30271[(4)])));

return statearr_30297;
})();
var state_30271__$1 = state_30271;
var ex30292 = (state_30271__$1[(2)]);
var statearr_30298_30330 = state_30271__$1;
(statearr_30298_30330[(5)] = ex30292);


if((ex30292 instanceof Error)){
var statearr_30299_30331 = state_30271__$1;
(statearr_30299_30331[(1)] = (4));

(statearr_30299_30331[(5)] = null);

} else {
throw ex30292;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30272 === (14))){
var inst_30242 = (state_30271[(11)]);
var inst_30246 = cljs.core.first(inst_30242);
var state_30271__$1 = state_30271;
var statearr_30300_30332 = state_30271__$1;
(statearr_30300_30332[(2)] = inst_30246);

(statearr_30300_30332[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30272 === (16))){
var state_30271__$1 = state_30271;
var statearr_30301_30333 = state_30271__$1;
(statearr_30301_30333[(2)] = null);

(statearr_30301_30333[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30272 === (10))){
var inst_30234 = (state_30271[(12)]);
var state_30271__$1 = state_30271;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_30271__$1,(12),inst_30234);
} else {
if((state_val_30272 === (18))){
var inst_30255 = (state_30271[(9)]);
var inst_30255__$1 = (state_30271[(2)]);
var state_30271__$1 = (function (){var statearr_30302 = state_30271;
(statearr_30302[(9)] = inst_30255__$1);

return statearr_30302;
})();
if(cljs.core.truth_(inst_30255__$1)){
var statearr_30303_30334 = state_30271__$1;
(statearr_30303_30334[(1)] = (19));

} else {
var statearr_30304_30335 = state_30271__$1;
(statearr_30304_30335[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30272 === (8))){
var inst_30234 = (state_30271[(12)]);
var inst_30234__$1 = (state_30271[(2)]);
var inst_30235 = (inst_30234__$1 == null);
var state_30271__$1 = (function (){var statearr_30305 = state_30271;
(statearr_30305[(12)] = inst_30234__$1);

return statearr_30305;
})();
if(cljs.core.truth_(inst_30235)){
var statearr_30306_30336 = state_30271__$1;
(statearr_30306_30336[(1)] = (9));

} else {
var statearr_30307_30337 = state_30271__$1;
(statearr_30307_30337[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$time_travel$block_to_t_$_state_machine__11410__auto__ = null;
var fluree$db$time_travel$block_to_t_$_state_machine__11410__auto____0 = (function (){
var statearr_30308 = [null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_30308[(0)] = fluree$db$time_travel$block_to_t_$_state_machine__11410__auto__);

(statearr_30308[(1)] = (1));

return statearr_30308;
});
var fluree$db$time_travel$block_to_t_$_state_machine__11410__auto____1 = (function (state_30271){
while(true){
var ret_value__11411__auto__ = (function (){try{while(true){
var result__11412__auto__ = switch__11409__auto__(state_30271);
if(cljs.core.keyword_identical_QMARK_(result__11412__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11412__auto__;
}
break;
}
}catch (e30309){var ex__11413__auto__ = e30309;
var statearr_30310_30338 = state_30271;
(statearr_30310_30338[(2)] = ex__11413__auto__);


if(cljs.core.seq((state_30271[(4)]))){
var statearr_30311_30339 = state_30271;
(statearr_30311_30339[(1)] = cljs.core.first((state_30271[(4)])));

} else {
throw ex__11413__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11411__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__30340 = state_30271;
state_30271 = G__30340;
continue;
} else {
return ret_value__11411__auto__;
}
break;
}
});
fluree$db$time_travel$block_to_t_$_state_machine__11410__auto__ = function(state_30271){
switch(arguments.length){
case 0:
return fluree$db$time_travel$block_to_t_$_state_machine__11410__auto____0.call(this);
case 1:
return fluree$db$time_travel$block_to_t_$_state_machine__11410__auto____1.call(this,state_30271);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$time_travel$block_to_t_$_state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$time_travel$block_to_t_$_state_machine__11410__auto____0;
fluree$db$time_travel$block_to_t_$_state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$time_travel$block_to_t_$_state_machine__11410__auto____1;
return fluree$db$time_travel$block_to_t_$_state_machine__11410__auto__;
})()
})();
var state__11486__auto__ = (function (){var statearr_30312 = (f__11485__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11485__auto__.cljs$core$IFn$_invoke$arity$0() : f__11485__auto__.call(null));
(statearr_30312[(6)] = c__11484__auto__);

return statearr_30312;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11486__auto__);
}));

return c__11484__auto__;
});
/**
 * Takes any time value: block, ISO-8601 time or duration string, or t
 *   and returns the exact 't' as of that value into a core async channel.
 */
fluree.db.time_travel.to_t = (function fluree$db$time_travel$to_t(db,block_or_t_or_time){
var c__11484__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__11485__auto__ = (function (){var switch__11409__auto__ = (function (state_30411){
var state_val_30412 = (state_30411[(1)]);
if((state_val_30412 === (7))){
var state_30411__$1 = state_30411;
var statearr_30413_30458 = state_30411__$1;
(statearr_30413_30458[(2)] = null);

(statearr_30413_30458[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (20))){
var inst_30402 = (state_30411[(2)]);
var state_30411__$1 = state_30411;
var statearr_30414_30459 = state_30411__$1;
(statearr_30414_30459[(2)] = inst_30402);

(statearr_30414_30459[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (27))){
var state_30411__$1 = state_30411;
var statearr_30415_30460 = state_30411__$1;
(statearr_30415_30460[(2)] = null);

(statearr_30415_30460[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (1))){
var state_30411__$1 = state_30411;
var statearr_30416_30461 = state_30411__$1;
(statearr_30416_30461[(2)] = null);

(statearr_30416_30461[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (24))){
var inst_30380 = (state_30411[(2)]);
var inst_30381 = fluree.db.util.async.throw_err(inst_30380);
var state_30411__$1 = state_30411;
var statearr_30417_30462 = state_30411__$1;
(statearr_30417_30462[(2)] = inst_30381);

(statearr_30417_30462[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (4))){
var inst_30341 = (state_30411[(2)]);
var state_30411__$1 = state_30411;
var statearr_30418_30463 = state_30411__$1;
(statearr_30418_30463[(2)] = inst_30341);

(statearr_30418_30463[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (15))){
var state_30411__$1 = state_30411;
var statearr_30420_30464 = state_30411__$1;
(statearr_30420_30464[(2)] = block_or_t_or_time);

(statearr_30420_30464[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (21))){
var inst_30350 = (state_30411[(7)]);
var inst_30377 = fluree.db.time_travel.duration_parse(block_or_t_or_time);
var inst_30378 = fluree.db.time_travel.time_to_t(inst_30350,inst_30377);
var state_30411__$1 = state_30411;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_30411__$1,(24),inst_30378);
} else {
if((state_val_30412 === (13))){
var _ = (function (){var statearr_30421 = state_30411;
(statearr_30421[(4)] = cljs.core.rest((state_30411[(4)])));

return statearr_30421;
})();
var state_30411__$1 = state_30411;
var ex30419 = (state_30411__$1[(2)]);
var statearr_30422_30465 = state_30411__$1;
(statearr_30422_30465[(5)] = ex30419);


var statearr_30423_30466 = state_30411__$1;
(statearr_30423_30466[(1)] = (12));

(statearr_30423_30466[(5)] = null);



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (22))){
var inst_30350 = (state_30411[(7)]);
var inst_30383 = fluree.db.time_travel.time_to_t(inst_30350,block_or_t_or_time);
var state_30411__$1 = state_30411;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_30411__$1,(25),inst_30383);
} else {
if((state_val_30412 === (6))){
var inst_30349 = (state_30411[(2)]);
var inst_30350 = fluree.db.util.async.throw_err(inst_30349);
var inst_30351 = cljs.core.pos_int_QMARK_(block_or_t_or_time);
var state_30411__$1 = (function (){var statearr_30424 = state_30411;
(statearr_30424[(7)] = inst_30350);

return statearr_30424;
})();
if(inst_30351){
var statearr_30425_30467 = state_30411__$1;
(statearr_30425_30467[(1)] = (7));

} else {
var statearr_30426_30468 = state_30411__$1;
(statearr_30426_30468[(1)] = (8));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (28))){
var inst_30400 = (state_30411[(2)]);
var state_30411__$1 = state_30411;
var statearr_30427_30469 = state_30411__$1;
(statearr_30427_30469[(2)] = inst_30400);

(statearr_30427_30469[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (25))){
var inst_30385 = (state_30411[(2)]);
var inst_30386 = fluree.db.util.async.throw_err(inst_30385);
var state_30411__$1 = state_30411;
var statearr_30428_30470 = state_30411__$1;
(statearr_30428_30470[(2)] = inst_30386);

(statearr_30428_30470[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (17))){
var inst_30404 = (state_30411[(2)]);
var state_30411__$1 = state_30411;
var statearr_30429_30471 = state_30411__$1;
(statearr_30429_30471[(2)] = inst_30404);

(statearr_30429_30471[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (3))){
var inst_30409 = (state_30411[(2)]);
var state_30411__$1 = state_30411;
return cljs.core.async.impl.ioc_helpers.return_chan(state_30411__$1,inst_30409);
} else {
if((state_val_30412 === (12))){
var inst_30350 = (state_30411[(7)]);
var inst_30353 = (state_30411[(2)]);
var inst_30354 = new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(inst_30350);
var state_30411__$1 = (function (){var statearr_30430 = state_30411;
(statearr_30430[(8)] = inst_30353);

return statearr_30430;
})();
var statearr_30431_30472 = state_30411__$1;
(statearr_30431_30472[(2)] = inst_30354);

(statearr_30431_30472[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (2))){
var _ = (function (){var statearr_30432 = state_30411;
(statearr_30432[(4)] = cljs.core.cons((5),(state_30411[(4)])));

return statearr_30432;
})();
var inst_30347 = fluree.db.dbproto._latest_db(db);
var state_30411__$1 = state_30411;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_30411__$1,(6),inst_30347);
} else {
if((state_val_30412 === (23))){
var inst_30388 = (state_30411[(2)]);
var state_30411__$1 = state_30411;
var statearr_30433_30473 = state_30411__$1;
(statearr_30433_30473[(2)] = inst_30388);

(statearr_30433_30473[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (19))){
var state_30411__$1 = state_30411;
var statearr_30434_30474 = state_30411__$1;
(statearr_30434_30474[(1)] = (26));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (11))){
var inst_30366 = (state_30411[(2)]);
var state_30411__$1 = state_30411;
var statearr_30437_30475 = state_30411__$1;
(statearr_30437_30475[(2)] = inst_30366);

(statearr_30437_30475[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (9))){
var inst_30406 = (state_30411[(2)]);
var _ = (function (){var statearr_30438 = state_30411;
(statearr_30438[(4)] = cljs.core.rest((state_30411[(4)])));

return statearr_30438;
})();
var state_30411__$1 = state_30411;
var statearr_30439_30476 = state_30411__$1;
(statearr_30439_30476[(2)] = inst_30406);

(statearr_30439_30476[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (5))){
var _ = (function (){var statearr_30440 = state_30411;
(statearr_30440[(4)] = cljs.core.rest((state_30411[(4)])));

return statearr_30440;
})();
var state_30411__$1 = state_30411;
var ex30436 = (state_30411__$1[(2)]);
var statearr_30441_30477 = state_30411__$1;
(statearr_30441_30477[(5)] = ex30436);


if((ex30436 instanceof Error)){
var statearr_30442_30478 = state_30411__$1;
(statearr_30442_30478[(1)] = (4));

(statearr_30442_30478[(5)] = null);

} else {
throw ex30436;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (14))){
var inst_30362 = (state_30411[(2)]);
var inst_30363 = fluree.db.util.async.throw_err(inst_30362);
var _ = (function (){var statearr_30443 = state_30411;
(statearr_30443[(4)] = cljs.core.rest((state_30411[(4)])));

return statearr_30443;
})();
var state_30411__$1 = state_30411;
var statearr_30444_30479 = state_30411__$1;
(statearr_30444_30479[(2)] = inst_30363);

(statearr_30444_30479[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (26))){
var inst_30391 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([block_or_t_or_time], 0));
var inst_30392 = ["Invalid time value provided: ",inst_30391].join('');
var inst_30393 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_30394 = [(400),new cljs.core.Keyword("db","invalid-time","db/invalid-time",-1496866235)];
var inst_30395 = cljs.core.PersistentHashMap.fromArrays(inst_30393,inst_30394);
var inst_30396 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_30392,inst_30395);
var inst_30397 = (function(){throw inst_30396})();
var state_30411__$1 = state_30411;
var statearr_30445_30480 = state_30411__$1;
(statearr_30445_30480[(2)] = inst_30397);

(statearr_30445_30480[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (16))){
var inst_30371 = typeof block_or_t_or_time === 'string';
var state_30411__$1 = state_30411;
if(cljs.core.truth_(inst_30371)){
var statearr_30446_30481 = state_30411__$1;
(statearr_30446_30481[(1)] = (18));

} else {
var statearr_30447_30482 = state_30411__$1;
(statearr_30447_30482[(1)] = (19));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (10))){
var inst_30350 = (state_30411[(7)]);
var _ = (function (){var statearr_30448 = state_30411;
(statearr_30448[(4)] = cljs.core.cons((13),(state_30411[(4)])));

return statearr_30448;
})();
var inst_30360 = fluree.db.time_travel.block_to_t(inst_30350,block_or_t_or_time);
var state_30411__$1 = state_30411;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_30411__$1,(14),inst_30360);
} else {
if((state_val_30412 === (18))){
var inst_30373 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(block_or_t_or_time,(0));
var inst_30374 = cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_30373);
var inst_30375 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("P",inst_30374);
var state_30411__$1 = state_30411;
if(inst_30375){
var statearr_30449_30483 = state_30411__$1;
(statearr_30449_30483[(1)] = (21));

} else {
var statearr_30450_30484 = state_30411__$1;
(statearr_30450_30484[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30412 === (8))){
var inst_30368 = cljs.core.neg_int_QMARK_(block_or_t_or_time);
var state_30411__$1 = state_30411;
if(inst_30368){
var statearr_30451_30485 = state_30411__$1;
(statearr_30451_30485[(1)] = (15));

} else {
var statearr_30452_30486 = state_30411__$1;
(statearr_30452_30486[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$time_travel$to_t_$_state_machine__11410__auto__ = null;
var fluree$db$time_travel$to_t_$_state_machine__11410__auto____0 = (function (){
var statearr_30453 = [null,null,null,null,null,null,null,null,null];
(statearr_30453[(0)] = fluree$db$time_travel$to_t_$_state_machine__11410__auto__);

(statearr_30453[(1)] = (1));

return statearr_30453;
});
var fluree$db$time_travel$to_t_$_state_machine__11410__auto____1 = (function (state_30411){
while(true){
var ret_value__11411__auto__ = (function (){try{while(true){
var result__11412__auto__ = switch__11409__auto__(state_30411);
if(cljs.core.keyword_identical_QMARK_(result__11412__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11412__auto__;
}
break;
}
}catch (e30454){var ex__11413__auto__ = e30454;
var statearr_30455_30487 = state_30411;
(statearr_30455_30487[(2)] = ex__11413__auto__);


if(cljs.core.seq((state_30411[(4)]))){
var statearr_30456_30488 = state_30411;
(statearr_30456_30488[(1)] = cljs.core.first((state_30411[(4)])));

} else {
throw ex__11413__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11411__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__30489 = state_30411;
state_30411 = G__30489;
continue;
} else {
return ret_value__11411__auto__;
}
break;
}
});
fluree$db$time_travel$to_t_$_state_machine__11410__auto__ = function(state_30411){
switch(arguments.length){
case 0:
return fluree$db$time_travel$to_t_$_state_machine__11410__auto____0.call(this);
case 1:
return fluree$db$time_travel$to_t_$_state_machine__11410__auto____1.call(this,state_30411);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$time_travel$to_t_$_state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$time_travel$to_t_$_state_machine__11410__auto____0;
fluree$db$time_travel$to_t_$_state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$time_travel$to_t_$_state_machine__11410__auto____1;
return fluree$db$time_travel$to_t_$_state_machine__11410__auto__;
})()
})();
var state__11486__auto__ = (function (){var statearr_30457 = (f__11485__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11485__auto__.cljs$core$IFn$_invoke$arity$0() : f__11485__auto__.call(null));
(statearr_30457[(6)] = c__11484__auto__);

return statearr_30457;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11486__auto__);
}));

return c__11484__auto__;
});
/**
 * Gets the database as-of a specified block. Either block number or a time string in ISO-8601 format.
 *   Returns db as a promise channel
 */
fluree.db.time_travel.as_of_block = (function fluree$db$time_travel$as_of_block(db,block_or_t_or_time){
var pc = cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();
var c__11484__auto___30533 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__11485__auto__ = (function (){var switch__11409__auto__ = (function (state_30515){
var state_val_30516 = (state_30515[(1)]);
if((state_val_30516 === (1))){
var state_30515__$1 = state_30515;
var statearr_30517_30534 = state_30515__$1;
(statearr_30517_30534[(2)] = null);

(statearr_30517_30534[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30516 === (2))){
var _ = (function (){var statearr_30518 = state_30515;
(statearr_30518[(4)] = cljs.core.cons((5),(state_30515[(4)])));

return statearr_30518;
})();
var inst_30497 = fluree.db.dbproto._latest_db(db);
var state_30515__$1 = state_30515;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_30515__$1,(6),inst_30497);
} else {
if((state_val_30516 === (3))){
var inst_30513 = (state_30515[(2)]);
var state_30515__$1 = state_30515;
return cljs.core.async.impl.ioc_helpers.return_chan(state_30515__$1,inst_30513);
} else {
if((state_val_30516 === (4))){
var inst_30490 = (state_30515[(2)]);
var inst_30491 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(pc,inst_30490);
var state_30515__$1 = state_30515;
var statearr_30520_30535 = state_30515__$1;
(statearr_30520_30535[(2)] = inst_30491);

(statearr_30520_30535[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30516 === (5))){
var _ = (function (){var statearr_30521 = state_30515;
(statearr_30521[(4)] = cljs.core.rest((state_30515[(4)])));

return statearr_30521;
})();
var state_30515__$1 = state_30515;
var ex30519 = (state_30515__$1[(2)]);
var statearr_30522_30536 = state_30515__$1;
(statearr_30522_30536[(5)] = ex30519);


var statearr_30523_30537 = state_30515__$1;
(statearr_30523_30537[(1)] = (4));

(statearr_30523_30537[(5)] = null);



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_30516 === (6))){
var inst_30500 = (state_30515[(7)]);
var inst_30499 = (state_30515[(2)]);
var inst_30500__$1 = fluree.db.util.async.throw_err(inst_30499);
var inst_30501 = fluree.db.time_travel.to_t(inst_30500__$1,block_or_t_or_time);
var state_30515__$1 = (function (){var statearr_30524 = state_30515;
(statearr_30524[(7)] = inst_30500__$1);

return statearr_30524;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_30515__$1,(7),inst_30501);
} else {
if((state_val_30516 === (7))){
var inst_30504 = (state_30515[(8)]);
var inst_30500 = (state_30515[(7)]);
var inst_30503 = (state_30515[(2)]);
var inst_30504__$1 = fluree.db.util.async.throw_err(inst_30503);
var inst_30505 = fluree.db.time_travel.t_to_block(inst_30500,inst_30504__$1);
var state_30515__$1 = (function (){var statearr_30525 = state_30515;
(statearr_30525[(8)] = inst_30504__$1);

return statearr_30525;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_30515__$1,(8),inst_30505);
} else {
if((state_val_30516 === (8))){
var inst_30504 = (state_30515[(8)]);
var inst_30507 = (state_30515[(2)]);
var inst_30508 = fluree.db.util.async.throw_err(inst_30507);
var inst_30509 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(db,new cljs.core.Keyword(null,"t","t",-1397832519),inst_30504,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.Keyword(null,"block","block",664686210),inst_30508], 0));
var inst_30510 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(pc,inst_30509);
var _ = (function (){var statearr_30526 = state_30515;
(statearr_30526[(4)] = cljs.core.rest((state_30515[(4)])));

return statearr_30526;
})();
var state_30515__$1 = state_30515;
var statearr_30527_30538 = state_30515__$1;
(statearr_30527_30538[(2)] = inst_30510);

(statearr_30527_30538[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$time_travel$as_of_block_$_state_machine__11410__auto__ = null;
var fluree$db$time_travel$as_of_block_$_state_machine__11410__auto____0 = (function (){
var statearr_30528 = [null,null,null,null,null,null,null,null,null];
(statearr_30528[(0)] = fluree$db$time_travel$as_of_block_$_state_machine__11410__auto__);

(statearr_30528[(1)] = (1));

return statearr_30528;
});
var fluree$db$time_travel$as_of_block_$_state_machine__11410__auto____1 = (function (state_30515){
while(true){
var ret_value__11411__auto__ = (function (){try{while(true){
var result__11412__auto__ = switch__11409__auto__(state_30515);
if(cljs.core.keyword_identical_QMARK_(result__11412__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__11412__auto__;
}
break;
}
}catch (e30529){var ex__11413__auto__ = e30529;
var statearr_30530_30539 = state_30515;
(statearr_30530_30539[(2)] = ex__11413__auto__);


if(cljs.core.seq((state_30515[(4)]))){
var statearr_30531_30540 = state_30515;
(statearr_30531_30540[(1)] = cljs.core.first((state_30515[(4)])));

} else {
throw ex__11413__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__11411__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__30541 = state_30515;
state_30515 = G__30541;
continue;
} else {
return ret_value__11411__auto__;
}
break;
}
});
fluree$db$time_travel$as_of_block_$_state_machine__11410__auto__ = function(state_30515){
switch(arguments.length){
case 0:
return fluree$db$time_travel$as_of_block_$_state_machine__11410__auto____0.call(this);
case 1:
return fluree$db$time_travel$as_of_block_$_state_machine__11410__auto____1.call(this,state_30515);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$time_travel$as_of_block_$_state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$time_travel$as_of_block_$_state_machine__11410__auto____0;
fluree$db$time_travel$as_of_block_$_state_machine__11410__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$time_travel$as_of_block_$_state_machine__11410__auto____1;
return fluree$db$time_travel$as_of_block_$_state_machine__11410__auto__;
})()
})();
var state__11486__auto__ = (function (){var statearr_30532 = (f__11485__auto__.cljs$core$IFn$_invoke$arity$0 ? f__11485__auto__.cljs$core$IFn$_invoke$arity$0() : f__11485__auto__.call(null));
(statearr_30532[(6)] = c__11484__auto___30533);

return statearr_30532;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__11486__auto__);
}));


return pc;
});
