// Compiled by ClojureScript 1.10.891 {:target :nodejs, :nodejs-rt true, :optimizations :simple}
goog.provide('fluree.db.conn_events');
goog.require('cljs.core');
goog.require('fluree.db.util.core');
goog.require('fluree.db.util.log');
goog.require('cljs.core.async');
if((typeof fluree !== 'undefined') && (typeof fluree.db !== 'undefined') && (typeof fluree.db.conn_events !== 'undefined') && (typeof fluree.db.conn_events.process_event !== 'undefined')){
} else {
fluree.db.conn_events.process_event = (function (){var method_table__4747__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var prefer_table__4748__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var method_cache__4749__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var cached_hierarchy__4750__auto__ = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var hierarchy__4751__auto__ = cljs.core.get.call(null,cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword(null,"hierarchy","hierarchy",-1053470341),cljs.core.get_global_hierarchy.call(null));
return (new cljs.core.MultiFn(cljs.core.symbol.call(null,"fluree.db.conn-events","process-event"),(function (_,event_type,___$1,___$2){
return event_type;
}),new cljs.core.Keyword(null,"default","default",-1987822328),hierarchy__4751__auto__,method_table__4747__auto__,prefer_table__4748__auto__,method_cache__4749__auto__,cached_hierarchy__4750__auto__));
})();
}
cljs.core._add_method.call(null,fluree.db.conn_events.process_event,new cljs.core.Keyword(null,"set-ws-id","set-ws-id",-1586193013),(function (conn,_,___$1,ws_id){
fluree.db.util.log.trace.call(null,"set websocket id:",ws_id);

return cljs.core.swap_BANG_.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(conn),cljs.core.assoc,new cljs.core.Keyword(null,"socket-id","socket-id",1022615280),ws_id);
}));
cljs.core._add_method.call(null,fluree.db.conn_events.process_event,new cljs.core.Keyword(null,"default","default",-1987822328),(function (conn,event_type,subject,event_data){
fluree.db.util.log.trace.call(null,"process event:",event_type,event_data);

var callbacks = cljs.core.get_in.call(null,cljs.core.deref.call(null,new cljs.core.Keyword(null,"state","state",-1988618099).cljs$core$IFn$_invoke$arity$1(conn)),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"listeners","listeners",394544445),subject], null));
var seq__28745 = cljs.core.seq.call(null,callbacks);
var chunk__28746 = null;
var count__28747 = (0);
var i__28748 = (0);
while(true){
if((i__28748 < count__28747)){
var vec__28757 = cljs.core._nth.call(null,chunk__28746,i__28748);
var k = cljs.core.nth.call(null,vec__28757,(0),null);
var f = cljs.core.nth.call(null,vec__28757,(1),null);
try{f.call(null,event_type,event_data);
}catch (e28760){var e_28765 = e28760;
fluree.db.util.log.error.call(null,e_28765,["Error calling registered callback: ",cljs.core.pr_str.call(null,k)," for db: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(subject),". Event: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(event_type)," Data: ",cljs.core.pr_str.call(null,event_data),"."].join(''));
}

var G__28766 = seq__28745;
var G__28767 = chunk__28746;
var G__28768 = count__28747;
var G__28769 = (i__28748 + (1));
seq__28745 = G__28766;
chunk__28746 = G__28767;
count__28747 = G__28768;
i__28748 = G__28769;
continue;
} else {
var temp__5753__auto__ = cljs.core.seq.call(null,seq__28745);
if(temp__5753__auto__){
var seq__28745__$1 = temp__5753__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__28745__$1)){
var c__4679__auto__ = cljs.core.chunk_first.call(null,seq__28745__$1);
var G__28770 = cljs.core.chunk_rest.call(null,seq__28745__$1);
var G__28771 = c__4679__auto__;
var G__28772 = cljs.core.count.call(null,c__4679__auto__);
var G__28773 = (0);
seq__28745 = G__28770;
chunk__28746 = G__28771;
count__28747 = G__28772;
i__28748 = G__28773;
continue;
} else {
var vec__28761 = cljs.core.first.call(null,seq__28745__$1);
var k = cljs.core.nth.call(null,vec__28761,(0),null);
var f = cljs.core.nth.call(null,vec__28761,(1),null);
try{f.call(null,event_type,event_data);
}catch (e28764){var e_28774 = e28764;
fluree.db.util.log.error.call(null,e_28774,["Error calling registered callback: ",cljs.core.pr_str.call(null,k)," for db: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(subject),". Event: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(event_type)," Data: ",cljs.core.pr_str.call(null,event_data),"."].join(''));
}

var G__28775 = cljs.core.next.call(null,seq__28745__$1);
var G__28776 = null;
var G__28777 = (0);
var G__28778 = (0);
seq__28745 = G__28775;
chunk__28746 = G__28776;
count__28747 = G__28777;
i__28748 = G__28778;
continue;
}
} else {
return null;
}
}
break;
}
}));
/**
 * Processes incoming events from the ledger.
 * 
 *   Requests that carry a :req-id in the header will attempt to lookup a
 *   corresponding return channel and send the message along on it.
 * 
 *   Otherwise looks for database events and updates local state accordingly.
 */
fluree.db.conn_events.process_events = (function fluree$db$conn_events$process_events(conn,msg){
try{var _ = fluree.db.util.log.trace.call(null,"Process events: ",msg);
var vec__28781 = msg;
var event_type = cljs.core.nth.call(null,vec__28781,(0),null);
var subject = cljs.core.nth.call(null,vec__28781,(1),null);
var event_data = cljs.core.nth.call(null,vec__28781,(2),null);
var error_data = cljs.core.nth.call(null,vec__28781,(3),null);
var event_type__$1 = cljs.core.keyword.call(null,event_type);
var map__28784 = conn;
var map__28784__$1 = cljs.core.__destructure_map.call(null,map__28784);
var state = cljs.core.get.call(null,map__28784__$1,new cljs.core.Keyword(null,"state","state",-1988618099));
var G__28785 = event_type__$1;
var G__28785__$1 = (((G__28785 instanceof cljs.core.Keyword))?G__28785.fqn:null);
switch (G__28785__$1) {
case "response":
var temp__5753__auto__ = cljs.core.get_in.call(null,cljs.core.deref.call(null,state),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"pending-req","pending-req",2064800871),subject], null));
if(cljs.core.truth_(temp__5753__auto__)){
var res_chan = temp__5753__auto__;
fluree.db.util.log.trace.call(null,"Found response channel for subject",subject);

cljs.core.swap_BANG_.call(null,state,cljs.core.update,new cljs.core.Keyword(null,"pending-req","pending-req",2064800871),(function (p1__28779_SHARP_){
return cljs.core.dissoc.call(null,p1__28779_SHARP_,subject);
}));

if(cljs.core.truth_(error_data)){
var map__28786 = error_data;
var map__28786__$1 = cljs.core.__destructure_map.call(null,map__28786);
var message = cljs.core.get.call(null,map__28786__$1,new cljs.core.Keyword(null,"message","message",-406056002));
var exception = cljs.core.ex_info.call(null,(function (){var or__4253__auto__ = message;
if(cljs.core.truth_(or__4253__auto__)){
return or__4253__auto__;
} else {
return cljs.core.pr_str.call(null,error_data);
}
})(),cljs.core.dissoc.call(null,error_data,new cljs.core.Keyword(null,"message","message",-406056002)));
return cljs.core.async.put_BANG_.call(null,res_chan,exception);
} else {
if(cljs.core.truth_(event_data)){
return cljs.core.async.put_BANG_.call(null,res_chan,event_data);
} else {
return cljs.core.async.close_BANG_.call(null,res_chan);

}
}
} else {
return null;
}

break;
case "pong":
return null;

break;
default:
return fluree.db.conn_events.process_event.call(null,conn,event_type__$1,subject,event_data);

}
}catch (e28780){var e = e28780;
return fluree.db.util.log.error.call(null,e);
}});
