// Compiled by ClojureScript 1.10.891 {:target :nodejs, :nodejs-rt true, :optimizations :simple}
goog.provide('fluree.db.index');
goog.require('cljs.core');
goog.require('clojure.data.avl');
goog.require('fluree.db.dbproto');
goog.require('cljs.core.async');
goog.require('fluree.db.util.async');
goog.require('fluree.db.util.log');

/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.index.IndexConfig = (function (index_type,comparator,historyComparator,__meta,__extmap,__hash){
this.index_type = index_type;
this.comparator = comparator;
this.historyComparator = historyComparator;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
(fluree.db.index.IndexConfig.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4502__auto__,k__4503__auto__){
var self__ = this;
var this__4502__auto____$1 = this;
return this__4502__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4503__auto__,null);
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4504__auto__,k27018,else__4505__auto__){
var self__ = this;
var this__4504__auto____$1 = this;
var G__27022 = k27018;
var G__27022__$1 = (((G__27022 instanceof cljs.core.Keyword))?G__27022.fqn:null);
switch (G__27022__$1) {
case "index-type":
return self__.index_type;

break;
case "comparator":
return self__.comparator;

break;
case "historyComparator":
return self__.historyComparator;

break;
default:
return cljs.core.get.call(null,self__.__extmap,k27018,else__4505__auto__);

}
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4522__auto__,f__4523__auto__,init__4524__auto__){
var self__ = this;
var this__4522__auto____$1 = this;
return cljs.core.reduce.call(null,(function (ret__4525__auto__,p__27023){
var vec__27024 = p__27023;
var k__4526__auto__ = cljs.core.nth.call(null,vec__27024,(0),null);
var v__4527__auto__ = cljs.core.nth.call(null,vec__27024,(1),null);
return f__4523__auto__.call(null,ret__4525__auto__,k__4526__auto__,v__4527__auto__);
}),init__4524__auto__,this__4522__auto____$1);
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4517__auto__,writer__4518__auto__,opts__4519__auto__){
var self__ = this;
var this__4517__auto____$1 = this;
var pr_pair__4520__auto__ = (function (keyval__4521__auto__){
return cljs.core.pr_sequential_writer.call(null,writer__4518__auto__,cljs.core.pr_writer,""," ","",opts__4519__auto__,keyval__4521__auto__);
});
return cljs.core.pr_sequential_writer.call(null,writer__4518__auto__,pr_pair__4520__auto__,"#fluree.db.index.IndexConfig{",", ","}",opts__4519__auto__,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"index-type","index-type",500383962),self__.index_type],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"comparator","comparator",2144896662),self__.comparator],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658),self__.historyComparator],null))], null),self__.__extmap));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__27017){
var self__ = this;
var G__27017__$1 = this;
return (new cljs.core.RecordIter((0),G__27017__$1,3,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"index-type","index-type",500383962),new cljs.core.Keyword(null,"comparator","comparator",2144896662),new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658)], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator.call(null,self__.__extmap):cljs.core.nil_iter.call(null))));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4500__auto__){
var self__ = this;
var this__4500__auto____$1 = this;
return self__.__meta;
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4497__auto__){
var self__ = this;
var this__4497__auto____$1 = this;
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,self__.historyComparator,self__.__meta,self__.__extmap,self__.__hash));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4506__auto__){
var self__ = this;
var this__4506__auto____$1 = this;
return (3 + cljs.core.count.call(null,self__.__extmap));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4498__auto__){
var self__ = this;
var this__4498__auto____$1 = this;
var h__4360__auto__ = self__.__hash;
if((!((h__4360__auto__ == null)))){
return h__4360__auto__;
} else {
var h__4360__auto____$1 = (function (coll__4499__auto__){
return (1512230614 ^ cljs.core.hash_unordered_coll.call(null,coll__4499__auto__));
}).call(null,this__4498__auto____$1);
(self__.__hash = h__4360__auto____$1);

return h__4360__auto____$1;
}
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this27019,other27020){
var self__ = this;
var this27019__$1 = this;
return (((!((other27020 == null)))) && ((((this27019__$1.constructor === other27020.constructor)) && (((cljs.core._EQ_.call(null,this27019__$1.index_type,other27020.index_type)) && (((cljs.core._EQ_.call(null,this27019__$1.comparator,other27020.comparator)) && (((cljs.core._EQ_.call(null,this27019__$1.historyComparator,other27020.historyComparator)) && (cljs.core._EQ_.call(null,this27019__$1.__extmap,other27020.__extmap)))))))))));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4512__auto__,k__4513__auto__){
var self__ = this;
var this__4512__auto____$1 = this;
if(cljs.core.contains_QMARK_.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658),null,new cljs.core.Keyword(null,"comparator","comparator",2144896662),null,new cljs.core.Keyword(null,"index-type","index-type",500383962),null], null), null),k__4513__auto__)){
return cljs.core.dissoc.call(null,cljs.core._with_meta.call(null,cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,this__4512__auto____$1),self__.__meta),k__4513__auto__);
} else {
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,self__.historyComparator,self__.__meta,cljs.core.not_empty.call(null,cljs.core.dissoc.call(null,self__.__extmap,k__4513__auto__)),null));
}
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IAssociative$_contains_key_QMARK_$arity$2 = (function (this__4509__auto__,k27018){
var self__ = this;
var this__4509__auto____$1 = this;
var G__27027 = k27018;
var G__27027__$1 = (((G__27027 instanceof cljs.core.Keyword))?G__27027.fqn:null);
switch (G__27027__$1) {
case "index-type":
case "comparator":
case "historyComparator":
return true;

break;
default:
return cljs.core.contains_QMARK_.call(null,self__.__extmap,k27018);

}
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4510__auto__,k__4511__auto__,G__27017){
var self__ = this;
var this__4510__auto____$1 = this;
var pred__27028 = cljs.core.keyword_identical_QMARK_;
var expr__27029 = k__4511__auto__;
if(cljs.core.truth_(pred__27028.call(null,new cljs.core.Keyword(null,"index-type","index-type",500383962),expr__27029))){
return (new fluree.db.index.IndexConfig(G__27017,self__.comparator,self__.historyComparator,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__27028.call(null,new cljs.core.Keyword(null,"comparator","comparator",2144896662),expr__27029))){
return (new fluree.db.index.IndexConfig(self__.index_type,G__27017,self__.historyComparator,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__27028.call(null,new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658),expr__27029))){
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,G__27017,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,self__.historyComparator,self__.__meta,cljs.core.assoc.call(null,self__.__extmap,k__4511__auto__,G__27017),null));
}
}
}
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4515__auto__){
var self__ = this;
var this__4515__auto____$1 = this;
return cljs.core.seq.call(null,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(new cljs.core.Keyword(null,"index-type","index-type",500383962),self__.index_type,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"comparator","comparator",2144896662),self__.comparator,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658),self__.historyComparator,null))], null),self__.__extmap));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4501__auto__,G__27017){
var self__ = this;
var this__4501__auto____$1 = this;
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,self__.historyComparator,G__27017,self__.__extmap,self__.__hash));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4507__auto__,entry__4508__auto__){
var self__ = this;
var this__4507__auto____$1 = this;
if(cljs.core.vector_QMARK_.call(null,entry__4508__auto__)){
return this__4507__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.call(null,entry__4508__auto__,(0)),cljs.core._nth.call(null,entry__4508__auto__,(1)));
} else {
return cljs.core.reduce.call(null,cljs.core._conj,this__4507__auto____$1,entry__4508__auto__);
}
}));

(fluree.db.index.IndexConfig.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"index-type","index-type",2140915489,null),new cljs.core.Symbol(null,"comparator","comparator",-509539107,null),new cljs.core.Symbol(null,"historyComparator","historyComparator",236913869,null)], null);
}));

(fluree.db.index.IndexConfig.cljs$lang$type = true);

(fluree.db.index.IndexConfig.cljs$lang$ctorPrSeq = (function (this__4546__auto__){
return (new cljs.core.List(null,"fluree.db.index/IndexConfig",null,(1),null));
}));

(fluree.db.index.IndexConfig.cljs$lang$ctorPrWriter = (function (this__4546__auto__,writer__4547__auto__){
return cljs.core._write.call(null,writer__4547__auto__,"fluree.db.index/IndexConfig");
}));

/**
 * Positional factory function for fluree.db.index/IndexConfig.
 */
fluree.db.index.__GT_IndexConfig = (function fluree$db$index$__GT_IndexConfig(index_type,comparator,historyComparator){
return (new fluree.db.index.IndexConfig(index_type,comparator,historyComparator,null,null,null));
});

/**
 * Factory function for fluree.db.index/IndexConfig, taking a map of keywords to field values.
 */
fluree.db.index.map__GT_IndexConfig = (function fluree$db$index$map__GT_IndexConfig(G__27021){
var extmap__4542__auto__ = (function (){var G__27031 = cljs.core.dissoc.call(null,G__27021,new cljs.core.Keyword(null,"index-type","index-type",500383962),new cljs.core.Keyword(null,"comparator","comparator",2144896662),new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658));
if(cljs.core.record_QMARK_.call(null,G__27021)){
return cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,G__27031);
} else {
return G__27031;
}
})();
return (new fluree.db.index.IndexConfig(new cljs.core.Keyword(null,"index-type","index-type",500383962).cljs$core$IFn$_invoke$arity$1(G__27021),new cljs.core.Keyword(null,"comparator","comparator",2144896662).cljs$core$IFn$_invoke$arity$1(G__27021),new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658).cljs$core$IFn$_invoke$arity$1(G__27021),null,cljs.core.not_empty.call(null,extmap__4542__auto__),null));
});


/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {fluree.db.dbproto.INode}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {fluree.db.dbproto.IResolve}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.index.IndexNode = (function (block,t,rhs,children,config,leftmost_QMARK_,__meta,__extmap,__hash){
this.block = block;
this.t = t;
this.rhs = rhs;
this.children = children;
this.config = config;
this.leftmost_QMARK_ = leftmost_QMARK_;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
(fluree.db.index.IndexNode.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4502__auto__,k__4503__auto__){
var self__ = this;
var this__4502__auto____$1 = this;
return this__4502__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4503__auto__,null);
}));

(fluree.db.index.IndexNode.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4504__auto__,k27035,else__4505__auto__){
var self__ = this;
var this__4504__auto____$1 = this;
var G__27039 = k27035;
var G__27039__$1 = (((G__27039 instanceof cljs.core.Keyword))?G__27039.fqn:null);
switch (G__27039__$1) {
case "block":
return self__.block;

break;
case "t":
return self__.t;

break;
case "rhs":
return self__.rhs;

break;
case "children":
return self__.children;

break;
case "config":
return self__.config;

break;
case "leftmost?":
return self__.leftmost_QMARK_;

break;
default:
return cljs.core.get.call(null,self__.__extmap,k27035,else__4505__auto__);

}
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4522__auto__,f__4523__auto__,init__4524__auto__){
var self__ = this;
var this__4522__auto____$1 = this;
return cljs.core.reduce.call(null,(function (ret__4525__auto__,p__27040){
var vec__27041 = p__27040;
var k__4526__auto__ = cljs.core.nth.call(null,vec__27041,(0),null);
var v__4527__auto__ = cljs.core.nth.call(null,vec__27041,(1),null);
return f__4523__auto__.call(null,ret__4525__auto__,k__4526__auto__,v__4527__auto__);
}),init__4524__auto__,this__4522__auto____$1);
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4517__auto__,writer__4518__auto__,opts__4519__auto__){
var self__ = this;
var this__4517__auto____$1 = this;
var pr_pair__4520__auto__ = (function (keyval__4521__auto__){
return cljs.core.pr_sequential_writer.call(null,writer__4518__auto__,cljs.core.pr_writer,""," ","",opts__4519__auto__,keyval__4521__auto__);
});
return cljs.core.pr_sequential_writer.call(null,writer__4518__auto__,pr_pair__4520__auto__,"#fluree.db.index.IndexNode{",", ","}",opts__4519__auto__,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"block","block",664686210),self__.block],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"t","t",-1397832519),self__.t],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"rhs","rhs",-229356739),self__.rhs],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"children","children",-940561982),self__.children],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"config","config",994861415),self__.config],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),self__.leftmost_QMARK_],null))], null),self__.__extmap));
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__27034){
var self__ = this;
var G__27034__$1 = this;
return (new cljs.core.RecordIter((0),G__27034__$1,6,new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"rhs","rhs",-229356739),new cljs.core.Keyword(null,"children","children",-940561982),new cljs.core.Keyword(null,"config","config",994861415),new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559)], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator.call(null,self__.__extmap):cljs.core.nil_iter.call(null))));
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$IResolve$ = cljs.core.PROTOCOL_SENTINEL);

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$IResolve$_resolve$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
var c__10976__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,(function (){
var f__10977__auto__ = (function (){var switch__10902__auto__ = (function (state_27045){
var state_val_27046 = (state_27045[(1)]);
if((state_val_27046 === (1))){
var state_27045__$1 = state_27045;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_27045__$1,this$__$1);
} else {
return null;
}
});
return (function() {
var fluree$db$index$state_machine__10903__auto__ = null;
var fluree$db$index$state_machine__10903__auto____0 = (function (){
var statearr_27047 = [null,null,null,null,null,null,null];
(statearr_27047[(0)] = fluree$db$index$state_machine__10903__auto__);

(statearr_27047[(1)] = (1));

return statearr_27047;
});
var fluree$db$index$state_machine__10903__auto____1 = (function (state_27045){
while(true){
var ret_value__10904__auto__ = (function (){try{while(true){
var result__10905__auto__ = switch__10902__auto__.call(null,state_27045);
if(cljs.core.keyword_identical_QMARK_.call(null,result__10905__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__10905__auto__;
}
break;
}
}catch (e27048){var ex__10906__auto__ = e27048;
var statearr_27049_27148 = state_27045;
(statearr_27049_27148[(2)] = ex__10906__auto__);


if(cljs.core.seq.call(null,(state_27045[(4)]))){
var statearr_27050_27149 = state_27045;
(statearr_27050_27149[(1)] = cljs.core.first.call(null,(state_27045[(4)])));

} else {
throw ex__10906__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__10904__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__27150 = state_27045;
state_27045 = G__27150;
continue;
} else {
return ret_value__10904__auto__;
}
break;
}
});
fluree$db$index$state_machine__10903__auto__ = function(state_27045){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__10903__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__10903__auto____1.call(this,state_27045);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__10903__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__10903__auto____0;
fluree$db$index$state_machine__10903__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__10903__auto____1;
return fluree$db$index$state_machine__10903__auto__;
})()
})();
var state__10978__auto__ = (function (){var statearr_27051 = f__10977__auto__.call(null);
(statearr_27051[(6)] = c__10976__auto__);

return statearr_27051;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__10978__auto__);
}));

return c__10976__auto__;
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$IResolve$_first_flake$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.key.call(null,cljs.core.first.call(null,self__.children));
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$IResolve$_rhs$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.rhs;
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4500__auto__){
var self__ = this;
var this__4500__auto____$1 = this;
return self__.__meta;
}));

(fluree.db.index.IndexNode.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4497__auto__){
var self__ = this;
var this__4497__auto____$1 = this;
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,self__.__hash));
}));

(fluree.db.index.IndexNode.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4506__auto__){
var self__ = this;
var this__4506__auto____$1 = this;
return (6 + cljs.core.count.call(null,self__.__extmap));
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$ = cljs.core.PROTOCOL_SENTINEL);

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$_lookup$arity$2 = (function (this$,flake){
var self__ = this;
var this$__$1 = this;
return cljs.core.val.call(null,(function (){var or__4253__auto__ = clojure.data.avl.nearest.call(null,self__.children,cljs.core._LT__EQ_,flake);
if(cljs.core.truth_(or__4253__auto__)){
return or__4253__auto__;
} else {
return cljs.core.first.call(null,self__.children);
}
})());
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$_lookup_after$arity$2 = (function (_,flake){
var self__ = this;
var ___$1 = this;
return cljs.core.val.call(null,(function (){var or__4253__auto__ = clojure.data.avl.nearest.call(null,self__.children,cljs.core._GT_,flake);
if(cljs.core.truth_(or__4253__auto__)){
return or__4253__auto__;
} else {
return cljs.core.last.call(null,self__.children);
}
})());
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$_lookup_leaf$arity$2 = (function (this$,flake){
var self__ = this;
var this$__$1 = this;
var c__10976__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,(function (){
var f__10977__auto__ = (function (){var switch__10902__auto__ = (function (state_27076){
var state_val_27077 = (state_27076[(1)]);
if((state_val_27077 === (7))){
var inst_27058 = (state_27076[(7)]);
var inst_27062 = fluree.db.dbproto._resolve.call(null,inst_27058);
var state_27076__$1 = state_27076;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_27076__$1,(10),inst_27062);
} else {
if((state_val_27077 === (1))){
var state_27076__$1 = state_27076;
var statearr_27078_27151 = state_27076__$1;
(statearr_27078_27151[(2)] = null);

(statearr_27078_27151[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27077 === (4))){
var inst_27052 = (state_27076[(2)]);
var state_27076__$1 = state_27076;
var statearr_27079_27152 = state_27076__$1;
(statearr_27079_27152[(2)] = inst_27052);

(statearr_27079_27152[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27077 === (6))){
var inst_27058 = (state_27076[(7)]);
var state_27076__$1 = state_27076;
var statearr_27080_27153 = state_27076__$1;
(statearr_27080_27153[(2)] = inst_27058);

(statearr_27080_27153[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27077 === (3))){
var inst_27074 = (state_27076[(2)]);
var state_27076__$1 = state_27076;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_27076__$1,inst_27074);
} else {
if((state_val_27077 === (2))){
var inst_27058 = (state_27076[(7)]);
var _ = (function (){var statearr_27082 = state_27076;
(statearr_27082[(4)] = cljs.core.cons.call(null,(5),(state_27076[(4)])));

return statearr_27082;
})();
var inst_27058__$1 = fluree.db.dbproto._lookup.call(null,this$__$1,flake);
var inst_27059 = new cljs.core.Keyword(null,"leaf","leaf",1306118732).cljs$core$IFn$_invoke$arity$1(inst_27058__$1);
var state_27076__$1 = (function (){var statearr_27083 = state_27076;
(statearr_27083[(7)] = inst_27058__$1);

return statearr_27083;
})();
if(cljs.core.truth_(inst_27059)){
var statearr_27084_27154 = state_27076__$1;
(statearr_27084_27154[(1)] = (6));

} else {
var statearr_27085_27155 = state_27076__$1;
(statearr_27085_27155[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27077 === (9))){
var inst_27068 = (state_27076[(2)]);
var inst_27069 = fluree.db.util.async.throw_err.call(null,inst_27068);
var state_27076__$1 = state_27076;
var statearr_27086_27156 = state_27076__$1;
(statearr_27086_27156[(2)] = inst_27069);

(statearr_27086_27156[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27077 === (5))){
var _ = (function (){var statearr_27087 = state_27076;
(statearr_27087[(4)] = cljs.core.rest.call(null,(state_27076[(4)])));

return statearr_27087;
})();
var state_27076__$1 = state_27076;
var ex27081 = (state_27076__$1[(2)]);
var statearr_27088_27157 = state_27076__$1;
(statearr_27088_27157[(5)] = ex27081);


if((ex27081 instanceof Error)){
var statearr_27089_27158 = state_27076__$1;
(statearr_27089_27158[(1)] = (4));

(statearr_27089_27158[(5)] = null);

} else {
throw ex27081;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27077 === (10))){
var inst_27064 = (state_27076[(2)]);
var inst_27065 = fluree.db.util.async.throw_err.call(null,inst_27064);
var inst_27066 = fluree.db.dbproto._lookup_leaf.call(null,inst_27065,flake);
var state_27076__$1 = state_27076;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_27076__$1,(9),inst_27066);
} else {
if((state_val_27077 === (8))){
var inst_27071 = (state_27076[(2)]);
var _ = (function (){var statearr_27090 = state_27076;
(statearr_27090[(4)] = cljs.core.rest.call(null,(state_27076[(4)])));

return statearr_27090;
})();
var state_27076__$1 = state_27076;
var statearr_27091_27159 = state_27076__$1;
(statearr_27091_27159[(2)] = inst_27071);

(statearr_27091_27159[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$index$state_machine__10903__auto__ = null;
var fluree$db$index$state_machine__10903__auto____0 = (function (){
var statearr_27092 = [null,null,null,null,null,null,null,null];
(statearr_27092[(0)] = fluree$db$index$state_machine__10903__auto__);

(statearr_27092[(1)] = (1));

return statearr_27092;
});
var fluree$db$index$state_machine__10903__auto____1 = (function (state_27076){
while(true){
var ret_value__10904__auto__ = (function (){try{while(true){
var result__10905__auto__ = switch__10902__auto__.call(null,state_27076);
if(cljs.core.keyword_identical_QMARK_.call(null,result__10905__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__10905__auto__;
}
break;
}
}catch (e27093){var ex__10906__auto__ = e27093;
var statearr_27094_27160 = state_27076;
(statearr_27094_27160[(2)] = ex__10906__auto__);


if(cljs.core.seq.call(null,(state_27076[(4)]))){
var statearr_27095_27161 = state_27076;
(statearr_27095_27161[(1)] = cljs.core.first.call(null,(state_27076[(4)])));

} else {
throw ex__10906__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__10904__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__27162 = state_27076;
state_27076 = G__27162;
continue;
} else {
return ret_value__10904__auto__;
}
break;
}
});
fluree$db$index$state_machine__10903__auto__ = function(state_27076){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__10903__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__10903__auto____1.call(this,state_27076);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__10903__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__10903__auto____0;
fluree$db$index$state_machine__10903__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__10903__auto____1;
return fluree$db$index$state_machine__10903__auto__;
})()
})();
var state__10978__auto__ = (function (){var statearr_27096 = f__10977__auto__.call(null);
(statearr_27096[(6)] = c__10976__auto__);

return statearr_27096;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__10978__auto__);
}));

return c__10976__auto__;
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$_lookup_leaf_after$arity$2 = (function (this$,flake){
var self__ = this;
var this$__$1 = this;
var c__10976__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,(function (){
var f__10977__auto__ = (function (){var switch__10902__auto__ = (function (state_27121){
var state_val_27122 = (state_27121[(1)]);
if((state_val_27122 === (7))){
var inst_27103 = (state_27121[(7)]);
var inst_27107 = fluree.db.dbproto._resolve.call(null,inst_27103);
var state_27121__$1 = state_27121;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_27121__$1,(10),inst_27107);
} else {
if((state_val_27122 === (1))){
var state_27121__$1 = state_27121;
var statearr_27123_27163 = state_27121__$1;
(statearr_27123_27163[(2)] = null);

(statearr_27123_27163[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27122 === (4))){
var inst_27097 = (state_27121[(2)]);
var state_27121__$1 = state_27121;
var statearr_27124_27164 = state_27121__$1;
(statearr_27124_27164[(2)] = inst_27097);

(statearr_27124_27164[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27122 === (6))){
var inst_27103 = (state_27121[(7)]);
var state_27121__$1 = state_27121;
var statearr_27125_27165 = state_27121__$1;
(statearr_27125_27165[(2)] = inst_27103);

(statearr_27125_27165[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27122 === (3))){
var inst_27119 = (state_27121[(2)]);
var state_27121__$1 = state_27121;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_27121__$1,inst_27119);
} else {
if((state_val_27122 === (2))){
var inst_27103 = (state_27121[(7)]);
var _ = (function (){var statearr_27127 = state_27121;
(statearr_27127[(4)] = cljs.core.cons.call(null,(5),(state_27121[(4)])));

return statearr_27127;
})();
var inst_27103__$1 = fluree.db.dbproto._lookup_after.call(null,this$__$1,flake);
var inst_27104 = new cljs.core.Keyword(null,"leaf","leaf",1306118732).cljs$core$IFn$_invoke$arity$1(inst_27103__$1);
var state_27121__$1 = (function (){var statearr_27128 = state_27121;
(statearr_27128[(7)] = inst_27103__$1);

return statearr_27128;
})();
if(cljs.core.truth_(inst_27104)){
var statearr_27129_27166 = state_27121__$1;
(statearr_27129_27166[(1)] = (6));

} else {
var statearr_27130_27167 = state_27121__$1;
(statearr_27130_27167[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27122 === (9))){
var inst_27113 = (state_27121[(2)]);
var inst_27114 = fluree.db.util.async.throw_err.call(null,inst_27113);
var state_27121__$1 = state_27121;
var statearr_27131_27168 = state_27121__$1;
(statearr_27131_27168[(2)] = inst_27114);

(statearr_27131_27168[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27122 === (5))){
var _ = (function (){var statearr_27132 = state_27121;
(statearr_27132[(4)] = cljs.core.rest.call(null,(state_27121[(4)])));

return statearr_27132;
})();
var state_27121__$1 = state_27121;
var ex27126 = (state_27121__$1[(2)]);
var statearr_27133_27169 = state_27121__$1;
(statearr_27133_27169[(5)] = ex27126);


if((ex27126 instanceof Error)){
var statearr_27134_27170 = state_27121__$1;
(statearr_27134_27170[(1)] = (4));

(statearr_27134_27170[(5)] = null);

} else {
throw ex27126;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_27122 === (10))){
var inst_27109 = (state_27121[(2)]);
var inst_27110 = fluree.db.util.async.throw_err.call(null,inst_27109);
var inst_27111 = fluree.db.dbproto._lookup_leaf_after.call(null,inst_27110,flake);
var state_27121__$1 = state_27121;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_27121__$1,(9),inst_27111);
} else {
if((state_val_27122 === (8))){
var inst_27116 = (state_27121[(2)]);
var _ = (function (){var statearr_27135 = state_27121;
(statearr_27135[(4)] = cljs.core.rest.call(null,(state_27121[(4)])));

return statearr_27135;
})();
var state_27121__$1 = state_27121;
var statearr_27136_27171 = state_27121__$1;
(statearr_27136_27171[(2)] = inst_27116);

(statearr_27136_27171[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$index$state_machine__10903__auto__ = null;
var fluree$db$index$state_machine__10903__auto____0 = (function (){
var statearr_27137 = [null,null,null,null,null,null,null,null];
(statearr_27137[(0)] = fluree$db$index$state_machine__10903__auto__);

(statearr_27137[(1)] = (1));

return statearr_27137;
});
var fluree$db$index$state_machine__10903__auto____1 = (function (state_27121){
while(true){
var ret_value__10904__auto__ = (function (){try{while(true){
var result__10905__auto__ = switch__10902__auto__.call(null,state_27121);
if(cljs.core.keyword_identical_QMARK_.call(null,result__10905__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__10905__auto__;
}
break;
}
}catch (e27138){var ex__10906__auto__ = e27138;
var statearr_27139_27172 = state_27121;
(statearr_27139_27172[(2)] = ex__10906__auto__);


if(cljs.core.seq.call(null,(state_27121[(4)]))){
var statearr_27140_27173 = state_27121;
(statearr_27140_27173[(1)] = cljs.core.first.call(null,(state_27121[(4)])));

} else {
throw ex__10906__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__10904__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__27174 = state_27121;
state_27121 = G__27174;
continue;
} else {
return ret_value__10904__auto__;
}
break;
}
});
fluree$db$index$state_machine__10903__auto__ = function(state_27121){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__10903__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__10903__auto____1.call(this,state_27121);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__10903__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__10903__auto____0;
fluree$db$index$state_machine__10903__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__10903__auto____1;
return fluree$db$index$state_machine__10903__auto__;
})()
})();
var state__10978__auto__ = (function (){var statearr_27141 = f__10977__auto__.call(null);
(statearr_27141[(6)] = c__10976__auto__);

return statearr_27141;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__10978__auto__);
}));

return c__10976__auto__;
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4498__auto__){
var self__ = this;
var this__4498__auto____$1 = this;
var h__4360__auto__ = self__.__hash;
if((!((h__4360__auto__ == null)))){
return h__4360__auto__;
} else {
var h__4360__auto____$1 = (function (coll__4499__auto__){
return (659789215 ^ cljs.core.hash_unordered_coll.call(null,coll__4499__auto__));
}).call(null,this__4498__auto____$1);
(self__.__hash = h__4360__auto____$1);

return h__4360__auto____$1;
}
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this27036,other27037){
var self__ = this;
var this27036__$1 = this;
return (((!((other27037 == null)))) && ((((this27036__$1.constructor === other27037.constructor)) && (((cljs.core._EQ_.call(null,this27036__$1.block,other27037.block)) && (((cljs.core._EQ_.call(null,this27036__$1.t,other27037.t)) && (((cljs.core._EQ_.call(null,this27036__$1.rhs,other27037.rhs)) && (((cljs.core._EQ_.call(null,this27036__$1.children,other27037.children)) && (((cljs.core._EQ_.call(null,this27036__$1.config,other27037.config)) && (((cljs.core._EQ_.call(null,this27036__$1.leftmost_QMARK_,other27037.leftmost_QMARK_)) && (cljs.core._EQ_.call(null,this27036__$1.__extmap,other27037.__extmap)))))))))))))))));
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4512__auto__,k__4513__auto__){
var self__ = this;
var this__4512__auto____$1 = this;
if(cljs.core.contains_QMARK_.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"children","children",-940561982),null,new cljs.core.Keyword(null,"block","block",664686210),null,new cljs.core.Keyword(null,"config","config",994861415),null,new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),null,new cljs.core.Keyword(null,"t","t",-1397832519),null,new cljs.core.Keyword(null,"rhs","rhs",-229356739),null], null), null),k__4513__auto__)){
return cljs.core.dissoc.call(null,cljs.core._with_meta.call(null,cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,this__4512__auto____$1),self__.__meta),k__4513__auto__);
} else {
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,cljs.core.not_empty.call(null,cljs.core.dissoc.call(null,self__.__extmap,k__4513__auto__)),null));
}
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IAssociative$_contains_key_QMARK_$arity$2 = (function (this__4509__auto__,k27035){
var self__ = this;
var this__4509__auto____$1 = this;
var G__27142 = k27035;
var G__27142__$1 = (((G__27142 instanceof cljs.core.Keyword))?G__27142.fqn:null);
switch (G__27142__$1) {
case "block":
case "t":
case "rhs":
case "children":
case "config":
case "leftmost?":
return true;

break;
default:
return cljs.core.contains_QMARK_.call(null,self__.__extmap,k27035);

}
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4510__auto__,k__4511__auto__,G__27034){
var self__ = this;
var this__4510__auto____$1 = this;
var pred__27143 = cljs.core.keyword_identical_QMARK_;
var expr__27144 = k__4511__auto__;
if(cljs.core.truth_(pred__27143.call(null,new cljs.core.Keyword(null,"block","block",664686210),expr__27144))){
return (new fluree.db.index.IndexNode(G__27034,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__27143.call(null,new cljs.core.Keyword(null,"t","t",-1397832519),expr__27144))){
return (new fluree.db.index.IndexNode(self__.block,G__27034,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__27143.call(null,new cljs.core.Keyword(null,"rhs","rhs",-229356739),expr__27144))){
return (new fluree.db.index.IndexNode(self__.block,self__.t,G__27034,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__27143.call(null,new cljs.core.Keyword(null,"children","children",-940561982),expr__27144))){
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,G__27034,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__27143.call(null,new cljs.core.Keyword(null,"config","config",994861415),expr__27144))){
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,G__27034,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__27143.call(null,new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),expr__27144))){
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,G__27034,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,cljs.core.assoc.call(null,self__.__extmap,k__4511__auto__,G__27034),null));
}
}
}
}
}
}
}));

(fluree.db.index.IndexNode.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4515__auto__){
var self__ = this;
var this__4515__auto____$1 = this;
return cljs.core.seq.call(null,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(new cljs.core.Keyword(null,"block","block",664686210),self__.block,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"t","t",-1397832519),self__.t,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"rhs","rhs",-229356739),self__.rhs,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"children","children",-940561982),self__.children,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"config","config",994861415),self__.config,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),self__.leftmost_QMARK_,null))], null),self__.__extmap));
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4501__auto__,G__27034){
var self__ = this;
var this__4501__auto____$1 = this;
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,G__27034,self__.__extmap,self__.__hash));
}));

(fluree.db.index.IndexNode.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4507__auto__,entry__4508__auto__){
var self__ = this;
var this__4507__auto____$1 = this;
if(cljs.core.vector_QMARK_.call(null,entry__4508__auto__)){
return this__4507__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.call(null,entry__4508__auto__,(0)),cljs.core._nth.call(null,entry__4508__auto__,(1)));
} else {
return cljs.core.reduce.call(null,cljs.core._conj,this__4507__auto____$1,entry__4508__auto__);
}
}));

(fluree.db.index.IndexNode.getBasis = (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"block","block",-1989749559,null),new cljs.core.Symbol(null,"t","t",242699008,null),new cljs.core.Symbol(null,"rhs","rhs",1411174788,null),new cljs.core.Symbol(null,"children","children",699969545,null),new cljs.core.Symbol(null,"config","config",-1659574354,null),new cljs.core.Symbol(null,"leftmost?","leftmost?",-31657032,null)], null);
}));

(fluree.db.index.IndexNode.cljs$lang$type = true);

(fluree.db.index.IndexNode.cljs$lang$ctorPrSeq = (function (this__4546__auto__){
return (new cljs.core.List(null,"fluree.db.index/IndexNode",null,(1),null));
}));

(fluree.db.index.IndexNode.cljs$lang$ctorPrWriter = (function (this__4546__auto__,writer__4547__auto__){
return cljs.core._write.call(null,writer__4547__auto__,"fluree.db.index/IndexNode");
}));

/**
 * Positional factory function for fluree.db.index/IndexNode.
 */
fluree.db.index.__GT_IndexNode = (function fluree$db$index$__GT_IndexNode(block,t,rhs,children,config,leftmost_QMARK_){
return (new fluree.db.index.IndexNode(block,t,rhs,children,config,leftmost_QMARK_,null,null,null));
});

/**
 * Factory function for fluree.db.index/IndexNode, taking a map of keywords to field values.
 */
fluree.db.index.map__GT_IndexNode = (function fluree$db$index$map__GT_IndexNode(G__27038){
var extmap__4542__auto__ = (function (){var G__27146 = cljs.core.dissoc.call(null,G__27038,new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"rhs","rhs",-229356739),new cljs.core.Keyword(null,"children","children",-940561982),new cljs.core.Keyword(null,"config","config",994861415),new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559));
if(cljs.core.record_QMARK_.call(null,G__27038)){
return cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,G__27146);
} else {
return G__27146;
}
})();
return (new fluree.db.index.IndexNode(new cljs.core.Keyword(null,"block","block",664686210).cljs$core$IFn$_invoke$arity$1(G__27038),new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(G__27038),new cljs.core.Keyword(null,"rhs","rhs",-229356739).cljs$core$IFn$_invoke$arity$1(G__27038),new cljs.core.Keyword(null,"children","children",-940561982).cljs$core$IFn$_invoke$arity$1(G__27038),new cljs.core.Keyword(null,"config","config",994861415).cljs$core$IFn$_invoke$arity$1(G__27038),new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559).cljs$core$IFn$_invoke$arity$1(G__27038),null,cljs.core.not_empty.call(null,extmap__4542__auto__),null));
});

fluree.db.index.index_node_QMARK_ = (function fluree$db$index$index_node_QMARK_(node){
return (node instanceof fluree.db.index.IndexNode);
});

/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {fluree.db.dbproto.INode}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {fluree.db.dbproto.IResolve}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.index.DataNode = (function (block,t,flakes,rhs,config,__meta,__extmap,__hash){
this.block = block;
this.t = t;
this.flakes = flakes;
this.rhs = rhs;
this.config = config;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
(fluree.db.index.DataNode.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4502__auto__,k__4503__auto__){
var self__ = this;
var this__4502__auto____$1 = this;
return this__4502__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4503__auto__,null);
}));

(fluree.db.index.DataNode.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4504__auto__,k27177,else__4505__auto__){
var self__ = this;
var this__4504__auto____$1 = this;
var G__27181 = k27177;
var G__27181__$1 = (((G__27181 instanceof cljs.core.Keyword))?G__27181.fqn:null);
switch (G__27181__$1) {
case "block":
return self__.block;

break;
case "t":
return self__.t;

break;
case "flakes":
return self__.flakes;

break;
case "rhs":
return self__.rhs;

break;
case "config":
return self__.config;

break;
default:
return cljs.core.get.call(null,self__.__extmap,k27177,else__4505__auto__);

}
}));

(fluree.db.index.DataNode.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4522__auto__,f__4523__auto__,init__4524__auto__){
var self__ = this;
var this__4522__auto____$1 = this;
return cljs.core.reduce.call(null,(function (ret__4525__auto__,p__27182){
var vec__27183 = p__27182;
var k__4526__auto__ = cljs.core.nth.call(null,vec__27183,(0),null);
var v__4527__auto__ = cljs.core.nth.call(null,vec__27183,(1),null);
return f__4523__auto__.call(null,ret__4525__auto__,k__4526__auto__,v__4527__auto__);
}),init__4524__auto__,this__4522__auto____$1);
}));

(fluree.db.index.DataNode.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4517__auto__,writer__4518__auto__,opts__4519__auto__){
var self__ = this;
var this__4517__auto____$1 = this;
var pr_pair__4520__auto__ = (function (keyval__4521__auto__){
return cljs.core.pr_sequential_writer.call(null,writer__4518__auto__,cljs.core.pr_writer,""," ","",opts__4519__auto__,keyval__4521__auto__);
});
return cljs.core.pr_sequential_writer.call(null,writer__4518__auto__,pr_pair__4520__auto__,"#fluree.db.index.DataNode{",", ","}",opts__4519__auto__,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"block","block",664686210),self__.block],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"t","t",-1397832519),self__.t],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"flakes","flakes",1977895739),self__.flakes],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"rhs","rhs",-229356739),self__.rhs],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"config","config",994861415),self__.config],null))], null),self__.__extmap));
}));

(fluree.db.index.DataNode.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__27176){
var self__ = this;
var G__27176__$1 = this;
return (new cljs.core.RecordIter((0),G__27176__$1,5,new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"flakes","flakes",1977895739),new cljs.core.Keyword(null,"rhs","rhs",-229356739),new cljs.core.Keyword(null,"config","config",994861415)], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator.call(null,self__.__extmap):cljs.core.nil_iter.call(null))));
}));

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$ = cljs.core.PROTOCOL_SENTINEL);

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$_resolve$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
var c__10976__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,(function (){
var f__10977__auto__ = (function (){var switch__10902__auto__ = (function (state_27187){
var state_val_27188 = (state_27187[(1)]);
if((state_val_27188 === (1))){
var state_27187__$1 = state_27187;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_27187__$1,this$__$1);
} else {
return null;
}
});
return (function() {
var fluree$db$index$state_machine__10903__auto__ = null;
var fluree$db$index$state_machine__10903__auto____0 = (function (){
var statearr_27189 = [null,null,null,null,null,null,null];
(statearr_27189[(0)] = fluree$db$index$state_machine__10903__auto__);

(statearr_27189[(1)] = (1));

return statearr_27189;
});
var fluree$db$index$state_machine__10903__auto____1 = (function (state_27187){
while(true){
var ret_value__10904__auto__ = (function (){try{while(true){
var result__10905__auto__ = switch__10902__auto__.call(null,state_27187);
if(cljs.core.keyword_identical_QMARK_.call(null,result__10905__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__10905__auto__;
}
break;
}
}catch (e27190){var ex__10906__auto__ = e27190;
var statearr_27191_27212 = state_27187;
(statearr_27191_27212[(2)] = ex__10906__auto__);


if(cljs.core.seq.call(null,(state_27187[(4)]))){
var statearr_27192_27213 = state_27187;
(statearr_27192_27213[(1)] = cljs.core.first.call(null,(state_27187[(4)])));

} else {
throw ex__10906__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__10904__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__27214 = state_27187;
state_27187 = G__27214;
continue;
} else {
return ret_value__10904__auto__;
}
break;
}
});
fluree$db$index$state_machine__10903__auto__ = function(state_27187){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__10903__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__10903__auto____1.call(this,state_27187);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__10903__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__10903__auto____0;
fluree$db$index$state_machine__10903__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__10903__auto____1;
return fluree$db$index$state_machine__10903__auto__;
})()
})();
var state__10978__auto__ = (function (){var statearr_27193 = f__10977__auto__.call(null);
(statearr_27193[(6)] = c__10976__auto__);

return statearr_27193;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__10978__auto__);
}));

return c__10976__auto__;
}));

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$_resolve_history$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
throw cljs.core.ex_info.call(null,"-resolve-history called on DATA NODE!!!",cljs.core.PersistentArrayMap.EMPTY);
}));

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$_first_flake$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.first.call(null,self__.flakes);
}));

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$_rhs$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.rhs;
}));

(fluree.db.index.DataNode.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4500__auto__){
var self__ = this;
var this__4500__auto____$1 = this;
return self__.__meta;
}));

(fluree.db.index.DataNode.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4497__auto__){
var self__ = this;
var this__4497__auto____$1 = this;
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,self__.config,self__.__meta,self__.__extmap,self__.__hash));
}));

(fluree.db.index.DataNode.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4506__auto__){
var self__ = this;
var this__4506__auto____$1 = this;
return (5 + cljs.core.count.call(null,self__.__extmap));
}));

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$INode$ = cljs.core.PROTOCOL_SENTINEL);

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$INode$_lookup$arity$2 = (function (root,flake){
var self__ = this;
var root__$1 = this;
throw cljs.core.ex_info.call(null,"-lookup was called on a data node, which shouldn't happen!",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(500),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","unexpected-error","db/unexpected-error",1973857597)], null));
}));

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$INode$_lookup_leaf$arity$2 = (function (root,flake){
var self__ = this;
var root__$1 = this;
fluree.db.util.log.error.call(null,"-lookup-leaf was called on a data node, which shouldn't happen!");

var c__10976__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,(function (){
var f__10977__auto__ = (function (){var switch__10902__auto__ = (function (state_27199){
var state_val_27200 = (state_27199[(1)]);
if((state_val_27200 === (1))){
var inst_27194 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_27195 = [(500),new cljs.core.Keyword("db","unexpected-error","db/unexpected-error",1973857597)];
var inst_27196 = cljs.core.PersistentHashMap.fromArrays(inst_27194,inst_27195);
var inst_27197 = cljs.core.ex_info.call(null,"-lookup-leaf was called on a data node, which shouldn't happen!",inst_27196);
var state_27199__$1 = state_27199;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_27199__$1,inst_27197);
} else {
return null;
}
});
return (function() {
var fluree$db$index$state_machine__10903__auto__ = null;
var fluree$db$index$state_machine__10903__auto____0 = (function (){
var statearr_27201 = [null,null,null,null,null,null,null];
(statearr_27201[(0)] = fluree$db$index$state_machine__10903__auto__);

(statearr_27201[(1)] = (1));

return statearr_27201;
});
var fluree$db$index$state_machine__10903__auto____1 = (function (state_27199){
while(true){
var ret_value__10904__auto__ = (function (){try{while(true){
var result__10905__auto__ = switch__10902__auto__.call(null,state_27199);
if(cljs.core.keyword_identical_QMARK_.call(null,result__10905__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__10905__auto__;
}
break;
}
}catch (e27202){var ex__10906__auto__ = e27202;
var statearr_27203_27215 = state_27199;
(statearr_27203_27215[(2)] = ex__10906__auto__);


if(cljs.core.seq.call(null,(state_27199[(4)]))){
var statearr_27204_27216 = state_27199;
(statearr_27204_27216[(1)] = cljs.core.first.call(null,(state_27199[(4)])));

} else {
throw ex__10906__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__10904__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__27217 = state_27199;
state_27199 = G__27217;
continue;
} else {
return ret_value__10904__auto__;
}
break;
}
});
fluree$db$index$state_machine__10903__auto__ = function(state_27199){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__10903__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__10903__auto____1.call(this,state_27199);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__10903__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__10903__auto____0;
fluree$db$index$state_machine__10903__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__10903__auto____1;
return fluree$db$index$state_machine__10903__auto__;
})()
})();
var state__10978__auto__ = (function (){var statearr_27205 = f__10977__auto__.call(null);
(statearr_27205[(6)] = c__10976__auto__);

return statearr_27205;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__10978__auto__);
}));

return c__10976__auto__;
}));

(fluree.db.index.DataNode.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4498__auto__){
var self__ = this;
var this__4498__auto____$1 = this;
var h__4360__auto__ = self__.__hash;
if((!((h__4360__auto__ == null)))){
return h__4360__auto__;
} else {
var h__4360__auto____$1 = (function (coll__4499__auto__){
return (1312629141 ^ cljs.core.hash_unordered_coll.call(null,coll__4499__auto__));
}).call(null,this__4498__auto____$1);
(self__.__hash = h__4360__auto____$1);

return h__4360__auto____$1;
}
}));

(fluree.db.index.DataNode.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this27178,other27179){
var self__ = this;
var this27178__$1 = this;
return (((!((other27179 == null)))) && ((((this27178__$1.constructor === other27179.constructor)) && (((cljs.core._EQ_.call(null,this27178__$1.block,other27179.block)) && (((cljs.core._EQ_.call(null,this27178__$1.t,other27179.t)) && (((cljs.core._EQ_.call(null,this27178__$1.flakes,other27179.flakes)) && (((cljs.core._EQ_.call(null,this27178__$1.rhs,other27179.rhs)) && (((cljs.core._EQ_.call(null,this27178__$1.config,other27179.config)) && (cljs.core._EQ_.call(null,this27178__$1.__extmap,other27179.__extmap)))))))))))))));
}));

(fluree.db.index.DataNode.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4512__auto__,k__4513__auto__){
var self__ = this;
var this__4512__auto____$1 = this;
if(cljs.core.contains_QMARK_.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"block","block",664686210),null,new cljs.core.Keyword(null,"config","config",994861415),null,new cljs.core.Keyword(null,"t","t",-1397832519),null,new cljs.core.Keyword(null,"flakes","flakes",1977895739),null,new cljs.core.Keyword(null,"rhs","rhs",-229356739),null], null), null),k__4513__auto__)){
return cljs.core.dissoc.call(null,cljs.core._with_meta.call(null,cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,this__4512__auto____$1),self__.__meta),k__4513__auto__);
} else {
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,self__.config,self__.__meta,cljs.core.not_empty.call(null,cljs.core.dissoc.call(null,self__.__extmap,k__4513__auto__)),null));
}
}));

(fluree.db.index.DataNode.prototype.cljs$core$IAssociative$_contains_key_QMARK_$arity$2 = (function (this__4509__auto__,k27177){
var self__ = this;
var this__4509__auto____$1 = this;
var G__27206 = k27177;
var G__27206__$1 = (((G__27206 instanceof cljs.core.Keyword))?G__27206.fqn:null);
switch (G__27206__$1) {
case "block":
case "t":
case "flakes":
case "rhs":
case "config":
return true;

break;
default:
return cljs.core.contains_QMARK_.call(null,self__.__extmap,k27177);

}
}));

(fluree.db.index.DataNode.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4510__auto__,k__4511__auto__,G__27176){
var self__ = this;
var this__4510__auto____$1 = this;
var pred__27207 = cljs.core.keyword_identical_QMARK_;
var expr__27208 = k__4511__auto__;
if(cljs.core.truth_(pred__27207.call(null,new cljs.core.Keyword(null,"block","block",664686210),expr__27208))){
return (new fluree.db.index.DataNode(G__27176,self__.t,self__.flakes,self__.rhs,self__.config,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__27207.call(null,new cljs.core.Keyword(null,"t","t",-1397832519),expr__27208))){
return (new fluree.db.index.DataNode(self__.block,G__27176,self__.flakes,self__.rhs,self__.config,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__27207.call(null,new cljs.core.Keyword(null,"flakes","flakes",1977895739),expr__27208))){
return (new fluree.db.index.DataNode(self__.block,self__.t,G__27176,self__.rhs,self__.config,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__27207.call(null,new cljs.core.Keyword(null,"rhs","rhs",-229356739),expr__27208))){
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,G__27176,self__.config,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_(pred__27207.call(null,new cljs.core.Keyword(null,"config","config",994861415),expr__27208))){
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,G__27176,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,self__.config,self__.__meta,cljs.core.assoc.call(null,self__.__extmap,k__4511__auto__,G__27176),null));
}
}
}
}
}
}));

(fluree.db.index.DataNode.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4515__auto__){
var self__ = this;
var this__4515__auto____$1 = this;
return cljs.core.seq.call(null,cljs.core.concat.call(null,new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(new cljs.core.Keyword(null,"block","block",664686210),self__.block,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"t","t",-1397832519),self__.t,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"flakes","flakes",1977895739),self__.flakes,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"rhs","rhs",-229356739),self__.rhs,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"config","config",994861415),self__.config,null))], null),self__.__extmap));
}));

(fluree.db.index.DataNode.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4501__auto__,G__27176){
var self__ = this;
var this__4501__auto____$1 = this;
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,self__.config,G__27176,self__.__extmap,self__.__hash));
}));

(fluree.db.index.DataNode.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4507__auto__,entry__4508__auto__){
var self__ = this;
var this__4507__auto____$1 = this;
if(cljs.core.vector_QMARK_.call(null,entry__4508__auto__)){
return this__4507__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.call(null,entry__4508__auto__,(0)),cljs.core._nth.call(null,entry__4508__auto__,(1)));
} else {
return cljs.core.reduce.call(null,cljs.core._conj,this__4507__auto____$1,entry__4508__auto__);
}
}));

(fluree.db.index.DataNode.getBasis = (function (){
return new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"block","block",-1989749559,null),new cljs.core.Symbol(null,"t","t",242699008,null),new cljs.core.Symbol(null,"flakes","flakes",-676540030,null),new cljs.core.Symbol(null,"rhs","rhs",1411174788,null),new cljs.core.Symbol(null,"config","config",-1659574354,null)], null);
}));

(fluree.db.index.DataNode.cljs$lang$type = true);

(fluree.db.index.DataNode.cljs$lang$ctorPrSeq = (function (this__4546__auto__){
return (new cljs.core.List(null,"fluree.db.index/DataNode",null,(1),null));
}));

(fluree.db.index.DataNode.cljs$lang$ctorPrWriter = (function (this__4546__auto__,writer__4547__auto__){
return cljs.core._write.call(null,writer__4547__auto__,"fluree.db.index/DataNode");
}));

/**
 * Positional factory function for fluree.db.index/DataNode.
 */
fluree.db.index.__GT_DataNode = (function fluree$db$index$__GT_DataNode(block,t,flakes,rhs,config){
return (new fluree.db.index.DataNode(block,t,flakes,rhs,config,null,null,null));
});

/**
 * Factory function for fluree.db.index/DataNode, taking a map of keywords to field values.
 */
fluree.db.index.map__GT_DataNode = (function fluree$db$index$map__GT_DataNode(G__27180){
var extmap__4542__auto__ = (function (){var G__27210 = cljs.core.dissoc.call(null,G__27180,new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"flakes","flakes",1977895739),new cljs.core.Keyword(null,"rhs","rhs",-229356739),new cljs.core.Keyword(null,"config","config",994861415));
if(cljs.core.record_QMARK_.call(null,G__27180)){
return cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,G__27210);
} else {
return G__27210;
}
})();
return (new fluree.db.index.DataNode(new cljs.core.Keyword(null,"block","block",664686210).cljs$core$IFn$_invoke$arity$1(G__27180),new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(G__27180),new cljs.core.Keyword(null,"flakes","flakes",1977895739).cljs$core$IFn$_invoke$arity$1(G__27180),new cljs.core.Keyword(null,"rhs","rhs",-229356739).cljs$core$IFn$_invoke$arity$1(G__27180),new cljs.core.Keyword(null,"config","config",994861415).cljs$core$IFn$_invoke$arity$1(G__27180),null,cljs.core.not_empty.call(null,extmap__4542__auto__),null));
});

/**
 * Creates a new data node
 */
fluree.db.index.data_node = (function fluree$db$index$data_node(block_id,t,flakes,rhs,config){
return fluree.db.index.__GT_DataNode.call(null,block_id,t,flakes,rhs,config);
});
fluree.db.index.data_node_QMARK_ = (function fluree$db$index$data_node_QMARK_(node){
return (node instanceof fluree.db.index.DataNode);
});
