// Compiled by ClojureScript 1.10.891 {:target :nodejs, :nodejs-rt true, :optimizations :simple}
goog.provide('fluree.db.query.http_signatures');
goog.require('cljs.core');
goog.require('fluree.crypto');
goog.require('clojure.string');
goog.require('fluree.db.util.core');
goog.require('fluree.db.util.log');
goog.require('fluree.db.util.json');
/**
 * keys must include:
 *   method - post, get, etc. - used for (request-target) which is required
 *   path - path of the request
 *   
 */
fluree.db.query.http_signatures.generate_signing_string = (function fluree$db$query$http_signatures$generate_signing_string(val_map,ks){
if(cljs.core.truth_((function (){var and__4251__auto__ = cljs.core.some.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, ["(request-target)",null], null), null),ks);
if(cljs.core.truth_(and__4251__auto__)){
return cljs.core.some.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, ["mydate",null,"x-fluree-date",null,"date",null], null), null),ks);
} else {
return and__4251__auto__;
}
})())){
} else {
throw cljs.core.ex_info.call(null,["A valid http-signature must sign at least (request-target), date (or x-fluree-date), ","and digest if the request has a body. You requested a signature based on: ",cljs.core.pr_str.call(null,ks),"."].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-auth","db/invalid-auth",-1361562568)], null));
}

var get_or_throw = (function (m,k){
var or__4253__auto__ = cljs.core.get.call(null,m,k);
if(cljs.core.truth_(or__4253__auto__)){
return or__4253__auto__;
} else {
throw cljs.core.ex_info.call(null,["Signing string component ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(k)," is not present."].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(401),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-auth","db/invalid-auth",-1361562568)], null));
}
});
return clojure.string.join.call(null,"\n",cljs.core.reduce.call(null,(function (acc,k){
if(cljs.core._EQ_.call(null,"(request-target)",k)){
return cljs.core.conj.call(null,acc,["(request-target): ",clojure.string.lower_case.call(null,cljs.core.name.call(null,get_or_throw.call(null,val_map,"method")))," ",clojure.string.lower_case.call(null,get_or_throw.call(null,val_map,"path"))].join(''));
} else {
return cljs.core.conj.call(null,acc,[cljs.core.str.cljs$core$IFn$_invoke$arity$1(k),": ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(get_or_throw.call(null,val_map,k))].join(''));
}
}),cljs.core.PersistentVector.EMPTY,ks));
});
fluree.db.query.http_signatures.verify_signature_header_STAR_ = (function fluree$db$query$http_signatures$verify_signature_header_STAR_(req,sig_header_str){
var map__71578 = req;
var map__71578__$1 = cljs.core.__destructure_map.call(null,map__71578);
var request_method = cljs.core.get.call(null,map__71578__$1,new cljs.core.Keyword(null,"request-method","request-method",1764796830));
var uri = cljs.core.get.call(null,map__71578__$1,new cljs.core.Keyword(null,"uri","uri",-774711847));
var headers = cljs.core.get.call(null,map__71578__$1,new cljs.core.Keyword(null,"headers","headers",-835030129));
var server_name = cljs.core.get.call(null,map__71578__$1,new cljs.core.Keyword(null,"server-name","server-name",-1012104295));
var sig_map = (function (){try{return cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,cljs.core.map.call(null,(function (p1__71577_SHARP_){
return clojure.string.split.call(null,clojure.string.replace.call(null,p1__71577_SHARP_,/\"/,""),/=/);
}),clojure.string.split.call(null,sig_header_str,/\",/)));
}catch (e71579){var _ = e71579;
throw cljs.core.ex_info.call(null,["Invalid Signature header. Ensure you have ","key1=value1,key2=value2 format and all string ","values are inside double-quotes."].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-auth","db/invalid-auth",-1361562568)], null));
}})();
var sig_parts = clojure.string.split.call(null,cljs.core.get.call(null,sig_map,"headers",""),/ /);
var sign_string = fluree.db.query.http_signatures.generate_signing_string.call(null,cljs.core.assoc.call(null,headers,"method",request_method,"path",uri,"host",server_name),sig_parts);
var signature = cljs.core.get.call(null,sig_map,"signature");
var authority = fluree.crypto.account_id_from_message.call(null,sign_string,signature);
var keyId = cljs.core.get.call(null,sig_map,"keyId");
var auth = ((cljs.core._EQ_.call(null,"na",keyId))?null:keyId);
fluree.db.util.log.debug.call(null,"Verifying signature. Sign string: ",sign_string," Signature: ",signature," Account Id: ",auth);

return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"auth","auth",1389754926),(function (){var or__4253__auto__ = auth;
if(cljs.core.truth_(or__4253__auto__)){
return or__4253__auto__;
} else {
return authority;
}
})(),new cljs.core.Keyword(null,"authority","authority",-551669367),authority,new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"http-signature","http-signature",993976719)], null);
});
/**
 * Verifies signed http request. If signature header does not exist,
 *   returns nil. If it exists and is valid, returns the authid associated
 *   with it. If it exists and is invalid, throws exception.
 */
fluree.db.query.http_signatures.verify_signature_header = (function fluree$db$query$http_signatures$verify_signature_header(req){
var temp__5753__auto__ = cljs.core.get.call(null,new cljs.core.Keyword(null,"headers","headers",-835030129).cljs$core$IFn$_invoke$arity$1(req),"signature");
if(cljs.core.truth_(temp__5753__auto__)){
var sig_header_str = temp__5753__auto__;
fluree.db.util.log.trace.call(null,["Verifying http signature header: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(sig_header_str)].join(''));

return fluree.db.query.http_signatures.verify_signature_header_STAR_.call(null,req,sig_header_str);
} else {
return null;
}
});
/**
 * If a message digest is present, verifies it.
 */
fluree.db.query.http_signatures.verify_digest = (function fluree$db$query$http_signatures$verify_digest(req){
var digest = cljs.core.get_in.call(null,req,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"headers","headers",-835030129),"digest"], null));
if(cljs.core.truth_((function (){var and__4251__auto__ = digest;
if(cljs.core.truth_(and__4251__auto__)){
return cljs.core.not_EQ_.call(null,digest,"null");
} else {
return and__4251__auto__;
}
})())){
var vec__71580 = cljs.core.re_find.call(null,/^([^=]+)=(.+)$/,digest);
var _ = cljs.core.nth.call(null,vec__71580,(0),null);
var hash_type = cljs.core.nth.call(null,vec__71580,(1),null);
var hash = cljs.core.nth.call(null,vec__71580,(2),null);
var ___$1 = (cljs.core.truth_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, ["SHA-256",null], null), null).call(null,hash_type))?null:(function(){throw cljs.core.ex_info.call(null,["Digest type of ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(hash_type)," is not supported."].join(''),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(401),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-auth","db/invalid-auth",-1361562568)], null))})());
var body = new cljs.core.Keyword(null,"body","body",-2049205669).cljs$core$IFn$_invoke$arity$1(req);
var body__$1 = ((typeof body === 'string')?body:fluree.db.util.json.stringify.call(null,body));
var calc_digest = (function (){var G__71583 = hash_type;
switch (G__71583) {
case "SHA-256":
return fluree.crypto.sha2_256.call(null,body__$1,new cljs.core.Keyword(null,"base64","base64",167760174));

break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__71583)].join('')));

}
})();
var valid_QMARK_ = cljs.core._EQ_.call(null,hash,calc_digest);
if((!(valid_QMARK_))){
throw cljs.core.ex_info.call(null,"Invalid digest.",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(401),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","invalid-auth","db/invalid-auth",-1361562568)], null));
} else {
return req;
}
} else {
return req;
}
});
/**
 * Signs http request by creating required headers and using supplied private key.
 *   req-type should be :get, :post, etc.
 */
fluree.db.query.http_signatures.sign_request = (function fluree$db$query$http_signatures$sign_request(var_args){
var G__71586 = arguments.length;
switch (G__71586) {
case 4:
return fluree.db.query.http_signatures.sign_request.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return fluree.db.query.http_signatures.sign_request.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(fluree.db.query.http_signatures.sign_request.cljs$core$IFn$_invoke$arity$4 = (function (req_method,url,request,private_key){
return fluree.db.query.http_signatures.sign_request.call(null,req_method,url,request,private_key,null);
}));

(fluree.db.query.http_signatures.sign_request.cljs$core$IFn$_invoke$arity$5 = (function (req_method,url,request,private_key,auth){
var map__71587 = request;
var map__71587__$1 = cljs.core.__destructure_map.call(null,map__71587);
var headers = cljs.core.get.call(null,map__71587__$1,new cljs.core.Keyword(null,"headers","headers",-835030129));
var body = cljs.core.get.call(null,map__71587__$1,new cljs.core.Keyword(null,"body","body",-2049205669));
var vec__71588 = (function (){var match = cljs.core.re_find.call(null,/^(https?\:)\/\/(([^:\/?#]*)(?:\:([0-9]+))?)([\/]{0,1}[^?#]*)$/,url);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.get.call(null,match,(2)),cljs.core.get.call(null,match,(5))], null);
})();
var host = cljs.core.nth.call(null,vec__71588,(0),null);
var path = cljs.core.nth.call(null,vec__71588,(1),null);
var date = (function (){var or__4253__auto__ = cljs.core.get.call(null,headers,"date");
if(cljs.core.truth_(or__4253__auto__)){
return or__4253__auto__;
} else {
return (new Date()).toUTCString();
}
})();
var digest = (cljs.core.truth_(body)?["SHA-256=",cljs.core.str.cljs$core$IFn$_invoke$arity$1(fluree.crypto.sha2_256.call(null,body,new cljs.core.Keyword(null,"base64","base64",167760174)))].join(''):null);
var sign_headers = (cljs.core.truth_(body)?new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, ["(request-target)","x-fluree-date","digest"], null):new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, ["(request-target)","x-fluree-date"], null));
var sign_vals = (cljs.core.truth_(body)?new cljs.core.PersistentArrayMap(null, 4, ["x-fluree-date",date,"digest",digest,"method",req_method,"path",path], null):new cljs.core.PersistentArrayMap(null, 3, ["x-fluree-date",date,"method",req_method,"path",path], null));
var signing_string = fluree.db.query.http_signatures.generate_signing_string.call(null,sign_vals,sign_headers);
var sign_headers_str = clojure.string.join.call(null," ",sign_headers);
var sig = fluree.crypto.sign_message.call(null,signing_string,private_key);
var auth__$1 = (function (){var or__4253__auto__ = auth;
if(cljs.core.truth_(or__4253__auto__)){
return or__4253__auto__;
} else {
return "na";
}
})();
var sig_header = ["keyId=\"",cljs.core.str.cljs$core$IFn$_invoke$arity$1(auth__$1),"\",headers=\"",sign_headers_str,"\",algorithm=\"ecdsa-sha256\",signature=\"",sig,"\",date=\"",cljs.core.str.cljs$core$IFn$_invoke$arity$1(date),"\""].join('');
var headers_STAR_ = fluree.db.util.core.without_nils.call(null,cljs.core.merge.call(null,headers,new cljs.core.PersistentArrayMap(null, 3, ["Digest",digest,"X-Fluree-Date",date,"Signature",sig_header], null)));
return cljs.core.assoc.call(null,request,new cljs.core.Keyword(null,"headers","headers",-835030129),headers_STAR_);
}));

(fluree.db.query.http_signatures.sign_request.cljs$lang$maxFixedArity = 5);

/**
 * Returns auth record from separated request parts.
 */
fluree.db.query.http_signatures.verify_request_STAR_ = (function fluree$db$query$http_signatures$verify_request_STAR_(var_args){
var G__71593 = arguments.length;
switch (G__71593) {
case 5:
return fluree.db.query.http_signatures.verify_request_STAR_.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 4:
return fluree.db.query.http_signatures.verify_request_STAR_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(fluree.db.query.http_signatures.verify_request_STAR_.cljs$core$IFn$_invoke$arity$5 = (function (req,method,action,db_name,host){
return fluree.db.query.http_signatures.verify_request_STAR_.call(null,req,method,["/fdb/",fluree.db.util.core.keyword__GT_str.call(null,db_name),"/",fluree.db.util.core.keyword__GT_str.call(null,action)].join(''),host);
}));

(fluree.db.query.http_signatures.verify_request_STAR_.cljs$core$IFn$_invoke$arity$4 = (function (req,method,uri,host){
return fluree.db.query.http_signatures.verify_signature_header.call(null,cljs.core.assoc.call(null,fluree.db.query.http_signatures.verify_digest.call(null,req),new cljs.core.Keyword(null,"request-method","request-method",1764796830),method,new cljs.core.Keyword(null,"uri","uri",-774711847),uri,new cljs.core.Keyword(null,"server-name","server-name",-1012104295),host));
}));

(fluree.db.query.http_signatures.verify_request_STAR_.cljs$lang$maxFixedArity = 5);

/**
 * Returns map of auth and authority from request.
 */
fluree.db.query.http_signatures.verify_request = (function fluree$db$query$http_signatures$verify_request(request){
return fluree.db.query.http_signatures.verify_signature_header.call(null,fluree.db.query.http_signatures.verify_digest.call(null,request));
});
