// Compiled by ClojureScript 1.10.891 {:target :nodejs, :nodejs-rt true, :optimizations :simple}
goog.provide('fluree.db.serde.json');
goog.require('cljs.core');
goog.require('fluree.db.serde.protocol');
goog.require('fluree.db.util.json');
goog.require('fluree.db.flake');
goog.require('fluree.db.util.log');
fluree.db.serde.json.deserialize_block = (function fluree$db$serde$json$deserialize_block(block){
return cljs.core.assoc.call(null,block,new cljs.core.Keyword(null,"flakes","flakes",1977895739),cljs.core.mapv.call(null,fluree.db.flake.parts__GT_Flake,new cljs.core.Keyword(null,"flakes","flakes",1977895739).cljs$core$IFn$_invoke$arity$1(block)));
});
/**
 * Turns :first and :rhs into flakes
 */
fluree.db.serde.json.deserialize_child_node = (function fluree$db$serde$json$deserialize_child_node(child_node){
return cljs.core.assoc.call(null,child_node,new cljs.core.Keyword(null,"first","first",-644103046),(function (){var G__71597 = new cljs.core.Keyword(null,"first","first",-644103046).cljs$core$IFn$_invoke$arity$1(child_node);
if((G__71597 == null)){
return null;
} else {
return fluree.db.flake.parts__GT_Flake.call(null,G__71597);
}
})(),new cljs.core.Keyword(null,"rhs","rhs",-229356739),(function (){var G__71598 = new cljs.core.Keyword(null,"rhs","rhs",-229356739).cljs$core$IFn$_invoke$arity$1(child_node);
if((G__71598 == null)){
return null;
} else {
return fluree.db.flake.parts__GT_Flake.call(null,G__71598);
}
})());
});
fluree.db.serde.json.deserialize_db_root = (function fluree$db$serde$json$deserialize_db_root(db_root){
var map__71599 = db_root;
var map__71599__$1 = cljs.core.__destructure_map.call(null,map__71599);
var spot = cljs.core.get.call(null,map__71599__$1,new cljs.core.Keyword(null,"spot","spot",-1706962147));
var psot = cljs.core.get.call(null,map__71599__$1,new cljs.core.Keyword(null,"psot","psot",2111653059));
var post = cljs.core.get.call(null,map__71599__$1,new cljs.core.Keyword(null,"post","post",269697687));
var opst = cljs.core.get.call(null,map__71599__$1,new cljs.core.Keyword(null,"opst","opst",1213963058));
return cljs.core.assoc.call(null,db_root,new cljs.core.Keyword(null,"spot","spot",-1706962147),fluree.db.serde.json.deserialize_child_node.call(null,spot),new cljs.core.Keyword(null,"psot","psot",2111653059),fluree.db.serde.json.deserialize_child_node.call(null,psot),new cljs.core.Keyword(null,"post","post",269697687),fluree.db.serde.json.deserialize_child_node.call(null,post),new cljs.core.Keyword(null,"opst","opst",1213963058),fluree.db.serde.json.deserialize_child_node.call(null,opst));
});
fluree.db.serde.json.deserialize_branch_node = (function fluree$db$serde$json$deserialize_branch_node(branch){
return cljs.core.assoc.call(null,branch,new cljs.core.Keyword(null,"children","children",-940561982),cljs.core.mapv.call(null,fluree.db.serde.json.deserialize_child_node,new cljs.core.Keyword(null,"children","children",-940561982).cljs$core$IFn$_invoke$arity$1(branch)),new cljs.core.Keyword(null,"rhs","rhs",-229356739),(function (){var G__71600 = new cljs.core.Keyword(null,"rhs","rhs",-229356739).cljs$core$IFn$_invoke$arity$1(branch);
if((G__71600 == null)){
return null;
} else {
return fluree.db.flake.parts__GT_Flake.call(null,G__71600);
}
})());
});
fluree.db.serde.json.deserialize_leaf_node = (function fluree$db$serde$json$deserialize_leaf_node(leaf){
return cljs.core.assoc.call(null,leaf,new cljs.core.Keyword(null,"flakes","flakes",1977895739),cljs.core.mapv.call(null,fluree.db.flake.parts__GT_Flake,new cljs.core.Keyword(null,"flakes","flakes",1977895739).cljs$core$IFn$_invoke$arity$1(leaf)));
});

/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {fluree.db.serde.protocol.StorageSerializer}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.serde.json.Serializer = (function (__meta,__extmap,__hash){
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
(fluree.db.serde.json.Serializer.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4502__auto__,k__4503__auto__){
var self__ = this;
var this__4502__auto____$1 = this;
return this__4502__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4503__auto__,null);
}));

(fluree.db.serde.json.Serializer.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4504__auto__,k71602,else__4505__auto__){
var self__ = this;
var this__4504__auto____$1 = this;
var G__71606 = k71602;
switch (G__71606) {
default:
return cljs.core.get.call(null,self__.__extmap,k71602,else__4505__auto__);

}
}));

(fluree.db.serde.json.Serializer.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4522__auto__,f__4523__auto__,init__4524__auto__){
var self__ = this;
var this__4522__auto____$1 = this;
return cljs.core.reduce.call(null,(function (ret__4525__auto__,p__71607){
var vec__71608 = p__71607;
var k__4526__auto__ = cljs.core.nth.call(null,vec__71608,(0),null);
var v__4527__auto__ = cljs.core.nth.call(null,vec__71608,(1),null);
return f__4523__auto__.call(null,ret__4525__auto__,k__4526__auto__,v__4527__auto__);
}),init__4524__auto__,this__4522__auto____$1);
}));

(fluree.db.serde.json.Serializer.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4517__auto__,writer__4518__auto__,opts__4519__auto__){
var self__ = this;
var this__4517__auto____$1 = this;
var pr_pair__4520__auto__ = (function (keyval__4521__auto__){
return cljs.core.pr_sequential_writer.call(null,writer__4518__auto__,cljs.core.pr_writer,""," ","",opts__4519__auto__,keyval__4521__auto__);
});
return cljs.core.pr_sequential_writer.call(null,writer__4518__auto__,pr_pair__4520__auto__,"#fluree.db.serde.json.Serializer{",", ","}",opts__4519__auto__,cljs.core.concat.call(null,cljs.core.PersistentVector.EMPTY,self__.__extmap));
}));

(fluree.db.serde.json.Serializer.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__71601){
var self__ = this;
var G__71601__$1 = this;
return (new cljs.core.RecordIter((0),G__71601__$1,0,cljs.core.PersistentVector.EMPTY,(cljs.core.truth_(self__.__extmap)?cljs.core._iterator.call(null,self__.__extmap):cljs.core.nil_iter.call(null))));
}));

(fluree.db.serde.json.Serializer.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4500__auto__){
var self__ = this;
var this__4500__auto____$1 = this;
return self__.__meta;
}));

(fluree.db.serde.json.Serializer.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4497__auto__){
var self__ = this;
var this__4497__auto____$1 = this;
return (new fluree.db.serde.json.Serializer(self__.__meta,self__.__extmap,self__.__hash));
}));

(fluree.db.serde.json.Serializer.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4506__auto__){
var self__ = this;
var this__4506__auto____$1 = this;
return (0 + cljs.core.count.call(null,self__.__extmap));
}));

(fluree.db.serde.json.Serializer.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4498__auto__){
var self__ = this;
var this__4498__auto____$1 = this;
var h__4360__auto__ = self__.__hash;
if((!((h__4360__auto__ == null)))){
return h__4360__auto__;
} else {
var h__4360__auto____$1 = (function (coll__4499__auto__){
return (1505122844 ^ cljs.core.hash_unordered_coll.call(null,coll__4499__auto__));
}).call(null,this__4498__auto____$1);
(self__.__hash = h__4360__auto____$1);

return h__4360__auto____$1;
}
}));

(fluree.db.serde.json.Serializer.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this71603,other71604){
var self__ = this;
var this71603__$1 = this;
return (((!((other71604 == null)))) && ((((this71603__$1.constructor === other71604.constructor)) && (cljs.core._EQ_.call(null,this71603__$1.__extmap,other71604.__extmap)))));
}));

(fluree.db.serde.json.Serializer.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4512__auto__,k__4513__auto__){
var self__ = this;
var this__4512__auto____$1 = this;
if(cljs.core.contains_QMARK_.call(null,cljs.core.PersistentHashSet.EMPTY,k__4513__auto__)){
return cljs.core.dissoc.call(null,cljs.core._with_meta.call(null,cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,this__4512__auto____$1),self__.__meta),k__4513__auto__);
} else {
return (new fluree.db.serde.json.Serializer(self__.__meta,cljs.core.not_empty.call(null,cljs.core.dissoc.call(null,self__.__extmap,k__4513__auto__)),null));
}
}));

(fluree.db.serde.json.Serializer.prototype.cljs$core$IAssociative$_contains_key_QMARK_$arity$2 = (function (this__4509__auto__,k71602){
var self__ = this;
var this__4509__auto____$1 = this;
return cljs.core.contains_QMARK_.call(null,self__.__extmap,k71602);
}));

(fluree.db.serde.json.Serializer.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4510__auto__,k__4511__auto__,G__71601){
var self__ = this;
var this__4510__auto____$1 = this;
var pred__71611 = cljs.core.keyword_identical_QMARK_;
var expr__71612 = k__4511__auto__;
return (new fluree.db.serde.json.Serializer(self__.__meta,cljs.core.assoc.call(null,self__.__extmap,k__4511__auto__,G__71601),null));
}));

(fluree.db.serde.json.Serializer.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4515__auto__){
var self__ = this;
var this__4515__auto____$1 = this;
return cljs.core.seq.call(null,cljs.core.concat.call(null,cljs.core.PersistentVector.EMPTY,self__.__extmap));
}));

(fluree.db.serde.json.Serializer.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4501__auto__,G__71601){
var self__ = this;
var this__4501__auto____$1 = this;
return (new fluree.db.serde.json.Serializer(G__71601,self__.__extmap,self__.__hash));
}));

(fluree.db.serde.json.Serializer.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4507__auto__,entry__4508__auto__){
var self__ = this;
var this__4507__auto____$1 = this;
if(cljs.core.vector_QMARK_.call(null,entry__4508__auto__)){
return this__4507__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.call(null,entry__4508__auto__,(0)),cljs.core._nth.call(null,entry__4508__auto__,(1)));
} else {
return cljs.core.reduce.call(null,cljs.core._conj,this__4507__auto____$1,entry__4508__auto__);
}
}));

(fluree.db.serde.json.Serializer.prototype.fluree$db$serde$protocol$StorageSerializer$ = cljs.core.PROTOCOL_SENTINEL);

(fluree.db.serde.json.Serializer.prototype.fluree$db$serde$protocol$StorageSerializer$_deserialize_block$arity$2 = (function (_,block){
var self__ = this;
var ___$1 = this;
return fluree.db.serde.json.deserialize_block.call(null,fluree.db.util.json.parse.call(null,block));
}));

(fluree.db.serde.json.Serializer.prototype.fluree$db$serde$protocol$StorageSerializer$_deserialize_branch$arity$2 = (function (_,branch){
var self__ = this;
var ___$1 = this;
return fluree.db.serde.json.deserialize_branch_node.call(null,fluree.db.util.json.parse.call(null,branch));
}));

(fluree.db.serde.json.Serializer.prototype.fluree$db$serde$protocol$StorageSerializer$_serialize_garbage$arity$2 = (function (_,garbage){
var self__ = this;
var ___$1 = this;
throw cljs.core.ex_info.call(null,"-serialize-garbage not supported for JSON.",cljs.core.PersistentArrayMap.EMPTY);
}));

(fluree.db.serde.json.Serializer.prototype.fluree$db$serde$protocol$StorageSerializer$_deserialize_db_pointer$arity$2 = (function (_,pointer){
var self__ = this;
var ___$1 = this;
return fluree.db.util.json.parse.call(null,pointer);
}));

(fluree.db.serde.json.Serializer.prototype.fluree$db$serde$protocol$StorageSerializer$_deserialize_db_root$arity$2 = (function (_,db_root){
var self__ = this;
var ___$1 = this;
return fluree.db.serde.json.deserialize_db_root.call(null,fluree.db.util.json.parse.call(null,db_root));
}));

(fluree.db.serde.json.Serializer.prototype.fluree$db$serde$protocol$StorageSerializer$_serialize_branch$arity$2 = (function (_,branch){
var self__ = this;
var ___$1 = this;
throw cljs.core.ex_info.call(null,"-serialize-branch not supported for JSON.",cljs.core.PersistentArrayMap.EMPTY);
}));

(fluree.db.serde.json.Serializer.prototype.fluree$db$serde$protocol$StorageSerializer$_deserialize_garbage$arity$2 = (function (_,garbage){
var self__ = this;
var ___$1 = this;
return fluree.db.util.json.parse.call(null,garbage);
}));

(fluree.db.serde.json.Serializer.prototype.fluree$db$serde$protocol$StorageSerializer$_serialize_leaf$arity$2 = (function (_,leaf){
var self__ = this;
var ___$1 = this;
throw cljs.core.ex_info.call(null,"-serialize-leaf not supported for JSON.",cljs.core.PersistentArrayMap.EMPTY);
}));

(fluree.db.serde.json.Serializer.prototype.fluree$db$serde$protocol$StorageSerializer$_serialize_db_pointer$arity$2 = (function (_,pointer){
var self__ = this;
var ___$1 = this;
throw cljs.core.ex_info.call(null,"-serialize-db-pointer not supported for JSON.",cljs.core.PersistentArrayMap.EMPTY);
}));

(fluree.db.serde.json.Serializer.prototype.fluree$db$serde$protocol$StorageSerializer$_deserialize_leaf$arity$2 = (function (_,leaf){
var self__ = this;
var ___$1 = this;
return fluree.db.serde.json.deserialize_leaf_node.call(null,fluree.db.util.json.parse.call(null,leaf));
}));

(fluree.db.serde.json.Serializer.prototype.fluree$db$serde$protocol$StorageSerializer$_serialize_db_root$arity$2 = (function (_,db_root){
var self__ = this;
var ___$1 = this;
throw cljs.core.ex_info.call(null,"-serialize-db-root not supported for JSON.",cljs.core.PersistentArrayMap.EMPTY);
}));

(fluree.db.serde.json.Serializer.prototype.fluree$db$serde$protocol$StorageSerializer$_serialize_block$arity$2 = (function (_,block){
var self__ = this;
var ___$1 = this;
throw cljs.core.ex_info.call(null,"-serialize-block not supported for JSON.",cljs.core.PersistentArrayMap.EMPTY);
}));

(fluree.db.serde.json.Serializer.getBasis = (function (){
return cljs.core.PersistentVector.EMPTY;
}));

(fluree.db.serde.json.Serializer.cljs$lang$type = true);

(fluree.db.serde.json.Serializer.cljs$lang$ctorPrSeq = (function (this__4546__auto__){
return (new cljs.core.List(null,"fluree.db.serde.json/Serializer",null,(1),null));
}));

(fluree.db.serde.json.Serializer.cljs$lang$ctorPrWriter = (function (this__4546__auto__,writer__4547__auto__){
return cljs.core._write.call(null,writer__4547__auto__,"fluree.db.serde.json/Serializer");
}));

/**
 * Positional factory function for fluree.db.serde.json/Serializer.
 */
fluree.db.serde.json.__GT_Serializer = (function fluree$db$serde$json$__GT_Serializer(){
return (new fluree.db.serde.json.Serializer(null,null,null));
});

/**
 * Factory function for fluree.db.serde.json/Serializer, taking a map of keywords to field values.
 */
fluree.db.serde.json.map__GT_Serializer = (function fluree$db$serde$json$map__GT_Serializer(G__71605){
var extmap__4542__auto__ = (function (){var G__71614 = cljs.core.dissoc.call(null,G__71605);
if(cljs.core.record_QMARK_.call(null,G__71605)){
return cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,G__71614);
} else {
return G__71614;
}
})();
return (new fluree.db.serde.json.Serializer(null,cljs.core.not_empty.call(null,extmap__4542__auto__),null));
});

/**
 * Returns a JSON serializer / deserializer
 */
fluree.db.serde.json.json_serde = (function fluree$db$serde$json$json_serde(){
return fluree.db.serde.json.__GT_Serializer.call(null);
});
