// Compiled by ClojureScript 1.10.891 {:target :nodejs, :nodejs-rt true, :optimizations :simple}
goog.provide('tailrecursion.priority_map');
goog.require('cljs.core');
goog.require('cljs.core');
goog.require('cljs.reader');

/**
* @constructor
 * @implements {cljs.core.IReversible}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.IFn}
 * @implements {cljs.core.ICollection}
 * @implements {cljs.core.IEmptyableCollection}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISorted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IStack}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
tailrecursion.priority_map.PersistentPriorityMap = (function (priority__GT_set_of_items,item__GT_priority,meta,keyfn,__hash){
this.priority__GT_set_of_items = priority__GT_set_of_items;
this.item__GT_priority = item__GT_priority;
this.meta = meta;
this.keyfn = keyfn;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2565220111;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this$,item){
var self__ = this;
var this$__$1 = this;
return cljs.core.get.call(null,self__.item__GT_priority,item);
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (coll,item,not_found){
var self__ = this;
var coll__$1 = this;
return cljs.core.get.call(null,self__.item__GT_priority,item,not_found);
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (coll,writer,opts){
var self__ = this;
var coll__$1 = this;
var pr_pair = (function (keyval){
return cljs.core.pr_sequential_writer.call(null,writer,cljs.core.pr_writer,""," ","",opts,keyval);
});
return cljs.core.pr_sequential_writer.call(null,writer,pr_pair,"#tailrecursion.priority-map {",", ","}",opts,coll__$1);
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
return self__.meta;
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$ICounted$_count$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
return cljs.core.count.call(null,self__.item__GT_priority);
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IStack$_peek$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
if((cljs.core.count.call(null,self__.item__GT_priority) === (0))){
return null;
} else {
var f = cljs.core.first.call(null,self__.priority__GT_set_of_items);
var item = cljs.core.first.call(null,cljs.core.val.call(null,f));
if(cljs.core.truth_(self__.keyfn)){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,self__.item__GT_priority.call(null,item)], null);
} else {
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,cljs.core.key.call(null,f)], null);
}
}
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IStack$_pop$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
if((cljs.core.count.call(null,self__.item__GT_priority) === (0))){
throw (new Error("Can't pop empty priority map"));
} else {
var f = cljs.core.first.call(null,self__.priority__GT_set_of_items);
var item_set = cljs.core.val.call(null,f);
var item = cljs.core.first.call(null,item_set);
var priority_key = cljs.core.key.call(null,f);
if(cljs.core._EQ_.call(null,cljs.core.count.call(null,item_set),(1))){
return (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.dissoc.call(null,self__.priority__GT_set_of_items,priority_key),cljs.core.dissoc.call(null,self__.item__GT_priority,item),self__.meta,self__.keyfn,null));
} else {
return (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.assoc.call(null,self__.priority__GT_set_of_items,priority_key,cljs.core.disj.call(null,item_set,item)),cljs.core.dissoc.call(null,self__.item__GT_priority,item),self__.meta,self__.keyfn,null));
}
}
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IReversible$_rseq$arity$1 = (function (coll){
var self__ = this;
var coll__$1 = this;
if(cljs.core.truth_(self__.keyfn)){
return cljs.core.seq.call(null,(function (){var iter__4652__auto__ = (function tailrecursion$priority_map$iter__37928(s__37929){
return (new cljs.core.LazySeq(null,(function (){
var s__37929__$1 = s__37929;
while(true){
var temp__5753__auto__ = cljs.core.seq.call(null,s__37929__$1);
if(temp__5753__auto__){
var xs__6308__auto__ = temp__5753__auto__;
var vec__37934 = cljs.core.first.call(null,xs__6308__auto__);
var priority = cljs.core.nth.call(null,vec__37934,(0),null);
var item_set = cljs.core.nth.call(null,vec__37934,(1),null);
var iterys__4648__auto__ = ((function (s__37929__$1,vec__37934,priority,item_set,xs__6308__auto__,temp__5753__auto__,coll__$1){
return (function tailrecursion$priority_map$iter__37928_$_iter__37930(s__37931){
return (new cljs.core.LazySeq(null,((function (s__37929__$1,vec__37934,priority,item_set,xs__6308__auto__,temp__5753__auto__,coll__$1){
return (function (){
var s__37931__$1 = s__37931;
while(true){
var temp__5753__auto____$1 = cljs.core.seq.call(null,s__37931__$1);
if(temp__5753__auto____$1){
var s__37931__$2 = temp__5753__auto____$1;
if(cljs.core.chunked_seq_QMARK_.call(null,s__37931__$2)){
var c__4650__auto__ = cljs.core.chunk_first.call(null,s__37931__$2);
var size__4651__auto__ = cljs.core.count.call(null,c__4650__auto__);
var b__37933 = cljs.core.chunk_buffer.call(null,size__4651__auto__);
if((function (){var i__37932 = (0);
while(true){
if((i__37932 < size__4651__auto__)){
var item = cljs.core._nth.call(null,c__4650__auto__,i__37932);
cljs.core.chunk_append.call(null,b__37933,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,self__.item__GT_priority.call(null,item)], null));

var G__37982 = (i__37932 + (1));
i__37932 = G__37982;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37933),tailrecursion$priority_map$iter__37928_$_iter__37930.call(null,cljs.core.chunk_rest.call(null,s__37931__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37933),null);
}
} else {
var item = cljs.core.first.call(null,s__37931__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,self__.item__GT_priority.call(null,item)], null),tailrecursion$priority_map$iter__37928_$_iter__37930.call(null,cljs.core.rest.call(null,s__37931__$2)));
}
} else {
return null;
}
break;
}
});})(s__37929__$1,vec__37934,priority,item_set,xs__6308__auto__,temp__5753__auto__,coll__$1))
,null,null));
});})(s__37929__$1,vec__37934,priority,item_set,xs__6308__auto__,temp__5753__auto__,coll__$1))
;
var fs__4649__auto__ = cljs.core.seq.call(null,iterys__4648__auto__.call(null,item_set));
if(fs__4649__auto__){
return cljs.core.concat.call(null,fs__4649__auto__,tailrecursion$priority_map$iter__37928.call(null,cljs.core.rest.call(null,s__37929__$1)));
} else {
var G__37983 = cljs.core.rest.call(null,s__37929__$1);
s__37929__$1 = G__37983;
continue;
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__4652__auto__.call(null,cljs.core.rseq.call(null,self__.priority__GT_set_of_items));
})());
} else {
return cljs.core.seq.call(null,(function (){var iter__4652__auto__ = (function tailrecursion$priority_map$iter__37937(s__37938){
return (new cljs.core.LazySeq(null,(function (){
var s__37938__$1 = s__37938;
while(true){
var temp__5753__auto__ = cljs.core.seq.call(null,s__37938__$1);
if(temp__5753__auto__){
var xs__6308__auto__ = temp__5753__auto__;
var vec__37943 = cljs.core.first.call(null,xs__6308__auto__);
var priority = cljs.core.nth.call(null,vec__37943,(0),null);
var item_set = cljs.core.nth.call(null,vec__37943,(1),null);
var iterys__4648__auto__ = ((function (s__37938__$1,vec__37943,priority,item_set,xs__6308__auto__,temp__5753__auto__,coll__$1){
return (function tailrecursion$priority_map$iter__37937_$_iter__37939(s__37940){
return (new cljs.core.LazySeq(null,((function (s__37938__$1,vec__37943,priority,item_set,xs__6308__auto__,temp__5753__auto__,coll__$1){
return (function (){
var s__37940__$1 = s__37940;
while(true){
var temp__5753__auto____$1 = cljs.core.seq.call(null,s__37940__$1);
if(temp__5753__auto____$1){
var s__37940__$2 = temp__5753__auto____$1;
if(cljs.core.chunked_seq_QMARK_.call(null,s__37940__$2)){
var c__4650__auto__ = cljs.core.chunk_first.call(null,s__37940__$2);
var size__4651__auto__ = cljs.core.count.call(null,c__4650__auto__);
var b__37942 = cljs.core.chunk_buffer.call(null,size__4651__auto__);
if((function (){var i__37941 = (0);
while(true){
if((i__37941 < size__4651__auto__)){
var item = cljs.core._nth.call(null,c__4650__auto__,i__37941);
cljs.core.chunk_append.call(null,b__37942,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,priority], null));

var G__37984 = (i__37941 + (1));
i__37941 = G__37984;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37942),tailrecursion$priority_map$iter__37937_$_iter__37939.call(null,cljs.core.chunk_rest.call(null,s__37940__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37942),null);
}
} else {
var item = cljs.core.first.call(null,s__37940__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,priority], null),tailrecursion$priority_map$iter__37937_$_iter__37939.call(null,cljs.core.rest.call(null,s__37940__$2)));
}
} else {
return null;
}
break;
}
});})(s__37938__$1,vec__37943,priority,item_set,xs__6308__auto__,temp__5753__auto__,coll__$1))
,null,null));
});})(s__37938__$1,vec__37943,priority,item_set,xs__6308__auto__,temp__5753__auto__,coll__$1))
;
var fs__4649__auto__ = cljs.core.seq.call(null,iterys__4648__auto__.call(null,item_set));
if(fs__4649__auto__){
return cljs.core.concat.call(null,fs__4649__auto__,tailrecursion$priority_map$iter__37937.call(null,cljs.core.rest.call(null,s__37938__$1)));
} else {
var G__37985 = cljs.core.rest.call(null,s__37938__$1);
s__37938__$1 = G__37985;
continue;
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__4652__auto__.call(null,cljs.core.rseq.call(null,self__.priority__GT_set_of_items));
})());
}
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IHash$_hash$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
var h__4360__auto__ = self__.__hash;
if((!((h__4360__auto__ == null)))){
return h__4360__auto__;
} else {
var h__4360__auto____$1 = cljs.core.hash_unordered_coll.call(null,this$__$1);
(self__.__hash = h__4360__auto____$1);

return h__4360__auto____$1;
}
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this$,other){
var self__ = this;
var this$__$1 = this;
return cljs.core._equiv.call(null,self__.item__GT_priority,other);
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IEmptyableCollection$_empty$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
return cljs.core.with_meta.call(null,tailrecursion.priority_map.PersistentPriorityMap.EMPTY,self__.meta);
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this$,item){
var self__ = this;
var this$__$1 = this;
var priority = self__.item__GT_priority.call(null,item,new cljs.core.Keyword("tailrecursion.priority-map","not-found","tailrecursion.priority-map/not-found",-436727517));
if(cljs.core._EQ_.call(null,priority,new cljs.core.Keyword("tailrecursion.priority-map","not-found","tailrecursion.priority-map/not-found",-436727517))){
return this$__$1;
} else {
var priority_key = self__.keyfn.call(null,priority);
var item_set = self__.priority__GT_set_of_items.call(null,priority_key);
if(cljs.core._EQ_.call(null,cljs.core.count.call(null,item_set),(1))){
return (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.dissoc.call(null,self__.priority__GT_set_of_items,priority_key),cljs.core.dissoc.call(null,self__.item__GT_priority,item),self__.meta,self__.keyfn,null));
} else {
return (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.assoc.call(null,self__.priority__GT_set_of_items,priority_key,cljs.core.disj.call(null,item_set,item)),cljs.core.dissoc.call(null,self__.item__GT_priority,item),self__.meta,self__.keyfn,null));
}
}
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this$,item,priority){
var self__ = this;
var this$__$1 = this;
var temp__5751__auto__ = cljs.core.get.call(null,self__.item__GT_priority,item,null);
if(cljs.core.truth_(temp__5751__auto__)){
var current_priority = temp__5751__auto__;
if(cljs.core._EQ_.call(null,current_priority,priority)){
return this$__$1;
} else {
var priority_key = self__.keyfn.call(null,priority);
var current_priority_key = self__.keyfn.call(null,current_priority);
var item_set = cljs.core.get.call(null,self__.priority__GT_set_of_items,current_priority_key);
if(cljs.core._EQ_.call(null,cljs.core.count.call(null,item_set),(1))){
return (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.assoc.call(null,cljs.core.dissoc.call(null,self__.priority__GT_set_of_items,current_priority_key),priority_key,cljs.core.conj.call(null,cljs.core.get.call(null,self__.priority__GT_set_of_items,priority_key,cljs.core.PersistentHashSet.EMPTY),item)),cljs.core.assoc.call(null,self__.item__GT_priority,item,priority),self__.meta,self__.keyfn,null));
} else {
return (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.assoc.call(null,self__.priority__GT_set_of_items,current_priority_key,cljs.core.disj.call(null,cljs.core.get.call(null,self__.priority__GT_set_of_items,current_priority_key),item),priority_key,cljs.core.conj.call(null,cljs.core.get.call(null,self__.priority__GT_set_of_items,priority_key,cljs.core.PersistentHashSet.EMPTY),item)),cljs.core.assoc.call(null,self__.item__GT_priority,item,priority),self__.meta,self__.keyfn,null));
}
}
} else {
var priority_key = self__.keyfn.call(null,priority);
return (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.assoc.call(null,self__.priority__GT_set_of_items,priority_key,cljs.core.conj.call(null,cljs.core.get.call(null,self__.priority__GT_set_of_items,priority_key,cljs.core.PersistentHashSet.EMPTY),item)),cljs.core.assoc.call(null,self__.item__GT_priority,item,priority),self__.meta,self__.keyfn,null));
}
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IAssociative$_contains_key_QMARK_$arity$2 = (function (this$,item){
var self__ = this;
var this$__$1 = this;
return cljs.core.contains_QMARK_.call(null,self__.item__GT_priority,item);
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
if(cljs.core.truth_(self__.keyfn)){
return cljs.core.seq.call(null,(function (){var iter__4652__auto__ = (function tailrecursion$priority_map$iter__37946(s__37947){
return (new cljs.core.LazySeq(null,(function (){
var s__37947__$1 = s__37947;
while(true){
var temp__5753__auto__ = cljs.core.seq.call(null,s__37947__$1);
if(temp__5753__auto__){
var xs__6308__auto__ = temp__5753__auto__;
var vec__37952 = cljs.core.first.call(null,xs__6308__auto__);
var priority = cljs.core.nth.call(null,vec__37952,(0),null);
var item_set = cljs.core.nth.call(null,vec__37952,(1),null);
var iterys__4648__auto__ = ((function (s__37947__$1,vec__37952,priority,item_set,xs__6308__auto__,temp__5753__auto__,this$__$1){
return (function tailrecursion$priority_map$iter__37946_$_iter__37948(s__37949){
return (new cljs.core.LazySeq(null,((function (s__37947__$1,vec__37952,priority,item_set,xs__6308__auto__,temp__5753__auto__,this$__$1){
return (function (){
var s__37949__$1 = s__37949;
while(true){
var temp__5753__auto____$1 = cljs.core.seq.call(null,s__37949__$1);
if(temp__5753__auto____$1){
var s__37949__$2 = temp__5753__auto____$1;
if(cljs.core.chunked_seq_QMARK_.call(null,s__37949__$2)){
var c__4650__auto__ = cljs.core.chunk_first.call(null,s__37949__$2);
var size__4651__auto__ = cljs.core.count.call(null,c__4650__auto__);
var b__37951 = cljs.core.chunk_buffer.call(null,size__4651__auto__);
if((function (){var i__37950 = (0);
while(true){
if((i__37950 < size__4651__auto__)){
var item = cljs.core._nth.call(null,c__4650__auto__,i__37950);
cljs.core.chunk_append.call(null,b__37951,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,self__.item__GT_priority.call(null,item)], null));

var G__37986 = (i__37950 + (1));
i__37950 = G__37986;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37951),tailrecursion$priority_map$iter__37946_$_iter__37948.call(null,cljs.core.chunk_rest.call(null,s__37949__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37951),null);
}
} else {
var item = cljs.core.first.call(null,s__37949__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,self__.item__GT_priority.call(null,item)], null),tailrecursion$priority_map$iter__37946_$_iter__37948.call(null,cljs.core.rest.call(null,s__37949__$2)));
}
} else {
return null;
}
break;
}
});})(s__37947__$1,vec__37952,priority,item_set,xs__6308__auto__,temp__5753__auto__,this$__$1))
,null,null));
});})(s__37947__$1,vec__37952,priority,item_set,xs__6308__auto__,temp__5753__auto__,this$__$1))
;
var fs__4649__auto__ = cljs.core.seq.call(null,iterys__4648__auto__.call(null,item_set));
if(fs__4649__auto__){
return cljs.core.concat.call(null,fs__4649__auto__,tailrecursion$priority_map$iter__37946.call(null,cljs.core.rest.call(null,s__37947__$1)));
} else {
var G__37987 = cljs.core.rest.call(null,s__37947__$1);
s__37947__$1 = G__37987;
continue;
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__4652__auto__.call(null,self__.priority__GT_set_of_items);
})());
} else {
return cljs.core.seq.call(null,(function (){var iter__4652__auto__ = (function tailrecursion$priority_map$iter__37955(s__37956){
return (new cljs.core.LazySeq(null,(function (){
var s__37956__$1 = s__37956;
while(true){
var temp__5753__auto__ = cljs.core.seq.call(null,s__37956__$1);
if(temp__5753__auto__){
var xs__6308__auto__ = temp__5753__auto__;
var vec__37961 = cljs.core.first.call(null,xs__6308__auto__);
var priority = cljs.core.nth.call(null,vec__37961,(0),null);
var item_set = cljs.core.nth.call(null,vec__37961,(1),null);
var iterys__4648__auto__ = ((function (s__37956__$1,vec__37961,priority,item_set,xs__6308__auto__,temp__5753__auto__,this$__$1){
return (function tailrecursion$priority_map$iter__37955_$_iter__37957(s__37958){
return (new cljs.core.LazySeq(null,((function (s__37956__$1,vec__37961,priority,item_set,xs__6308__auto__,temp__5753__auto__,this$__$1){
return (function (){
var s__37958__$1 = s__37958;
while(true){
var temp__5753__auto____$1 = cljs.core.seq.call(null,s__37958__$1);
if(temp__5753__auto____$1){
var s__37958__$2 = temp__5753__auto____$1;
if(cljs.core.chunked_seq_QMARK_.call(null,s__37958__$2)){
var c__4650__auto__ = cljs.core.chunk_first.call(null,s__37958__$2);
var size__4651__auto__ = cljs.core.count.call(null,c__4650__auto__);
var b__37960 = cljs.core.chunk_buffer.call(null,size__4651__auto__);
if((function (){var i__37959 = (0);
while(true){
if((i__37959 < size__4651__auto__)){
var item = cljs.core._nth.call(null,c__4650__auto__,i__37959);
cljs.core.chunk_append.call(null,b__37960,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,priority], null));

var G__37988 = (i__37959 + (1));
i__37959 = G__37988;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37960),tailrecursion$priority_map$iter__37955_$_iter__37957.call(null,cljs.core.chunk_rest.call(null,s__37958__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37960),null);
}
} else {
var item = cljs.core.first.call(null,s__37958__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,priority], null),tailrecursion$priority_map$iter__37955_$_iter__37957.call(null,cljs.core.rest.call(null,s__37958__$2)));
}
} else {
return null;
}
break;
}
});})(s__37956__$1,vec__37961,priority,item_set,xs__6308__auto__,temp__5753__auto__,this$__$1))
,null,null));
});})(s__37956__$1,vec__37961,priority,item_set,xs__6308__auto__,temp__5753__auto__,this$__$1))
;
var fs__4649__auto__ = cljs.core.seq.call(null,iterys__4648__auto__.call(null,item_set));
if(fs__4649__auto__){
return cljs.core.concat.call(null,fs__4649__auto__,tailrecursion$priority_map$iter__37955.call(null,cljs.core.rest.call(null,s__37956__$1)));
} else {
var G__37989 = cljs.core.rest.call(null,s__37956__$1);
s__37956__$1 = G__37989;
continue;
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__4652__auto__.call(null,self__.priority__GT_set_of_items);
})());
}
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this$,meta__$1){
var self__ = this;
var this$__$1 = this;
return (new tailrecursion.priority_map.PersistentPriorityMap(self__.priority__GT_set_of_items,self__.item__GT_priority,meta__$1,self__.keyfn,self__.__hash));
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this$,entry){
var self__ = this;
var this$__$1 = this;
if(cljs.core.vector_QMARK_.call(null,entry)){
return cljs.core._assoc.call(null,this$__$1,cljs.core._nth.call(null,entry,(0)),cljs.core._nth.call(null,entry,(1)));
} else {
return cljs.core.reduce.call(null,cljs.core._conj,this$__$1,entry);
}
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.call = (function() {
var G__37990 = null;
var G__37990__2 = (function (self__,item){
var self__ = this;
var self____$1 = this;
var this$ = self____$1;
return cljs.core._lookup.call(null,this$,item);
});
var G__37990__3 = (function (self__,item,not_found){
var self__ = this;
var self____$1 = this;
var this$ = self____$1;
return cljs.core._lookup.call(null,this$,item,not_found);
});
G__37990 = function(self__,item,not_found){
switch(arguments.length){
case 2:
return G__37990__2.call(this,self__,item);
case 3:
return G__37990__3.call(this,self__,item,not_found);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
G__37990.cljs$core$IFn$_invoke$arity$2 = G__37990__2;
G__37990.cljs$core$IFn$_invoke$arity$3 = G__37990__3;
return G__37990;
})()
);

(tailrecursion.priority_map.PersistentPriorityMap.prototype.apply = (function (self__,args37927){
var self__ = this;
var self____$1 = this;
return self____$1.call.apply(self____$1,[self____$1].concat(cljs.core.aclone.call(null,args37927)));
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IFn$_invoke$arity$1 = (function (item){
var self__ = this;
var this$ = this;
return cljs.core._lookup.call(null,this$,item);
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$IFn$_invoke$arity$2 = (function (item,not_found){
var self__ = this;
var this$ = this;
return cljs.core._lookup.call(null,this$,item,not_found);
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$ISorted$_sorted_seq$arity$2 = (function (this$,ascending_QMARK_){
var self__ = this;
var this$__$1 = this;
return (cljs.core.truth_(ascending_QMARK_)?cljs.core.seq:cljs.core.rseq).call(null,this$__$1);
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$ISorted$_sorted_seq_from$arity$3 = (function (this$,k,ascending_QMARK_){
var self__ = this;
var this$__$1 = this;
var sets = (cljs.core.truth_(ascending_QMARK_)?cljs.core.subseq.call(null,self__.priority__GT_set_of_items,cljs.core._GT__EQ_,k):cljs.core.rsubseq.call(null,self__.priority__GT_set_of_items,cljs.core._LT__EQ_,k));
if(cljs.core.truth_(self__.keyfn)){
return cljs.core.seq.call(null,(function (){var iter__4652__auto__ = (function tailrecursion$priority_map$iter__37964(s__37965){
return (new cljs.core.LazySeq(null,(function (){
var s__37965__$1 = s__37965;
while(true){
var temp__5753__auto__ = cljs.core.seq.call(null,s__37965__$1);
if(temp__5753__auto__){
var xs__6308__auto__ = temp__5753__auto__;
var vec__37970 = cljs.core.first.call(null,xs__6308__auto__);
var priority = cljs.core.nth.call(null,vec__37970,(0),null);
var item_set = cljs.core.nth.call(null,vec__37970,(1),null);
var iterys__4648__auto__ = ((function (s__37965__$1,vec__37970,priority,item_set,xs__6308__auto__,temp__5753__auto__,sets,this$__$1){
return (function tailrecursion$priority_map$iter__37964_$_iter__37966(s__37967){
return (new cljs.core.LazySeq(null,((function (s__37965__$1,vec__37970,priority,item_set,xs__6308__auto__,temp__5753__auto__,sets,this$__$1){
return (function (){
var s__37967__$1 = s__37967;
while(true){
var temp__5753__auto____$1 = cljs.core.seq.call(null,s__37967__$1);
if(temp__5753__auto____$1){
var s__37967__$2 = temp__5753__auto____$1;
if(cljs.core.chunked_seq_QMARK_.call(null,s__37967__$2)){
var c__4650__auto__ = cljs.core.chunk_first.call(null,s__37967__$2);
var size__4651__auto__ = cljs.core.count.call(null,c__4650__auto__);
var b__37969 = cljs.core.chunk_buffer.call(null,size__4651__auto__);
if((function (){var i__37968 = (0);
while(true){
if((i__37968 < size__4651__auto__)){
var item = cljs.core._nth.call(null,c__4650__auto__,i__37968);
cljs.core.chunk_append.call(null,b__37969,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,self__.item__GT_priority.call(null,item)], null));

var G__37991 = (i__37968 + (1));
i__37968 = G__37991;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37969),tailrecursion$priority_map$iter__37964_$_iter__37966.call(null,cljs.core.chunk_rest.call(null,s__37967__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37969),null);
}
} else {
var item = cljs.core.first.call(null,s__37967__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,self__.item__GT_priority.call(null,item)], null),tailrecursion$priority_map$iter__37964_$_iter__37966.call(null,cljs.core.rest.call(null,s__37967__$2)));
}
} else {
return null;
}
break;
}
});})(s__37965__$1,vec__37970,priority,item_set,xs__6308__auto__,temp__5753__auto__,sets,this$__$1))
,null,null));
});})(s__37965__$1,vec__37970,priority,item_set,xs__6308__auto__,temp__5753__auto__,sets,this$__$1))
;
var fs__4649__auto__ = cljs.core.seq.call(null,iterys__4648__auto__.call(null,item_set));
if(fs__4649__auto__){
return cljs.core.concat.call(null,fs__4649__auto__,tailrecursion$priority_map$iter__37964.call(null,cljs.core.rest.call(null,s__37965__$1)));
} else {
var G__37992 = cljs.core.rest.call(null,s__37965__$1);
s__37965__$1 = G__37992;
continue;
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__4652__auto__.call(null,sets);
})());
} else {
return cljs.core.seq.call(null,(function (){var iter__4652__auto__ = (function tailrecursion$priority_map$iter__37973(s__37974){
return (new cljs.core.LazySeq(null,(function (){
var s__37974__$1 = s__37974;
while(true){
var temp__5753__auto__ = cljs.core.seq.call(null,s__37974__$1);
if(temp__5753__auto__){
var xs__6308__auto__ = temp__5753__auto__;
var vec__37979 = cljs.core.first.call(null,xs__6308__auto__);
var priority = cljs.core.nth.call(null,vec__37979,(0),null);
var item_set = cljs.core.nth.call(null,vec__37979,(1),null);
var iterys__4648__auto__ = ((function (s__37974__$1,vec__37979,priority,item_set,xs__6308__auto__,temp__5753__auto__,sets,this$__$1){
return (function tailrecursion$priority_map$iter__37973_$_iter__37975(s__37976){
return (new cljs.core.LazySeq(null,((function (s__37974__$1,vec__37979,priority,item_set,xs__6308__auto__,temp__5753__auto__,sets,this$__$1){
return (function (){
var s__37976__$1 = s__37976;
while(true){
var temp__5753__auto____$1 = cljs.core.seq.call(null,s__37976__$1);
if(temp__5753__auto____$1){
var s__37976__$2 = temp__5753__auto____$1;
if(cljs.core.chunked_seq_QMARK_.call(null,s__37976__$2)){
var c__4650__auto__ = cljs.core.chunk_first.call(null,s__37976__$2);
var size__4651__auto__ = cljs.core.count.call(null,c__4650__auto__);
var b__37978 = cljs.core.chunk_buffer.call(null,size__4651__auto__);
if((function (){var i__37977 = (0);
while(true){
if((i__37977 < size__4651__auto__)){
var item = cljs.core._nth.call(null,c__4650__auto__,i__37977);
cljs.core.chunk_append.call(null,b__37978,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,priority], null));

var G__37993 = (i__37977 + (1));
i__37977 = G__37993;
continue;
} else {
return true;
}
break;
}
})()){
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37978),tailrecursion$priority_map$iter__37973_$_iter__37975.call(null,cljs.core.chunk_rest.call(null,s__37976__$2)));
} else {
return cljs.core.chunk_cons.call(null,cljs.core.chunk.call(null,b__37978),null);
}
} else {
var item = cljs.core.first.call(null,s__37976__$2);
return cljs.core.cons.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [item,priority], null),tailrecursion$priority_map$iter__37973_$_iter__37975.call(null,cljs.core.rest.call(null,s__37976__$2)));
}
} else {
return null;
}
break;
}
});})(s__37974__$1,vec__37979,priority,item_set,xs__6308__auto__,temp__5753__auto__,sets,this$__$1))
,null,null));
});})(s__37974__$1,vec__37979,priority,item_set,xs__6308__auto__,temp__5753__auto__,sets,this$__$1))
;
var fs__4649__auto__ = cljs.core.seq.call(null,iterys__4648__auto__.call(null,item_set));
if(fs__4649__auto__){
return cljs.core.concat.call(null,fs__4649__auto__,tailrecursion$priority_map$iter__37973.call(null,cljs.core.rest.call(null,s__37974__$1)));
} else {
var G__37994 = cljs.core.rest.call(null,s__37974__$1);
s__37974__$1 = G__37994;
continue;
}
} else {
return null;
}
break;
}
}),null,null));
});
return iter__4652__auto__.call(null,sets);
})());
}
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$ISorted$_entry_key$arity$2 = (function (this$,entry){
var self__ = this;
var this$__$1 = this;
return self__.keyfn.call(null,cljs.core.val.call(null,entry));
}));

(tailrecursion.priority_map.PersistentPriorityMap.prototype.cljs$core$ISorted$_comparator$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
return cljs.core.compare;
}));

(tailrecursion.priority_map.PersistentPriorityMap.getBasis = (function (){
return new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"priority->set-of-items","priority->set-of-items",-1256537211,null),new cljs.core.Symbol(null,"item->priority","item->priority",-899999435,null),new cljs.core.Symbol(null,"meta","meta",-1154898805,null),new cljs.core.Symbol(null,"keyfn","keyfn",-1874375437,null),cljs.core.with_meta(new cljs.core.Symbol(null,"__hash","__hash",-1328796629,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"mutable","mutable",875778266),true], null))], null);
}));

(tailrecursion.priority_map.PersistentPriorityMap.cljs$lang$type = true);

(tailrecursion.priority_map.PersistentPriorityMap.cljs$lang$ctorStr = "tailrecursion.priority-map/PersistentPriorityMap");

(tailrecursion.priority_map.PersistentPriorityMap.cljs$lang$ctorPrWriter = (function (this__4491__auto__,writer__4492__auto__,opt__4493__auto__){
return cljs.core._write.call(null,writer__4492__auto__,"tailrecursion.priority-map/PersistentPriorityMap");
}));

/**
 * Positional factory function for tailrecursion.priority-map/PersistentPriorityMap.
 */
tailrecursion.priority_map.__GT_PersistentPriorityMap = (function tailrecursion$priority_map$__GT_PersistentPriorityMap(priority__GT_set_of_items,item__GT_priority,meta,keyfn,__hash){
return (new tailrecursion.priority_map.PersistentPriorityMap(priority__GT_set_of_items,item__GT_priority,meta,keyfn,__hash));
});

(tailrecursion.priority_map.PersistentPriorityMap.EMPTY = (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.sorted_map.call(null),cljs.core.PersistentArrayMap.EMPTY,cljs.core.PersistentArrayMap.EMPTY,cljs.core.identity,null)));
tailrecursion.priority_map.pm_empty_by = (function tailrecursion$priority_map$pm_empty_by(comparator){
return (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.sorted_map_by.call(null,comparator),cljs.core.PersistentArrayMap.EMPTY,cljs.core.PersistentArrayMap.EMPTY,cljs.core.identity,null));
});
tailrecursion.priority_map.pm_empty_keyfn = (function tailrecursion$priority_map$pm_empty_keyfn(var_args){
var G__37996 = arguments.length;
switch (G__37996) {
case 1:
return tailrecursion.priority_map.pm_empty_keyfn.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return tailrecursion.priority_map.pm_empty_keyfn.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

(tailrecursion.priority_map.pm_empty_keyfn.cljs$core$IFn$_invoke$arity$1 = (function (keyfn){
return (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.sorted_map.call(null),cljs.core.PersistentArrayMap.EMPTY,cljs.core.PersistentArrayMap.EMPTY,keyfn,null));
}));

(tailrecursion.priority_map.pm_empty_keyfn.cljs$core$IFn$_invoke$arity$2 = (function (keyfn,comparator){
return (new tailrecursion.priority_map.PersistentPriorityMap(cljs.core.sorted_map_by.call(null,comparator),cljs.core.PersistentArrayMap.EMPTY,cljs.core.PersistentArrayMap.EMPTY,keyfn,null));
}));

(tailrecursion.priority_map.pm_empty_keyfn.cljs$lang$maxFixedArity = 2);

tailrecursion.priority_map.read_priority_map = (function tailrecursion$priority_map$read_priority_map(elems){
if(cljs.core.map_QMARK_.call(null,elems)){
return cljs.core.into.call(null,tailrecursion.priority_map.PersistentPriorityMap.EMPTY,elems);
} else {
throw Error("Priority map literal expects a map for its elements.");
}
});
cljs.reader.register_tag_parser_BANG_.call(null,"tailrecursion.priority-map",tailrecursion.priority_map.read_priority_map);
/**
 * keyval => key val
 *   Returns a new priority map with supplied mappings.
 */
tailrecursion.priority_map.priority_map = (function tailrecursion$priority_map$priority_map(var_args){
var args__4870__auto__ = [];
var len__4864__auto___37999 = arguments.length;
var i__4865__auto___38000 = (0);
while(true){
if((i__4865__auto___38000 < len__4864__auto___37999)){
args__4870__auto__.push((arguments[i__4865__auto___38000]));

var G__38001 = (i__4865__auto___38000 + (1));
i__4865__auto___38000 = G__38001;
continue;
} else {
}
break;
}

var argseq__4871__auto__ = ((((0) < args__4870__auto__.length))?(new cljs.core.IndexedSeq(args__4870__auto__.slice((0)),(0),null)):null);
return tailrecursion.priority_map.priority_map.cljs$core$IFn$_invoke$arity$variadic(argseq__4871__auto__);
});

(tailrecursion.priority_map.priority_map.cljs$core$IFn$_invoke$arity$variadic = (function (keyvals){
var in$ = cljs.core.seq.call(null,keyvals);
var out = tailrecursion.priority_map.PersistentPriorityMap.EMPTY;
while(true){
if(in$){
var G__38002 = cljs.core.nnext.call(null,in$);
var G__38003 = cljs.core.assoc.call(null,out,cljs.core.first.call(null,in$),cljs.core.second.call(null,in$));
in$ = G__38002;
out = G__38003;
continue;
} else {
return out;
}
break;
}
}));

(tailrecursion.priority_map.priority_map.cljs$lang$maxFixedArity = (0));

/** @this {Function} */
(tailrecursion.priority_map.priority_map.cljs$lang$applyTo = (function (seq37998){
var self__4852__auto__ = this;
return self__4852__auto__.cljs$core$IFn$_invoke$arity$variadic(cljs.core.seq.call(null,seq37998));
}));

/**
 * keyval => key val
 *   Returns a new priority map with supplied
 *   mappings, using the supplied comparator.
 */
tailrecursion.priority_map.priority_map_by = (function tailrecursion$priority_map$priority_map_by(var_args){
var args__4870__auto__ = [];
var len__4864__auto___38006 = arguments.length;
var i__4865__auto___38007 = (0);
while(true){
if((i__4865__auto___38007 < len__4864__auto___38006)){
args__4870__auto__.push((arguments[i__4865__auto___38007]));

var G__38008 = (i__4865__auto___38007 + (1));
i__4865__auto___38007 = G__38008;
continue;
} else {
}
break;
}

var argseq__4871__auto__ = ((((1) < args__4870__auto__.length))?(new cljs.core.IndexedSeq(args__4870__auto__.slice((1)),(0),null)):null);
return tailrecursion.priority_map.priority_map_by.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4871__auto__);
});

(tailrecursion.priority_map.priority_map_by.cljs$core$IFn$_invoke$arity$variadic = (function (comparator,keyvals){
var in$ = cljs.core.seq.call(null,keyvals);
var out = tailrecursion.priority_map.pm_empty_by.call(null,comparator);
while(true){
if(in$){
var G__38009 = cljs.core.nnext.call(null,in$);
var G__38010 = cljs.core.assoc.call(null,out,cljs.core.first.call(null,in$),cljs.core.second.call(null,in$));
in$ = G__38009;
out = G__38010;
continue;
} else {
return out;
}
break;
}
}));

(tailrecursion.priority_map.priority_map_by.cljs$lang$maxFixedArity = (1));

/** @this {Function} */
(tailrecursion.priority_map.priority_map_by.cljs$lang$applyTo = (function (seq38004){
var G__38005 = cljs.core.first.call(null,seq38004);
var seq38004__$1 = cljs.core.next.call(null,seq38004);
var self__4851__auto__ = this;
return self__4851__auto__.cljs$core$IFn$_invoke$arity$variadic(G__38005,seq38004__$1);
}));

/**
 * keyval => key val
 *   Returns a new priority map with supplied
 *   mappings, using the supplied keyfn.
 */
tailrecursion.priority_map.priority_map_keyfn = (function tailrecursion$priority_map$priority_map_keyfn(var_args){
var args__4870__auto__ = [];
var len__4864__auto___38013 = arguments.length;
var i__4865__auto___38014 = (0);
while(true){
if((i__4865__auto___38014 < len__4864__auto___38013)){
args__4870__auto__.push((arguments[i__4865__auto___38014]));

var G__38015 = (i__4865__auto___38014 + (1));
i__4865__auto___38014 = G__38015;
continue;
} else {
}
break;
}

var argseq__4871__auto__ = ((((1) < args__4870__auto__.length))?(new cljs.core.IndexedSeq(args__4870__auto__.slice((1)),(0),null)):null);
return tailrecursion.priority_map.priority_map_keyfn.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4871__auto__);
});

(tailrecursion.priority_map.priority_map_keyfn.cljs$core$IFn$_invoke$arity$variadic = (function (keyfn,keyvals){
var in$ = cljs.core.seq.call(null,keyvals);
var out = tailrecursion.priority_map.pm_empty_keyfn.call(null,keyfn);
while(true){
if(in$){
var G__38016 = cljs.core.nnext.call(null,in$);
var G__38017 = cljs.core.assoc.call(null,out,cljs.core.first.call(null,in$),cljs.core.second.call(null,in$));
in$ = G__38016;
out = G__38017;
continue;
} else {
return out;
}
break;
}
}));

(tailrecursion.priority_map.priority_map_keyfn.cljs$lang$maxFixedArity = (1));

/** @this {Function} */
(tailrecursion.priority_map.priority_map_keyfn.cljs$lang$applyTo = (function (seq38011){
var G__38012 = cljs.core.first.call(null,seq38011);
var seq38011__$1 = cljs.core.next.call(null,seq38011);
var self__4851__auto__ = this;
return self__4851__auto__.cljs$core$IFn$_invoke$arity$variadic(G__38012,seq38011__$1);
}));

/**
 * keyval => key val
 *   Returns a new priority map with supplied
 *   mappings, using the supplied keyfn and comparator.
 */
tailrecursion.priority_map.priority_map_keyfn_by = (function tailrecursion$priority_map$priority_map_keyfn_by(var_args){
var args__4870__auto__ = [];
var len__4864__auto___38021 = arguments.length;
var i__4865__auto___38022 = (0);
while(true){
if((i__4865__auto___38022 < len__4864__auto___38021)){
args__4870__auto__.push((arguments[i__4865__auto___38022]));

var G__38023 = (i__4865__auto___38022 + (1));
i__4865__auto___38022 = G__38023;
continue;
} else {
}
break;
}

var argseq__4871__auto__ = ((((2) < args__4870__auto__.length))?(new cljs.core.IndexedSeq(args__4870__auto__.slice((2)),(0),null)):null);
return tailrecursion.priority_map.priority_map_keyfn_by.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),argseq__4871__auto__);
});

(tailrecursion.priority_map.priority_map_keyfn_by.cljs$core$IFn$_invoke$arity$variadic = (function (keyfn,comparator,keyvals){
var in$ = cljs.core.seq.call(null,keyvals);
var out = tailrecursion.priority_map.pm_empty_keyfn.call(null,keyfn,comparator);
while(true){
if(in$){
var G__38024 = cljs.core.nnext.call(null,in$);
var G__38025 = cljs.core.assoc.call(null,out,cljs.core.first.call(null,in$),cljs.core.second.call(null,in$));
in$ = G__38024;
out = G__38025;
continue;
} else {
return out;
}
break;
}
}));

(tailrecursion.priority_map.priority_map_keyfn_by.cljs$lang$maxFixedArity = (2));

/** @this {Function} */
(tailrecursion.priority_map.priority_map_keyfn_by.cljs$lang$applyTo = (function (seq38018){
var G__38019 = cljs.core.first.call(null,seq38018);
var seq38018__$1 = cljs.core.next.call(null,seq38018);
var G__38020 = cljs.core.first.call(null,seq38018__$1);
var seq38018__$2 = cljs.core.next.call(null,seq38018__$1);
var self__4851__auto__ = this;
return self__4851__auto__.cljs$core$IFn$_invoke$arity$variadic(G__38019,G__38020,seq38018__$2);
}));

