// Compiled by ClojureScript 1.10.891 {:static-fns true, :optimize-constants false, :target :nodejs, :nodejs-rt false, :optimizations :advanced}
goog.provide('fluree.db.auth');
goog.require('cljs.core');
goog.require('fluree.db.dbproto');
goog.require('fluree.db.util.async');
/**
 * Given an _auth identity, returns associated roles.
 *   First returns roles directly associated with auth ident.
 *   If none exist, attempts to retrieve default roles for associated
 *   user, if they exist.
 */
fluree.db.auth.roles = (function fluree$db$auth$roles(db,auth_id){
var c__2763__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__2764__auto__ = (function (){var switch__2740__auto__ = (function (state_58917){
var state_val_58918 = (state_58917[(1)]);
if((state_val_58918 === (7))){
var inst_58869 = typeof auth_id === 'string';
var state_58917__$1 = state_58917;
if(cljs.core.truth_(inst_58869)){
var statearr_58919_58947 = state_58917__$1;
(statearr_58919_58947[(1)] = (9));

} else {
var statearr_58920_58948 = state_58917__$1;
(statearr_58920_58948[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_58918 === (1))){
var state_58917__$1 = state_58917;
var statearr_58921_58949 = state_58917__$1;
(statearr_58921_58949[(2)] = null);

(statearr_58921_58949[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_58918 === (4))){
var inst_58859 = (state_58917[(2)]);
var state_58917__$1 = state_58917;
var statearr_58922_58950 = state_58917__$1;
(statearr_58922_58950[(2)] = inst_58859);

(statearr_58922_58950[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_58918 === (15))){
var inst_58910 = (state_58917[(2)]);
var state_58917__$1 = state_58917;
var statearr_58923_58951 = state_58917__$1;
(statearr_58923_58951[(2)] = inst_58910);

(statearr_58923_58951[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_58918 === (13))){
var inst_58890 = (state_58917[(7)]);
var state_58917__$1 = state_58917;
var statearr_58924_58952 = state_58917__$1;
(statearr_58924_58952[(2)] = inst_58890);

(statearr_58924_58952[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_58918 === (6))){
var inst_58867 = cljs.core.PersistentVector.EMPTY;
var state_58917__$1 = state_58917;
var statearr_58925_58953 = state_58917__$1;
(statearr_58925_58953[(2)] = inst_58867);

(statearr_58925_58953[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_58918 === (3))){
var inst_58915 = (state_58917[(2)]);
var state_58917__$1 = state_58917;
return cljs.core.async.impl.ioc_helpers.return_chan(state_58917__$1,inst_58915);
} else {
if((state_val_58918 === (12))){
var inst_58890 = (state_58917[(7)]);
var inst_58888 = (state_58917[(2)]);
var inst_58889 = fluree.db.util.async.throw_err(inst_58888);
var inst_58890__$1 = cljs.core.not_empty(inst_58889);
var state_58917__$1 = (function (){var statearr_58926 = state_58917;
(statearr_58926[(7)] = inst_58890__$1);

return statearr_58926;
})();
if(cljs.core.truth_(inst_58890__$1)){
var statearr_58927_58954 = state_58917__$1;
(statearr_58927_58954[(1)] = (13));

} else {
var statearr_58928_58955 = state_58917__$1;
(statearr_58928_58955[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_58918 === (2))){
var _ = (function (){var statearr_58929 = state_58917;
(statearr_58929[(4)] = cljs.core.cons((5),(state_58917[(4)])));

return statearr_58929;
})();
var inst_58865 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2((0),auth_id);
var state_58917__$1 = state_58917;
if(inst_58865){
var statearr_58930_58956 = state_58917__$1;
(statearr_58930_58956[(1)] = (6));

} else {
var statearr_58931_58957 = state_58917__$1;
(statearr_58931_58957[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_58918 === (11))){
var inst_58876 = (state_58917[(8)]);
var inst_58876__$1 = (state_58917[(2)]);
var inst_58877 = [new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.Keyword(null,"where","where",-2044795965)];
var inst_58878 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_58879 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_58880 = [inst_58876__$1,"_auth/roles","?roles"];
var inst_58881 = (new cljs.core.PersistentVector(null,3,(5),inst_58879,inst_58880,null));
var inst_58882 = [inst_58881];
var inst_58883 = (new cljs.core.PersistentVector(null,1,(5),inst_58878,inst_58882,null));
var inst_58884 = ["?roles",inst_58883];
var inst_58885 = cljs.core.PersistentHashMap.fromArrays(inst_58877,inst_58884);
var inst_58886 = fluree.db.dbproto._query.cljs$core$IFn$_invoke$arity$2(db,inst_58885);
var state_58917__$1 = (function (){var statearr_58933 = state_58917;
(statearr_58933[(8)] = inst_58876__$1);

return statearr_58933;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_58917__$1,(12),inst_58886);
} else {
if((state_val_58918 === (9))){
var inst_58871 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_58872 = ["_auth/id",auth_id];
var inst_58873 = (new cljs.core.PersistentVector(null,2,(5),inst_58871,inst_58872,null));
var state_58917__$1 = state_58917;
var statearr_58934_58958 = state_58917__$1;
(statearr_58934_58958[(2)] = inst_58873);

(statearr_58934_58958[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_58918 === (5))){
var _ = (function (){var statearr_58935 = state_58917;
(statearr_58935[(4)] = cljs.core.rest((state_58917[(4)])));

return statearr_58935;
})();
var state_58917__$1 = state_58917;
var ex58932 = (state_58917__$1[(2)]);
var statearr_58936_58959 = state_58917__$1;
(statearr_58936_58959[(5)] = ex58932);


if((ex58932 instanceof Error)){
var statearr_58937_58960 = state_58917__$1;
(statearr_58937_58960[(1)] = (4));

(statearr_58937_58960[(5)] = null);

} else {
throw ex58932;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_58918 === (14))){
var inst_58876 = (state_58917[(8)]);
var inst_58893 = [new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.Keyword(null,"where","where",-2044795965)];
var inst_58894 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_58895 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_58896 = ["?user","_user/auth",inst_58876];
var inst_58897 = (new cljs.core.PersistentVector(null,3,(5),inst_58895,inst_58896,null));
var inst_58898 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_58899 = ["?user","_user/roles","?roles"];
var inst_58900 = (new cljs.core.PersistentVector(null,3,(5),inst_58898,inst_58899,null));
var inst_58901 = [inst_58897,inst_58900];
var inst_58902 = (new cljs.core.PersistentVector(null,2,(5),inst_58894,inst_58901,null));
var inst_58903 = ["?roles",inst_58902];
var inst_58904 = cljs.core.PersistentHashMap.fromArrays(inst_58893,inst_58903);
var inst_58905 = fluree.db.dbproto._query.cljs$core$IFn$_invoke$arity$2(db,inst_58904);
var state_58917__$1 = state_58917;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_58917__$1,(16),inst_58905);
} else {
if((state_val_58918 === (16))){
var inst_58907 = (state_58917[(2)]);
var inst_58908 = fluree.db.util.async.throw_err(inst_58907);
var state_58917__$1 = state_58917;
var statearr_58938_58961 = state_58917__$1;
(statearr_58938_58961[(2)] = inst_58908);

(statearr_58938_58961[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_58918 === (10))){
var state_58917__$1 = state_58917;
var statearr_58939_58962 = state_58917__$1;
(statearr_58939_58962[(2)] = auth_id);

(statearr_58939_58962[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_58918 === (8))){
var inst_58912 = (state_58917[(2)]);
var _ = (function (){var statearr_58940 = state_58917;
(statearr_58940[(4)] = cljs.core.rest((state_58917[(4)])));

return statearr_58940;
})();
var state_58917__$1 = state_58917;
var statearr_58941_58963 = state_58917__$1;
(statearr_58941_58963[(2)] = inst_58912);

(statearr_58941_58963[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$auth$roles_$_state_machine__2741__auto__ = null;
var fluree$db$auth$roles_$_state_machine__2741__auto____0 = (function (){
var statearr_58942 = [null,null,null,null,null,null,null,null,null];
(statearr_58942[(0)] = fluree$db$auth$roles_$_state_machine__2741__auto__);

(statearr_58942[(1)] = (1));

return statearr_58942;
});
var fluree$db$auth$roles_$_state_machine__2741__auto____1 = (function (state_58917){
while(true){
var ret_value__2742__auto__ = (function (){try{while(true){
var result__2743__auto__ = switch__2740__auto__(state_58917);
if(cljs.core.keyword_identical_QMARK_(result__2743__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2743__auto__;
}
break;
}
}catch (e58943){var ex__2744__auto__ = e58943;
var statearr_58944_58964 = state_58917;
(statearr_58944_58964[(2)] = ex__2744__auto__);


if(cljs.core.seq((state_58917[(4)]))){
var statearr_58945_58965 = state_58917;
(statearr_58945_58965[(1)] = cljs.core.first((state_58917[(4)])));

} else {
throw ex__2744__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__2742__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__58966 = state_58917;
state_58917 = G__58966;
continue;
} else {
return ret_value__2742__auto__;
}
break;
}
});
fluree$db$auth$roles_$_state_machine__2741__auto__ = function(state_58917){
switch(arguments.length){
case 0:
return fluree$db$auth$roles_$_state_machine__2741__auto____0.call(this);
case 1:
return fluree$db$auth$roles_$_state_machine__2741__auto____1.call(this,state_58917);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$auth$roles_$_state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$auth$roles_$_state_machine__2741__auto____0;
fluree$db$auth$roles_$_state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$auth$roles_$_state_machine__2741__auto____1;
return fluree$db$auth$roles_$_state_machine__2741__auto__;
})()
})();
var state__2765__auto__ = (function (){var statearr_58946 = (f__2764__auto__.cljs$core$IFn$_invoke$arity$0 ? f__2764__auto__.cljs$core$IFn$_invoke$arity$0() : f__2764__auto__.call(null));
(statearr_58946[(6)] = c__2763__auto__);

return statearr_58946;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__2765__auto__);
}));

return c__2763__auto__;
});
/**
 * Given an _auth identity, returns roles directly associated
 *   with the auth ident.  If none found, attempts to retrieve
 *   default roles for an associated user.
 */
fluree.db.auth.root_role_QMARK_ = (function fluree$db$auth$root_role_QMARK_(db,auth_id){
var c__2763__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__2764__auto__ = (function (){var switch__2740__auto__ = (function (state_59037){
var state_val_59038 = (state_59037[(1)]);
if((state_val_59038 === (7))){
var inst_58976 = typeof auth_id === 'string';
var state_59037__$1 = state_59037;
if(cljs.core.truth_(inst_58976)){
var statearr_59039_59067 = state_59037__$1;
(statearr_59039_59067[(1)] = (9));

} else {
var statearr_59040_59068 = state_59037__$1;
(statearr_59040_59068[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_59038 === (1))){
var state_59037__$1 = state_59037;
var statearr_59041_59069 = state_59037__$1;
(statearr_59041_59069[(2)] = null);

(statearr_59041_59069[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_59038 === (4))){
var inst_58967 = (state_59037[(2)]);
var state_59037__$1 = state_59037;
var statearr_59042_59070 = state_59037__$1;
(statearr_59042_59070[(2)] = inst_58967);

(statearr_59042_59070[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_59038 === (15))){
var inst_59030 = (state_59037[(2)]);
var state_59037__$1 = state_59037;
var statearr_59043_59071 = state_59037__$1;
(statearr_59043_59071[(2)] = inst_59030);

(statearr_59043_59071[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_59038 === (13))){
var inst_59003 = (state_59037[(7)]);
var state_59037__$1 = state_59037;
var statearr_59044_59072 = state_59037__$1;
(statearr_59044_59072[(2)] = inst_59003);

(statearr_59044_59072[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_59038 === (6))){
var state_59037__$1 = state_59037;
var statearr_59045_59073 = state_59037__$1;
(statearr_59045_59073[(2)] = false);

(statearr_59045_59073[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_59038 === (3))){
var inst_59035 = (state_59037[(2)]);
var state_59037__$1 = state_59037;
return cljs.core.async.impl.ioc_helpers.return_chan(state_59037__$1,inst_59035);
} else {
if((state_val_59038 === (12))){
var inst_59003 = (state_59037[(7)]);
var inst_59001 = (state_59037[(2)]);
var inst_59002 = fluree.db.util.async.throw_err(inst_59001);
var inst_59003__$1 = cljs.core.not_empty(inst_59002);
var state_59037__$1 = (function (){var statearr_59046 = state_59037;
(statearr_59046[(7)] = inst_59003__$1);

return statearr_59046;
})();
if(cljs.core.truth_(inst_59003__$1)){
var statearr_59047_59074 = state_59037__$1;
(statearr_59047_59074[(1)] = (13));

} else {
var statearr_59048_59075 = state_59037__$1;
(statearr_59048_59075[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_59038 === (2))){
var _ = (function (){var statearr_59049 = state_59037;
(statearr_59049[(4)] = cljs.core.cons((5),(state_59037[(4)])));

return statearr_59049;
})();
var inst_58973 = (auth_id == null);
var state_59037__$1 = state_59037;
if(cljs.core.truth_(inst_58973)){
var statearr_59050_59076 = state_59037__$1;
(statearr_59050_59076[(1)] = (6));

} else {
var statearr_59051_59077 = state_59037__$1;
(statearr_59051_59077[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_59038 === (11))){
var inst_58983 = (state_59037[(8)]);
var inst_58983__$1 = (state_59037[(2)]);
var inst_58984 = [new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.Keyword(null,"where","where",-2044795965),new cljs.core.Keyword(null,"opts","opts",155075701)];
var inst_58985 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_58986 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_58987 = ["?role","_role/id","root"];
var inst_58988 = (new cljs.core.PersistentVector(null,3,(5),inst_58986,inst_58987,null));
var inst_58989 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_58990 = [inst_58983__$1,"_auth/roles","?role"];
var inst_58991 = (new cljs.core.PersistentVector(null,3,(5),inst_58989,inst_58990,null));
var inst_58992 = [inst_58988,inst_58991];
var inst_58993 = (new cljs.core.PersistentVector(null,2,(5),inst_58985,inst_58992,null));
var inst_58994 = [new cljs.core.Keyword(null,"cache","cache",-1237023054)];
var inst_58995 = [true];
var inst_58996 = cljs.core.PersistentHashMap.fromArrays(inst_58994,inst_58995);
var inst_58997 = ["?role",inst_58993,inst_58996];
var inst_58998 = cljs.core.PersistentHashMap.fromArrays(inst_58984,inst_58997);
var inst_58999 = fluree.db.dbproto._query.cljs$core$IFn$_invoke$arity$2(db,inst_58998);
var state_59037__$1 = (function (){var statearr_59053 = state_59037;
(statearr_59053[(8)] = inst_58983__$1);

return statearr_59053;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_59037__$1,(12),inst_58999);
} else {
if((state_val_59038 === (9))){
var inst_58978 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_58979 = ["_auth/id",auth_id];
var inst_58980 = (new cljs.core.PersistentVector(null,2,(5),inst_58978,inst_58979,null));
var state_59037__$1 = state_59037;
var statearr_59054_59078 = state_59037__$1;
(statearr_59054_59078[(2)] = inst_58980);

(statearr_59054_59078[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_59038 === (5))){
var _ = (function (){var statearr_59055 = state_59037;
(statearr_59055[(4)] = cljs.core.rest((state_59037[(4)])));

return statearr_59055;
})();
var state_59037__$1 = state_59037;
var ex59052 = (state_59037__$1[(2)]);
var statearr_59056_59079 = state_59037__$1;
(statearr_59056_59079[(5)] = ex59052);


if((ex59052 instanceof Error)){
var statearr_59057_59080 = state_59037__$1;
(statearr_59057_59080[(1)] = (4));

(statearr_59057_59080[(5)] = null);

} else {
throw ex59052;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_59038 === (14))){
var inst_58983 = (state_59037[(8)]);
var inst_59006 = [new cljs.core.Keyword(null,"select","select",1147833503),new cljs.core.Keyword(null,"where","where",-2044795965),new cljs.core.Keyword(null,"opts","opts",155075701)];
var inst_59007 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_59008 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_59009 = ["?role","_role/id","root"];
var inst_59010 = (new cljs.core.PersistentVector(null,3,(5),inst_59008,inst_59009,null));
var inst_59011 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_59012 = ["?user","_user/auth",inst_58983];
var inst_59013 = (new cljs.core.PersistentVector(null,3,(5),inst_59011,inst_59012,null));
var inst_59014 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_59015 = ["?user","_user/roles","?roles"];
var inst_59016 = (new cljs.core.PersistentVector(null,3,(5),inst_59014,inst_59015,null));
var inst_59017 = [inst_59010,inst_59013,inst_59016];
var inst_59018 = (new cljs.core.PersistentVector(null,3,(5),inst_59007,inst_59017,null));
var inst_59019 = [new cljs.core.Keyword(null,"cache","cache",-1237023054)];
var inst_59020 = [true];
var inst_59021 = cljs.core.PersistentHashMap.fromArrays(inst_59019,inst_59020);
var inst_59022 = ["?role",inst_59018,inst_59021];
var inst_59023 = cljs.core.PersistentHashMap.fromArrays(inst_59006,inst_59022);
var inst_59024 = fluree.db.dbproto._query.cljs$core$IFn$_invoke$arity$2(db,inst_59023);
var state_59037__$1 = state_59037;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_59037__$1,(16),inst_59024);
} else {
if((state_val_59038 === (16))){
var inst_59026 = (state_59037[(2)]);
var inst_59027 = fluree.db.util.async.throw_err(inst_59026);
var inst_59028 = cljs.core.not_empty(inst_59027);
var state_59037__$1 = state_59037;
var statearr_59058_59081 = state_59037__$1;
(statearr_59058_59081[(2)] = inst_59028);

(statearr_59058_59081[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_59038 === (10))){
var state_59037__$1 = state_59037;
var statearr_59059_59082 = state_59037__$1;
(statearr_59059_59082[(2)] = auth_id);

(statearr_59059_59082[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_59038 === (8))){
var inst_59032 = (state_59037[(2)]);
var _ = (function (){var statearr_59060 = state_59037;
(statearr_59060[(4)] = cljs.core.rest((state_59037[(4)])));

return statearr_59060;
})();
var state_59037__$1 = state_59037;
var statearr_59061_59083 = state_59037__$1;
(statearr_59061_59083[(2)] = inst_59032);

(statearr_59061_59083[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$auth$root_role_QMARK__$_state_machine__2741__auto__ = null;
var fluree$db$auth$root_role_QMARK__$_state_machine__2741__auto____0 = (function (){
var statearr_59062 = [null,null,null,null,null,null,null,null,null];
(statearr_59062[(0)] = fluree$db$auth$root_role_QMARK__$_state_machine__2741__auto__);

(statearr_59062[(1)] = (1));

return statearr_59062;
});
var fluree$db$auth$root_role_QMARK__$_state_machine__2741__auto____1 = (function (state_59037){
while(true){
var ret_value__2742__auto__ = (function (){try{while(true){
var result__2743__auto__ = switch__2740__auto__(state_59037);
if(cljs.core.keyword_identical_QMARK_(result__2743__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2743__auto__;
}
break;
}
}catch (e59063){var ex__2744__auto__ = e59063;
var statearr_59064_59084 = state_59037;
(statearr_59064_59084[(2)] = ex__2744__auto__);


if(cljs.core.seq((state_59037[(4)]))){
var statearr_59065_59085 = state_59037;
(statearr_59065_59085[(1)] = cljs.core.first((state_59037[(4)])));

} else {
throw ex__2744__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__2742__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__59086 = state_59037;
state_59037 = G__59086;
continue;
} else {
return ret_value__2742__auto__;
}
break;
}
});
fluree$db$auth$root_role_QMARK__$_state_machine__2741__auto__ = function(state_59037){
switch(arguments.length){
case 0:
return fluree$db$auth$root_role_QMARK__$_state_machine__2741__auto____0.call(this);
case 1:
return fluree$db$auth$root_role_QMARK__$_state_machine__2741__auto____1.call(this,state_59037);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$auth$root_role_QMARK__$_state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$auth$root_role_QMARK__$_state_machine__2741__auto____0;
fluree$db$auth$root_role_QMARK__$_state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$auth$root_role_QMARK__$_state_machine__2741__auto____1;
return fluree$db$auth$root_role_QMARK__$_state_machine__2741__auto__;
})()
})();
var state__2765__auto__ = (function (){var statearr_59066 = (f__2764__auto__.cljs$core$IFn$_invoke$arity$0 ? f__2764__auto__.cljs$core$IFn$_invoke$arity$0() : f__2764__auto__.call(null));
(statearr_59066[(6)] = c__2763__auto__);

return statearr_59066;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__2765__auto__);
}));

return c__2763__auto__;
});
