// Compiled by ClojureScript 1.10.891 {:static-fns true, :optimize-constants false, :target :nodejs, :nodejs-rt false, :optimizations :advanced}
goog.provide('fluree.db.index');
goog.require('cljs.core');
goog.require('clojure.data.avl');
goog.require('fluree.db.dbproto');
goog.require('cljs.core.async');
goog.require('fluree.db.util.async');
goog.require('fluree.db.util.log');

/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.index.IndexConfig = (function (index_type,comparator,historyComparator,__meta,__extmap,__hash){
this.index_type = index_type;
this.comparator = comparator;
this.historyComparator = historyComparator;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
(fluree.db.index.IndexConfig.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4502__auto__,k__4503__auto__){
var self__ = this;
var this__4502__auto____$1 = this;
return this__4502__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4503__auto__,null);
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4504__auto__,k16997,else__4505__auto__){
var self__ = this;
var this__4504__auto____$1 = this;
var G__17001 = k16997;
var G__17001__$1 = (((G__17001 instanceof cljs.core.Keyword))?G__17001.fqn:null);
switch (G__17001__$1) {
case "index-type":
return self__.index_type;

break;
case "comparator":
return self__.comparator;

break;
case "historyComparator":
return self__.historyComparator;

break;
default:
return cljs.core.get.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k16997,else__4505__auto__);

}
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4522__auto__,f__4523__auto__,init__4524__auto__){
var self__ = this;
var this__4522__auto____$1 = this;
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (ret__4525__auto__,p__17002){
var vec__17003 = p__17002;
var k__4526__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__17003,(0),null);
var v__4527__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__17003,(1),null);
return (f__4523__auto__.cljs$core$IFn$_invoke$arity$3 ? f__4523__auto__.cljs$core$IFn$_invoke$arity$3(ret__4525__auto__,k__4526__auto__,v__4527__auto__) : f__4523__auto__.call(null,ret__4525__auto__,k__4526__auto__,v__4527__auto__));
}),init__4524__auto__,this__4522__auto____$1);
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4517__auto__,writer__4518__auto__,opts__4519__auto__){
var self__ = this;
var this__4517__auto____$1 = this;
var pr_pair__4520__auto__ = (function (keyval__4521__auto__){
return cljs.core.pr_sequential_writer(writer__4518__auto__,cljs.core.pr_writer,""," ","",opts__4519__auto__,keyval__4521__auto__);
});
return cljs.core.pr_sequential_writer(writer__4518__auto__,pr_pair__4520__auto__,"#fluree.db.index.IndexConfig{",", ","}",opts__4519__auto__,cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"index-type","index-type",500383962),self__.index_type],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"comparator","comparator",2144896662),self__.comparator],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658),self__.historyComparator],null))], null),self__.__extmap));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__16996){
var self__ = this;
var G__16996__$1 = this;
return (new cljs.core.RecordIter((0),G__16996__$1,3,new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"index-type","index-type",500383962),new cljs.core.Keyword(null,"comparator","comparator",2144896662),new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658)], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator(self__.__extmap):cljs.core.nil_iter())));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4500__auto__){
var self__ = this;
var this__4500__auto____$1 = this;
return self__.__meta;
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4497__auto__){
var self__ = this;
var this__4497__auto____$1 = this;
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,self__.historyComparator,self__.__meta,self__.__extmap,self__.__hash));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4506__auto__){
var self__ = this;
var this__4506__auto____$1 = this;
return (3 + cljs.core.count(self__.__extmap));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4498__auto__){
var self__ = this;
var this__4498__auto____$1 = this;
var h__4360__auto__ = self__.__hash;
if((!((h__4360__auto__ == null)))){
return h__4360__auto__;
} else {
var h__4360__auto____$1 = (function (){var fexpr__17006 = (function (coll__4499__auto__){
return (1512230614 ^ cljs.core.hash_unordered_coll(coll__4499__auto__));
});
return fexpr__17006(this__4498__auto____$1);
})();
(self__.__hash = h__4360__auto____$1);

return h__4360__auto____$1;
}
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this16998,other16999){
var self__ = this;
var this16998__$1 = this;
return (((!((other16999 == null)))) && ((((this16998__$1.constructor === other16999.constructor)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this16998__$1.index_type,other16999.index_type)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this16998__$1.comparator,other16999.comparator)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this16998__$1.historyComparator,other16999.historyComparator)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this16998__$1.__extmap,other16999.__extmap)))))))))));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4512__auto__,k__4513__auto__){
var self__ = this;
var this__4512__auto____$1 = this;
if(cljs.core.contains_QMARK_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658),null,new cljs.core.Keyword(null,"comparator","comparator",2144896662),null,new cljs.core.Keyword(null,"index-type","index-type",500383962),null], null), null),k__4513__auto__)){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(cljs.core._with_meta(cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,this__4512__auto____$1),self__.__meta),k__4513__auto__);
} else {
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,self__.historyComparator,self__.__meta,cljs.core.not_empty(cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(self__.__extmap,k__4513__auto__)),null));
}
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IAssociative$_contains_key_QMARK_$arity$2 = (function (this__4509__auto__,k16997){
var self__ = this;
var this__4509__auto____$1 = this;
var G__17007 = k16997;
var G__17007__$1 = (((G__17007 instanceof cljs.core.Keyword))?G__17007.fqn:null);
switch (G__17007__$1) {
case "index-type":
case "comparator":
case "historyComparator":
return true;

break;
default:
return cljs.core.contains_QMARK_(self__.__extmap,k16997);

}
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4510__auto__,k__4511__auto__,G__16996){
var self__ = this;
var this__4510__auto____$1 = this;
var pred__17008 = cljs.core.keyword_identical_QMARK_;
var expr__17009 = k__4511__auto__;
if(cljs.core.truth_((function (){var G__17011 = new cljs.core.Keyword(null,"index-type","index-type",500383962);
var G__17012 = expr__17009;
return (pred__17008.cljs$core$IFn$_invoke$arity$2 ? pred__17008.cljs$core$IFn$_invoke$arity$2(G__17011,G__17012) : pred__17008.call(null,G__17011,G__17012));
})())){
return (new fluree.db.index.IndexConfig(G__16996,self__.comparator,self__.historyComparator,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__17013 = new cljs.core.Keyword(null,"comparator","comparator",2144896662);
var G__17014 = expr__17009;
return (pred__17008.cljs$core$IFn$_invoke$arity$2 ? pred__17008.cljs$core$IFn$_invoke$arity$2(G__17013,G__17014) : pred__17008.call(null,G__17013,G__17014));
})())){
return (new fluree.db.index.IndexConfig(self__.index_type,G__16996,self__.historyComparator,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__17015 = new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658);
var G__17016 = expr__17009;
return (pred__17008.cljs$core$IFn$_invoke$arity$2 ? pred__17008.cljs$core$IFn$_invoke$arity$2(G__17015,G__17016) : pred__17008.call(null,G__17015,G__17016));
})())){
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,G__16996,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,self__.historyComparator,self__.__meta,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k__4511__auto__,G__16996),null));
}
}
}
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4515__auto__){
var self__ = this;
var this__4515__auto____$1 = this;
return cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(new cljs.core.Keyword(null,"index-type","index-type",500383962),self__.index_type,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"comparator","comparator",2144896662),self__.comparator,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658),self__.historyComparator,null))], null),self__.__extmap));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4501__auto__,G__16996){
var self__ = this;
var this__4501__auto____$1 = this;
return (new fluree.db.index.IndexConfig(self__.index_type,self__.comparator,self__.historyComparator,G__16996,self__.__extmap,self__.__hash));
}));

(fluree.db.index.IndexConfig.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4507__auto__,entry__4508__auto__){
var self__ = this;
var this__4507__auto____$1 = this;
if(cljs.core.vector_QMARK_(entry__4508__auto__)){
return this__4507__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4508__auto__,(0)),cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4508__auto__,(1)));
} else {
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(cljs.core._conj,this__4507__auto____$1,entry__4508__auto__);
}
}));

(fluree.db.index.IndexConfig.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"index-type","index-type",2140915489,null),new cljs.core.Symbol(null,"comparator","comparator",-509539107,null),new cljs.core.Symbol(null,"historyComparator","historyComparator",236913869,null)], null);
}));

(fluree.db.index.IndexConfig.cljs$lang$type = true);

(fluree.db.index.IndexConfig.cljs$lang$ctorPrSeq = (function (this__4546__auto__){
return (new cljs.core.List(null,"fluree.db.index/IndexConfig",null,(1),null));
}));

(fluree.db.index.IndexConfig.cljs$lang$ctorPrWriter = (function (this__4546__auto__,writer__4547__auto__){
return cljs.core._write(writer__4547__auto__,"fluree.db.index/IndexConfig");
}));

/**
 * Positional factory function for fluree.db.index/IndexConfig.
 */
fluree.db.index.__GT_IndexConfig = (function fluree$db$index$__GT_IndexConfig(index_type,comparator,historyComparator){
return (new fluree.db.index.IndexConfig(index_type,comparator,historyComparator,null,null,null));
});

/**
 * Factory function for fluree.db.index/IndexConfig, taking a map of keywords to field values.
 */
fluree.db.index.map__GT_IndexConfig = (function fluree$db$index$map__GT_IndexConfig(G__17000){
var extmap__4542__auto__ = (function (){var G__17017 = cljs.core.dissoc.cljs$core$IFn$_invoke$arity$variadic(G__17000,new cljs.core.Keyword(null,"index-type","index-type",500383962),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.Keyword(null,"comparator","comparator",2144896662),new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658)], 0));
if(cljs.core.record_QMARK_(G__17000)){
return cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,G__17017);
} else {
return G__17017;
}
})();
return (new fluree.db.index.IndexConfig(new cljs.core.Keyword(null,"index-type","index-type",500383962).cljs$core$IFn$_invoke$arity$1(G__17000),new cljs.core.Keyword(null,"comparator","comparator",2144896662).cljs$core$IFn$_invoke$arity$1(G__17000),new cljs.core.Keyword(null,"historyComparator","historyComparator",-1403617658).cljs$core$IFn$_invoke$arity$1(G__17000),null,cljs.core.not_empty(extmap__4542__auto__),null));
});


/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {fluree.db.dbproto.INode}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {fluree.db.dbproto.IResolve}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.index.IndexNode = (function (block,t,rhs,children,config,leftmost_QMARK_,__meta,__extmap,__hash){
this.block = block;
this.t = t;
this.rhs = rhs;
this.children = children;
this.config = config;
this.leftmost_QMARK_ = leftmost_QMARK_;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
(fluree.db.index.IndexNode.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4502__auto__,k__4503__auto__){
var self__ = this;
var this__4502__auto____$1 = this;
return this__4502__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4503__auto__,null);
}));

(fluree.db.index.IndexNode.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4504__auto__,k17021,else__4505__auto__){
var self__ = this;
var this__4504__auto____$1 = this;
var G__17025 = k17021;
var G__17025__$1 = (((G__17025 instanceof cljs.core.Keyword))?G__17025.fqn:null);
switch (G__17025__$1) {
case "block":
return self__.block;

break;
case "t":
return self__.t;

break;
case "rhs":
return self__.rhs;

break;
case "children":
return self__.children;

break;
case "config":
return self__.config;

break;
case "leftmost?":
return self__.leftmost_QMARK_;

break;
default:
return cljs.core.get.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k17021,else__4505__auto__);

}
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4522__auto__,f__4523__auto__,init__4524__auto__){
var self__ = this;
var this__4522__auto____$1 = this;
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (ret__4525__auto__,p__17026){
var vec__17027 = p__17026;
var k__4526__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__17027,(0),null);
var v__4527__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__17027,(1),null);
return (f__4523__auto__.cljs$core$IFn$_invoke$arity$3 ? f__4523__auto__.cljs$core$IFn$_invoke$arity$3(ret__4525__auto__,k__4526__auto__,v__4527__auto__) : f__4523__auto__.call(null,ret__4525__auto__,k__4526__auto__,v__4527__auto__));
}),init__4524__auto__,this__4522__auto____$1);
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4517__auto__,writer__4518__auto__,opts__4519__auto__){
var self__ = this;
var this__4517__auto____$1 = this;
var pr_pair__4520__auto__ = (function (keyval__4521__auto__){
return cljs.core.pr_sequential_writer(writer__4518__auto__,cljs.core.pr_writer,""," ","",opts__4519__auto__,keyval__4521__auto__);
});
return cljs.core.pr_sequential_writer(writer__4518__auto__,pr_pair__4520__auto__,"#fluree.db.index.IndexNode{",", ","}",opts__4519__auto__,cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"block","block",664686210),self__.block],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"t","t",-1397832519),self__.t],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"rhs","rhs",-229356739),self__.rhs],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"children","children",-940561982),self__.children],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"config","config",994861415),self__.config],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),self__.leftmost_QMARK_],null))], null),self__.__extmap));
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__17020){
var self__ = this;
var G__17020__$1 = this;
return (new cljs.core.RecordIter((0),G__17020__$1,6,new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"rhs","rhs",-229356739),new cljs.core.Keyword(null,"children","children",-940561982),new cljs.core.Keyword(null,"config","config",994861415),new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559)], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator(self__.__extmap):cljs.core.nil_iter())));
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$IResolve$ = cljs.core.PROTOCOL_SENTINEL);

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$IResolve$_resolve$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
var c__2763__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__2764__auto__ = (function (){var switch__2740__auto__ = (function (state_17031){
var state_val_17032 = (state_17031[(1)]);
if((state_val_17032 === (1))){
var state_17031__$1 = state_17031;
return cljs.core.async.impl.ioc_helpers.return_chan(state_17031__$1,this$__$1);
} else {
return null;
}
});
return (function() {
var fluree$db$index$state_machine__2741__auto__ = null;
var fluree$db$index$state_machine__2741__auto____0 = (function (){
var statearr_17033 = [null,null,null,null,null,null,null];
(statearr_17033[(0)] = fluree$db$index$state_machine__2741__auto__);

(statearr_17033[(1)] = (1));

return statearr_17033;
});
var fluree$db$index$state_machine__2741__auto____1 = (function (state_17031){
while(true){
var ret_value__2742__auto__ = (function (){try{while(true){
var result__2743__auto__ = switch__2740__auto__(state_17031);
if(cljs.core.keyword_identical_QMARK_(result__2743__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2743__auto__;
}
break;
}
}catch (e17034){var ex__2744__auto__ = e17034;
var statearr_17035_17147 = state_17031;
(statearr_17035_17147[(2)] = ex__2744__auto__);


if(cljs.core.seq((state_17031[(4)]))){
var statearr_17036_17148 = state_17031;
(statearr_17036_17148[(1)] = cljs.core.first((state_17031[(4)])));

} else {
throw ex__2744__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__2742__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__17149 = state_17031;
state_17031 = G__17149;
continue;
} else {
return ret_value__2742__auto__;
}
break;
}
});
fluree$db$index$state_machine__2741__auto__ = function(state_17031){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__2741__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__2741__auto____1.call(this,state_17031);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__2741__auto____0;
fluree$db$index$state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__2741__auto____1;
return fluree$db$index$state_machine__2741__auto__;
})()
})();
var state__2765__auto__ = (function (){var statearr_17037 = (f__2764__auto__.cljs$core$IFn$_invoke$arity$0 ? f__2764__auto__.cljs$core$IFn$_invoke$arity$0() : f__2764__auto__.call(null));
(statearr_17037[(6)] = c__2763__auto__);

return statearr_17037;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__2765__auto__);
}));

return c__2763__auto__;
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$IResolve$_first_flake$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.key(cljs.core.first(self__.children));
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$IResolve$_rhs$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.rhs;
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4500__auto__){
var self__ = this;
var this__4500__auto____$1 = this;
return self__.__meta;
}));

(fluree.db.index.IndexNode.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4497__auto__){
var self__ = this;
var this__4497__auto____$1 = this;
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,self__.__hash));
}));

(fluree.db.index.IndexNode.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4506__auto__){
var self__ = this;
var this__4506__auto____$1 = this;
return (6 + cljs.core.count(self__.__extmap));
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$ = cljs.core.PROTOCOL_SENTINEL);

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$_lookup$arity$2 = (function (this$,flake){
var self__ = this;
var this$__$1 = this;
return cljs.core.val((function (){var or__4253__auto__ = clojure.data.avl.nearest(self__.children,cljs.core._LT__EQ_,flake);
if(cljs.core.truth_(or__4253__auto__)){
return or__4253__auto__;
} else {
return cljs.core.first(self__.children);
}
})());
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$_lookup_after$arity$2 = (function (_,flake){
var self__ = this;
var ___$1 = this;
return cljs.core.val((function (){var or__4253__auto__ = clojure.data.avl.nearest(self__.children,cljs.core._GT_,flake);
if(cljs.core.truth_(or__4253__auto__)){
return or__4253__auto__;
} else {
return cljs.core.last(self__.children);
}
})());
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$_lookup_leaf$arity$2 = (function (this$,flake){
var self__ = this;
var this$__$1 = this;
var c__2763__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__2764__auto__ = (function (){var switch__2740__auto__ = (function (state_17062){
var state_val_17063 = (state_17062[(1)]);
if((state_val_17063 === (7))){
var inst_17044 = (state_17062[(7)]);
var inst_17048 = fluree.db.dbproto._resolve(inst_17044);
var state_17062__$1 = state_17062;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_17062__$1,(10),inst_17048);
} else {
if((state_val_17063 === (1))){
var state_17062__$1 = state_17062;
var statearr_17064_17150 = state_17062__$1;
(statearr_17064_17150[(2)] = null);

(statearr_17064_17150[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17063 === (4))){
var inst_17038 = (state_17062[(2)]);
var state_17062__$1 = state_17062;
var statearr_17065_17151 = state_17062__$1;
(statearr_17065_17151[(2)] = inst_17038);

(statearr_17065_17151[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17063 === (6))){
var inst_17044 = (state_17062[(7)]);
var state_17062__$1 = state_17062;
var statearr_17066_17152 = state_17062__$1;
(statearr_17066_17152[(2)] = inst_17044);

(statearr_17066_17152[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17063 === (3))){
var inst_17060 = (state_17062[(2)]);
var state_17062__$1 = state_17062;
return cljs.core.async.impl.ioc_helpers.return_chan(state_17062__$1,inst_17060);
} else {
if((state_val_17063 === (2))){
var inst_17044 = (state_17062[(7)]);
var _ = (function (){var statearr_17068 = state_17062;
(statearr_17068[(4)] = cljs.core.cons((5),(state_17062[(4)])));

return statearr_17068;
})();
var inst_17044__$1 = this$__$1.fluree$db$dbproto$INode$_lookup$arity$2(null,flake);
var inst_17045 = new cljs.core.Keyword(null,"leaf","leaf",1306118732).cljs$core$IFn$_invoke$arity$1(inst_17044__$1);
var state_17062__$1 = (function (){var statearr_17069 = state_17062;
(statearr_17069[(7)] = inst_17044__$1);

return statearr_17069;
})();
if(cljs.core.truth_(inst_17045)){
var statearr_17070_17153 = state_17062__$1;
(statearr_17070_17153[(1)] = (6));

} else {
var statearr_17071_17154 = state_17062__$1;
(statearr_17071_17154[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17063 === (9))){
var inst_17054 = (state_17062[(2)]);
var inst_17055 = fluree.db.util.async.throw_err(inst_17054);
var state_17062__$1 = state_17062;
var statearr_17072_17155 = state_17062__$1;
(statearr_17072_17155[(2)] = inst_17055);

(statearr_17072_17155[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17063 === (5))){
var _ = (function (){var statearr_17073 = state_17062;
(statearr_17073[(4)] = cljs.core.rest((state_17062[(4)])));

return statearr_17073;
})();
var state_17062__$1 = state_17062;
var ex17067 = (state_17062__$1[(2)]);
var statearr_17074_17156 = state_17062__$1;
(statearr_17074_17156[(5)] = ex17067);


if((ex17067 instanceof Error)){
var statearr_17075_17157 = state_17062__$1;
(statearr_17075_17157[(1)] = (4));

(statearr_17075_17157[(5)] = null);

} else {
throw ex17067;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17063 === (10))){
var inst_17050 = (state_17062[(2)]);
var inst_17051 = fluree.db.util.async.throw_err(inst_17050);
var inst_17052 = fluree.db.dbproto._lookup_leaf(inst_17051,flake);
var state_17062__$1 = state_17062;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_17062__$1,(9),inst_17052);
} else {
if((state_val_17063 === (8))){
var inst_17057 = (state_17062[(2)]);
var _ = (function (){var statearr_17076 = state_17062;
(statearr_17076[(4)] = cljs.core.rest((state_17062[(4)])));

return statearr_17076;
})();
var state_17062__$1 = state_17062;
var statearr_17077_17158 = state_17062__$1;
(statearr_17077_17158[(2)] = inst_17057);

(statearr_17077_17158[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$index$state_machine__2741__auto__ = null;
var fluree$db$index$state_machine__2741__auto____0 = (function (){
var statearr_17078 = [null,null,null,null,null,null,null,null];
(statearr_17078[(0)] = fluree$db$index$state_machine__2741__auto__);

(statearr_17078[(1)] = (1));

return statearr_17078;
});
var fluree$db$index$state_machine__2741__auto____1 = (function (state_17062){
while(true){
var ret_value__2742__auto__ = (function (){try{while(true){
var result__2743__auto__ = switch__2740__auto__(state_17062);
if(cljs.core.keyword_identical_QMARK_(result__2743__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2743__auto__;
}
break;
}
}catch (e17079){var ex__2744__auto__ = e17079;
var statearr_17080_17159 = state_17062;
(statearr_17080_17159[(2)] = ex__2744__auto__);


if(cljs.core.seq((state_17062[(4)]))){
var statearr_17081_17160 = state_17062;
(statearr_17081_17160[(1)] = cljs.core.first((state_17062[(4)])));

} else {
throw ex__2744__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__2742__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__17161 = state_17062;
state_17062 = G__17161;
continue;
} else {
return ret_value__2742__auto__;
}
break;
}
});
fluree$db$index$state_machine__2741__auto__ = function(state_17062){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__2741__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__2741__auto____1.call(this,state_17062);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__2741__auto____0;
fluree$db$index$state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__2741__auto____1;
return fluree$db$index$state_machine__2741__auto__;
})()
})();
var state__2765__auto__ = (function (){var statearr_17082 = (f__2764__auto__.cljs$core$IFn$_invoke$arity$0 ? f__2764__auto__.cljs$core$IFn$_invoke$arity$0() : f__2764__auto__.call(null));
(statearr_17082[(6)] = c__2763__auto__);

return statearr_17082;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__2765__auto__);
}));

return c__2763__auto__;
}));

(fluree.db.index.IndexNode.prototype.fluree$db$dbproto$INode$_lookup_leaf_after$arity$2 = (function (this$,flake){
var self__ = this;
var this$__$1 = this;
var c__2763__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__2764__auto__ = (function (){var switch__2740__auto__ = (function (state_17107){
var state_val_17108 = (state_17107[(1)]);
if((state_val_17108 === (7))){
var inst_17089 = (state_17107[(7)]);
var inst_17093 = fluree.db.dbproto._resolve(inst_17089);
var state_17107__$1 = state_17107;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_17107__$1,(10),inst_17093);
} else {
if((state_val_17108 === (1))){
var state_17107__$1 = state_17107;
var statearr_17109_17162 = state_17107__$1;
(statearr_17109_17162[(2)] = null);

(statearr_17109_17162[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17108 === (4))){
var inst_17083 = (state_17107[(2)]);
var state_17107__$1 = state_17107;
var statearr_17110_17163 = state_17107__$1;
(statearr_17110_17163[(2)] = inst_17083);

(statearr_17110_17163[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17108 === (6))){
var inst_17089 = (state_17107[(7)]);
var state_17107__$1 = state_17107;
var statearr_17111_17164 = state_17107__$1;
(statearr_17111_17164[(2)] = inst_17089);

(statearr_17111_17164[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17108 === (3))){
var inst_17105 = (state_17107[(2)]);
var state_17107__$1 = state_17107;
return cljs.core.async.impl.ioc_helpers.return_chan(state_17107__$1,inst_17105);
} else {
if((state_val_17108 === (2))){
var inst_17089 = (state_17107[(7)]);
var _ = (function (){var statearr_17113 = state_17107;
(statearr_17113[(4)] = cljs.core.cons((5),(state_17107[(4)])));

return statearr_17113;
})();
var inst_17089__$1 = this$__$1.fluree$db$dbproto$INode$_lookup_after$arity$2(null,flake);
var inst_17090 = new cljs.core.Keyword(null,"leaf","leaf",1306118732).cljs$core$IFn$_invoke$arity$1(inst_17089__$1);
var state_17107__$1 = (function (){var statearr_17114 = state_17107;
(statearr_17114[(7)] = inst_17089__$1);

return statearr_17114;
})();
if(cljs.core.truth_(inst_17090)){
var statearr_17115_17165 = state_17107__$1;
(statearr_17115_17165[(1)] = (6));

} else {
var statearr_17116_17166 = state_17107__$1;
(statearr_17116_17166[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17108 === (9))){
var inst_17099 = (state_17107[(2)]);
var inst_17100 = fluree.db.util.async.throw_err(inst_17099);
var state_17107__$1 = state_17107;
var statearr_17117_17167 = state_17107__$1;
(statearr_17117_17167[(2)] = inst_17100);

(statearr_17117_17167[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17108 === (5))){
var _ = (function (){var statearr_17118 = state_17107;
(statearr_17118[(4)] = cljs.core.rest((state_17107[(4)])));

return statearr_17118;
})();
var state_17107__$1 = state_17107;
var ex17112 = (state_17107__$1[(2)]);
var statearr_17119_17168 = state_17107__$1;
(statearr_17119_17168[(5)] = ex17112);


if((ex17112 instanceof Error)){
var statearr_17120_17169 = state_17107__$1;
(statearr_17120_17169[(1)] = (4));

(statearr_17120_17169[(5)] = null);

} else {
throw ex17112;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_17108 === (10))){
var inst_17095 = (state_17107[(2)]);
var inst_17096 = fluree.db.util.async.throw_err(inst_17095);
var inst_17097 = fluree.db.dbproto._lookup_leaf_after(inst_17096,flake);
var state_17107__$1 = state_17107;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_17107__$1,(9),inst_17097);
} else {
if((state_val_17108 === (8))){
var inst_17102 = (state_17107[(2)]);
var _ = (function (){var statearr_17121 = state_17107;
(statearr_17121[(4)] = cljs.core.rest((state_17107[(4)])));

return statearr_17121;
})();
var state_17107__$1 = state_17107;
var statearr_17122_17170 = state_17107__$1;
(statearr_17122_17170[(2)] = inst_17102);

(statearr_17122_17170[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$index$state_machine__2741__auto__ = null;
var fluree$db$index$state_machine__2741__auto____0 = (function (){
var statearr_17123 = [null,null,null,null,null,null,null,null];
(statearr_17123[(0)] = fluree$db$index$state_machine__2741__auto__);

(statearr_17123[(1)] = (1));

return statearr_17123;
});
var fluree$db$index$state_machine__2741__auto____1 = (function (state_17107){
while(true){
var ret_value__2742__auto__ = (function (){try{while(true){
var result__2743__auto__ = switch__2740__auto__(state_17107);
if(cljs.core.keyword_identical_QMARK_(result__2743__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2743__auto__;
}
break;
}
}catch (e17124){var ex__2744__auto__ = e17124;
var statearr_17125_17171 = state_17107;
(statearr_17125_17171[(2)] = ex__2744__auto__);


if(cljs.core.seq((state_17107[(4)]))){
var statearr_17126_17172 = state_17107;
(statearr_17126_17172[(1)] = cljs.core.first((state_17107[(4)])));

} else {
throw ex__2744__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__2742__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__17173 = state_17107;
state_17107 = G__17173;
continue;
} else {
return ret_value__2742__auto__;
}
break;
}
});
fluree$db$index$state_machine__2741__auto__ = function(state_17107){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__2741__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__2741__auto____1.call(this,state_17107);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__2741__auto____0;
fluree$db$index$state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__2741__auto____1;
return fluree$db$index$state_machine__2741__auto__;
})()
})();
var state__2765__auto__ = (function (){var statearr_17127 = (f__2764__auto__.cljs$core$IFn$_invoke$arity$0 ? f__2764__auto__.cljs$core$IFn$_invoke$arity$0() : f__2764__auto__.call(null));
(statearr_17127[(6)] = c__2763__auto__);

return statearr_17127;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__2765__auto__);
}));

return c__2763__auto__;
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4498__auto__){
var self__ = this;
var this__4498__auto____$1 = this;
var h__4360__auto__ = self__.__hash;
if((!((h__4360__auto__ == null)))){
return h__4360__auto__;
} else {
var h__4360__auto____$1 = (function (){var fexpr__17128 = (function (coll__4499__auto__){
return (659789215 ^ cljs.core.hash_unordered_coll(coll__4499__auto__));
});
return fexpr__17128(this__4498__auto____$1);
})();
(self__.__hash = h__4360__auto____$1);

return h__4360__auto____$1;
}
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this17022,other17023){
var self__ = this;
var this17022__$1 = this;
return (((!((other17023 == null)))) && ((((this17022__$1.constructor === other17023.constructor)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this17022__$1.block,other17023.block)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this17022__$1.t,other17023.t)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this17022__$1.rhs,other17023.rhs)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this17022__$1.children,other17023.children)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this17022__$1.config,other17023.config)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this17022__$1.leftmost_QMARK_,other17023.leftmost_QMARK_)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this17022__$1.__extmap,other17023.__extmap)))))))))))))))));
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4512__auto__,k__4513__auto__){
var self__ = this;
var this__4512__auto____$1 = this;
if(cljs.core.contains_QMARK_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"children","children",-940561982),null,new cljs.core.Keyword(null,"block","block",664686210),null,new cljs.core.Keyword(null,"config","config",994861415),null,new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),null,new cljs.core.Keyword(null,"t","t",-1397832519),null,new cljs.core.Keyword(null,"rhs","rhs",-229356739),null], null), null),k__4513__auto__)){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(cljs.core._with_meta(cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,this__4512__auto____$1),self__.__meta),k__4513__auto__);
} else {
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,cljs.core.not_empty(cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(self__.__extmap,k__4513__auto__)),null));
}
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IAssociative$_contains_key_QMARK_$arity$2 = (function (this__4509__auto__,k17021){
var self__ = this;
var this__4509__auto____$1 = this;
var G__17129 = k17021;
var G__17129__$1 = (((G__17129 instanceof cljs.core.Keyword))?G__17129.fqn:null);
switch (G__17129__$1) {
case "block":
case "t":
case "rhs":
case "children":
case "config":
case "leftmost?":
return true;

break;
default:
return cljs.core.contains_QMARK_(self__.__extmap,k17021);

}
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4510__auto__,k__4511__auto__,G__17020){
var self__ = this;
var this__4510__auto____$1 = this;
var pred__17130 = cljs.core.keyword_identical_QMARK_;
var expr__17131 = k__4511__auto__;
if(cljs.core.truth_((function (){var G__17133 = new cljs.core.Keyword(null,"block","block",664686210);
var G__17134 = expr__17131;
return (pred__17130.cljs$core$IFn$_invoke$arity$2 ? pred__17130.cljs$core$IFn$_invoke$arity$2(G__17133,G__17134) : pred__17130.call(null,G__17133,G__17134));
})())){
return (new fluree.db.index.IndexNode(G__17020,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__17135 = new cljs.core.Keyword(null,"t","t",-1397832519);
var G__17136 = expr__17131;
return (pred__17130.cljs$core$IFn$_invoke$arity$2 ? pred__17130.cljs$core$IFn$_invoke$arity$2(G__17135,G__17136) : pred__17130.call(null,G__17135,G__17136));
})())){
return (new fluree.db.index.IndexNode(self__.block,G__17020,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__17137 = new cljs.core.Keyword(null,"rhs","rhs",-229356739);
var G__17138 = expr__17131;
return (pred__17130.cljs$core$IFn$_invoke$arity$2 ? pred__17130.cljs$core$IFn$_invoke$arity$2(G__17137,G__17138) : pred__17130.call(null,G__17137,G__17138));
})())){
return (new fluree.db.index.IndexNode(self__.block,self__.t,G__17020,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__17139 = new cljs.core.Keyword(null,"children","children",-940561982);
var G__17140 = expr__17131;
return (pred__17130.cljs$core$IFn$_invoke$arity$2 ? pred__17130.cljs$core$IFn$_invoke$arity$2(G__17139,G__17140) : pred__17130.call(null,G__17139,G__17140));
})())){
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,G__17020,self__.config,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__17141 = new cljs.core.Keyword(null,"config","config",994861415);
var G__17142 = expr__17131;
return (pred__17130.cljs$core$IFn$_invoke$arity$2 ? pred__17130.cljs$core$IFn$_invoke$arity$2(G__17141,G__17142) : pred__17130.call(null,G__17141,G__17142));
})())){
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,G__17020,self__.leftmost_QMARK_,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__17143 = new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559);
var G__17144 = expr__17131;
return (pred__17130.cljs$core$IFn$_invoke$arity$2 ? pred__17130.cljs$core$IFn$_invoke$arity$2(G__17143,G__17144) : pred__17130.call(null,G__17143,G__17144));
})())){
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,G__17020,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,self__.__meta,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k__4511__auto__,G__17020),null));
}
}
}
}
}
}
}));

(fluree.db.index.IndexNode.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4515__auto__){
var self__ = this;
var this__4515__auto____$1 = this;
return cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(new cljs.core.Keyword(null,"block","block",664686210),self__.block,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"t","t",-1397832519),self__.t,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"rhs","rhs",-229356739),self__.rhs,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"children","children",-940561982),self__.children,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"config","config",994861415),self__.config,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559),self__.leftmost_QMARK_,null))], null),self__.__extmap));
}));

(fluree.db.index.IndexNode.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4501__auto__,G__17020){
var self__ = this;
var this__4501__auto____$1 = this;
return (new fluree.db.index.IndexNode(self__.block,self__.t,self__.rhs,self__.children,self__.config,self__.leftmost_QMARK_,G__17020,self__.__extmap,self__.__hash));
}));

(fluree.db.index.IndexNode.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4507__auto__,entry__4508__auto__){
var self__ = this;
var this__4507__auto____$1 = this;
if(cljs.core.vector_QMARK_(entry__4508__auto__)){
return this__4507__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4508__auto__,(0)),cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4508__auto__,(1)));
} else {
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(cljs.core._conj,this__4507__auto____$1,entry__4508__auto__);
}
}));

(fluree.db.index.IndexNode.getBasis = (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"block","block",-1989749559,null),new cljs.core.Symbol(null,"t","t",242699008,null),new cljs.core.Symbol(null,"rhs","rhs",1411174788,null),new cljs.core.Symbol(null,"children","children",699969545,null),new cljs.core.Symbol(null,"config","config",-1659574354,null),new cljs.core.Symbol(null,"leftmost?","leftmost?",-31657032,null)], null);
}));

(fluree.db.index.IndexNode.cljs$lang$type = true);

(fluree.db.index.IndexNode.cljs$lang$ctorPrSeq = (function (this__4546__auto__){
return (new cljs.core.List(null,"fluree.db.index/IndexNode",null,(1),null));
}));

(fluree.db.index.IndexNode.cljs$lang$ctorPrWriter = (function (this__4546__auto__,writer__4547__auto__){
return cljs.core._write(writer__4547__auto__,"fluree.db.index/IndexNode");
}));

/**
 * Positional factory function for fluree.db.index/IndexNode.
 */
fluree.db.index.__GT_IndexNode = (function fluree$db$index$__GT_IndexNode(block,t,rhs,children,config,leftmost_QMARK_){
return (new fluree.db.index.IndexNode(block,t,rhs,children,config,leftmost_QMARK_,null,null,null));
});

/**
 * Factory function for fluree.db.index/IndexNode, taking a map of keywords to field values.
 */
fluree.db.index.map__GT_IndexNode = (function fluree$db$index$map__GT_IndexNode(G__17024){
var extmap__4542__auto__ = (function (){var G__17145 = cljs.core.dissoc.cljs$core$IFn$_invoke$arity$variadic(G__17024,new cljs.core.Keyword(null,"block","block",664686210),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"rhs","rhs",-229356739),new cljs.core.Keyword(null,"children","children",-940561982),new cljs.core.Keyword(null,"config","config",994861415),new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559)], 0));
if(cljs.core.record_QMARK_(G__17024)){
return cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,G__17145);
} else {
return G__17145;
}
})();
return (new fluree.db.index.IndexNode(new cljs.core.Keyword(null,"block","block",664686210).cljs$core$IFn$_invoke$arity$1(G__17024),new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(G__17024),new cljs.core.Keyword(null,"rhs","rhs",-229356739).cljs$core$IFn$_invoke$arity$1(G__17024),new cljs.core.Keyword(null,"children","children",-940561982).cljs$core$IFn$_invoke$arity$1(G__17024),new cljs.core.Keyword(null,"config","config",994861415).cljs$core$IFn$_invoke$arity$1(G__17024),new cljs.core.Keyword(null,"leftmost?","leftmost?",-1672188559).cljs$core$IFn$_invoke$arity$1(G__17024),null,cljs.core.not_empty(extmap__4542__auto__),null));
});

fluree.db.index.index_node_QMARK_ = (function fluree$db$index$index_node_QMARK_(node){
return (node instanceof fluree.db.index.IndexNode);
});

/**
* @constructor
 * @implements {cljs.core.IRecord}
 * @implements {cljs.core.IKVReduce}
 * @implements {cljs.core.IEquiv}
 * @implements {cljs.core.IHash}
 * @implements {cljs.core.ICollection}
 * @implements {fluree.db.dbproto.INode}
 * @implements {cljs.core.ICounted}
 * @implements {cljs.core.ISeqable}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.ICloneable}
 * @implements {cljs.core.IPrintWithWriter}
 * @implements {cljs.core.IIterable}
 * @implements {fluree.db.dbproto.IResolve}
 * @implements {cljs.core.IWithMeta}
 * @implements {cljs.core.IAssociative}
 * @implements {cljs.core.IMap}
 * @implements {cljs.core.ILookup}
*/
fluree.db.index.DataNode = (function (block,t,flakes,rhs,config,__meta,__extmap,__hash){
this.block = block;
this.t = t;
this.flakes = flakes;
this.rhs = rhs;
this.config = config;
this.__meta = __meta;
this.__extmap = __extmap;
this.__hash = __hash;
this.cljs$lang$protocol_mask$partition0$ = 2230716170;
this.cljs$lang$protocol_mask$partition1$ = 139264;
});
(fluree.db.index.DataNode.prototype.cljs$core$ILookup$_lookup$arity$2 = (function (this__4502__auto__,k__4503__auto__){
var self__ = this;
var this__4502__auto____$1 = this;
return this__4502__auto____$1.cljs$core$ILookup$_lookup$arity$3(null,k__4503__auto__,null);
}));

(fluree.db.index.DataNode.prototype.cljs$core$ILookup$_lookup$arity$3 = (function (this__4504__auto__,k17176,else__4505__auto__){
var self__ = this;
var this__4504__auto____$1 = this;
var G__17180 = k17176;
var G__17180__$1 = (((G__17180 instanceof cljs.core.Keyword))?G__17180.fqn:null);
switch (G__17180__$1) {
case "block":
return self__.block;

break;
case "t":
return self__.t;

break;
case "flakes":
return self__.flakes;

break;
case "rhs":
return self__.rhs;

break;
case "config":
return self__.config;

break;
default:
return cljs.core.get.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k17176,else__4505__auto__);

}
}));

(fluree.db.index.DataNode.prototype.cljs$core$IKVReduce$_kv_reduce$arity$3 = (function (this__4522__auto__,f__4523__auto__,init__4524__auto__){
var self__ = this;
var this__4522__auto____$1 = this;
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3((function (ret__4525__auto__,p__17181){
var vec__17182 = p__17181;
var k__4526__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__17182,(0),null);
var v__4527__auto__ = cljs.core.nth.cljs$core$IFn$_invoke$arity$3(vec__17182,(1),null);
return (f__4523__auto__.cljs$core$IFn$_invoke$arity$3 ? f__4523__auto__.cljs$core$IFn$_invoke$arity$3(ret__4525__auto__,k__4526__auto__,v__4527__auto__) : f__4523__auto__.call(null,ret__4525__auto__,k__4526__auto__,v__4527__auto__));
}),init__4524__auto__,this__4522__auto____$1);
}));

(fluree.db.index.DataNode.prototype.cljs$core$IPrintWithWriter$_pr_writer$arity$3 = (function (this__4517__auto__,writer__4518__auto__,opts__4519__auto__){
var self__ = this;
var this__4517__auto____$1 = this;
var pr_pair__4520__auto__ = (function (keyval__4521__auto__){
return cljs.core.pr_sequential_writer(writer__4518__auto__,cljs.core.pr_writer,""," ","",opts__4519__auto__,keyval__4521__auto__);
});
return cljs.core.pr_sequential_writer(writer__4518__auto__,pr_pair__4520__auto__,"#fluree.db.index.DataNode{",", ","}",opts__4519__auto__,cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"block","block",664686210),self__.block],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"t","t",-1397832519),self__.t],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"flakes","flakes",1977895739),self__.flakes],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"rhs","rhs",-229356739),self__.rhs],null)),(new cljs.core.PersistentVector(null,2,(5),cljs.core.PersistentVector.EMPTY_NODE,[new cljs.core.Keyword(null,"config","config",994861415),self__.config],null))], null),self__.__extmap));
}));

(fluree.db.index.DataNode.prototype.cljs$core$IIterable$_iterator$arity$1 = (function (G__17175){
var self__ = this;
var G__17175__$1 = this;
return (new cljs.core.RecordIter((0),G__17175__$1,5,new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"block","block",664686210),new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"flakes","flakes",1977895739),new cljs.core.Keyword(null,"rhs","rhs",-229356739),new cljs.core.Keyword(null,"config","config",994861415)], null),(cljs.core.truth_(self__.__extmap)?cljs.core._iterator(self__.__extmap):cljs.core.nil_iter())));
}));

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$ = cljs.core.PROTOCOL_SENTINEL);

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$_resolve$arity$1 = (function (this$){
var self__ = this;
var this$__$1 = this;
var c__2763__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__2764__auto__ = (function (){var switch__2740__auto__ = (function (state_17186){
var state_val_17187 = (state_17186[(1)]);
if((state_val_17187 === (1))){
var state_17186__$1 = state_17186;
return cljs.core.async.impl.ioc_helpers.return_chan(state_17186__$1,this$__$1);
} else {
return null;
}
});
return (function() {
var fluree$db$index$state_machine__2741__auto__ = null;
var fluree$db$index$state_machine__2741__auto____0 = (function (){
var statearr_17188 = [null,null,null,null,null,null,null];
(statearr_17188[(0)] = fluree$db$index$state_machine__2741__auto__);

(statearr_17188[(1)] = (1));

return statearr_17188;
});
var fluree$db$index$state_machine__2741__auto____1 = (function (state_17186){
while(true){
var ret_value__2742__auto__ = (function (){try{while(true){
var result__2743__auto__ = switch__2740__auto__(state_17186);
if(cljs.core.keyword_identical_QMARK_(result__2743__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2743__auto__;
}
break;
}
}catch (e17189){var ex__2744__auto__ = e17189;
var statearr_17190_17222 = state_17186;
(statearr_17190_17222[(2)] = ex__2744__auto__);


if(cljs.core.seq((state_17186[(4)]))){
var statearr_17191_17223 = state_17186;
(statearr_17191_17223[(1)] = cljs.core.first((state_17186[(4)])));

} else {
throw ex__2744__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__2742__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__17224 = state_17186;
state_17186 = G__17224;
continue;
} else {
return ret_value__2742__auto__;
}
break;
}
});
fluree$db$index$state_machine__2741__auto__ = function(state_17186){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__2741__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__2741__auto____1.call(this,state_17186);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__2741__auto____0;
fluree$db$index$state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__2741__auto____1;
return fluree$db$index$state_machine__2741__auto__;
})()
})();
var state__2765__auto__ = (function (){var statearr_17192 = (f__2764__auto__.cljs$core$IFn$_invoke$arity$0 ? f__2764__auto__.cljs$core$IFn$_invoke$arity$0() : f__2764__auto__.call(null));
(statearr_17192[(6)] = c__2763__auto__);

return statearr_17192;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__2765__auto__);
}));

return c__2763__auto__;
}));

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$_resolve_history$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("-resolve-history called on DATA NODE!!!",cljs.core.PersistentArrayMap.EMPTY);
}));

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$_first_flake$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.first(self__.flakes);
}));

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$IResolve$_rhs$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.rhs;
}));

(fluree.db.index.DataNode.prototype.cljs$core$IMeta$_meta$arity$1 = (function (this__4500__auto__){
var self__ = this;
var this__4500__auto____$1 = this;
return self__.__meta;
}));

(fluree.db.index.DataNode.prototype.cljs$core$ICloneable$_clone$arity$1 = (function (this__4497__auto__){
var self__ = this;
var this__4497__auto____$1 = this;
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,self__.config,self__.__meta,self__.__extmap,self__.__hash));
}));

(fluree.db.index.DataNode.prototype.cljs$core$ICounted$_count$arity$1 = (function (this__4506__auto__){
var self__ = this;
var this__4506__auto____$1 = this;
return (5 + cljs.core.count(self__.__extmap));
}));

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$INode$ = cljs.core.PROTOCOL_SENTINEL);

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$INode$_lookup$arity$2 = (function (root,flake){
var self__ = this;
var root__$1 = this;
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("-lookup was called on a data node, which shouldn't happen!",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(500),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","unexpected-error","db/unexpected-error",1973857597)], null));
}));

(fluree.db.index.DataNode.prototype.fluree$db$dbproto$INode$_lookup_leaf$arity$2 = (function (root,flake){
var self__ = this;
var root__$1 = this;
fluree.db.util.log.error.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2(["-lookup-leaf was called on a data node, which shouldn't happen!"], 0));

var c__2763__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__2764__auto__ = (function (){var switch__2740__auto__ = (function (state_17198){
var state_val_17199 = (state_17198[(1)]);
if((state_val_17199 === (1))){
var inst_17193 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_17194 = [(500),new cljs.core.Keyword("db","unexpected-error","db/unexpected-error",1973857597)];
var inst_17195 = cljs.core.PersistentHashMap.fromArrays(inst_17193,inst_17194);
var inst_17196 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("-lookup-leaf was called on a data node, which shouldn't happen!",inst_17195);
var state_17198__$1 = state_17198;
return cljs.core.async.impl.ioc_helpers.return_chan(state_17198__$1,inst_17196);
} else {
return null;
}
});
return (function() {
var fluree$db$index$state_machine__2741__auto__ = null;
var fluree$db$index$state_machine__2741__auto____0 = (function (){
var statearr_17200 = [null,null,null,null,null,null,null];
(statearr_17200[(0)] = fluree$db$index$state_machine__2741__auto__);

(statearr_17200[(1)] = (1));

return statearr_17200;
});
var fluree$db$index$state_machine__2741__auto____1 = (function (state_17198){
while(true){
var ret_value__2742__auto__ = (function (){try{while(true){
var result__2743__auto__ = switch__2740__auto__(state_17198);
if(cljs.core.keyword_identical_QMARK_(result__2743__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2743__auto__;
}
break;
}
}catch (e17201){var ex__2744__auto__ = e17201;
var statearr_17202_17225 = state_17198;
(statearr_17202_17225[(2)] = ex__2744__auto__);


if(cljs.core.seq((state_17198[(4)]))){
var statearr_17203_17226 = state_17198;
(statearr_17203_17226[(1)] = cljs.core.first((state_17198[(4)])));

} else {
throw ex__2744__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__2742__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__17227 = state_17198;
state_17198 = G__17227;
continue;
} else {
return ret_value__2742__auto__;
}
break;
}
});
fluree$db$index$state_machine__2741__auto__ = function(state_17198){
switch(arguments.length){
case 0:
return fluree$db$index$state_machine__2741__auto____0.call(this);
case 1:
return fluree$db$index$state_machine__2741__auto____1.call(this,state_17198);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$index$state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$index$state_machine__2741__auto____0;
fluree$db$index$state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$index$state_machine__2741__auto____1;
return fluree$db$index$state_machine__2741__auto__;
})()
})();
var state__2765__auto__ = (function (){var statearr_17204 = (f__2764__auto__.cljs$core$IFn$_invoke$arity$0 ? f__2764__auto__.cljs$core$IFn$_invoke$arity$0() : f__2764__auto__.call(null));
(statearr_17204[(6)] = c__2763__auto__);

return statearr_17204;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__2765__auto__);
}));

return c__2763__auto__;
}));

(fluree.db.index.DataNode.prototype.cljs$core$IHash$_hash$arity$1 = (function (this__4498__auto__){
var self__ = this;
var this__4498__auto____$1 = this;
var h__4360__auto__ = self__.__hash;
if((!((h__4360__auto__ == null)))){
return h__4360__auto__;
} else {
var h__4360__auto____$1 = (function (){var fexpr__17205 = (function (coll__4499__auto__){
return (1312629141 ^ cljs.core.hash_unordered_coll(coll__4499__auto__));
});
return fexpr__17205(this__4498__auto____$1);
})();
(self__.__hash = h__4360__auto____$1);

return h__4360__auto____$1;
}
}));

(fluree.db.index.DataNode.prototype.cljs$core$IEquiv$_equiv$arity$2 = (function (this17177,other17178){
var self__ = this;
var this17177__$1 = this;
return (((!((other17178 == null)))) && ((((this17177__$1.constructor === other17178.constructor)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this17177__$1.block,other17178.block)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this17177__$1.t,other17178.t)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this17177__$1.flakes,other17178.flakes)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this17177__$1.rhs,other17178.rhs)) && (((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this17177__$1.config,other17178.config)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(this17177__$1.__extmap,other17178.__extmap)))))))))))))));
}));

(fluree.db.index.DataNode.prototype.cljs$core$IMap$_dissoc$arity$2 = (function (this__4512__auto__,k__4513__auto__){
var self__ = this;
var this__4512__auto____$1 = this;
if(cljs.core.contains_QMARK_(new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 5, [new cljs.core.Keyword(null,"block","block",664686210),null,new cljs.core.Keyword(null,"config","config",994861415),null,new cljs.core.Keyword(null,"t","t",-1397832519),null,new cljs.core.Keyword(null,"flakes","flakes",1977895739),null,new cljs.core.Keyword(null,"rhs","rhs",-229356739),null], null), null),k__4513__auto__)){
return cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(cljs.core._with_meta(cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,this__4512__auto____$1),self__.__meta),k__4513__auto__);
} else {
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,self__.config,self__.__meta,cljs.core.not_empty(cljs.core.dissoc.cljs$core$IFn$_invoke$arity$2(self__.__extmap,k__4513__auto__)),null));
}
}));

(fluree.db.index.DataNode.prototype.cljs$core$IAssociative$_contains_key_QMARK_$arity$2 = (function (this__4509__auto__,k17176){
var self__ = this;
var this__4509__auto____$1 = this;
var G__17206 = k17176;
var G__17206__$1 = (((G__17206 instanceof cljs.core.Keyword))?G__17206.fqn:null);
switch (G__17206__$1) {
case "block":
case "t":
case "flakes":
case "rhs":
case "config":
return true;

break;
default:
return cljs.core.contains_QMARK_(self__.__extmap,k17176);

}
}));

(fluree.db.index.DataNode.prototype.cljs$core$IAssociative$_assoc$arity$3 = (function (this__4510__auto__,k__4511__auto__,G__17175){
var self__ = this;
var this__4510__auto____$1 = this;
var pred__17207 = cljs.core.keyword_identical_QMARK_;
var expr__17208 = k__4511__auto__;
if(cljs.core.truth_((function (){var G__17210 = new cljs.core.Keyword(null,"block","block",664686210);
var G__17211 = expr__17208;
return (pred__17207.cljs$core$IFn$_invoke$arity$2 ? pred__17207.cljs$core$IFn$_invoke$arity$2(G__17210,G__17211) : pred__17207.call(null,G__17210,G__17211));
})())){
return (new fluree.db.index.DataNode(G__17175,self__.t,self__.flakes,self__.rhs,self__.config,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__17212 = new cljs.core.Keyword(null,"t","t",-1397832519);
var G__17213 = expr__17208;
return (pred__17207.cljs$core$IFn$_invoke$arity$2 ? pred__17207.cljs$core$IFn$_invoke$arity$2(G__17212,G__17213) : pred__17207.call(null,G__17212,G__17213));
})())){
return (new fluree.db.index.DataNode(self__.block,G__17175,self__.flakes,self__.rhs,self__.config,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__17214 = new cljs.core.Keyword(null,"flakes","flakes",1977895739);
var G__17215 = expr__17208;
return (pred__17207.cljs$core$IFn$_invoke$arity$2 ? pred__17207.cljs$core$IFn$_invoke$arity$2(G__17214,G__17215) : pred__17207.call(null,G__17214,G__17215));
})())){
return (new fluree.db.index.DataNode(self__.block,self__.t,G__17175,self__.rhs,self__.config,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__17216 = new cljs.core.Keyword(null,"rhs","rhs",-229356739);
var G__17217 = expr__17208;
return (pred__17207.cljs$core$IFn$_invoke$arity$2 ? pred__17207.cljs$core$IFn$_invoke$arity$2(G__17216,G__17217) : pred__17207.call(null,G__17216,G__17217));
})())){
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,G__17175,self__.config,self__.__meta,self__.__extmap,null));
} else {
if(cljs.core.truth_((function (){var G__17218 = new cljs.core.Keyword(null,"config","config",994861415);
var G__17219 = expr__17208;
return (pred__17207.cljs$core$IFn$_invoke$arity$2 ? pred__17207.cljs$core$IFn$_invoke$arity$2(G__17218,G__17219) : pred__17207.call(null,G__17218,G__17219));
})())){
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,G__17175,self__.__meta,self__.__extmap,null));
} else {
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,self__.config,self__.__meta,cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(self__.__extmap,k__4511__auto__,G__17175),null));
}
}
}
}
}
}));

(fluree.db.index.DataNode.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this__4515__auto__){
var self__ = this;
var this__4515__auto____$1 = this;
return cljs.core.seq(cljs.core.concat.cljs$core$IFn$_invoke$arity$2(new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [(new cljs.core.MapEntry(new cljs.core.Keyword(null,"block","block",664686210),self__.block,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"t","t",-1397832519),self__.t,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"flakes","flakes",1977895739),self__.flakes,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"rhs","rhs",-229356739),self__.rhs,null)),(new cljs.core.MapEntry(new cljs.core.Keyword(null,"config","config",994861415),self__.config,null))], null),self__.__extmap));
}));

(fluree.db.index.DataNode.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (this__4501__auto__,G__17175){
var self__ = this;
var this__4501__auto____$1 = this;
return (new fluree.db.index.DataNode(self__.block,self__.t,self__.flakes,self__.rhs,self__.config,G__17175,self__.__extmap,self__.__hash));
}));

(fluree.db.index.DataNode.prototype.cljs$core$ICollection$_conj$arity$2 = (function (this__4507__auto__,entry__4508__auto__){
var self__ = this;
var this__4507__auto____$1 = this;
if(cljs.core.vector_QMARK_(entry__4508__auto__)){
return this__4507__auto____$1.cljs$core$IAssociative$_assoc$arity$3(null,cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4508__auto__,(0)),cljs.core._nth.cljs$core$IFn$_invoke$arity$2(entry__4508__auto__,(1)));
} else {
return cljs.core.reduce.cljs$core$IFn$_invoke$arity$3(cljs.core._conj,this__4507__auto____$1,entry__4508__auto__);
}
}));

(fluree.db.index.DataNode.getBasis = (function (){
return new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"block","block",-1989749559,null),new cljs.core.Symbol(null,"t","t",242699008,null),new cljs.core.Symbol(null,"flakes","flakes",-676540030,null),new cljs.core.Symbol(null,"rhs","rhs",1411174788,null),new cljs.core.Symbol(null,"config","config",-1659574354,null)], null);
}));

(fluree.db.index.DataNode.cljs$lang$type = true);

(fluree.db.index.DataNode.cljs$lang$ctorPrSeq = (function (this__4546__auto__){
return (new cljs.core.List(null,"fluree.db.index/DataNode",null,(1),null));
}));

(fluree.db.index.DataNode.cljs$lang$ctorPrWriter = (function (this__4546__auto__,writer__4547__auto__){
return cljs.core._write(writer__4547__auto__,"fluree.db.index/DataNode");
}));

/**
 * Positional factory function for fluree.db.index/DataNode.
 */
fluree.db.index.__GT_DataNode = (function fluree$db$index$__GT_DataNode(block,t,flakes,rhs,config){
return (new fluree.db.index.DataNode(block,t,flakes,rhs,config,null,null,null));
});

/**
 * Factory function for fluree.db.index/DataNode, taking a map of keywords to field values.
 */
fluree.db.index.map__GT_DataNode = (function fluree$db$index$map__GT_DataNode(G__17179){
var extmap__4542__auto__ = (function (){var G__17220 = cljs.core.dissoc.cljs$core$IFn$_invoke$arity$variadic(G__17179,new cljs.core.Keyword(null,"block","block",664686210),cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.Keyword(null,"t","t",-1397832519),new cljs.core.Keyword(null,"flakes","flakes",1977895739),new cljs.core.Keyword(null,"rhs","rhs",-229356739),new cljs.core.Keyword(null,"config","config",994861415)], 0));
if(cljs.core.record_QMARK_(G__17179)){
return cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentArrayMap.EMPTY,G__17220);
} else {
return G__17220;
}
})();
return (new fluree.db.index.DataNode(new cljs.core.Keyword(null,"block","block",664686210).cljs$core$IFn$_invoke$arity$1(G__17179),new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(G__17179),new cljs.core.Keyword(null,"flakes","flakes",1977895739).cljs$core$IFn$_invoke$arity$1(G__17179),new cljs.core.Keyword(null,"rhs","rhs",-229356739).cljs$core$IFn$_invoke$arity$1(G__17179),new cljs.core.Keyword(null,"config","config",994861415).cljs$core$IFn$_invoke$arity$1(G__17179),null,cljs.core.not_empty(extmap__4542__auto__),null));
});

/**
 * Creates a new data node
 */
fluree.db.index.data_node = (function fluree$db$index$data_node(block_id,t,flakes,rhs,config){
return fluree.db.index.__GT_DataNode(block_id,t,flakes,rhs,config);
});
fluree.db.index.data_node_QMARK_ = (function fluree$db$index$data_node_QMARK_(node){
return (node instanceof fluree.db.index.DataNode);
});
