// Compiled by ClojureScript 1.10.891 {:static-fns true, :optimize-constants false, :target :nodejs, :nodejs-rt false, :optimizations :advanced}
goog.provide('fluree.db.time_travel');
goog.require('cljs.core');
goog.require('fluree.db.dbproto');
goog.require('fluree.db.util.core');
goog.require('fluree.db.query.range');
goog.require('clojure.string');
goog.require('fluree.db.flake');
goog.require('fluree.db.util.async');
goog.require('cljs.core.async');
/**
 * Given a duration, returns a ISO-8601 formatted time string of now minus duration
 */
fluree.db.time_travel.duration_parse = (function fluree$db$time_travel$duration_parse(time_str){
throw cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2("Duration timeframes not yet supported in javascript.",new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"status","status",-1997798413),(400),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword("db","platform-support","db/platform-support",72429710)], null));
});
fluree.db.time_travel.time_to_t = (function fluree$db$time_travel$time_to_t(db,time_str){
var c__2763__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__2764__auto__ = (function (){var switch__2740__auto__ = (function (state_19096){
var state_val_19097 = (state_19096[(1)]);
if((state_val_19097 === (7))){
var state_19096__$1 = state_19096;
var statearr_19098_19140 = state_19096__$1;
(statearr_19098_19140[(2)] = time_str);

(statearr_19098_19140[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (20))){
var inst_19081 = (state_19096[(7)]);
var state_19096__$1 = state_19096;
if(cljs.core.truth_(inst_19081)){
var statearr_19099_19141 = state_19096__$1;
(statearr_19099_19141[(1)] = (22));

} else {
var statearr_19100_19142 = state_19096__$1;
(statearr_19100_19142[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (1))){
var state_19096__$1 = state_19096;
var statearr_19101_19143 = state_19096__$1;
(statearr_19101_19143[(2)] = null);

(statearr_19101_19143[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (24))){
var inst_19089 = (state_19096[(2)]);
var state_19096__$1 = state_19096;
var statearr_19102_19144 = state_19096__$1;
(statearr_19102_19144[(2)] = inst_19089);

(statearr_19102_19144[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (4))){
var inst_19035 = (state_19096[(2)]);
var state_19096__$1 = state_19096;
var statearr_19103_19145 = state_19096__$1;
(statearr_19103_19145[(2)] = inst_19035);

(statearr_19103_19145[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (15))){
var inst_19065 = (state_19096[(2)]);
var inst_19066 = fluree.db.util.async.throw_err(inst_19065);
var state_19096__$1 = state_19096;
var statearr_19104_19146 = state_19096__$1;
(statearr_19104_19146[(2)] = inst_19066);

(statearr_19104_19146[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (21))){
var inst_19091 = (state_19096[(2)]);
var _ = (function (){var statearr_19105 = state_19096;
(statearr_19105[(4)] = cljs.core.rest((state_19096[(4)])));

return statearr_19105;
})();
var state_19096__$1 = state_19096;
var statearr_19106_19147 = state_19096__$1;
(statearr_19106_19147[(2)] = inst_19091);

(statearr_19106_19147[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (13))){
var inst_19060 = (state_19096[(8)]);
var state_19096__$1 = state_19096;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_19096__$1,(15),inst_19060);
} else {
if((state_val_19097 === (22))){
var inst_19081 = (state_19096[(7)]);
var state_19096__$1 = state_19096;
var statearr_19107_19148 = state_19096__$1;
(statearr_19107_19148[(2)] = inst_19081);

(statearr_19107_19148[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (6))){
var inst_19043 = fluree.db.util.core.str__GT_epoch_ms(time_str);
var state_19096__$1 = state_19096;
var statearr_19108_19149 = state_19096__$1;
(statearr_19108_19149[(2)] = inst_19043);

(statearr_19108_19149[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (17))){
var state_19096__$1 = state_19096;
var statearr_19109_19150 = state_19096__$1;
(statearr_19109_19150[(2)] = null);

(statearr_19109_19150[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (3))){
var inst_19094 = (state_19096[(2)]);
var state_19096__$1 = state_19096;
return cljs.core.async.impl.ioc_helpers.return_chan(state_19096__$1,inst_19094);
} else {
if((state_val_19097 === (12))){
var state_19096__$1 = state_19096;
var statearr_19110_19151 = state_19096__$1;
(statearr_19110_19151[(2)] = null);

(statearr_19110_19151[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (2))){
var _ = (function (){var statearr_19111 = state_19096;
(statearr_19111[(4)] = cljs.core.cons((5),(state_19096[(4)])));

return statearr_19111;
})();
var inst_19041 = typeof time_str === 'string';
var state_19096__$1 = state_19096;
if(cljs.core.truth_(inst_19041)){
var statearr_19112_19152 = state_19096__$1;
(statearr_19112_19152[(1)] = (6));

} else {
var statearr_19113_19153 = state_19096__$1;
(statearr_19113_19153[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (23))){
var inst_19087 = new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(db);
var state_19096__$1 = state_19096;
var statearr_19114_19154 = state_19096__$1;
(statearr_19114_19154[(2)] = inst_19087);

(statearr_19114_19154[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (19))){
var inst_19082 = (state_19096[(9)]);
var state_19096__$1 = state_19096;
var statearr_19115_19155 = state_19096__$1;
(statearr_19115_19155[(2)] = inst_19082);

(statearr_19115_19155[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (11))){
var inst_19060 = (state_19096[(8)]);
var inst_19060__$1 = (state_19096[(2)]);
var inst_19061 = (inst_19060__$1 == null);
var state_19096__$1 = (function (){var statearr_19117 = state_19096;
(statearr_19117[(8)] = inst_19060__$1);

return statearr_19117;
})();
if(cljs.core.truth_(inst_19061)){
var statearr_19118_19156 = state_19096__$1;
(statearr_19118_19156[(1)] = (12));

} else {
var statearr_19119_19157 = state_19096__$1;
(statearr_19119_19157[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (9))){
var state_19096__$1 = state_19096;
var statearr_19120_19158 = state_19096__$1;
(statearr_19120_19158[(2)] = null);

(statearr_19120_19158[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (5))){
var _ = (function (){var statearr_19121 = state_19096;
(statearr_19121[(4)] = cljs.core.rest((state_19096[(4)])));

return statearr_19121;
})();
var state_19096__$1 = state_19096;
var ex19116 = (state_19096__$1[(2)]);
var statearr_19122_19159 = state_19096__$1;
(statearr_19122_19159[(5)] = ex19116);


if((ex19116 instanceof Error)){
var statearr_19123_19160 = state_19096__$1;
(statearr_19123_19160[(1)] = (4));

(statearr_19123_19160[(5)] = null);

} else {
throw ex19116;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (14))){
var inst_19068 = (state_19096[(10)]);
var inst_19068__$1 = (state_19096[(2)]);
var inst_19069 = cljs.core.empty_QMARK_(inst_19068__$1);
var state_19096__$1 = (function (){var statearr_19124 = state_19096;
(statearr_19124[(10)] = inst_19068__$1);

return statearr_19124;
})();
if(inst_19069){
var statearr_19125_19161 = state_19096__$1;
(statearr_19125_19161[(1)] = (16));

} else {
var statearr_19126_19162 = state_19096__$1;
(statearr_19126_19162[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (16))){
var inst_19046 = (state_19096[(11)]);
var inst_19071 = ["There is no data as of ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_19046)].join('');
var inst_19072 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_19073 = [(400),new cljs.core.Keyword("db","invalid-block","db/invalid-block",1677435518)];
var inst_19074 = cljs.core.PersistentHashMap.fromArrays(inst_19072,inst_19073);
var inst_19075 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_19071,inst_19074);
var inst_19076 = (function(){throw inst_19075})();
var state_19096__$1 = state_19096;
var statearr_19127_19163 = state_19096__$1;
(statearr_19127_19163[(2)] = inst_19076);

(statearr_19127_19163[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (10))){
var inst_19046 = (state_19096[(11)]);
var inst_19048 = (state_19096[(12)]);
var inst_19052 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_19053 = ["_block/instant",(0)];
var inst_19054 = (new cljs.core.PersistentVector(null,2,(5),inst_19052,inst_19053,null));
var inst_19055 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_19056 = ["_block/instant",inst_19046];
var inst_19057 = (new cljs.core.PersistentVector(null,2,(5),inst_19055,inst_19056,null));
var inst_19058 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$6(inst_19048,new cljs.core.Keyword(null,"post","post",269697687),cljs.core._GT_,inst_19054,cljs.core._LT_,inst_19057);
var state_19096__$1 = state_19096;
var statearr_19128_19164 = state_19096__$1;
(statearr_19128_19164[(2)] = inst_19058);

(statearr_19128_19164[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (18))){
var inst_19082 = (state_19096[(9)]);
var inst_19081 = (state_19096[(7)]);
var inst_19046 = (state_19096[(11)]);
var inst_19068 = (state_19096[(10)]);
var inst_19079 = (state_19096[(2)]);
var inst_19080 = (function (){var epoch_as_of = inst_19046;
var ts = inst_19068;
var _ = inst_19079;
return (function (p1__19034_SHARP_){
return p1__19034_SHARP_.s;
});
})();
var inst_19081__$1 = cljs.core.apply.cljs$core$IFn$_invoke$arity$3(cljs.core.min_key,inst_19080,inst_19068);
var inst_19082__$1 = inst_19081__$1.s;
var state_19096__$1 = (function (){var statearr_19129 = state_19096;
(statearr_19129[(9)] = inst_19082__$1);

(statearr_19129[(7)] = inst_19081__$1);

return statearr_19129;
})();
if(cljs.core.truth_(inst_19082__$1)){
var statearr_19130_19165 = state_19096__$1;
(statearr_19130_19165[(1)] = (19));

} else {
var statearr_19131_19166 = state_19096__$1;
(statearr_19131_19166[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19097 === (8))){
var inst_19048 = (state_19096[(12)]);
var inst_19046 = (state_19096[(2)]);
var inst_19048__$1 = fluree.db.dbproto._rootdb(db);
var inst_19049 = (inst_19048__$1 == null);
var state_19096__$1 = (function (){var statearr_19132 = state_19096;
(statearr_19132[(11)] = inst_19046);

(statearr_19132[(12)] = inst_19048__$1);

return statearr_19132;
})();
if(cljs.core.truth_(inst_19049)){
var statearr_19133_19167 = state_19096__$1;
(statearr_19133_19167[(1)] = (9));

} else {
var statearr_19134_19168 = state_19096__$1;
(statearr_19134_19168[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$time_travel$time_to_t_$_state_machine__2741__auto__ = null;
var fluree$db$time_travel$time_to_t_$_state_machine__2741__auto____0 = (function (){
var statearr_19135 = [null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_19135[(0)] = fluree$db$time_travel$time_to_t_$_state_machine__2741__auto__);

(statearr_19135[(1)] = (1));

return statearr_19135;
});
var fluree$db$time_travel$time_to_t_$_state_machine__2741__auto____1 = (function (state_19096){
while(true){
var ret_value__2742__auto__ = (function (){try{while(true){
var result__2743__auto__ = switch__2740__auto__(state_19096);
if(cljs.core.keyword_identical_QMARK_(result__2743__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2743__auto__;
}
break;
}
}catch (e19136){var ex__2744__auto__ = e19136;
var statearr_19137_19169 = state_19096;
(statearr_19137_19169[(2)] = ex__2744__auto__);


if(cljs.core.seq((state_19096[(4)]))){
var statearr_19138_19170 = state_19096;
(statearr_19138_19170[(1)] = cljs.core.first((state_19096[(4)])));

} else {
throw ex__2744__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__2742__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__19171 = state_19096;
state_19096 = G__19171;
continue;
} else {
return ret_value__2742__auto__;
}
break;
}
});
fluree$db$time_travel$time_to_t_$_state_machine__2741__auto__ = function(state_19096){
switch(arguments.length){
case 0:
return fluree$db$time_travel$time_to_t_$_state_machine__2741__auto____0.call(this);
case 1:
return fluree$db$time_travel$time_to_t_$_state_machine__2741__auto____1.call(this,state_19096);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$time_travel$time_to_t_$_state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$time_travel$time_to_t_$_state_machine__2741__auto____0;
fluree$db$time_travel$time_to_t_$_state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$time_travel$time_to_t_$_state_machine__2741__auto____1;
return fluree$db$time_travel$time_to_t_$_state_machine__2741__auto__;
})()
})();
var state__2765__auto__ = (function (){var statearr_19139 = (f__2764__auto__.cljs$core$IFn$_invoke$arity$0 ? f__2764__auto__.cljs$core$IFn$_invoke$arity$0() : f__2764__auto__.call(null));
(statearr_19139[(6)] = c__2763__auto__);

return statearr_19139;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__2765__auto__);
}));

return c__2763__auto__;
});
fluree.db.time_travel.t_to_block = (function fluree$db$time_travel$t_to_block(db,t){
var c__2763__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__2764__auto__ = (function (){var switch__2740__auto__ = (function (state_19226){
var state_val_19227 = (state_19226[(1)]);
if((state_val_19227 === (7))){
var inst_19180 = (state_19226[(7)]);
var inst_19184 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_19185 = ["_block/number",t];
var inst_19186 = (new cljs.core.PersistentVector(null,2,(5),inst_19184,inst_19185,null));
var inst_19187 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_19188 = ["_block/number"];
var inst_19189 = (new cljs.core.PersistentVector(null,1,(5),inst_19187,inst_19188,null));
var inst_19190 = [new cljs.core.Keyword(null,"limit","limit",-1355822363)];
var inst_19191 = [(1)];
var inst_19192 = cljs.core.PersistentHashMap.fromArrays(inst_19190,inst_19191);
var inst_19193 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$7(inst_19180,new cljs.core.Keyword(null,"psot","psot",2111653059),cljs.core._GT__EQ_,inst_19186,cljs.core._LT__EQ_,inst_19189,inst_19192);
var state_19226__$1 = state_19226;
var statearr_19228_19267 = state_19226__$1;
(statearr_19228_19267[(2)] = inst_19193);

(statearr_19228_19267[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19227 === (20))){
var state_19226__$1 = state_19226;
var statearr_19229_19268 = state_19226__$1;
(statearr_19229_19268[(2)] = (1));

(statearr_19229_19268[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19227 === (1))){
var state_19226__$1 = state_19226;
var statearr_19230_19269 = state_19226__$1;
(statearr_19230_19269[(2)] = null);

(statearr_19230_19269[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19227 === (4))){
var inst_19173 = (state_19226[(2)]);
var state_19226__$1 = state_19226;
var statearr_19231_19270 = state_19226__$1;
(statearr_19231_19270[(2)] = inst_19173);

(statearr_19231_19270[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19227 === (15))){
var inst_19209 = (state_19226[(8)]);
var inst_19209__$1 = (state_19226[(2)]);
var inst_19210 = (inst_19209__$1 == null);
var state_19226__$1 = (function (){var statearr_19232 = state_19226;
(statearr_19232[(8)] = inst_19209__$1);

return statearr_19232;
})();
if(cljs.core.truth_(inst_19210)){
var statearr_19233_19271 = state_19226__$1;
(statearr_19233_19271[(1)] = (16));

} else {
var statearr_19234_19272 = state_19226__$1;
(statearr_19234_19272[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19227 === (21))){
var inst_19221 = (state_19226[(2)]);
var _ = (function (){var statearr_19235 = state_19226;
(statearr_19235[(4)] = cljs.core.rest((state_19226[(4)])));

return statearr_19235;
})();
var state_19226__$1 = state_19226;
var statearr_19236_19273 = state_19226__$1;
(statearr_19236_19273[(2)] = inst_19221);

(statearr_19236_19273[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19227 === (13))){
var state_19226__$1 = state_19226;
var statearr_19237_19274 = state_19226__$1;
(statearr_19237_19274[(2)] = null);

(statearr_19237_19274[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19227 === (6))){
var state_19226__$1 = state_19226;
var statearr_19238_19275 = state_19226__$1;
(statearr_19238_19275[(2)] = null);

(statearr_19238_19275[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19227 === (17))){
var inst_19209 = (state_19226[(8)]);
var inst_19213 = (function (){var G__19179 = inst_19209;
return (function (p1__19172_SHARP_){
var f = p1__19172_SHARP_;
return f.o;
});
})();
var inst_19214 = (inst_19213.cljs$core$IFn$_invoke$arity$1 ? inst_19213.cljs$core$IFn$_invoke$arity$1(inst_19209) : inst_19213.call(null,inst_19209));
var state_19226__$1 = state_19226;
var statearr_19239_19276 = state_19226__$1;
(statearr_19239_19276[(2)] = inst_19214);

(statearr_19239_19276[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19227 === (3))){
var inst_19224 = (state_19226[(2)]);
var state_19226__$1 = state_19226;
return cljs.core.async.impl.ioc_helpers.return_chan(state_19226__$1,inst_19224);
} else {
if((state_val_19227 === (12))){
var inst_19200 = (state_19226[(2)]);
var inst_19201 = fluree.db.util.async.throw_err(inst_19200);
var state_19226__$1 = state_19226;
var statearr_19240_19277 = state_19226__$1;
(statearr_19240_19277[(2)] = inst_19201);

(statearr_19240_19277[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19227 === (2))){
var inst_19180 = (state_19226[(7)]);
var _ = (function (){var statearr_19241 = state_19226;
(statearr_19241[(4)] = cljs.core.cons((5),(state_19226[(4)])));

return statearr_19241;
})();
var inst_19180__$1 = fluree.db.dbproto._rootdb(db);
var inst_19181 = (inst_19180__$1 == null);
var state_19226__$1 = (function (){var statearr_19242 = state_19226;
(statearr_19242[(7)] = inst_19180__$1);

return statearr_19242;
})();
if(cljs.core.truth_(inst_19181)){
var statearr_19243_19278 = state_19226__$1;
(statearr_19243_19278[(1)] = (6));

} else {
var statearr_19244_19279 = state_19226__$1;
(statearr_19244_19279[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19227 === (19))){
var inst_19216 = (state_19226[(9)]);
var state_19226__$1 = state_19226;
var statearr_19245_19280 = state_19226__$1;
(statearr_19245_19280[(2)] = inst_19216);

(statearr_19245_19280[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19227 === (11))){
var inst_19203 = (state_19226[(10)]);
var inst_19203__$1 = (state_19226[(2)]);
var inst_19204 = (inst_19203__$1 == null);
var state_19226__$1 = (function (){var statearr_19247 = state_19226;
(statearr_19247[(10)] = inst_19203__$1);

return statearr_19247;
})();
if(cljs.core.truth_(inst_19204)){
var statearr_19248_19281 = state_19226__$1;
(statearr_19248_19281[(1)] = (13));

} else {
var statearr_19249_19282 = state_19226__$1;
(statearr_19249_19282[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19227 === (9))){
var state_19226__$1 = state_19226;
var statearr_19250_19283 = state_19226__$1;
(statearr_19250_19283[(2)] = null);

(statearr_19250_19283[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19227 === (5))){
var _ = (function (){var statearr_19251 = state_19226;
(statearr_19251[(4)] = cljs.core.rest((state_19226[(4)])));

return statearr_19251;
})();
var state_19226__$1 = state_19226;
var ex19246 = (state_19226__$1[(2)]);
var statearr_19252_19284 = state_19226__$1;
(statearr_19252_19284[(5)] = ex19246);


if((ex19246 instanceof Error)){
var statearr_19253_19285 = state_19226__$1;
(statearr_19253_19285[(1)] = (4));

(statearr_19253_19285[(5)] = null);

} else {
throw ex19246;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19227 === (14))){
var inst_19203 = (state_19226[(10)]);
var inst_19207 = cljs.core.first(inst_19203);
var state_19226__$1 = state_19226;
var statearr_19254_19286 = state_19226__$1;
(statearr_19254_19286[(2)] = inst_19207);

(statearr_19254_19286[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19227 === (16))){
var state_19226__$1 = state_19226;
var statearr_19255_19287 = state_19226__$1;
(statearr_19255_19287[(2)] = null);

(statearr_19255_19287[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19227 === (10))){
var inst_19195 = (state_19226[(11)]);
var state_19226__$1 = state_19226;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_19226__$1,(12),inst_19195);
} else {
if((state_val_19227 === (18))){
var inst_19216 = (state_19226[(9)]);
var inst_19216__$1 = (state_19226[(2)]);
var inst_19217 = (inst_19216__$1 > (1));
var state_19226__$1 = (function (){var statearr_19256 = state_19226;
(statearr_19256[(9)] = inst_19216__$1);

return statearr_19256;
})();
if(cljs.core.truth_(inst_19217)){
var statearr_19257_19288 = state_19226__$1;
(statearr_19257_19288[(1)] = (19));

} else {
var statearr_19258_19289 = state_19226__$1;
(statearr_19258_19289[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19227 === (8))){
var inst_19195 = (state_19226[(11)]);
var inst_19195__$1 = (state_19226[(2)]);
var inst_19196 = (inst_19195__$1 == null);
var state_19226__$1 = (function (){var statearr_19259 = state_19226;
(statearr_19259[(11)] = inst_19195__$1);

return statearr_19259;
})();
if(cljs.core.truth_(inst_19196)){
var statearr_19260_19290 = state_19226__$1;
(statearr_19260_19290[(1)] = (9));

} else {
var statearr_19261_19291 = state_19226__$1;
(statearr_19261_19291[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$time_travel$t_to_block_$_state_machine__2741__auto__ = null;
var fluree$db$time_travel$t_to_block_$_state_machine__2741__auto____0 = (function (){
var statearr_19262 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_19262[(0)] = fluree$db$time_travel$t_to_block_$_state_machine__2741__auto__);

(statearr_19262[(1)] = (1));

return statearr_19262;
});
var fluree$db$time_travel$t_to_block_$_state_machine__2741__auto____1 = (function (state_19226){
while(true){
var ret_value__2742__auto__ = (function (){try{while(true){
var result__2743__auto__ = switch__2740__auto__(state_19226);
if(cljs.core.keyword_identical_QMARK_(result__2743__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2743__auto__;
}
break;
}
}catch (e19263){var ex__2744__auto__ = e19263;
var statearr_19264_19292 = state_19226;
(statearr_19264_19292[(2)] = ex__2744__auto__);


if(cljs.core.seq((state_19226[(4)]))){
var statearr_19265_19293 = state_19226;
(statearr_19265_19293[(1)] = cljs.core.first((state_19226[(4)])));

} else {
throw ex__2744__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__2742__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__19294 = state_19226;
state_19226 = G__19294;
continue;
} else {
return ret_value__2742__auto__;
}
break;
}
});
fluree$db$time_travel$t_to_block_$_state_machine__2741__auto__ = function(state_19226){
switch(arguments.length){
case 0:
return fluree$db$time_travel$t_to_block_$_state_machine__2741__auto____0.call(this);
case 1:
return fluree$db$time_travel$t_to_block_$_state_machine__2741__auto____1.call(this,state_19226);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$time_travel$t_to_block_$_state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$time_travel$t_to_block_$_state_machine__2741__auto____0;
fluree$db$time_travel$t_to_block_$_state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$time_travel$t_to_block_$_state_machine__2741__auto____1;
return fluree$db$time_travel$t_to_block_$_state_machine__2741__auto__;
})()
})();
var state__2765__auto__ = (function (){var statearr_19266 = (f__2764__auto__.cljs$core$IFn$_invoke$arity$0 ? f__2764__auto__.cljs$core$IFn$_invoke$arity$0() : f__2764__auto__.call(null));
(statearr_19266[(6)] = c__2763__auto__);

return statearr_19266;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__2765__auto__);
}));

return c__2763__auto__;
});
/**
 * Returns the block that any given 't' is contained within.
 */
fluree.db.time_travel.non_border_t_to_block = (function fluree$db$time_travel$non_border_t_to_block(db,t){
var c__2763__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__2764__auto__ = (function (){var switch__2740__auto__ = (function (state_19347){
var state_val_19348 = (state_19347[(1)]);
if((state_val_19348 === (7))){
var inst_19303 = (state_19347[(7)]);
var inst_19307 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_19308 = [t,"_block/transactions"];
var inst_19309 = (new cljs.core.PersistentVector(null,2,(5),inst_19307,inst_19308,null));
var inst_19310 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$4(inst_19303,new cljs.core.Keyword(null,"opst","opst",1213963058),cljs.core._EQ_,inst_19309);
var state_19347__$1 = state_19347;
var statearr_19349_19388 = state_19347__$1;
(statearr_19349_19388[(2)] = inst_19310);

(statearr_19349_19388[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19348 === (20))){
var inst_19337 = (state_19347[(8)]);
var state_19347__$1 = state_19347;
var statearr_19350_19389 = state_19347__$1;
(statearr_19350_19389[(2)] = inst_19337);

(statearr_19350_19389[(1)] = (22));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19348 === (1))){
var state_19347__$1 = state_19347;
var statearr_19351_19390 = state_19347__$1;
(statearr_19351_19390[(2)] = null);

(statearr_19351_19390[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19348 === (4))){
var inst_19296 = (state_19347[(2)]);
var state_19347__$1 = state_19347;
var statearr_19352_19391 = state_19347__$1;
(statearr_19352_19391[(2)] = inst_19296);

(statearr_19352_19391[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19348 === (15))){
var inst_19326 = (state_19347[(9)]);
var inst_19326__$1 = (state_19347[(2)]);
var inst_19327 = (inst_19326__$1 == null);
var state_19347__$1 = (function (){var statearr_19353 = state_19347;
(statearr_19353[(9)] = inst_19326__$1);

return statearr_19353;
})();
if(cljs.core.truth_(inst_19327)){
var statearr_19354_19392 = state_19347__$1;
(statearr_19354_19392[(1)] = (16));

} else {
var statearr_19355_19393 = state_19347__$1;
(statearr_19355_19393[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19348 === (21))){
var state_19347__$1 = state_19347;
var statearr_19356_19394 = state_19347__$1;
(statearr_19356_19394[(2)] = (1));

(statearr_19356_19394[(1)] = (22));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19348 === (13))){
var state_19347__$1 = state_19347;
var statearr_19357_19395 = state_19347__$1;
(statearr_19357_19395[(2)] = null);

(statearr_19357_19395[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19348 === (22))){
var inst_19342 = (state_19347[(2)]);
var _ = (function (){var statearr_19358 = state_19347;
(statearr_19358[(4)] = cljs.core.rest((state_19347[(4)])));

return statearr_19358;
})();
var state_19347__$1 = state_19347;
var statearr_19359_19396 = state_19347__$1;
(statearr_19359_19396[(2)] = inst_19342);

(statearr_19359_19396[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19348 === (6))){
var state_19347__$1 = state_19347;
var statearr_19360_19397 = state_19347__$1;
(statearr_19360_19397[(2)] = null);

(statearr_19360_19397[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19348 === (17))){
var inst_19326 = (state_19347[(9)]);
var inst_19330 = (function (){var G__19302 = inst_19326;
return (function (p1__19295_SHARP_){
var f = p1__19295_SHARP_;
return f.s;
});
})();
var inst_19331 = (inst_19330.cljs$core$IFn$_invoke$arity$1 ? inst_19330.cljs$core$IFn$_invoke$arity$1(inst_19326) : inst_19330.call(null,inst_19326));
var state_19347__$1 = state_19347;
var statearr_19361_19398 = state_19347__$1;
(statearr_19361_19398[(2)] = inst_19331);

(statearr_19361_19398[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19348 === (3))){
var inst_19345 = (state_19347[(2)]);
var state_19347__$1 = state_19347;
return cljs.core.async.impl.ioc_helpers.return_chan(state_19347__$1,inst_19345);
} else {
if((state_val_19348 === (12))){
var inst_19317 = (state_19347[(2)]);
var inst_19318 = fluree.db.util.async.throw_err(inst_19317);
var state_19347__$1 = state_19347;
var statearr_19362_19399 = state_19347__$1;
(statearr_19362_19399[(2)] = inst_19318);

(statearr_19362_19399[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19348 === (2))){
var inst_19303 = (state_19347[(7)]);
var _ = (function (){var statearr_19363 = state_19347;
(statearr_19363[(4)] = cljs.core.cons((5),(state_19347[(4)])));

return statearr_19363;
})();
var inst_19303__$1 = fluree.db.dbproto._rootdb(db);
var inst_19304 = (inst_19303__$1 == null);
var state_19347__$1 = (function (){var statearr_19364 = state_19347;
(statearr_19364[(7)] = inst_19303__$1);

return statearr_19364;
})();
if(cljs.core.truth_(inst_19304)){
var statearr_19365_19400 = state_19347__$1;
(statearr_19365_19400[(1)] = (6));

} else {
var statearr_19366_19401 = state_19347__$1;
(statearr_19366_19401[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19348 === (19))){
var inst_19337 = (state_19347[(8)]);
var inst_19336 = (state_19347[(2)]);
var inst_19337__$1 = fluree.db.util.async.throw_err(inst_19336);
var inst_19338 = (inst_19337__$1 > (1));
var state_19347__$1 = (function (){var statearr_19367 = state_19347;
(statearr_19367[(8)] = inst_19337__$1);

return statearr_19367;
})();
if(cljs.core.truth_(inst_19338)){
var statearr_19368_19402 = state_19347__$1;
(statearr_19368_19402[(1)] = (20));

} else {
var statearr_19369_19403 = state_19347__$1;
(statearr_19369_19403[(1)] = (21));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19348 === (11))){
var inst_19320 = (state_19347[(10)]);
var inst_19320__$1 = (state_19347[(2)]);
var inst_19321 = (inst_19320__$1 == null);
var state_19347__$1 = (function (){var statearr_19371 = state_19347;
(statearr_19371[(10)] = inst_19320__$1);

return statearr_19371;
})();
if(cljs.core.truth_(inst_19321)){
var statearr_19372_19404 = state_19347__$1;
(statearr_19372_19404[(1)] = (13));

} else {
var statearr_19373_19405 = state_19347__$1;
(statearr_19373_19405[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19348 === (9))){
var state_19347__$1 = state_19347;
var statearr_19374_19406 = state_19347__$1;
(statearr_19374_19406[(2)] = null);

(statearr_19374_19406[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19348 === (5))){
var _ = (function (){var statearr_19375 = state_19347;
(statearr_19375[(4)] = cljs.core.rest((state_19347[(4)])));

return statearr_19375;
})();
var state_19347__$1 = state_19347;
var ex19370 = (state_19347__$1[(2)]);
var statearr_19376_19407 = state_19347__$1;
(statearr_19376_19407[(5)] = ex19370);


if((ex19370 instanceof Error)){
var statearr_19377_19408 = state_19347__$1;
(statearr_19377_19408[(1)] = (4));

(statearr_19377_19408[(5)] = null);

} else {
throw ex19370;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19348 === (14))){
var inst_19320 = (state_19347[(10)]);
var inst_19324 = cljs.core.first(inst_19320);
var state_19347__$1 = state_19347;
var statearr_19378_19409 = state_19347__$1;
(statearr_19378_19409[(2)] = inst_19324);

(statearr_19378_19409[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19348 === (16))){
var state_19347__$1 = state_19347;
var statearr_19379_19410 = state_19347__$1;
(statearr_19379_19410[(2)] = null);

(statearr_19379_19410[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19348 === (10))){
var inst_19312 = (state_19347[(11)]);
var state_19347__$1 = state_19347;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_19347__$1,(12),inst_19312);
} else {
if((state_val_19348 === (18))){
var inst_19333 = (state_19347[(2)]);
var inst_19334 = fluree.db.time_travel.t_to_block(db,inst_19333);
var state_19347__$1 = state_19347;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_19347__$1,(19),inst_19334);
} else {
if((state_val_19348 === (8))){
var inst_19312 = (state_19347[(11)]);
var inst_19312__$1 = (state_19347[(2)]);
var inst_19313 = (inst_19312__$1 == null);
var state_19347__$1 = (function (){var statearr_19380 = state_19347;
(statearr_19380[(11)] = inst_19312__$1);

return statearr_19380;
})();
if(cljs.core.truth_(inst_19313)){
var statearr_19381_19411 = state_19347__$1;
(statearr_19381_19411[(1)] = (9));

} else {
var statearr_19382_19412 = state_19347__$1;
(statearr_19382_19412[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$time_travel$non_border_t_to_block_$_state_machine__2741__auto__ = null;
var fluree$db$time_travel$non_border_t_to_block_$_state_machine__2741__auto____0 = (function (){
var statearr_19383 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_19383[(0)] = fluree$db$time_travel$non_border_t_to_block_$_state_machine__2741__auto__);

(statearr_19383[(1)] = (1));

return statearr_19383;
});
var fluree$db$time_travel$non_border_t_to_block_$_state_machine__2741__auto____1 = (function (state_19347){
while(true){
var ret_value__2742__auto__ = (function (){try{while(true){
var result__2743__auto__ = switch__2740__auto__(state_19347);
if(cljs.core.keyword_identical_QMARK_(result__2743__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2743__auto__;
}
break;
}
}catch (e19384){var ex__2744__auto__ = e19384;
var statearr_19385_19413 = state_19347;
(statearr_19385_19413[(2)] = ex__2744__auto__);


if(cljs.core.seq((state_19347[(4)]))){
var statearr_19386_19414 = state_19347;
(statearr_19386_19414[(1)] = cljs.core.first((state_19347[(4)])));

} else {
throw ex__2744__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__2742__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__19415 = state_19347;
state_19347 = G__19415;
continue;
} else {
return ret_value__2742__auto__;
}
break;
}
});
fluree$db$time_travel$non_border_t_to_block_$_state_machine__2741__auto__ = function(state_19347){
switch(arguments.length){
case 0:
return fluree$db$time_travel$non_border_t_to_block_$_state_machine__2741__auto____0.call(this);
case 1:
return fluree$db$time_travel$non_border_t_to_block_$_state_machine__2741__auto____1.call(this,state_19347);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$time_travel$non_border_t_to_block_$_state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$time_travel$non_border_t_to_block_$_state_machine__2741__auto____0;
fluree$db$time_travel$non_border_t_to_block_$_state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$time_travel$non_border_t_to_block_$_state_machine__2741__auto____1;
return fluree$db$time_travel$non_border_t_to_block_$_state_machine__2741__auto__;
})()
})();
var state__2765__auto__ = (function (){var statearr_19387 = (f__2764__auto__.cljs$core$IFn$_invoke$arity$0 ? f__2764__auto__.cljs$core$IFn$_invoke$arity$0() : f__2764__auto__.call(null));
(statearr_19387[(6)] = c__2763__auto__);

return statearr_19387;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__2765__auto__);
}));

return c__2763__auto__;
});
/**
 * Returns the block for a given time as a string (ISO-8601 formatted time or a duration).
 *   If a block (positive integer) is provided, returns it unmodified.
 */
fluree.db.time_travel.block_to_int_format = (function fluree$db$time_travel$block_to_int_format(db,time_str){
var c__2763__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__2764__auto__ = (function (){var switch__2740__auto__ = (function (state_19476){
var state_val_19477 = (state_19476[(1)]);
if((state_val_19477 === (7))){
var inst_19425 = (state_19476[(7)]);
var inst_19425__$1 = typeof time_str === 'string';
var state_19476__$1 = (function (){var statearr_19478 = state_19476;
(statearr_19478[(7)] = inst_19425__$1);

return statearr_19478;
})();
if(cljs.core.truth_(inst_19425__$1)){
var statearr_19479_19513 = state_19476__$1;
(statearr_19479_19513[(1)] = (9));

} else {
var statearr_19480_19514 = state_19476__$1;
(statearr_19480_19514[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19477 === (20))){
var inst_19448 = (state_19476[(2)]);
var inst_19449 = fluree.db.util.async.throw_err(inst_19448);
var inst_19450 = fluree.db.time_travel.t_to_block(db,inst_19449);
var state_19476__$1 = state_19476;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_19476__$1,(21),inst_19450);
} else {
if((state_val_19477 === (1))){
var state_19476__$1 = state_19476;
var statearr_19481_19515 = state_19476__$1;
(statearr_19481_19515[(2)] = null);

(statearr_19481_19515[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19477 === (24))){
var inst_19465 = (state_19476[(2)]);
var state_19476__$1 = state_19476;
var statearr_19482_19516 = state_19476__$1;
(statearr_19482_19516[(2)] = inst_19465);

(statearr_19482_19516[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19477 === (4))){
var inst_19416 = (state_19476[(2)]);
var state_19476__$1 = state_19476;
var statearr_19483_19517 = state_19476__$1;
(statearr_19483_19517[(2)] = inst_19416);

(statearr_19483_19517[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19477 === (15))){
var inst_19437 = (state_19476[(2)]);
var inst_19438 = fluree.db.util.async.throw_err(inst_19437);
var inst_19439 = fluree.db.time_travel.t_to_block(db,inst_19438);
var state_19476__$1 = state_19476;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_19476__$1,(16),inst_19439);
} else {
if((state_val_19477 === (21))){
var inst_19452 = (state_19476[(2)]);
var inst_19453 = fluree.db.util.async.throw_err(inst_19452);
var state_19476__$1 = state_19476;
var statearr_19484_19518 = state_19476__$1;
(statearr_19484_19518[(2)] = inst_19453);

(statearr_19484_19518[(1)] = (19));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19477 === (13))){
var inst_19444 = typeof time_str === 'string';
var state_19476__$1 = state_19476;
if(cljs.core.truth_(inst_19444)){
var statearr_19485_19519 = state_19476__$1;
(statearr_19485_19519[(1)] = (17));

} else {
var statearr_19486_19520 = state_19476__$1;
(statearr_19486_19520[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19477 === (22))){
var inst_19456 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([time_str], 0));
var inst_19457 = ["Invalid block key provided: ",inst_19456].join('');
var inst_19458 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_19459 = [(400),new cljs.core.Keyword("db","invalid-time","db/invalid-time",-1496866235)];
var inst_19460 = cljs.core.PersistentHashMap.fromArrays(inst_19458,inst_19459);
var inst_19461 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_19457,inst_19460);
var inst_19462 = (function(){throw inst_19461})();
var state_19476__$1 = state_19476;
var statearr_19487_19521 = state_19476__$1;
(statearr_19487_19521[(2)] = inst_19462);

(statearr_19487_19521[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19477 === (6))){
var state_19476__$1 = state_19476;
var statearr_19488_19522 = state_19476__$1;
(statearr_19488_19522[(2)] = time_str);

(statearr_19488_19522[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19477 === (17))){
var inst_19446 = fluree.db.time_travel.time_to_t(db,time_str);
var state_19476__$1 = state_19476;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_19476__$1,(20),inst_19446);
} else {
if((state_val_19477 === (3))){
var inst_19474 = (state_19476[(2)]);
var state_19476__$1 = state_19476;
return cljs.core.async.impl.ioc_helpers.return_chan(state_19476__$1,inst_19474);
} else {
if((state_val_19477 === (12))){
var inst_19434 = fluree.db.time_travel.duration_parse(time_str);
var inst_19435 = fluree.db.time_travel.time_to_t(db,inst_19434);
var state_19476__$1 = state_19476;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_19476__$1,(15),inst_19435);
} else {
if((state_val_19477 === (2))){
var _ = (function (){var statearr_19489 = state_19476;
(statearr_19489[(4)] = cljs.core.cons((5),(state_19476[(4)])));

return statearr_19489;
})();
var inst_19422 = cljs.core.pos_int_QMARK_(time_str);
var state_19476__$1 = state_19476;
if(inst_19422){
var statearr_19490_19523 = state_19476__$1;
(statearr_19490_19523[(1)] = (6));

} else {
var statearr_19491_19524 = state_19476__$1;
(statearr_19491_19524[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19477 === (23))){
var state_19476__$1 = state_19476;
var statearr_19492_19525 = state_19476__$1;
(statearr_19492_19525[(2)] = null);

(statearr_19492_19525[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19477 === (19))){
var inst_19467 = (state_19476[(2)]);
var state_19476__$1 = state_19476;
var statearr_19493_19526 = state_19476__$1;
(statearr_19493_19526[(2)] = inst_19467);

(statearr_19493_19526[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19477 === (11))){
var inst_19432 = (state_19476[(2)]);
var state_19476__$1 = state_19476;
if(cljs.core.truth_(inst_19432)){
var statearr_19495_19527 = state_19476__$1;
(statearr_19495_19527[(1)] = (12));

} else {
var statearr_19496_19528 = state_19476__$1;
(statearr_19496_19528[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19477 === (9))){
var inst_19427 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(time_str,(0));
var inst_19428 = cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_19427);
var inst_19429 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("P",inst_19428);
var state_19476__$1 = state_19476;
var statearr_19497_19529 = state_19476__$1;
(statearr_19497_19529[(2)] = inst_19429);

(statearr_19497_19529[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19477 === (5))){
var _ = (function (){var statearr_19498 = state_19476;
(statearr_19498[(4)] = cljs.core.rest((state_19476[(4)])));

return statearr_19498;
})();
var state_19476__$1 = state_19476;
var ex19494 = (state_19476__$1[(2)]);
var statearr_19499_19530 = state_19476__$1;
(statearr_19499_19530[(5)] = ex19494);


if((ex19494 instanceof Error)){
var statearr_19500_19531 = state_19476__$1;
(statearr_19500_19531[(1)] = (4));

(statearr_19500_19531[(5)] = null);

} else {
throw ex19494;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19477 === (14))){
var inst_19469 = (state_19476[(2)]);
var state_19476__$1 = state_19476;
var statearr_19501_19532 = state_19476__$1;
(statearr_19501_19532[(2)] = inst_19469);

(statearr_19501_19532[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19477 === (16))){
var inst_19441 = (state_19476[(2)]);
var inst_19442 = fluree.db.util.async.throw_err(inst_19441);
var state_19476__$1 = state_19476;
var statearr_19502_19533 = state_19476__$1;
(statearr_19502_19533[(2)] = inst_19442);

(statearr_19502_19533[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19477 === (10))){
var inst_19425 = (state_19476[(7)]);
var state_19476__$1 = state_19476;
var statearr_19503_19534 = state_19476__$1;
(statearr_19503_19534[(2)] = inst_19425);

(statearr_19503_19534[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19477 === (18))){
var state_19476__$1 = state_19476;
var statearr_19504_19535 = state_19476__$1;
(statearr_19504_19535[(1)] = (22));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19477 === (8))){
var inst_19471 = (state_19476[(2)]);
var _ = (function (){var statearr_19506 = state_19476;
(statearr_19506[(4)] = cljs.core.rest((state_19476[(4)])));

return statearr_19506;
})();
var state_19476__$1 = state_19476;
var statearr_19507_19536 = state_19476__$1;
(statearr_19507_19536[(2)] = inst_19471);

(statearr_19507_19536[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$time_travel$block_to_int_format_$_state_machine__2741__auto__ = null;
var fluree$db$time_travel$block_to_int_format_$_state_machine__2741__auto____0 = (function (){
var statearr_19508 = [null,null,null,null,null,null,null,null];
(statearr_19508[(0)] = fluree$db$time_travel$block_to_int_format_$_state_machine__2741__auto__);

(statearr_19508[(1)] = (1));

return statearr_19508;
});
var fluree$db$time_travel$block_to_int_format_$_state_machine__2741__auto____1 = (function (state_19476){
while(true){
var ret_value__2742__auto__ = (function (){try{while(true){
var result__2743__auto__ = switch__2740__auto__(state_19476);
if(cljs.core.keyword_identical_QMARK_(result__2743__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2743__auto__;
}
break;
}
}catch (e19509){var ex__2744__auto__ = e19509;
var statearr_19510_19537 = state_19476;
(statearr_19510_19537[(2)] = ex__2744__auto__);


if(cljs.core.seq((state_19476[(4)]))){
var statearr_19511_19538 = state_19476;
(statearr_19511_19538[(1)] = cljs.core.first((state_19476[(4)])));

} else {
throw ex__2744__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__2742__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__19539 = state_19476;
state_19476 = G__19539;
continue;
} else {
return ret_value__2742__auto__;
}
break;
}
});
fluree$db$time_travel$block_to_int_format_$_state_machine__2741__auto__ = function(state_19476){
switch(arguments.length){
case 0:
return fluree$db$time_travel$block_to_int_format_$_state_machine__2741__auto____0.call(this);
case 1:
return fluree$db$time_travel$block_to_int_format_$_state_machine__2741__auto____1.call(this,state_19476);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$time_travel$block_to_int_format_$_state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$time_travel$block_to_int_format_$_state_machine__2741__auto____0;
fluree$db$time_travel$block_to_int_format_$_state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$time_travel$block_to_int_format_$_state_machine__2741__auto____1;
return fluree$db$time_travel$block_to_int_format_$_state_machine__2741__auto__;
})()
})();
var state__2765__auto__ = (function (){var statearr_19512 = (f__2764__auto__.cljs$core$IFn$_invoke$arity$0 ? f__2764__auto__.cljs$core$IFn$_invoke$arity$0() : f__2764__auto__.call(null));
(statearr_19512[(6)] = c__2763__auto__);

return statearr_19512;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__2765__auto__);
}));

return c__2763__auto__;
});
/**
 * Given a positive integer block, returns the t (negative integer) associated.
 *   If block does not exist, throws.
 */
fluree.db.time_travel.block_to_t = (function fluree$db$time_travel$block_to_t(db,block){
var c__2763__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__2764__auto__ = (function (){var switch__2740__auto__ = (function (state_19594){
var state_val_19595 = (state_19594[(1)]);
if((state_val_19595 === (7))){
var inst_19548 = (state_19594[(7)]);
var inst_19552 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_19553 = ["_block/number",block];
var inst_19554 = (new cljs.core.PersistentVector(null,2,(5),inst_19552,inst_19553,null));
var inst_19555 = fluree.db.query.range.index_range.cljs$core$IFn$_invoke$arity$4(inst_19548,new cljs.core.Keyword(null,"post","post",269697687),cljs.core._EQ_,inst_19554);
var state_19594__$1 = state_19594;
var statearr_19596_19636 = state_19594__$1;
(statearr_19596_19636[(2)] = inst_19555);

(statearr_19596_19636[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19595 === (20))){
var inst_19581 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([block], 0));
var inst_19582 = ["Invalid block key provided: ",inst_19581].join('');
var inst_19583 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_19584 = [(400),new cljs.core.Keyword("db","invalid-time","db/invalid-time",-1496866235)];
var inst_19585 = cljs.core.PersistentHashMap.fromArrays(inst_19583,inst_19584);
var inst_19586 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_19582,inst_19585);
var inst_19587 = (function(){throw inst_19586})();
var state_19594__$1 = state_19594;
var statearr_19597_19637 = state_19594__$1;
(statearr_19597_19637[(2)] = inst_19587);

(statearr_19597_19637[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19595 === (1))){
var state_19594__$1 = state_19594;
var statearr_19598_19638 = state_19594__$1;
(statearr_19598_19638[(2)] = null);

(statearr_19598_19638[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19595 === (4))){
var inst_19541 = (state_19594[(2)]);
var state_19594__$1 = state_19594;
var statearr_19599_19639 = state_19594__$1;
(statearr_19599_19639[(2)] = inst_19541);

(statearr_19599_19639[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19595 === (15))){
var inst_19571 = (state_19594[(8)]);
var inst_19571__$1 = (state_19594[(2)]);
var inst_19572 = (inst_19571__$1 == null);
var state_19594__$1 = (function (){var statearr_19600 = state_19594;
(statearr_19600[(8)] = inst_19571__$1);

return statearr_19600;
})();
if(cljs.core.truth_(inst_19572)){
var statearr_19601_19640 = state_19594__$1;
(statearr_19601_19640[(1)] = (16));

} else {
var statearr_19602_19641 = state_19594__$1;
(statearr_19602_19641[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19595 === (21))){
var inst_19578 = (state_19594[(9)]);
var inst_19589 = (state_19594[(2)]);
var _ = (function (){var statearr_19603 = state_19594;
(statearr_19603[(4)] = cljs.core.rest((state_19594[(4)])));

return statearr_19603;
})();
var state_19594__$1 = (function (){var statearr_19604 = state_19594;
(statearr_19604[(10)] = inst_19589);

return statearr_19604;
})();
var statearr_19605_19642 = state_19594__$1;
(statearr_19605_19642[(2)] = inst_19578);

(statearr_19605_19642[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19595 === (13))){
var state_19594__$1 = state_19594;
var statearr_19606_19643 = state_19594__$1;
(statearr_19606_19643[(2)] = null);

(statearr_19606_19643[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19595 === (6))){
var state_19594__$1 = state_19594;
var statearr_19607_19644 = state_19594__$1;
(statearr_19607_19644[(2)] = null);

(statearr_19607_19644[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19595 === (17))){
var inst_19571 = (state_19594[(8)]);
var inst_19575 = (function (){var G__19547 = inst_19571;
return (function (p1__19540_SHARP_){
var f = p1__19540_SHARP_;
return f.t;
});
})();
var inst_19576 = (inst_19575.cljs$core$IFn$_invoke$arity$1 ? inst_19575.cljs$core$IFn$_invoke$arity$1(inst_19571) : inst_19575.call(null,inst_19571));
var state_19594__$1 = state_19594;
var statearr_19608_19645 = state_19594__$1;
(statearr_19608_19645[(2)] = inst_19576);

(statearr_19608_19645[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19595 === (3))){
var inst_19592 = (state_19594[(2)]);
var state_19594__$1 = state_19594;
return cljs.core.async.impl.ioc_helpers.return_chan(state_19594__$1,inst_19592);
} else {
if((state_val_19595 === (12))){
var inst_19562 = (state_19594[(2)]);
var inst_19563 = fluree.db.util.async.throw_err(inst_19562);
var state_19594__$1 = state_19594;
var statearr_19609_19646 = state_19594__$1;
(statearr_19609_19646[(2)] = inst_19563);

(statearr_19609_19646[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19595 === (2))){
var inst_19548 = (state_19594[(7)]);
var _ = (function (){var statearr_19610 = state_19594;
(statearr_19610[(4)] = cljs.core.cons((5),(state_19594[(4)])));

return statearr_19610;
})();
var inst_19548__$1 = fluree.db.dbproto._rootdb(db);
var inst_19549 = (inst_19548__$1 == null);
var state_19594__$1 = (function (){var statearr_19611 = state_19594;
(statearr_19611[(7)] = inst_19548__$1);

return statearr_19611;
})();
if(cljs.core.truth_(inst_19549)){
var statearr_19612_19647 = state_19594__$1;
(statearr_19612_19647[(1)] = (6));

} else {
var statearr_19613_19648 = state_19594__$1;
(statearr_19613_19648[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19595 === (19))){
var state_19594__$1 = state_19594;
var statearr_19614_19649 = state_19594__$1;
(statearr_19614_19649[(2)] = null);

(statearr_19614_19649[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19595 === (11))){
var inst_19565 = (state_19594[(11)]);
var inst_19565__$1 = (state_19594[(2)]);
var inst_19566 = (inst_19565__$1 == null);
var state_19594__$1 = (function (){var statearr_19616 = state_19594;
(statearr_19616[(11)] = inst_19565__$1);

return statearr_19616;
})();
if(cljs.core.truth_(inst_19566)){
var statearr_19617_19650 = state_19594__$1;
(statearr_19617_19650[(1)] = (13));

} else {
var statearr_19618_19651 = state_19594__$1;
(statearr_19618_19651[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19595 === (9))){
var state_19594__$1 = state_19594;
var statearr_19619_19652 = state_19594__$1;
(statearr_19619_19652[(2)] = null);

(statearr_19619_19652[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19595 === (5))){
var _ = (function (){var statearr_19620 = state_19594;
(statearr_19620[(4)] = cljs.core.rest((state_19594[(4)])));

return statearr_19620;
})();
var state_19594__$1 = state_19594;
var ex19615 = (state_19594__$1[(2)]);
var statearr_19621_19653 = state_19594__$1;
(statearr_19621_19653[(5)] = ex19615);


if((ex19615 instanceof Error)){
var statearr_19622_19654 = state_19594__$1;
(statearr_19622_19654[(1)] = (4));

(statearr_19622_19654[(5)] = null);

} else {
throw ex19615;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19595 === (14))){
var inst_19565 = (state_19594[(11)]);
var inst_19569 = cljs.core.first(inst_19565);
var state_19594__$1 = state_19594;
var statearr_19623_19655 = state_19594__$1;
(statearr_19623_19655[(2)] = inst_19569);

(statearr_19623_19655[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19595 === (16))){
var state_19594__$1 = state_19594;
var statearr_19624_19656 = state_19594__$1;
(statearr_19624_19656[(2)] = null);

(statearr_19624_19656[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19595 === (10))){
var inst_19557 = (state_19594[(12)]);
var state_19594__$1 = state_19594;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_19594__$1,(12),inst_19557);
} else {
if((state_val_19595 === (18))){
var inst_19578 = (state_19594[(9)]);
var inst_19578__$1 = (state_19594[(2)]);
var state_19594__$1 = (function (){var statearr_19625 = state_19594;
(statearr_19625[(9)] = inst_19578__$1);

return statearr_19625;
})();
if(cljs.core.truth_(inst_19578__$1)){
var statearr_19626_19657 = state_19594__$1;
(statearr_19626_19657[(1)] = (19));

} else {
var statearr_19627_19658 = state_19594__$1;
(statearr_19627_19658[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19595 === (8))){
var inst_19557 = (state_19594[(12)]);
var inst_19557__$1 = (state_19594[(2)]);
var inst_19558 = (inst_19557__$1 == null);
var state_19594__$1 = (function (){var statearr_19628 = state_19594;
(statearr_19628[(12)] = inst_19557__$1);

return statearr_19628;
})();
if(cljs.core.truth_(inst_19558)){
var statearr_19629_19659 = state_19594__$1;
(statearr_19629_19659[(1)] = (9));

} else {
var statearr_19630_19660 = state_19594__$1;
(statearr_19630_19660[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$time_travel$block_to_t_$_state_machine__2741__auto__ = null;
var fluree$db$time_travel$block_to_t_$_state_machine__2741__auto____0 = (function (){
var statearr_19631 = [null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_19631[(0)] = fluree$db$time_travel$block_to_t_$_state_machine__2741__auto__);

(statearr_19631[(1)] = (1));

return statearr_19631;
});
var fluree$db$time_travel$block_to_t_$_state_machine__2741__auto____1 = (function (state_19594){
while(true){
var ret_value__2742__auto__ = (function (){try{while(true){
var result__2743__auto__ = switch__2740__auto__(state_19594);
if(cljs.core.keyword_identical_QMARK_(result__2743__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2743__auto__;
}
break;
}
}catch (e19632){var ex__2744__auto__ = e19632;
var statearr_19633_19661 = state_19594;
(statearr_19633_19661[(2)] = ex__2744__auto__);


if(cljs.core.seq((state_19594[(4)]))){
var statearr_19634_19662 = state_19594;
(statearr_19634_19662[(1)] = cljs.core.first((state_19594[(4)])));

} else {
throw ex__2744__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__2742__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__19663 = state_19594;
state_19594 = G__19663;
continue;
} else {
return ret_value__2742__auto__;
}
break;
}
});
fluree$db$time_travel$block_to_t_$_state_machine__2741__auto__ = function(state_19594){
switch(arguments.length){
case 0:
return fluree$db$time_travel$block_to_t_$_state_machine__2741__auto____0.call(this);
case 1:
return fluree$db$time_travel$block_to_t_$_state_machine__2741__auto____1.call(this,state_19594);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$time_travel$block_to_t_$_state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$time_travel$block_to_t_$_state_machine__2741__auto____0;
fluree$db$time_travel$block_to_t_$_state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$time_travel$block_to_t_$_state_machine__2741__auto____1;
return fluree$db$time_travel$block_to_t_$_state_machine__2741__auto__;
})()
})();
var state__2765__auto__ = (function (){var statearr_19635 = (f__2764__auto__.cljs$core$IFn$_invoke$arity$0 ? f__2764__auto__.cljs$core$IFn$_invoke$arity$0() : f__2764__auto__.call(null));
(statearr_19635[(6)] = c__2763__auto__);

return statearr_19635;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__2765__auto__);
}));

return c__2763__auto__;
});
/**
 * Takes any time value: block, ISO-8601 time or duration string, or t
 *   and returns the exact 't' as of that value into a core async channel.
 */
fluree.db.time_travel.to_t = (function fluree$db$time_travel$to_t(db,block_or_t_or_time){
var c__2763__auto__ = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__2764__auto__ = (function (){var switch__2740__auto__ = (function (state_19734){
var state_val_19735 = (state_19734[(1)]);
if((state_val_19735 === (7))){
var state_19734__$1 = state_19734;
var statearr_19736_19781 = state_19734__$1;
(statearr_19736_19781[(2)] = null);

(statearr_19736_19781[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (20))){
var inst_19725 = (state_19734[(2)]);
var state_19734__$1 = state_19734;
var statearr_19737_19782 = state_19734__$1;
(statearr_19737_19782[(2)] = inst_19725);

(statearr_19737_19782[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (27))){
var state_19734__$1 = state_19734;
var statearr_19738_19783 = state_19734__$1;
(statearr_19738_19783[(2)] = null);

(statearr_19738_19783[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (1))){
var state_19734__$1 = state_19734;
var statearr_19739_19784 = state_19734__$1;
(statearr_19739_19784[(2)] = null);

(statearr_19739_19784[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (24))){
var inst_19703 = (state_19734[(2)]);
var inst_19704 = fluree.db.util.async.throw_err(inst_19703);
var state_19734__$1 = state_19734;
var statearr_19740_19785 = state_19734__$1;
(statearr_19740_19785[(2)] = inst_19704);

(statearr_19740_19785[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (4))){
var inst_19664 = (state_19734[(2)]);
var state_19734__$1 = state_19734;
var statearr_19741_19786 = state_19734__$1;
(statearr_19741_19786[(2)] = inst_19664);

(statearr_19741_19786[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (15))){
var state_19734__$1 = state_19734;
var statearr_19743_19787 = state_19734__$1;
(statearr_19743_19787[(2)] = block_or_t_or_time);

(statearr_19743_19787[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (21))){
var inst_19673 = (state_19734[(7)]);
var inst_19700 = fluree.db.time_travel.duration_parse(block_or_t_or_time);
var inst_19701 = fluree.db.time_travel.time_to_t(inst_19673,inst_19700);
var state_19734__$1 = state_19734;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_19734__$1,(24),inst_19701);
} else {
if((state_val_19735 === (13))){
var _ = (function (){var statearr_19744 = state_19734;
(statearr_19744[(4)] = cljs.core.rest((state_19734[(4)])));

return statearr_19744;
})();
var state_19734__$1 = state_19734;
var ex19742 = (state_19734__$1[(2)]);
var statearr_19745_19788 = state_19734__$1;
(statearr_19745_19788[(5)] = ex19742);


var statearr_19746_19789 = state_19734__$1;
(statearr_19746_19789[(1)] = (12));

(statearr_19746_19789[(5)] = null);



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (22))){
var inst_19673 = (state_19734[(7)]);
var inst_19706 = fluree.db.time_travel.time_to_t(inst_19673,block_or_t_or_time);
var state_19734__$1 = state_19734;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_19734__$1,(25),inst_19706);
} else {
if((state_val_19735 === (6))){
var inst_19672 = (state_19734[(2)]);
var inst_19673 = fluree.db.util.async.throw_err(inst_19672);
var inst_19674 = cljs.core.pos_int_QMARK_(block_or_t_or_time);
var state_19734__$1 = (function (){var statearr_19747 = state_19734;
(statearr_19747[(7)] = inst_19673);

return statearr_19747;
})();
if(inst_19674){
var statearr_19748_19790 = state_19734__$1;
(statearr_19748_19790[(1)] = (7));

} else {
var statearr_19749_19791 = state_19734__$1;
(statearr_19749_19791[(1)] = (8));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (28))){
var inst_19723 = (state_19734[(2)]);
var state_19734__$1 = state_19734;
var statearr_19750_19792 = state_19734__$1;
(statearr_19750_19792[(2)] = inst_19723);

(statearr_19750_19792[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (25))){
var inst_19708 = (state_19734[(2)]);
var inst_19709 = fluree.db.util.async.throw_err(inst_19708);
var state_19734__$1 = state_19734;
var statearr_19751_19793 = state_19734__$1;
(statearr_19751_19793[(2)] = inst_19709);

(statearr_19751_19793[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (17))){
var inst_19727 = (state_19734[(2)]);
var state_19734__$1 = state_19734;
var statearr_19752_19794 = state_19734__$1;
(statearr_19752_19794[(2)] = inst_19727);

(statearr_19752_19794[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (3))){
var inst_19732 = (state_19734[(2)]);
var state_19734__$1 = state_19734;
return cljs.core.async.impl.ioc_helpers.return_chan(state_19734__$1,inst_19732);
} else {
if((state_val_19735 === (12))){
var inst_19673 = (state_19734[(7)]);
var inst_19676 = (state_19734[(2)]);
var inst_19677 = new cljs.core.Keyword(null,"t","t",-1397832519).cljs$core$IFn$_invoke$arity$1(inst_19673);
var state_19734__$1 = (function (){var statearr_19753 = state_19734;
(statearr_19753[(8)] = inst_19676);

return statearr_19753;
})();
var statearr_19754_19795 = state_19734__$1;
(statearr_19754_19795[(2)] = inst_19677);

(statearr_19754_19795[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (2))){
var _ = (function (){var statearr_19755 = state_19734;
(statearr_19755[(4)] = cljs.core.cons((5),(state_19734[(4)])));

return statearr_19755;
})();
var inst_19670 = fluree.db.dbproto._latest_db(db);
var state_19734__$1 = state_19734;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_19734__$1,(6),inst_19670);
} else {
if((state_val_19735 === (23))){
var inst_19711 = (state_19734[(2)]);
var state_19734__$1 = state_19734;
var statearr_19756_19796 = state_19734__$1;
(statearr_19756_19796[(2)] = inst_19711);

(statearr_19756_19796[(1)] = (20));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (19))){
var state_19734__$1 = state_19734;
var statearr_19757_19797 = state_19734__$1;
(statearr_19757_19797[(1)] = (26));



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (11))){
var inst_19689 = (state_19734[(2)]);
var state_19734__$1 = state_19734;
var statearr_19760_19798 = state_19734__$1;
(statearr_19760_19798[(2)] = inst_19689);

(statearr_19760_19798[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (9))){
var inst_19729 = (state_19734[(2)]);
var _ = (function (){var statearr_19761 = state_19734;
(statearr_19761[(4)] = cljs.core.rest((state_19734[(4)])));

return statearr_19761;
})();
var state_19734__$1 = state_19734;
var statearr_19762_19799 = state_19734__$1;
(statearr_19762_19799[(2)] = inst_19729);

(statearr_19762_19799[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (5))){
var _ = (function (){var statearr_19763 = state_19734;
(statearr_19763[(4)] = cljs.core.rest((state_19734[(4)])));

return statearr_19763;
})();
var state_19734__$1 = state_19734;
var ex19759 = (state_19734__$1[(2)]);
var statearr_19764_19800 = state_19734__$1;
(statearr_19764_19800[(5)] = ex19759);


if((ex19759 instanceof Error)){
var statearr_19765_19801 = state_19734__$1;
(statearr_19765_19801[(1)] = (4));

(statearr_19765_19801[(5)] = null);

} else {
throw ex19759;

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (14))){
var inst_19685 = (state_19734[(2)]);
var inst_19686 = fluree.db.util.async.throw_err(inst_19685);
var _ = (function (){var statearr_19766 = state_19734;
(statearr_19766[(4)] = cljs.core.rest((state_19734[(4)])));

return statearr_19766;
})();
var state_19734__$1 = state_19734;
var statearr_19767_19802 = state_19734__$1;
(statearr_19767_19802[(2)] = inst_19686);

(statearr_19767_19802[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (26))){
var inst_19714 = cljs.core.pr_str.cljs$core$IFn$_invoke$arity$variadic(cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([block_or_t_or_time], 0));
var inst_19715 = ["Invalid time value provided: ",inst_19714].join('');
var inst_19716 = [new cljs.core.Keyword(null,"status","status",-1997798413),new cljs.core.Keyword(null,"error","error",-978969032)];
var inst_19717 = [(400),new cljs.core.Keyword("db","invalid-time","db/invalid-time",-1496866235)];
var inst_19718 = cljs.core.PersistentHashMap.fromArrays(inst_19716,inst_19717);
var inst_19719 = cljs.core.ex_info.cljs$core$IFn$_invoke$arity$2(inst_19715,inst_19718);
var inst_19720 = (function(){throw inst_19719})();
var state_19734__$1 = state_19734;
var statearr_19768_19803 = state_19734__$1;
(statearr_19768_19803[(2)] = inst_19720);

(statearr_19768_19803[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (16))){
var inst_19694 = typeof block_or_t_or_time === 'string';
var state_19734__$1 = state_19734;
if(cljs.core.truth_(inst_19694)){
var statearr_19769_19804 = state_19734__$1;
(statearr_19769_19804[(1)] = (18));

} else {
var statearr_19770_19805 = state_19734__$1;
(statearr_19770_19805[(1)] = (19));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (10))){
var inst_19673 = (state_19734[(7)]);
var _ = (function (){var statearr_19771 = state_19734;
(statearr_19771[(4)] = cljs.core.cons((13),(state_19734[(4)])));

return statearr_19771;
})();
var inst_19683 = fluree.db.time_travel.block_to_t(inst_19673,block_or_t_or_time);
var state_19734__$1 = state_19734;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_19734__$1,(14),inst_19683);
} else {
if((state_val_19735 === (18))){
var inst_19696 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(block_or_t_or_time,(0));
var inst_19697 = cljs.core.str.cljs$core$IFn$_invoke$arity$1(inst_19696);
var inst_19698 = cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2("P",inst_19697);
var state_19734__$1 = state_19734;
if(inst_19698){
var statearr_19772_19806 = state_19734__$1;
(statearr_19772_19806[(1)] = (21));

} else {
var statearr_19773_19807 = state_19734__$1;
(statearr_19773_19807[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19735 === (8))){
var inst_19691 = cljs.core.neg_int_QMARK_(block_or_t_or_time);
var state_19734__$1 = state_19734;
if(inst_19691){
var statearr_19774_19808 = state_19734__$1;
(statearr_19774_19808[(1)] = (15));

} else {
var statearr_19775_19809 = state_19734__$1;
(statearr_19775_19809[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$time_travel$to_t_$_state_machine__2741__auto__ = null;
var fluree$db$time_travel$to_t_$_state_machine__2741__auto____0 = (function (){
var statearr_19776 = [null,null,null,null,null,null,null,null,null];
(statearr_19776[(0)] = fluree$db$time_travel$to_t_$_state_machine__2741__auto__);

(statearr_19776[(1)] = (1));

return statearr_19776;
});
var fluree$db$time_travel$to_t_$_state_machine__2741__auto____1 = (function (state_19734){
while(true){
var ret_value__2742__auto__ = (function (){try{while(true){
var result__2743__auto__ = switch__2740__auto__(state_19734);
if(cljs.core.keyword_identical_QMARK_(result__2743__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2743__auto__;
}
break;
}
}catch (e19777){var ex__2744__auto__ = e19777;
var statearr_19778_19810 = state_19734;
(statearr_19778_19810[(2)] = ex__2744__auto__);


if(cljs.core.seq((state_19734[(4)]))){
var statearr_19779_19811 = state_19734;
(statearr_19779_19811[(1)] = cljs.core.first((state_19734[(4)])));

} else {
throw ex__2744__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__2742__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__19812 = state_19734;
state_19734 = G__19812;
continue;
} else {
return ret_value__2742__auto__;
}
break;
}
});
fluree$db$time_travel$to_t_$_state_machine__2741__auto__ = function(state_19734){
switch(arguments.length){
case 0:
return fluree$db$time_travel$to_t_$_state_machine__2741__auto____0.call(this);
case 1:
return fluree$db$time_travel$to_t_$_state_machine__2741__auto____1.call(this,state_19734);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$time_travel$to_t_$_state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$time_travel$to_t_$_state_machine__2741__auto____0;
fluree$db$time_travel$to_t_$_state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$time_travel$to_t_$_state_machine__2741__auto____1;
return fluree$db$time_travel$to_t_$_state_machine__2741__auto__;
})()
})();
var state__2765__auto__ = (function (){var statearr_19780 = (f__2764__auto__.cljs$core$IFn$_invoke$arity$0 ? f__2764__auto__.cljs$core$IFn$_invoke$arity$0() : f__2764__auto__.call(null));
(statearr_19780[(6)] = c__2763__auto__);

return statearr_19780;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__2765__auto__);
}));

return c__2763__auto__;
});
/**
 * Gets the database as-of a specified block. Either block number or a time string in ISO-8601 format.
 *   Returns db as a promise channel
 */
fluree.db.time_travel.as_of_block = (function fluree$db$time_travel$as_of_block(db,block_or_t_or_time){
var pc = cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();
var c__2763__auto___19856 = cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((1));
cljs.core.async.impl.dispatch.run((function (){
var f__2764__auto__ = (function (){var switch__2740__auto__ = (function (state_19838){
var state_val_19839 = (state_19838[(1)]);
if((state_val_19839 === (1))){
var state_19838__$1 = state_19838;
var statearr_19840_19857 = state_19838__$1;
(statearr_19840_19857[(2)] = null);

(statearr_19840_19857[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19839 === (2))){
var _ = (function (){var statearr_19841 = state_19838;
(statearr_19841[(4)] = cljs.core.cons((5),(state_19838[(4)])));

return statearr_19841;
})();
var inst_19820 = fluree.db.dbproto._latest_db(db);
var state_19838__$1 = state_19838;
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_19838__$1,(6),inst_19820);
} else {
if((state_val_19839 === (3))){
var inst_19836 = (state_19838[(2)]);
var state_19838__$1 = state_19838;
return cljs.core.async.impl.ioc_helpers.return_chan(state_19838__$1,inst_19836);
} else {
if((state_val_19839 === (4))){
var inst_19813 = (state_19838[(2)]);
var inst_19814 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(pc,inst_19813);
var state_19838__$1 = state_19838;
var statearr_19843_19858 = state_19838__$1;
(statearr_19843_19858[(2)] = inst_19814);

(statearr_19843_19858[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19839 === (5))){
var _ = (function (){var statearr_19844 = state_19838;
(statearr_19844[(4)] = cljs.core.rest((state_19838[(4)])));

return statearr_19844;
})();
var state_19838__$1 = state_19838;
var ex19842 = (state_19838__$1[(2)]);
var statearr_19845_19859 = state_19838__$1;
(statearr_19845_19859[(5)] = ex19842);


var statearr_19846_19860 = state_19838__$1;
(statearr_19846_19860[(1)] = (4));

(statearr_19846_19860[(5)] = null);



return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_19839 === (6))){
var inst_19823 = (state_19838[(7)]);
var inst_19822 = (state_19838[(2)]);
var inst_19823__$1 = fluree.db.util.async.throw_err(inst_19822);
var inst_19824 = fluree.db.time_travel.to_t(inst_19823__$1,block_or_t_or_time);
var state_19838__$1 = (function (){var statearr_19847 = state_19838;
(statearr_19847[(7)] = inst_19823__$1);

return statearr_19847;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_19838__$1,(7),inst_19824);
} else {
if((state_val_19839 === (7))){
var inst_19823 = (state_19838[(7)]);
var inst_19827 = (state_19838[(8)]);
var inst_19826 = (state_19838[(2)]);
var inst_19827__$1 = fluree.db.util.async.throw_err(inst_19826);
var inst_19828 = fluree.db.time_travel.t_to_block(inst_19823,inst_19827__$1);
var state_19838__$1 = (function (){var statearr_19848 = state_19838;
(statearr_19848[(8)] = inst_19827__$1);

return statearr_19848;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_(state_19838__$1,(8),inst_19828);
} else {
if((state_val_19839 === (8))){
var inst_19827 = (state_19838[(8)]);
var inst_19830 = (state_19838[(2)]);
var inst_19831 = fluree.db.util.async.throw_err(inst_19830);
var inst_19832 = cljs.core.assoc.cljs$core$IFn$_invoke$arity$variadic(db,new cljs.core.Keyword(null,"t","t",-1397832519),inst_19827,cljs.core.prim_seq.cljs$core$IFn$_invoke$arity$2([new cljs.core.Keyword(null,"block","block",664686210),inst_19831], 0));
var inst_19833 = cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2(pc,inst_19832);
var _ = (function (){var statearr_19849 = state_19838;
(statearr_19849[(4)] = cljs.core.rest((state_19838[(4)])));

return statearr_19849;
})();
var state_19838__$1 = state_19838;
var statearr_19850_19861 = state_19838__$1;
(statearr_19850_19861[(2)] = inst_19833);

(statearr_19850_19861[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
});
return (function() {
var fluree$db$time_travel$as_of_block_$_state_machine__2741__auto__ = null;
var fluree$db$time_travel$as_of_block_$_state_machine__2741__auto____0 = (function (){
var statearr_19851 = [null,null,null,null,null,null,null,null,null];
(statearr_19851[(0)] = fluree$db$time_travel$as_of_block_$_state_machine__2741__auto__);

(statearr_19851[(1)] = (1));

return statearr_19851;
});
var fluree$db$time_travel$as_of_block_$_state_machine__2741__auto____1 = (function (state_19838){
while(true){
var ret_value__2742__auto__ = (function (){try{while(true){
var result__2743__auto__ = switch__2740__auto__(state_19838);
if(cljs.core.keyword_identical_QMARK_(result__2743__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__2743__auto__;
}
break;
}
}catch (e19852){var ex__2744__auto__ = e19852;
var statearr_19853_19862 = state_19838;
(statearr_19853_19862[(2)] = ex__2744__auto__);


if(cljs.core.seq((state_19838[(4)]))){
var statearr_19854_19863 = state_19838;
(statearr_19854_19863[(1)] = cljs.core.first((state_19838[(4)])));

} else {
throw ex__2744__auto__;
}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
}})();
if(cljs.core.keyword_identical_QMARK_(ret_value__2742__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__19864 = state_19838;
state_19838 = G__19864;
continue;
} else {
return ret_value__2742__auto__;
}
break;
}
});
fluree$db$time_travel$as_of_block_$_state_machine__2741__auto__ = function(state_19838){
switch(arguments.length){
case 0:
return fluree$db$time_travel$as_of_block_$_state_machine__2741__auto____0.call(this);
case 1:
return fluree$db$time_travel$as_of_block_$_state_machine__2741__auto____1.call(this,state_19838);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
fluree$db$time_travel$as_of_block_$_state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$0 = fluree$db$time_travel$as_of_block_$_state_machine__2741__auto____0;
fluree$db$time_travel$as_of_block_$_state_machine__2741__auto__.cljs$core$IFn$_invoke$arity$1 = fluree$db$time_travel$as_of_block_$_state_machine__2741__auto____1;
return fluree$db$time_travel$as_of_block_$_state_machine__2741__auto__;
})()
})();
var state__2765__auto__ = (function (){var statearr_19855 = (f__2764__auto__.cljs$core$IFn$_invoke$arity$0 ? f__2764__auto__.cljs$core$IFn$_invoke$arity$0() : f__2764__auto__.call(null));
(statearr_19855[(6)] = c__2763__auto___19856);

return statearr_19855;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped(state__2765__auto__);
}));


return pc;
});
